
DROP TABLE IF EXISTS "CAMERAS";
DROP TABLE IF EXISTS "manufacturers";


CREATE TABLE "manufacturers" (
  "id" integer NOT NULL PRIMARY KEY AUTOINCREMENT,
  "manufacturer" text(31) NOT NULL,
  "model_id" text(31) NOT NULL
);


CREATE TABLE "cameras" (
  "id" integer NOT NULL PRIMARY KEY AUTOINCREMENT,
  "api_id" text NOT NULL,
  "model" text NOT NULL,
  "manufacturer" integer NOT NULL,
  "jpeg_url" text NOT NULL,
  "mjpeg_url" text NOT NULL,
  "h264_url" text NOT NULL,
  "resolution" text NOT NULL,
  "shape" text NOT NULL,
  "default_username" text NOT NULL DEFAULT '',
  "default_password" text NOT NULL DEFAULT '',
  "psia" text NOT NULL DEFAULT '',
  "onvif" integer NOT NULL DEFAULT '0',
  "ptz" integer NOT NULL DEFAULT '0',
  "infrared" integer NOT NULL DEFAULT '0',
  "varifocal" integer NOT NULL DEFAULT '0',
  "sd_card" integer NOT NULL DEFAULT '0',
  "upnp" integer NOT NULL DEFAULT '0',
  "poe" integer NOT NULL DEFAULT '0',
  "audio_in" integer NOT NULL DEFAULT '0',
  "audio_out" integer NOT NULL DEFAULT '0',
  "discontinued" integer NOT NULL DEFAULT '0',
  "wifi" integer NOT NULL DEFAULT '0',
  "images" text NOT NULL DEFAULT '',
  "official_url" text NOT NULL,
  FOREIGN KEY ("manufacturer") REFERENCES "manufacturers" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION
);


-- MANUFACTURERS --
INSERT INTO "manufacturers" VALUES ('1', 'Sercomm', 'sercomm');
INSERT INTO "manufacturers" VALUES ('2', 'Sricam', 'sricam');
INSERT INTO "manufacturers" VALUES ('3', 'Dropcam', 'dropcam');
INSERT INTO "manufacturers" VALUES ('4', 'Tenvis', 'tenvis');
INSERT INTO "manufacturers" VALUES ('5', 'GenIV', 'geniv');
INSERT INTO "manufacturers" VALUES ('6', 'StarVedia', 'starvedia');
INSERT INTO "manufacturers" VALUES ('7', 'CP Plus', 'cp-plus');
INSERT INTO "manufacturers" VALUES ('8', 'CNB', 'cnb');
INSERT INTO "manufacturers" VALUES ('9', 'Qvis', 'qvis');
INSERT INTO "manufacturers" VALUES ('10', 'Flir', 'flir');
INSERT INTO "manufacturers" VALUES ('11', 'Dericam', 'dericam');
INSERT INTO "manufacturers" VALUES ('12', 'Convision', 'convision');
INSERT INTO "manufacturers" VALUES ('13', 'Compro', 'compro');
INSERT INTO "manufacturers" VALUES ('14', 'Canon', 'canon');
INSERT INTO "manufacturers" VALUES ('15', 'Basler', 'basler');
INSERT INTO "manufacturers" VALUES ('16', 'Beward', 'beward');
INSERT INTO "manufacturers" VALUES ('17', '3S Vision', '3s-vision');
INSERT INTO "manufacturers" VALUES ('18', 'Brickcom', 'brickcom');
INSERT INTO "manufacturers" VALUES ('19', 'Teltonika', 'teltonika');
INSERT INTO "manufacturers" VALUES ('20', 'TP-Link', 'tp-link');
INSERT INTO "manufacturers" VALUES ('21', 'Ubiquiti', 'ubiquiti');
INSERT INTO "manufacturers" VALUES ('22', 'Afreey', 'afreey');
INSERT INTO "manufacturers" VALUES ('23', 'Agasio', 'agasio');
INSERT INTO "manufacturers" VALUES ('24', 'Aposonic', 'aposonic');
INSERT INTO "manufacturers" VALUES ('25', 'ABS', 'abs');
INSERT INTO "manufacturers" VALUES ('26', 'Asoni', 'asoni');
INSERT INTO "manufacturers" VALUES ('27', 'Wansview', 'wansview');
INSERT INTO "manufacturers" VALUES ('28', 'Linksys', 'linksys');
INSERT INTO "manufacturers" VALUES ('29', 'Dallmeier', 'dallmeier');
INSERT INTO "manufacturers" VALUES ('30', 'Dahua', 'dahua');
INSERT INTO "manufacturers" VALUES ('31', 'ABUS', 'abus');
INSERT INTO "manufacturers" VALUES ('32', 'Evercam', 'evercam');
INSERT INTO "manufacturers" VALUES ('33', 'Foscam', 'foscam');
INSERT INTO "manufacturers" VALUES ('34', 'Lumenera', 'lumenera');
INSERT INTO "manufacturers" VALUES ('35', 'Planet', 'planet');
INSERT INTO "manufacturers" VALUES ('36', 'ACTi', 'acti');
INSERT INTO "manufacturers" VALUES ('37', 'IQinVision', 'iqinvision');
INSERT INTO "manufacturers" VALUES ('38', 'AVTECH', 'avtech');
INSERT INTO "manufacturers" VALUES ('39', 'Airlive', 'airlive');
INSERT INTO "manufacturers" VALUES ('40', 'Arecont Vision', 'arecont-vision');
INSERT INTO "manufacturers" VALUES ('41', 'Sony', 'sony');
INSERT INTO "manufacturers" VALUES ('42', 'Vivotek', 'vivotek');
INSERT INTO "manufacturers" VALUES ('43', 'Panasonic', 'panasonic');
INSERT INTO "manufacturers" VALUES ('44', 'Mobotix', 'mobotix');
INSERT INTO "manufacturers" VALUES ('45', 'Zavio', 'zavio');
INSERT INTO "manufacturers" VALUES ('46', 'D-Link', 'd-link');
INSERT INTO "manufacturers" VALUES ('47', 'Siemens', 'siemens');
INSERT INTO "manufacturers" VALUES ('48', 'Grandstream', 'grandstream');
INSERT INTO "manufacturers" VALUES ('49', 'Y-cam', 'y-cam');
INSERT INTO "manufacturers" VALUES ('50', 'Axis', 'axis');
INSERT INTO "manufacturers" VALUES ('51', 'Samsung', 'samsung');
INSERT INTO "manufacturers" VALUES ('52', 'Hikvision', 'hikvision');

-- CAMERAS --
INSERT INTO "cameras" 
VALUES (NULL, 'm1004-w', 'm1004-w', '50', '', '', '', '', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, '4551', '4551', '1', '', '', '', '1080p', 'Cube', '', '', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/468/original/2e56c1de11d12e0bd81a48d56dda283f.jpg?1424268523";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/469/original/2fb1c46c534b01be14ab774043adce85.jpg?1424268525";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/467/original/6c1f711ec3dc2b5b536c5703919c5ef1.jpg?1426617565";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=382');
INSERT INTO "cameras" 
VALUES (NULL, 'oc431', 'OC431', '1', '', '', '', '720p', 'Cube', '', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/466/original/4235d32f78843b57d8c1e59a738326f9.jpg?1424268054";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/465/original/8ee2a3928b7266eb872e47fe7dbb6c2c.jpg?1426617568";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=381');
INSERT INTO "cameras" 
VALUES (NULL, '8321', '8321', '1', '', '', '', '720p', 'Cube', '', '', '', 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/464/original/aaa6275ae40faf44e9cf5e3885979927.jpg?1424267901";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/463/original/e59bba2db65a4c186a6118e2ee9a115a.jpg?1426617571";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=380');
INSERT INTO "cameras" 
VALUES (NULL, '8110', '8110', '1', '', '', '', '720p', 'Cube', '', '', '', 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/462/original/e56fe764a7ac7837873e8c5c27531237.jpg?1424267711";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/461/original/8c05a464ecefddcb6fe2f68808d51174.jpg?1426617574";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=379');
INSERT INTO "cameras" 
VALUES (NULL, 'shc-rc8261', 'SHC-RC8261', '1', '', '', '', '720p', 'Cube', '', '', '', 0, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/460/original/523cd52399d0f9f44711891d777b6eab.jpg?1424267504";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/459/original/61cdb4889bd46db518de612bb4d2154a.jpg?1426617577";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'shc-oc821', 'SHC-OC821', '1', '', '', '', '720p', 'Cube', '', '', '', 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/458/original/63c43f75fec762d435bbdad69065a95d.jpg?1424267296";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/457/original/5805d85141294ab0cdb5d996589ffdec.jpg?1426617581";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=100');
INSERT INTO "cameras" 
VALUES (NULL, 'shc-rc8221', 'SHC-RC8221', '1', '', '', '', '720p', 'Cube', '', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/455/original/3faccff05d6152e7364b18c741a70872.jpg?1424264351";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/456/original/309e4d438274ae4ec9421881b1c79d02.jpg?1424264352";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/454/original/5999065b4b25d260dc29d82c842d2851.jpg?1426617584";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=99');
INSERT INTO "cameras" 
VALUES (NULL, 'shc-rc8026', 'SHC-RC8026', '1', '', '', '', 'VGA', 'Cube', '', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/452/original/9a8e9275916b354d7ef32e5294602a4e.jpg?1424263665";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/453/original/cfd0b5a8eeb9e94eea2d73e23ce06539.jpg?1424263666";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/451/original/07938bbcaa07cb8f882a0b1c3f7a56a7.jpg?1426617588";}}', 'http://www.sercomm.com/contpage.aspx?langid=1&type=prod3&L1id=2&L2id=3&L3id=9&Prodid=98');
INSERT INTO "cameras" 
VALUES (NULL, 'snc-rz25p', 'SNC-RZ25P', '41', '', '', '', '320x240', 'Dome', '', '', '', 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/449/original/17ed0b82a031039c3b7f7382b6019f93.jpg?1424261496";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/448/original/735adf1ce3a34512395ea69c4816408b.jpg?1426618947";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2de5184-a3', 'DS-2DE5184-A3', '52', '', '', '', '1920×1080', 'Dome', '', '', '1', 1, 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/447/original/5a1b7d0aa1418f89132cc123c766dd63.jpg?1426619756";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ap002', 'AP002', '2', '', '', '', '', 'Box', '', '', '', 0, 0, 1, 0, 1, 0, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/444/original/7b1e63ddfab519d7c89fd4d84fc714c8.jpg?1426616315";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/443/original/2c3239dc66c3464277e77e44bd9594f8.jpg?1426616901";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/445/original/2b6ea1f394a4788fc1cce1a31f934db3.jpg?1422259641";}}', 'http://www.sricam.com/product/1137504576-219111891/Sricam_AP002_Wireless_Megapixel_32G_TF_SD_Card_P2P_IR_Wifi_Camera_720P_Wireless_Megapixel_IP_Camera.html');
INSERT INTO "cameras" 
VALUES (NULL, 'jpt3815w', 'JPT3815W', '4', '', '', '', '640x480', 'Cube', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/439/original/21046f720158e5b89a3a41fe42bb6d26.jpg?1422259118";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/440/original/cd529acc71b771049d557433fda8257e.jpg?1422259119";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/441/original/1af8bebcefdf93e5a2e709c44c7ebf8f.jpg?1422259120";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/438/original/d35f2bbfe28ac1eeb0a0eba05fc35f48.jpg?1426617017";}}', 'http://www.tenvis.com/jpt3815w-hot-sale-pantilt-ip-camera-night-vision-white-p-215.html');
INSERT INTO "cameras" 
VALUES (NULL, 'g4-ip20atc', 'G4-IP20ATC', '5', '/cgi-bin/mjpg/video.cgi?channel=0&subtype=0', '/cgi-bin/mjpg/video.cgi?channel=0&subtype=0', '/cam/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ic711w', 'IC711w', '6', '', '', '', '1280x800', 'Box', '', '', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/324/original/e9e268ff30dd2f6ea350b604198260f9.jpg?1426617294";}}', 'http://www.starvedia.com/ProductDetail_ic711w.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ic727w', 'IC727w', '6', '', '', '', '1280x800', 'Bullet', '', '', '', 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/323/original/205d5b17a5a291b5be1d0494c53fc946.jpg?1426617298";}}', 'http://www.starvedia.com/ProductDetail_ic727w.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ic737w', 'IC737w', '6', '', '', '', '1280x800', 'Dome', '', '', '', 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/322/original/a1a99bb525c2657669ea3f03a5ef25db.jpg?1426617289";}}', 'http://www.starvedia.com/ProductDetail_ic737w.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ic502wplus', 'IC502wPLUS', '6', '', '', '', '-', 'Dome', '', '', '', 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/321/original/6cffe69296e5346b06e0a46fa2fcb742.jpg?1426617285";}}', 'http://www.starvedia.com/ProductDetail_ic502wp.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ic717hd', 'IC717HD', '6', '', '', '', '1280x800', 'Box', '', '', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/320/original/46f1d2552c34cefab1458176cf928d43.jpg?1426617302";}}', 'http://www.starvedia.com/ProductDetail_ic717HD.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2030l15d', 'CP-UNP-2030L15D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2030l10d', 'CP-UNP-2030L10D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2030d', 'CP-UNP-2030D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-0320', 'CP-UNP-0320', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020l10', 'CP-UNP-2020L10', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020l10d', 'CP-UNP-2020L10D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020d', 'CP-UNP-2020D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020', 'CP-UNP-2020', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020fl15', 'CP-UNP-2020FL15', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020pl20', 'CP-UNP-2020PL20', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-3020sl10t', 'CP-UNP-3020SL10T', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020sl10t', 'CP-UNP-2020SL10T', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-3020fl15', 'CP-UNP-3020FL15', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-3020f', 'CP-UNP-3020F', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-3020sl10', 'CP-UNP-3020SL10', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2020sl10', 'CP-UNP-2020SL10', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-4212t', 'CP-UNP-4212T', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-4212e', 'CP-UNP-4212E', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2013sl10', 'CP-UNP-2013SL10', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2013s', 'CP-UNP-2013S', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-1813l10dh', 'CP-UNP-1813L10DH', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-1813l10d', 'CP-UNP-1813L10D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-1813dh', 'CP-UNP-1813DH', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-1813d', 'CP-UNP-1813D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-3013d', 'CP-UNP-3013D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-2813d', 'CP-UNP-2813D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-36l8d', 'CP-UNP-36L8D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-28l8d', 'CP-UNP-28L8D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-18l8d', 'CP-UNP-18L8D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-36l8', 'CP-UNP-36L8', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-23l8', 'CP-UNP-23L8', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-36d', 'CP-UNP-36D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-28d', 'CP-UNP-28D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-18d', 'CP-UNP-18D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-37', 'CP-UNP-37', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unp-23', 'CP-UNP-23', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unz-1810cd', 'CP-UNZ-1810CD', '7', '', '', '', '', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-e2234', 'CP-UNC-E2234', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnp-1820', 'CP-RNP-1820', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnp-36d', 'CP-RNP-36D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnp-12d', 'CP-RNP-12D', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnc-tp20fl3c', 'CP-RNC-TP20FL3C', '7', '', '', '', '', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnc-bp20c', 'CP-RNC-BP20C', '7', '', '', '', '', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnc-dp20fl2c', 'CP-RNC-DP20FL2C', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnc-dv20', 'CP-RNC-DV20', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-rnc-dv10', 'CP-RNC-DV10', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-bp50c', 'CP-UNC-BP50C', '7', '', '', '', '', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vp30fl2cd', 'CP-UNC-VP30FL2CD', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vp30fcd', 'CP-UNC-VP30FCD', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-tp30fl2cd', 'CP-UNC-TP30FL2CD', '7', '', '', '', '', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-bp30cd', 'CP-UNC-BP30CD', '7', '', '', '', '', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-by30c', 'CP-UNC-BY30C', '7', '', '', '', '', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-ty30fl3c', 'CP-UNC-TY30FL3C', '7', '', '', '', '', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-ty30fl2c', 'CP-UNC-TY30FL2C', '7', '', '', '', '', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy30fl2c', 'CP-UNC-VY30FL2C', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy30fc', 'CP-UNC-VY30FC', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v4342l3', 'CP-UNC-V4342L3', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t2322l2', 'CP-UNC-T2322L2', '7', '', '', '', '', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-d2322l2', 'CP-UNC-D2322L2', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t4352el3', 'CP-UNC-T4352EL3', '7', '', '', '', '', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-d4352l2', 'CP-UNC-D4352L2', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v4352', 'CP-UNC-V4352', '7', '', '', '', '', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-by20c', 'CP-UNC-BY20C', '7', '', '', '', '1920x1080', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=303&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-ty20zl2c', 'CP-UNC-TY20ZL2C', '7', '', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=592&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-ty20fl2c', 'CP-UNC-TY20FL2C', '7', '', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=304&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-ty20l2c', 'CP-UNC-TY20L2C', '7', '', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=553&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy20zl2c', 'CP-UNC-VY20ZL2C', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=552&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy20zc', 'CP-UNC-VY20ZC', '7', '', '', '', '1280x960', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=551&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy20fl2c', 'CP-UNC-VY20FL2C', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/709/original/59e573258fb0ae0b3bd5e46654064a6c.jpg?1426620094";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=550&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy20fc', 'CP-UNC-VY20FC', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:114:"http://s3.amazonaws.com/cambase/images/files/000/007/739/original/85928f3cf67c67b4d73b8f9d023bfc90.jpeg?1426620104";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=549&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy20', 'CP-UNC-VY20', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/738/original/c94e71fe9fa0ec28c76d74bb1671b704.jpg?1426620086";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=302&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-b5254s', 'CP-UNC-B5254S', '7', '', '', '', '1920x1080', 'Box', '', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/737/original/aa4cc6e10530f9e744d5d7d2fe59133f.jpg?1426620075";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=879&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v5254l2t', 'CP-UNC-V5254L2T', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/736/original/b039f81f80efa062e1c2fd408d747cf6.jpg?1426620066";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=860&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dy20fl2c', 'CP-UNC-DY20FL2C', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/735/original/e6fea7e0b10f684bdfb0aa22735b90bd.jpg?1426620060";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=831&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dy20fc', 'CP-UNC-DY20FC', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/688/original/854551bf0bba53845b79e5ce46f7bea4.jpg?1426620045";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=830&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t5254l5', 'CP-UNC-T5254L5', '7', '', '', '', '1920x1080', 'Bullet', '', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/694/original/be83c7ca878a656cd4fef0afd5b645c2.jpg?1426620036";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=770&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t5254l10', 'CP-UNC-T5254L10', '7', '', '', '', '1920x1080', 'Bullet', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/692/original/7ed1ee95a700396741dbb35b7bc31aab.jpg?1426620029";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=768&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v5254l2', 'CP-UNC-V5254L2', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/734/original/6ddc8d95ebb20d3f28594a447b66a9cb.jpg?1426620053";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=767&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t5254l3', 'CP-UNC-T5254L3', '7', '', '', '', '1920x1080', 'Bullet', '', '', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/693/original/bdc2762a97aa1457cedb4342a69bfc20.jpg?1426620022";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=766&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-b5254', 'CP-UNC-B5254', '7', '', '', '', '1920x1080', 'Box', '', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/670/original/db581b1003133d60d3bdac23eb6fc830.jpg?1426620007";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=765&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dp20l2c', 'CP-UNC-DP20L2C', '7', '', '', '', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/687/original/c074675d3ddc0cdb6a7fdde03c3fb66d.jpg?1426619997";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=65&pid=738&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-bp13cd', 'CP-UNC-BP13CD', '7', '', '', '', '1280x960', 'Box', '', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/673/original/a83d37f2416b67281779caab8428a4c6.jpg?1426619989";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=64&pid=548&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-tp13fl2cd', 'CP-UNC-TP13FL2CD', '7', '', '', '', '1280x960', 'Bullet', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/696/original/d4ee6b6bff492ed7dd8bffd6fad74dbf.jpg?1426619979";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=64&pid=547&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vp13fl2cd', 'CP-UNC-VP13FL2CD', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/706/original/59ebf3643ecdfb4516440636a41d42ca.jpg?1426619972";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=64&pid=546&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vp13fcd', 'CP-UNC-VP13FCD', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/703/original/604ab2d236be04ca88efd2bb4ea5f61d.jpg?1426619965";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=64&pid=545&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-bp13c', 'CP-UNC-BP13C', '7', '', '', '', '1280x960', 'Box', '', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:114:"http://s3.amazonaws.com/cambase/images/files/000/007/672/original/ecb96348d81c4b4f61ea513e67e25081.jpeg?1426619957";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=301&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-tp13l3c', 'CP-UNC-TP13L3C', '7', '', '', '', '1280x960', 'Bullet', '', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/697/original/003e14ed1df2875da02cd00423735e9a.jpg?1426619947";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=591&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-bp10c', 'CP-UNC-BP10C', '7', '', '', '', '1280x960', 'Box', '', '', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/671/original/c93fe06899268fa62c8af834fab7962e.jpg?1426619941";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=372&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vp13fl2c', 'CP-UNC-VP13FL2C', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/704/original/33a54228b54639ad2c7631b7d4d7d902.jpg?1426619934";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=590&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vp13fc', 'CP-UNC-VP13FC', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/702/original/575c481692cfc4cc6ecff3c0ae7757e9.jpg?1426619926";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=589&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-tp10l2c', 'CP-UNC-TP10L2C', '7', '', '', '', '1280x960', 'Bullet', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/695/original/783071937607a7fffc190801020dc038.jpg?1426619917";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=300&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dp13fl2c', 'CP-UNC-DP13FL2C', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/686/original/5aec99ca928acddfc862f6e802220670.jpg?1426619909";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=588&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dp10l2c', 'CP-UNC-DP10L2C', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/684/original/6146606fa581a5b998b0f8a792a92f1b.jpg?1426619900";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=337&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dp10', 'CP-UNC-DP10', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/683/original/7657a59db7994f92644e5b30298d0c04.jpg?1426619891";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=299&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-dp13fc', 'CP-UNC-DP13FC', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/685/original/8b9421bd359b910ee1f29e70eccf8333.jpg?1426619882";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=587&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v4142l3', 'CP-UNC-V4142L3', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/700/original/c94216b8493856c3fc66da0e28a41815.jpg?1426619873";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=880&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t5142l3', 'CP-UNC-T5142L3', '7', '', '', '', '1280x960', 'Bullet', '', '', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/691/original/0915bfa160e93a218b631263e0576991.jpg?1426619864";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=769&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v5142l2', 'CP-UNC-V5142L2', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/701/original/0c016ba4cf28b41127c97e9504097a4f.jpg?1426619857";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=762&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t4142l3', 'CP-UNC-T4142L3', '7', '', '', '', '1280x960', 'Bullet', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/690/original/a8a6522edb5290e3b8fd7005a1d30619.jpg?1426619849";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=754&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-d4142l2', 'CP-UNC-D4142L2', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/682/original/aa9556203ebf63d75a02c75e14b63ee5.jpg?1426619841";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=753&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-v4142', 'CP-UNC-V4142', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/699/original/6154ff38e97f531ef36c940b1b504028.jpg?1426619833";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=63&pid=752&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-by10c', 'CP-UNC-BY10C', '7', '', '', '', '1280x960', 'Box', '', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/674/original/73d95c15d86e7935695678bd88134e2f.jpg?1426619824";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=62&pid=544&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-ty10fl5c', 'CP-UNC-TY10FL5C', '7', '', '', '', '1280x960', 'Bullet', '', '', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/698/original/d36ac8a8630c55a4044bf67ba1693c0a.jpg?1426619816";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=62&pid=543&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy10fl2c', 'CP-UNC-VY10FL2C', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/708/original/d49f2bee25eec705d120102cd2813e04.jpg?1426619809";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=62&pid=542&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-vy10fc', 'CP-UNC-VY10FC', '7', '', '', '', '1280x960', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/707/original/ed2049bc3ae4f77b8c5708a008e0bc74.jpg?1426619801";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=62&pid=541&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-cp10l1w', 'CP-UNC-CP10L1W', '7', '', '', '', '1280x720', 'Cube', '', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/677/original/444f02425aca39da0654188d8155ee90.jpg?1426619794";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=540&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-cp10l1a', 'CP-UNC-CP10L1A', '7', '', '', '', '1280x720', 'Cube', '', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/676/original/0ea53fd6ad1d980799e35acf330d9635.jpg?1426619788";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=539&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-cp10l1', 'CP-UNC-CP10L1', '7', '', '', '', '1280x720', 'Cube', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/675/original/c658e086b590daf1c913dc9c088213be.jpg?1426619781";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=538&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-t1011l2', 'CP-UNC-T1011L2', '7', '', '', '', '1280x720', 'Bullet', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/689/original/87b217d76b521eac06185f4233e698a1.jpg?1426619774";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=784&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-d1011l2', 'CP-UNC-D1011L2', '7', '', '', '', '1280x720', 'Dome', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/681/original/be686f29f2a03aeedd560c84ecce002f.jpg?1426619767";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=783&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-d1011', 'CP-UNC-D1011', '7', '', '', '', '1280x720', 'Dome', '', '', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/680/original/1ed6c2a8982666fe4bf12bac99559586.jpg?1426619760";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=782&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-cs10l1w', 'CP-UNC-CS10L1W', '7', '', '', '', '1280x720', 'Cube', '', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/679/original/ac30f4b95ceeb91f85388684f88aa7ff.jpg?1426619753";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=781&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-unc-cs10l1', 'CP-UNC-CS10L1', '7', '', '', '', '1280x720', 'Cube', '', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/678/original/2313e7ac2b4fb0cb24203d6c1a09ca23.jpg?1426620014";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=780&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-knc-cv10w', 'CP-KNC-CV10W', '7', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/669/original/2f122698d43b438e020444a813039532.jpg?1426620114";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=241&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'cp-knc-cv10', 'CP-KNC-CV10', '7', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/668/original/f4ece9eb6926f4cc3907c33d39634dfd.jpg?1426619746";}}', 'http://www.cpplusworld.com/product-details.aspx?mpgid=3&pgidtrail=3&mcid=14&cid=61&pid=240&langid=1');
INSERT INTO "cameras" 
VALUES (NULL, 'ismc1063p', 'ISMC1063P', '8', '', '', '', '704x576', 'Dome', 'root', 'admin', '', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/987/original/1b40f81387b8aa6f276662a15ce6de07.jpg?1416380041";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/988/original/ad8aaa0f44357e947f297adc7dabdcab.jpg?1416380043";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/986/original/58eaed24e47e982c88dbc25300c10b75.gif?1426618993";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1186');
INSERT INTO "cameras" 
VALUES (NULL, 'ismc1063n', 'ISMC1063N', '8', 'jpg/image.jpg', '', '', '704x480', 'Dome', 'root', 'admin', '', 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/998/original/c9ebc26f91d220bf7ac3c570ee4bc3d7.gif?1426618986";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/999/original/ac33a1c98c61d3cdcf37f42c8a79e791.jpg?1416380143";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/000/original/314152514953c6446ceabf71ea4681eb.jpg?1416380145";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1186');
INSERT INTO "cameras" 
VALUES (NULL, 'iss2765pw', 'ISS2765PW', '8', 'jpg/image.jpg', '', '', '704x576', 'Dome', 'root', 'admin', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/028/original/c668baba42971da497c15e2d904a3f90.gif?1416380318";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/029/original/94da311fd353ba3548c211b9a49bc028.gif?1416380320";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/027/original/50e1a6cc790b03daabb4f04942270300.gif?1426618825";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1184');
INSERT INTO "cameras" 
VALUES (NULL, 'iss2765nw', 'ISS2765NW', '8', 'jpg/image.jpg', '', '', '704x480', 'Dome', 'root', 'admin', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/044/original/bea3ad157e833ae5e0409c3f3530c100.gif?1416380401";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/045/original/3ffd88b5cd67acde697e72baddc83914.gif?1416380403";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/046/original/a5e36e0be1f8559cd8fa7b720e72c8ce.gif?1416380405";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/043/original/2782e186afb2f6ebd87554a678fd217d.gif?1426618831";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1184');
INSERT INTO "cameras" 
VALUES (NULL, 'iss2965pw', 'ISS2965PW', '8', 'jpg/image.jpg', '', '', '704x576', 'Dome', 'root', 'admin', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/054/original/b88e32a0c12ad297039bf974b8d0f213.gif?1416380462";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/053/original/bc1880d622e24d095e5d89cbbfdbb2f5.gif?1426618838";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1255');
INSERT INTO "cameras" 
VALUES (NULL, 'iss2965nw', 'ISS2965NW', '8', 'jpg/image.jpg', '', '', '704x480', 'Dome', 'root', 'admin', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/067/original/1920ce1d5f2048d926161c92e38832cf.gif?1416380558";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/068/original/a2119a3b3ead08ec6e19daafc0954e70.gif?1416380560";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/066/original/d9c6e44d1c632b8932f3f63f0b26e13f.gif?1426618844";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1255');
INSERT INTO "cameras" 
VALUES (NULL, 'ipm3063p', 'IPM3063P', '8', 'jpg/image.jpg', '', '', '704x576', 'Dome', 'root', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/078/original/5177b909f086ce3f8b83208484ccda40.jpg?1416380623";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/079/original/b30c2367718d337cd55a9c6e6c86a2da.jpg?1416380624";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/077/original/a38b75826241ed031192e864516c307e.jpg?1426618850";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1214');
INSERT INTO "cameras" 
VALUES (NULL, 'ipm3063n', 'IPM3063N', '8', 'jpg/image.jpg', '', '', '704x480', 'Other', 'root', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/081/original/93ae753e3e1fbc723d2db719dcf555ef.jpg?1416380669";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/082/original/aba842ce93149f91e168d79b3a632cd6.jpg?1416380670";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/080/original/ec0ed9ac261db59f75c616e93f863555.jpg?1426618855";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1214');
INSERT INTO "cameras" 
VALUES (NULL, 'mss4052z20w', 'MSS4052Z20W', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/083/original/e8341b905d4204a7cce62c63992436e8.jpg?1426618999";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1531');
INSERT INTO "cameras" 
VALUES (NULL, 'qss6052z30w', 'QSS6052Z30W', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/084/original/83510166f9ed211cdd8dc79af60af07d.jpg?1426618859";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1557');
INSERT INTO "cameras" 
VALUES (NULL, 'ibp5030cr', 'IBP5030CR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Bullet', 'root', 'admin', '', 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/085/original/25c5c89aa8891280993a136d253d0637.jpg?1426618863";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1281');
INSERT INTO "cameras" 
VALUES (NULL, 'ixc2050ir', 'IXC2050IR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Bullet', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/087/original/1f3530b53e6ffb1f978b705ff86af7c3.jpg?1416381259";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/086/original/5b3a9f9f81f9193b3d81eaeba218796b.jpg?1426618868";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1408');
INSERT INTO "cameras" 
VALUES (NULL, 'ixp3035vr', 'IXP3035VR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Bullet', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/088/original/8145e3550273f043d3c8d6dabf58f1e8.jpg?1426618872";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1409');
INSERT INTO "cameras" 
VALUES (NULL, 'nxe3055vr', 'NXE3055VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Bullet', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/089/original/01da15800be5cce813d44878c8264601.jpg?1426618876";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1470');
INSERT INTO "cameras" 
VALUES (NULL, 'nxe3055mr', 'NXE3055MR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Bullet', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/090/original/1e2fe7e6ce01053c8b4b3e34f282f101.jpg?1426618880";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1473');
INSERT INTO "cameras" 
VALUES (NULL, 'mxc6050ir', 'MXC6050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Bullet', 'root', 'admin', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/091/original/bf321a4dfebdbb95c11cc4b97b6e3437.jpg?1426618884";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1536');
INSERT INTO "cameras" 
VALUES (NULL, 'mxc6050vr', 'MXC6050VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Bullet', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/092/original/9026bca916e14e329a1d592c6f1eb964.jpg?1426618889";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1537');
INSERT INTO "cameras" 
VALUES (NULL, 'lxc1050ir', 'LXC1050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Bullet', 'root', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/094/original/49186b331875aaf6ca6454a018775f12.jpg?1416381454";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/093/original/78f31af219e7866d84bce8779067141e.jpg?1426618893";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1543');
INSERT INTO "cameras" 
VALUES (NULL, 'lxc2050vr', 'LXC2050VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Bullet', 'root', 'admin', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/095/original/59eb02e2e5acb38fb73f5b41c1fa8666.jpg?1426618897";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1554');
INSERT INTO "cameras" 
VALUES (NULL, 'ite1050', 'ITE1050', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Other', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/097/original/33e8563a462b9308fbb64a6cb62d6b46.jpg?1416381530";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/096/original/9acc62fd06032c069bc6af5f16e042c6.jpg?1426618902";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1474');
INSERT INTO "cameras" 
VALUES (NULL, 'mpc1050ir', 'MPC1050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/099/original/5b22c9e38f2b572eb9db163e60f2c116.jpg?1416381565";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/098/original/6d496dd77a6fb7cf1763d663be019d51.jpg?1426618906";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1538');
INSERT INTO "cameras" 
VALUES (NULL, 'mpc1070pn', 'MPC1070PN', '8', 'jpg/image.jpg', '', '', '2592x1944', 'Dome', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/101/original/0e92fdf4ab8c150c8d580ea90b0eb7d7.jpg?1416381604";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/100/original/44d8d1803258e8589f59009af6675a69.jpg?1426618910";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1539');
INSERT INTO "cameras" 
VALUES (NULL, 'lkc1050ir', 'LKC1050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/102/original/0ea9535743cf10cd8ced395e048d95a4.jpg?1426618915";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1555');
INSERT INTO "cameras" 
VALUES (NULL, 'lpc1050ir', 'LPC1050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/103/original/799dc46a953aa9609bef592da2f70906.jpg?1426618920";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1556');
INSERT INTO "cameras" 
VALUES (NULL, 'ivp4000vr', 'IVP4000VR', '8', 'jpg/image.jpg', '', '', '640x480', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/104/original/f9caa6a1e16e2e80f469aae283ee8f64.jpg?1416381714";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/105/original/fe14ef352f520e0f568377af18bddf98.jpg?1416381715";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/106/original/6d3850bcc3ff7e5377a8c55afe20020a.gif?1416381716";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/107/original/18d7ed9e797025751c8ea0eb88ee0a1f.gif?1416381720";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1174');
INSERT INTO "cameras" 
VALUES (NULL, 'ivb4110pvf', 'IVB4110PVF', '8', 'jpg/image.jpg', '', '', '704x576', 'Dome', 'root', 'admin', '', 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/109/original/27b0d2f12f1124cdb277ab35307adff2.gif?1416381767";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/110/original/480a54d43e136d27d493bf24728c071d.gif?1416381770";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/108/original/95887d8f7b86ca830665750791947e0c.jpg?1426618930";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1292');
INSERT INTO "cameras" 
VALUES (NULL, 'ivb4110nvf', 'IVB4110NVF', '8', 'jpg/image.jpg', '', '', '704x480', 'Dome', 'root', 'admin', '', 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/112/original/da2afafd4e62e91878a81e9fc4957ab3.gif?1416381812";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/113/original/fde0241b9f8fb2f0e6d1e80956c8e98d.gif?1416381814";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/111/original/a807a314a16eb3ced6d37bd483dcd67e.jpg?1426618934";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1292');
INSERT INTO "cameras" 
VALUES (NULL, 'ivp4030vr', 'IVP4030VR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/115/original/bb7d5c6c91b99ed8bd889b2c8bbc1a1d.jpg?1416381861";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/116/original/7623838de51a5d2672fb440c5ef03a3f.gif?1416381861";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/114/original/de7970448e6d465d695b16aa24d3b314.jpg?1426618939";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1182');
INSERT INTO "cameras" 
VALUES (NULL, 'ivp5035vr', 'IVP5035VR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/615/original/affb8df9a65dbfe69662ab25d65b88d7.jpg?1426618982";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1407');
INSERT INTO "cameras" 
VALUES (NULL, 'ivc5055vr', 'IVC5055VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/614/original/e66c3277a1ab055e8c404f4c77640042.jpg?1426618977";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1340');
INSERT INTO "cameras" 
VALUES (NULL, 'nve5055vr', 'NVE5055VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/629/original/41d1911ccac9ffd328cc3c4e69d6ace0.jpg?1416305778";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/628/original/1c8c6701184d9b7098b89aba7c6c23e0.jpg?1426618972";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1469');
INSERT INTO "cameras" 
VALUES (NULL, 'nve5055mf', 'NVE5055MF', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/627/original/e028e19ce7e1ecea42cc9d7b1c12fe71.jpg?1426618968";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1472');
INSERT INTO "cameras" 
VALUES (NULL, 'mvc4050vr', 'MVC4050VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/623/original/8433875cc14326f7d534605fa430e5ac.jpg?1426618963";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1535');
INSERT INTO "cameras" 
VALUES (NULL, 'idc4000t', 'IDC4000T', '8', 'jpg/image.jpg', '', '', '640x480', 'Dome', 'root', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/591/original/819e5ce244bb0b38fdfe2af87ede1180.jpg?1426618958";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1253');
INSERT INTO "cameras" 
VALUES (NULL, 'idp4000vd', 'IDP4000VD', '8', 'jpg/image.jpg', '', '', '640x480', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/597/original/6282ff0f9b2820a2778d2070ed06610c.jpg?1426618953";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1172');
INSERT INTO "cameras" 
VALUES (NULL, 'idp4000vr', 'IDP4000VR', '8', 'jpg/image.jpg', '', '', '640x480', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/598/original/e3746a7065b53adc33f2700659f78f7a.gif?1426618948";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/599/original/684e879fd7658dc60ac20ec84f97da9c.jpg?1416305676";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/600/original/f10520ac22dde6a1b0683b3e81f4ce52.gif?1416305678";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/601/original/4ccfa9df3cba6cece7faec85e6abf5d3.jpg?1416305681";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1173');
INSERT INTO "cameras" 
VALUES (NULL, 'idb4110pvf', 'IDB4110PVF', '8', 'jpg/image.jpg', '', '', '704x576', 'Dome', 'root', 'admin', '', 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/590/original/992eaa53a66a2bbdfe3679f934aadfc1.jpg?1416305648";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/589/original/cfe5bc0ee05bc28d6d99871691f12e57.jpg?1426618943";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1291');
INSERT INTO "cameras" 
VALUES (NULL, 'idb4110nvf', 'IDB4110NVF', '8', 'jpg/image.jpg', '', '', '704x480', 'Dome', 'root', 'admin', '', 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/588/original/de4e063393b938e714bee260935d7683.jpg?1416305642";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/587/original/fe0fa48dcae241cc1e70108b8b7f09f9.jpg?1426618821";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1291');
INSERT INTO "cameras" 
VALUES (NULL, 'idp4030vr', 'IDP4030VR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/602/original/a6523bb658441bf6e76981dd3c8947eb.gif?1426618814";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/603/original/4a6ed3bbef60eb3c32c7bd94864c4c19.jpg?1416305689";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/604/original/70aae5fde117d818e2f4f0e4adb90c30.gif?1416305691";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/605/original/2efc3339519d7a64030d5e882ad76105.jpg?1416305693";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1183');
INSERT INTO "cameras" 
VALUES (NULL, 'idc4050f', 'IDC4050F', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/593/original/42065399d1aa09a10c8be3cb66e96b3a.jpg?1416305656";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/592/original/e388c69a5b628e53ff8da876cf78acbe.jpg?1426618810";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1275');
INSERT INTO "cameras" 
VALUES (NULL, 'idc4050vf', 'IDC4050VF', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/595/original/9d83b050f056c2124c72d86f815dee61.jpg?1426618805";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1279');
INSERT INTO "cameras" 
VALUES (NULL, 'idc4050ir', 'IDC4050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/594/original/1a8d183e77111a78617c365ff691b81b.jpg?1426618800";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1274');
INSERT INTO "cameras" 
VALUES (NULL, 'idc4050vr', 'IDC4050VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/596/original/8251c3f9308b7284c3e8b4a8368a7702.jpg?1426618796";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1280');
INSERT INTO "cameras" 
VALUES (NULL, 'idp5035vr', 'IDP5035VR', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/606/original/a6bfa5f52635b9b1539c89160f255838.jpg?1426618791";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1406');
INSERT INTO "cameras" 
VALUES (NULL, 'nde5055vr', 'NDE5055VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/625/original/c63fe1a9d422dadd1c664c5c1e414b74.jpg?1426618787";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1468');
INSERT INTO "cameras" 
VALUES (NULL, 'nde5055mf', 'NDE5055MF', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/624/original/53535cf41ef0a4b5320277e2673b4719.jpg?1426618782";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1471');
INSERT INTO "cameras" 
VALUES (NULL, 'mdc4050ir', 'MDC4050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/620/original/75a5bd445c6b7bb17da2d9abb0c261b0.jpg?1426618778";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1533');
INSERT INTO "cameras" 
VALUES (NULL, 'mdc4050vr', 'MDC4050VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/621/original/107fd7419014c1bae7672138bef489b0.jpg?1426618773";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1534');
INSERT INTO "cameras" 
VALUES (NULL, 'ldc3050ir', 'LDC3050IR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/618/original/546dc4dddaa748bebd4cc15bfe4f56eb.jpg?1426618769";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1544');
INSERT INTO "cameras" 
VALUES (NULL, 'ldc3050vr', 'LDC3050VR', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Dome', 'root', 'admin', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/619/original/d96baf06cbd895a3444f22afe4240b41.jpg?1426618764";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1553');
INSERT INTO "cameras" 
VALUES (NULL, 'igp1000f', 'IGP1000F', '8', 'jpg/image.jpg', '', '', '640x480', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/611/original/b74eca564e7e17f5320b802e3c15620f.jpg?1426618759";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1250');
INSERT INTO "cameras" 
VALUES (NULL, 'igb1110pf', 'IGB1110PF', '8', 'jpg/image.jpg', '', '', '704x576', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/609/original/6e762adbdc0cc13e774b28e472e72263.jpg?1426618753";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1290');
INSERT INTO "cameras" 
VALUES (NULL, 'igb1110nf', 'IGB1110NF', '8', 'jpg/image.jpg', '', '', '704x480', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/608/original/694e88481accfbc5b6fe2ff21b177eb6.jpg?1416305702";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/607/original/8760a3bf44a3dbc7e5b3d6c3733df9e1.jpg?1426618749";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1290');
INSERT INTO "cameras" 
VALUES (NULL, 'igp1030', 'IGP1030', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/612/original/06081f192256123ad701690e0ebb5196.jpg?1426618744";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1169');
INSERT INTO "cameras" 
VALUES (NULL, 'igp2035f', 'IGP2035F', '8', 'jpg/image.jpg', '', '', '1280x1024', 'Box', 'root', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/613/original/29283f26bc15d507c4e76cb86863985e.jpg?1426618740";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1405');
INSERT INTO "cameras" 
VALUES (NULL, 'igc2050f', 'IGC2050F', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/610/original/f71d7ac6a8b5fea57b79c997352b2ac9.jpg?1426618736";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1278');
INSERT INTO "cameras" 
VALUES (NULL, 'nge2055f', 'NGE2055F', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/626/original/f95cd99f90b56536232c50512192d46e.jpg?1426618731";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1467');
INSERT INTO "cameras" 
VALUES (NULL, 'mgc6050f', 'MGC6050F', '8', 'jpg/image.jpg', '', '', '1920x1080', 'Box', 'root', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/622/original/e53e2d90c6b9b18a0cb83075b805a766.jpg?1426618727";}}', 'http://www.cnbtec.com/en/html/product/product.php?seqx_prod=1532');
INSERT INTO "cameras" 
VALUES (NULL, 'ptz-ir20-3mp-af', 'PTZ-IR20-3MP-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/171/original/01c503d87bace6b288c77b9598be013f.jpg?1426618523";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ipptz-12-int', 'IPPTZ-12-INT', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '-', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/172/original/dbfb8aebf9b45260a6503bb7f6f8a99a.jpg?1426618459";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'apoptz-18ir', 'APOPTZ-18IR', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '-', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/173/original/c7fb031d512948a862ae59f6669c7f03.jpg?1426618528";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'apohd-ptz20', 'APOHD-PTZ20', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '-', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/174/original/8d98e8c36ede81380993a2b110de4e87.jpg?1426618533";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ptz-ir12a-2-af', 'PTZ-IR12A-2-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '-', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/175/original/f31fe3f117c40f1eeda906ae045f0545.jpg?1426618537";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ipptz-12-ext', 'IPPTZ-12-EXT', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '-', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/176/original/ca355f9f427b4f7e57a96b5424799be4.jpg?1426618615";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-mb3-af', 'AMB-MB3-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/177/original/b1281240a7db820dd943577a058a9d6e.jpg?1426618542";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-mb3', 'AMB-MB3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/178/original/1a0f0db855b870bdadc4b279561f1438.jpg?1426618547";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-eye3-af', 'AMB-EYE3-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/179/original/6dfccfafa55c08bbe5103854d5e50b13.jpg?1426618552";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-blir3', 'AMB-BLIR3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/180/original/d56fe4d9c0d556a5d2f2dd15d36852b9.jpg?1426618558";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-bl3', 'AMB-BL3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/181/original/d5a9f482314ca798cc33af65245b5b98.jpg?1426618562";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'proip-vanir-2', 'PROIP-VANIR-2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/182/original/0a58f8f99d40258f279d8ba6ef81a149.jpg?1426618567";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'proip-mb2', 'PROIP-MB2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/183/original/81d8a30cd5bf8620da1932e5db0550c8.jpg?1426618572";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'proip-eye2', 'PROIP-EYE2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/184/original/11576f154c84a7b3a8ae8a94e0b7e953.jpg?1426618576";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'proip-bl2', 'PROIP-BL2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/185/original/f6a64621453aad2b11691fc2e5ada0c0.jpg?1426618583";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccvan-2801', 'CCVAN-2801', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/186/original/a8d1e2619a42fae5d283822f313f7f7a.jpg?1426618620";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccp400-2802', 'CCP400-2802', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/187/original/119ff7452f20027251f1f4177376a1e0.jpg?1426618595";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccp400-2801', 'CCP400-2801', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/188/original/3dc35e0e46e1e5bfc07e63a08dec8ccc.jpg?1426618599";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-vanirm2-af', 'AMB-VANIRM2-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/189/original/1376fe13501a66769b5e5d926162402a.jpg?1426618605";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-vanir2-af', 'AMB-VANIR2-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/190/original/1fb786fe2324e1b680f82b2b65a567ed.jpg?1426618610";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-vanir2', 'AMB-VANIR2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/191/original/92a95e9f291286d3fd2950befc6c5411.jpg?1426618627";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-mb2-af', 'AMB-MB2-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/192/original/5a3561858c2ca1d04e4143ed8241262e.jpg?1426618464";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-mb2', 'AMB-MB2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/193/original/10a4c7a0f7586d52eb9f8dcec57a352f.jpg?1426618468";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-eye2-af', 'AMB-EYE2-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/194/original/1cae2a364f5bddb7245d22c677a31ce1.jpg?1426618473";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-eye2', 'AMB-EYE2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/195/original/ce64a1b1a0a2f9688aee64061fbece44.jpg?1426618479";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-blm2', 'AMB-BLM2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/196/original/4072641a04cb99c49588319a6c2eae6c.jpg?1426618483";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-bl2', 'AMB-BL2', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/197/original/5fd0442662ce165a86c008cd335d4870.jpg?1426618488";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-vanir13', 'AMB-VANIR1.3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/198/original/088afa7cc918e5f7ee0014ce9fdf0395.jpg?1426618517";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-md13', 'AMB-MD1.3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/199/original/a46c2f097fb22fed5de2f6de45be3eb5.jpg?1426618492";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-mb13-af', 'AMB-MB1.3-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/200/original/aaec0f2c743413cacb017ab8016291f2.jpg?1426618632";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-mb13', 'AMB-MB1.3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/201/original/f3306dcf64b428ed3ea16bf02cea0edc.jpg?1426618498";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-eye13-af', 'AMB-EYE1.3-AF', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/202/original/5c5a1f9cd3f3ecfa57ed7a2a8c68f5a0.jpg?1426618503";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-eye13', 'AMB-EYE1.3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/203/original/333f50e76a17e8c901f40e07d3159df1.jpg?1426618508";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'amb-bl13', 'AMB-BL1.3', '9', 'cgi-bin/snapshot.cgi', '', 'cam/realmonitor', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/204/original/44271e4e0f2b81e6cb485e83d43a3bdb.jpg?1426618512";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'dnb14tl2', 'DNB14TL2', '10', '', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/435/original/1fb294b6b7ef5c0db2361a37a45ba2c4.jpg?1426617773";}}', 'http://www.flirsecurity.com/pro/product/dnb14tl2-ip-ir-varifocal-bullet-camera-onvif-poe-sd/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnv14tl2', 'DNV14TL2', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/441/original/1a315cafa50d58c7d1f49b9daa9487dc.jpg?1426617769";}}', 'http://www.flirsecurity.com/pro/product/dnv14tl2-ip-varifocal-vandal-ir-dome-h264-onvif-poe-1080p/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnd13tl2', 'DND13TL2', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/438/original/f6c89c2069711cd75f606746e188c31a.jpg?1426617766";}}', 'http://www.flirsecurity.com/pro/product/dnd13tl2-hd-ip-mini-dome-ir-camera-onvif-1080-sony-exmor-2mp-tdn-poe/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnb13tf2', 'DNB13TF2', '10', '', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/433/original/4cc16efa86d5d291f3716821cb9dc411.jpg?1426617763";}}', 'http://www.flirsecurity.com/pro/product/dnb13tf2-hd-ip-ir-bullet-camera-onvif-poe-mobile-apps/');
INSERT INTO "cameras" 
VALUES (NULL, 'dne14tl2', 'DNE14TL2', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/440/original/3a61a7f1cdcda696d8ba2bfae09c9c62.jpg?1426617760";}}', 'http://www.flirsecurity.com/pro/product/dne14tl2-ip-varifocal-eyeball-ir-dome-tdn-onvif-poe-1080p/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnb13tl2', 'DNB13TL2', '10', '', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/434/original/0ef5ae851ec30d728c2b833f379b7ff0.jpg?1426617756";}}', 'http://www.flirsecurity.com/pro/product/dnb13tl2-ip-varifocal-compact-ir-bullet-tdn-onvif-poe-1080p/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnv14ux2', 'DNV14UX2', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/442/original/ddbb3fffa68f7fa99f6b6291b7665033.jpg?1426617753";}}', 'http://www.flirsecurity.com/pro/product/dnv14ux2-ul-rated-hd-1080p-vandal-varifocal-dome-ip-camera-arcticpro/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnb14ux2', 'DNB14UX2', '10', '', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/436/original/c8687dd29bebb3a9cf00b2d466964a7c.jpg?1426617750";}}', 'http://www.flirsecurity.com/pro/product/dnb14ux2-ul-rated-hd-1080p-varifocal-ir-bullet-ip-camera-arcticpro/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnv16m2', 'DNV16M2', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/443/original/ee54de5aa1bd99dca5f27b275b4dd1ab.jpg?1426617746";}}', 'http://www.flirsecurity.com/pro/product/dnv16m2-hd-motorized-lens-ip-dome-camera-autofocus/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnb16m2', 'DNB16M2', '10', '', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/437/original/5a3e3dc8ce3f628636bc4332097fc6d0.jpg?1426617743";}}', 'http://www.flirsecurity.com/pro/product/dnb16m2-hd-motorized-lens-ip-bullet-camera-autofocus/');
INSERT INTO "cameras" 
VALUES (NULL, 'dnz30tl2r', 'DNZ30TL2R', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/444/original/b65514fdf57e7c0440aa8efeca8eda26.jpg?1426617739";}}', 'http://www.flirsecurity.com/pro/product/dnb16m2-hd-motorized-lens-ip-bullet-camera-autofocus/');
INSERT INTO "cameras" 
VALUES (NULL, 'dne12tl2', 'DNE12TL2', '10', '', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/439/original/8962d2a8a12391b1300971f48279b10b.jpg?1426617736";}}', 'http://www.flirsecurity.com/pro/product/dne12tl2-hd-ip-ir-dome-camera-onvif-poe-mobile-apps/');
INSERT INTO "cameras" 
VALUES (NULL, 'h201c-tm', 'H201C-TM', '11', '', '', '', '640x480', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/418/original/4f58475dcb24f0f19c901e39a93ebadf.jpg?1426617836";}}', 'http://dericam.net/Products_xl_sm.asp?id=12&i=2&a=5&typeid=11&typpid=53');
INSERT INTO "cameras" 
VALUES (NULL, 'h216w', 'H216W', '11', '', '', '', '1280x720', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/423/original/c365df47ecf61798883bc4d6a9c36626.jpg?1426617833";}}', 'http://dericam.net/Products_xl_sm.asp?id=6&i=2&a=5&typeid=11&typpid=20');
INSERT INTO "cameras" 
VALUES (NULL, 'h602c-tm', 'H602C-TM', '11', '', '', '', '1920x1080', 'Box', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/427/original/8dd88cd19cc8abeec9707e21fc885ee4.jpg?1426617829";}}', 'http://dericam.net/Products_xl_sm.asp?id=15&i=2&a=5&typeid=11&typpid=53');
INSERT INTO "cameras" 
VALUES (NULL, 'h201c', 'H201C', '11', '', '', '', '1280x720', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/419/original/a9b0ceb62b4619edfa7193ee182893c4.jpg?1426617825";}}', 'http://dericam.net/Products_xl_sm.asp?id=16&i=2&a=5&typeid=11&typpid=20');
INSERT INTO "cameras" 
VALUES (NULL, 'h502w', 'H502W', '11', '', '', '', '1280x720', 'Other', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/424/original/2c04d7719b01f8411e49fa4632c0286c.jpg?1426617822";}}', 'http://dericam.net/Products_xl_sm.asp?id=9&i=2&a=5&typeid=11&typpid=18');
INSERT INTO "cameras" 
VALUES (NULL, 'h206c', 'H206C', '11', '', '', '', '1280x720', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/422/original/410bf526a7dad7ad377126e5a5daa49b.jpg?1426617817";}}', 'http://dericam.net/Products_xl_sm.asp?id=17&i=2&a=5&typeid=11&typpid=20');
INSERT INTO "cameras" 
VALUES (NULL, 'h206c-tm', 'H206C-TM', '11', '', '', '', '1920x1080', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/421/original/e746ddc0bc7ca555711e3baab1d76a83.jpg?1426617812";}}', 'http://dericam.net/Products_xl_sm.asp?id=20&i=2&a=5&typeid=11&typpid=53');
INSERT INTO "cameras" 
VALUES (NULL, 'h802w', 'H802W', '11', '', '', '', '1280x720', 'Dome', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/429/original/9bb803cc1583ffd5cb8107cae72a81d9.jpg?1426617808";}}', 'http://dericam.net/Products_xl_sm.asp?id=22&i=2&a=5&typeid=11&typpid=18');
INSERT INTO "cameras" 
VALUES (NULL, 'h602c', 'H602C', '11', '', '', '', '1280x720', 'Box', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/428/original/dc6abf6aa6ba4309c265e022e00617b1.jpg?1426617805";}}', 'http://dericam.net/Products_xl_sm.asp?id=23&i=2&a=5&typeid=11&typpid=20');
INSERT INTO "cameras" 
VALUES (NULL, 'h601w', 'H601W', '11', '', '', '', '1280x720', 'Dome', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/426/original/cbbb56df1c722e925479001f589ef27b.jpg?1426617791";}}', 'http://dericam.net/Products_xl_sm.asp?id=24&i=2&a=5&typeid=11&typpid=21');
INSERT INTO "cameras" 
VALUES (NULL, 'h504w', 'H504W', '11', '', '', '', '1280x720', 'Other', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/425/original/714463298efe3ebc68f5f1faf4e36a44.jpg?1426617788";}}', 'http://dericam.net/Products_xl_sm.asp?id=25&i=2&a=5&typeid=11&typpid=18');
INSERT INTO "cameras" 
VALUES (NULL, 'h204w', 'H204W', '11', '', '', '', '1280x720', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/420/original/ea74fda6a4ee925799f6a9c3016e4f26.jpg?1426617785";}}', 'http://dericam.net/Products_xl_sm.asp?id=26&i=2&a=0&typeid=11&typpid=20');
INSERT INTO "cameras" 
VALUES (NULL, 'm601w', 'M601W', '11', '', '', '', '640x480', 'Other', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/431/original/26b8e1d1a6459415cf5e9fbac29f31fb.jpg?1426617801";}}', 'http://dericam.net/Products_xl_sm.asp?id=11&i=1&a=0&typeid=11&typpid=17');
INSERT INTO "cameras" 
VALUES (NULL, 'm801w', 'M801W', '11', '', '', '', '640x480', 'Other', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/432/original/e9a45e58e7b107b2365ab07d84b031ef.jpg?1426617798";}}', 'http://dericam.net/Products_xl_sm.asp?id=5&i=1&a=0&typeid=11&typpid=15');
INSERT INTO "cameras" 
VALUES (NULL, 'm204w', 'M204W', '11', '', '', '', '1280x720', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/430/original/872cefa36b784941297bc65058f9a243.jpg?1426617794";}}', 'http://dericam.net/Products_xl_sm.asp?id=26&i=2&a=0&typeid=11&typpid=20');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-6602-b', 'CC-6602-B', '12', 'capture/ch<ch_num>.jpg', 'capture/ch<ch_num>.mjpg', '', '720x576', 'Bullet', 'admin', '1234', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-6604dir-b', 'CC-6604DIR-B', '12', 'capture/ch<ch_num>.jpg', 'capture/ch<ch_num>.mjpg', '', '720x576', 'Dome', 'admin', '1234', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-6605dir-b', 'CC-6605DIR-B', '12', 'capture/ch<ch_num>.jpg', 'capture/ch<ch_num>.mjpg', '', '720x576', 'Dome', 'admin', '1234', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-6400-gw', 'CC-6400-GW', '12', 'capture/ch<ch_num>.jpg', 'capture/ch<ch_num>.mjpg', '', '720x576', 'Dome', 'admin', '1234', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-6337-g', 'CC-6337-G', '12', 'capture/ch<ch_num>.jpg', 'capture/ch<ch_num>.mjpg', '', '720x576', 'Dome', 'admin', '1234', '', 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8644-5', 'CC-8644-5', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1920x1080', 'Dome', 'root', 'pass', '', 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8552', 'CC-8552', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '2048x1536', 'Bullet', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8453-pm', 'CC-8453-PM', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '2048x1536', 'Bullet', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8353-pm', 'CC-8353-PM', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '2048x1536', 'Dome', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8171', 'CC-8171', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '2592x1920', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8262-pm', 'CC-8262-PM', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '2048x1536', 'Dome', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8151', 'CC-8151', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '2048x1536', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8433-lm', 'CC-8433-LM', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1920x1080', 'Bullet', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8333-l', 'CC-8333-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1920x1080', 'Dome', 'root', 'pass', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8732', 'CC-8732', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1920x1080', 'Dome', 'root', 'pass', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8233-l', 'CC-8233-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1920x1080', 'Dome', 'root', 'pass', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8131-l', 'CC-8131-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1920x1080', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8512-l', 'CC-8512-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1280x1024', 'Bullet', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8413-l', 'CC-8413-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1280x1024', 'Bullet', 'root', 'pass', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8313-l', 'CC-8313-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1280x1024', 'Dome', 'root', 'pass', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8213-l', 'CC-8213-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1280x1024', 'Dome', 'root', 'pass', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8722', 'CC-8722', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1280x1024', 'Dome', 'root', 'pass', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc-8111-l', 'CC-8111-L', '12', 'config/jpeg.cgi', 'stream/mjpg.cgi', 'rtpvideo[channel].sdp', '1280x1024', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:0:{}', 'http://www.convision.com/en/products/cameras/ip-cameras/');
INSERT INTO "cameras" 
VALUES (NULL, 'nc4230', 'NC4230', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/380/original/c992b26880710e4792734f954d9592b8.jpg?1426619603";}}', 'http://www.comprousa.com/en/surveillance/product/nc4230/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc3230', 'NC3230', '13', '', '', '', '1600x1200', 'Dome', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/378/original/1dbb59b66b0d6ba5cef790221bcd1859.jpg?1426619597";}}', 'http://www.comprousa.com/en/surveillance/product/nc3230/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc2200', 'NC2200', '13', '', '', '', '1600x1200', 'Dome', '', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/377/original/2d32ba5550955adc418f5163ae249585.jpg?1426619592";}}', 'http://www.comprousa.com/en/surveillance/product/nc2200/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc1200', 'NC1200', '13', '', '', '', '1600x1200', 'Box', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/373/original/1366ef2a348b6a38e850c9f4aa621d02.jpg?1426619585";}}', 'http://www.comprousa.com/en/surveillance/product/nc1200/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc500', 'NC500', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/382/original/48aec2918cbe7b300e6cfb479db6e4c4.jpg?1426619580";}}', 'http://www.comprousa.com/en/surveillance/product/NC500/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc450', 'NC450', '13', '', '', '', '1280x1024', 'Bullet', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/381/original/e4c96677e15deee9134a23a5e0421360.jpg?1426619574";}}', 'http://www.comprousa.com/en/surveillance/product/NC450/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc420', 'NC420', '13', '', '', '', '640x480', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/379/original/ceecea9cd7fbfcef866ec5f63be43091.jpg?1426619568";}}', 'http://www.comprousa.com/en/surveillance/product/NC420/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc150r', 'NC150R', '13', '', '', '', '1280x1024', 'Box', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/376/original/4e6fd3c403d49d0cc354348a472949b0.jpg?1426619555";}}', 'http://www.comprousa.com/en/surveillance/product/NC150_150R/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc150', 'NC150', '13', '', '', '', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/375/original/6f32770872f41ec41f75fd7c4314e771.jpg?1426619550";}}', 'http://www.comprousa.com/en/surveillance/product/NC150_150R/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc120r', 'NC120R', '13', '', '', '', '640x480', 'Box', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/374/original/c62de70634d1e763f9dc270fc7a4fe7a.jpg?1426619546";}}', 'http://www.comprousa.com/en/surveillance/product/NC120_120R/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'nc120', 'NC120', '13', '', '', '', '640x480', 'Box', '', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/372/original/d790df930c5bfe393d96a9d426fafd5c.jpg?1426619539";}}', 'http://www.comprousa.com/en/surveillance/product/NC120_120R/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip570p', 'IP570P', '13', '', '', '', '1280x1024', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/368/original/ee9f3db8e17387201b43251570e8cfcc.jpg?1426619529";}}', 'http://www.comprousa.com/en/surveillance/product/IP570/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip570', 'IP570', '13', '', '', '', '1280x1024', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/367/original/0d116c259c00eced24a75d472b3936d3.jpg?1426619519";}}', 'http://www.comprousa.com/en/surveillance/product/IP570/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip550p', 'IP550P', '13', '', '', '', '1600x1200', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/366/original/85238467a9da04398845ced93d49db60.jpg?1426619508";}}', 'http://www.comprousa.com/en/surveillance/product/ip550/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip550', 'IP550', '13', '', '', '', '1600x1200', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/365/original/8c00d42253343def8091a367f623e76c.jpg?1426619496";}}', 'http://www.comprousa.com/en/surveillance/product/ip550/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip540p', 'IP540P', '13', '', '', '', '1280x1024', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/363/original/70366a0d4a41e21dfb061a5607d810fd.jpg?1426619483";}}', 'http://www.comprousa.com/en/surveillance/product/IP540/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip540', 'IP540', '13', '', '', '', '1280x1024', 'Other', '', '', '', 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/362/original/4e7fcbf9dda3b08c66ae4d1a5287d340.jpg?1426619472";}}', 'http://www.comprousa.com/en/surveillance/product/IP540/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip400p', 'IP400P', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/361/original/ce851cbf6c8788240cf4dd4e9a82e22d.jpg?1426619465";}}', 'http://www.comprousa.com/en/surveillance/product/ip400/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip400', 'IP400', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/360/original/ac1dd0caf7c4872d665e72d5e47dccb2.jpg?1426619459";}}', 'http://www.comprousa.com/en/surveillance/product/ip400/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip90p', 'IP90P', '13', '', '', '', '1600x1200', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/371/original/c3ee9dce35d698c248900219a4a39d84.jpg?1426619624";}}', 'http://www.comprousa.com/en/surveillance/product/ip90/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip90', 'IP90', '13', '', '', '', '1600x1200', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/370/original/ccbda404b30775bc67e1239b85b38e42.jpg?1426619453";}}', 'http://www.comprousa.com/en/surveillance/product/ip90/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip70', 'IP70', '13', '', '', '', '1280x1024', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/369/original/c9d8816498ecef13388f83446a9ff58b.jpg?1426619446";}}', 'http://www.comprousa.com/en/surveillance/product/IP70/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip60', 'IP60', '13', '', '', '', '1280x1024', 'Cube', '', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/586/original/a0ab09c6a8189218f0ff74dd5f2a4845.jpg?1426619236";}}', 'http://www.comprousa.com/en/surveillance/product/IP60/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'ip55', 'IP55', '13', '', '', '', '1280x1024', 'Cube', '', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/364/original/ed29a1f5ac936a5697a23331debe9732.jpg?1426619440";}}', 'http://www.comprousa.com/en/surveillance/product/IP55/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs530w', 'CS530W', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/358/original/310edb5a27acff7fccd0950a4ac492a3.jpg?1426619433";}}', 'http://www.comprousa.com/en/surveillance/product/CS530/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs530', 'CS530', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/357/original/e8373a50dbd29ef883abd80e81475db2.jpg?1426619424";}}', 'http://www.comprousa.com/en/surveillance/product/CS530/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs400p', 'CS400P', '13', '', '', '', '640x480', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/355/original/5d0f8e3c97754cd70015da2317b4f058.jpg?1426619419";}}', 'http://www.comprousa.com/en/surveillance/product/cs400/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs400', 'CS400', '13', '', '', '', '640x480', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/354/original/b6b814f651eb4a25c4a9b32078046444.jpg?1426619413";}}', 'http://www.comprousa.com/en/surveillance/product/cs400/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs80', 'CS80', '13', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/359/original/5fbcbad0e085781f7f029858becdb210.jpg?1426619405";}}', 'http://www.comprousa.com/en/surveillance/product/cs80/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs40w', 'CS40W', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/356/original/620dfdf2df049c2fc086dd67d44b7d30.jpg?1426619398";}}', 'http://www.comprousa.com/en/surveillance/product/cs40/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'cs40', 'CS40', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/353/original/21ef2ca144a28168aeb2676c5c9eb869.jpg?1426619389";}}', 'http://www.comprousa.com/en/surveillance/product/cs40/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn4230', 'TN4230', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/390/original/bfd01b3cca82a6446c615a07adaa1751.jpg?1426619381";}}', 'http://www.comprousa.com/en/surveillance/product/tn4230/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn3230', 'TN3230', '13', '', '', '', '1600x1200', 'Dome', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/389/original/c24c6f16eba7db11c11579ec712926a5.jpg?1426619375";}}', 'http://www.comprousa.com/en/surveillance/product/tn3230/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn2200', 'TN2200', '13', '', '', '', '1600x1200', 'Dome', '', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/386/original/8a13a82597a2da8c5ab81f5e0068543e.jpg?1426619369";}}', 'http://www.comprousa.com/en/surveillance/product/tn2200/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn1600p', 'TN1600P', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/384/original/7252dec02a576de9b43020ca3b48a17d.jpg?1426619363";}}', 'http://www.comprousa.com/en/surveillance/product/tn1600/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn1600w', 'TN1600W', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/385/original/029a9787b253e40a2100b22e0031c94d.jpg?1426619357";}}', 'http://www.comprousa.com/en/surveillance/product/tn1600/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn1600', 'TN1600', '13', '', '', '', '1600x1200', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/383/original/da3f446d49a4eda8be9cb7e2f2104bcd.jpg?1426619352";}}', 'http://www.comprousa.com/en/surveillance/product/tn1600/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn1500p', 'TN1500P', '13', '', '', '', '640x480', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/585/original/23962bc2e3b6edc7ec9585422a7bfea8.jpg?1426619561";}}', 'http://www.comprousa.com/en/surveillance/product/tn1500/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn1500w', 'TN1500W', '13', '', '', '', '640x480', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/117/original/f92b80419c3d05c6353cc27e94d35246.jpg?1426619242";}}', 'http://www.comprousa.com/en/surveillance/product/tn1500/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn1500', 'TN1500', '13', '', '', '', '640x480', 'Bullet', '', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/584/original/5d2320af6653b6b2a8099894d08722a0.jpg?1426619611";}}', 'http://www.comprousa.com/en/surveillance/product/tn1500/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn920p', 'TN920P', '13', '', '', '', '1600x1200', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/411/original/889ccba6acfdb9d4bb701df5e6707dbb.jpg?1426619343";}}', 'http://www.comprousa.com/en/surveillance/product/tn920/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn920w', 'TN920W', '13', '', '', '', '1600x1200', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/412/original/cea7e0ffccda2eaac412fed8e618e318.jpg?1426619328";}}', 'http://www.comprousa.com/en/surveillance/product/tn920/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn920', 'TN920', '13', '', '', '', '1600x1200', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/410/original/51dde4b7a7f9ee492cd20d0ac0801061.jpg?1426619319";}}', 'http://www.comprousa.com/en/surveillance/product/tn920/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn900rw', 'TN900RW', '13', '', '', '', '1280x720', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/408/original/b95cbf8217b58c90ba915bada763bff7.jpg?1426619311";}}', 'http://www.comprousa.com/en/surveillance/product/tn900r/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn900r', 'TN900R', '13', '', '', '', '1280x720', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/407/original/57e13869e63db602c5a2d9f02387cca2.jpg?1426619302";}}', 'http://www.comprousa.com/en/surveillance/product/tn900r/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn900p', 'TN900P', '13', '', '', '', '1280x720', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/406/original/c123bf296a34e4711c91ea1f328f5b98.jpg?1426619293";}}', 'http://www.comprousa.com/en/surveillance/product/tn900/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn900w', 'TN900W', '13', '', '', '', '1280x720', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/409/original/62b8bdaa2b6327e001582e0dd119a783.jpg?1426619281";}}', 'http://www.comprousa.com/en/surveillance/product/tn900/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn900', 'TN900', '13', '', '', '', '1280x720', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/405/original/879ad7ffb2b129ec8c0e5b02cf6027f9.jpg?1426619271";}}', 'http://www.comprousa.com/en/surveillance/product/tn900/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn600rw', 'TN600RW', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/399/original/d5387a27e3ac7718aace5f993722a199.jpg?1426619262";}}', 'http://www.comprousa.com/en/surveillance/product/tn600r/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn600r', 'TN600R', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/398/original/8ecb96d74ca1e8ef209f682a00037a3e.jpg?1426619256";}}', 'http://www.comprousa.com/en/surveillance/product/tn600r/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn600w', 'TN600W', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/400/original/14f7dd7c39be8477aca77dcd0bf3b777.jpg?1426619251";}}', 'http://www.comprousa.com/en/surveillance/product/tn600/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn600', 'TN600', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/397/original/d3629485c6509eb58c069d3ac5a89528.jpg?1426619247";}}', 'http://www.comprousa.com/en/surveillance/product/tn600/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn540', 'TN540', '13', '', '', '', '1280x1024', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/395/original/6a55b6524482f86af03a7db933015b87.jpg?1426619230";}}', 'http://www.comprousa.com/en/surveillance/product/tn540/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn500w', 'TN500W', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/393/original/d26a0f7a240987666919b86448c1e73b.jpg?1426619220";}}', 'http://www.comprousa.com/en/surveillance/product/tn500/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn500', 'TN500', '13', '', '', '', '640x480', 'Other', '', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/392/original/31935030982ae5765aafd938ecce59d4.jpg?1426619209";}}', 'http://www.comprousa.com/en/surveillance/product/tn500/index.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn96p', 'TN96P', '13', '', '', '', '1600x1200', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/416/original/9619c83d9f436d5137c0f636bde3b871.jpg?1426619203";}}', 'http://www.comprousa.com/en/surveillance/product/tn96/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn96w', 'TN96W', '13', '', '', '', '1600x1200', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/417/original/d511dedecdd9dff968fd9f58c27d1bb5.jpg?1426619198";}}', 'http://www.comprousa.com/en/surveillance/product/tn96/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn96', 'TN96', '13', '', '', '', '1600x1200', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/415/original/6d9bf9e11d96e0fdc7f6d00880c8e23e.jpg?1426619191";}}', 'http://www.comprousa.com/en/surveillance/product/tn96/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn95w', 'TN95W', '13', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/414/original/953252dcd58efee69c117c8ab51bf3b1.jpg?1426619186";}}', 'http://www.comprousa.com/en/surveillance/product/tn95/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn95', 'TN95', '13', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/413/original/8c23f38932bfbba26563b16497fbe486.jpg?1426619618";}}', 'http://www.comprousa.com/en/surveillance/product/tn95/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn80w', 'TN80W', '13', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/661/original/58f58b88f64de6ff67aaf90b59b50131.png?1426619178";}}', 'http://www.comprousa.com/en/surveillance/product/tn80/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn80', 'TN80', '13', '', '', '', '1280x720', 'Cube', '', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/404/original/926e827a45e603399ac684a9169018a0.jpg?1426619170";}}', 'http://www.comprousa.com/en/surveillance/product/tn80/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn70', 'TN70', '13', '', '', '', '1280x1024', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/403/original/fb1a85a0860e1c6368bca89974fb7985.jpg?1426619158";}}', 'http://www.comprousa.com/en/surveillance/product/tn70/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn65', 'TN65', '13', '', '', '', '1280x1024', 'Cube', '', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/402/original/b53cbdad4643a0c272bdfbc15ec3207a.jpg?1426619146";}}', 'http://www.comprousa.com/en/surveillance/product/tn65/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn60w', 'TN60W', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/401/original/eb86a20e2a8f29749d094ed3c423a081.jpg?1426619135";}}', 'http://www.comprousa.com/en/surveillance/product/tn60/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn60', 'TN60', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/396/original/5e99bbb21b043b6315528f3ef6890ece.jpg?1426619120";}}', 'http://www.comprousa.com/en/surveillance/product/tn60/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn50w', 'TN50W', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/394/original/4f697453f29a1dbf6e2070cc31d6fbe6.jpg?1426619110";}}', 'http://www.comprousa.com/en/surveillance/product/tn50/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn50', 'TN50', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/391/original/458d85f9007f653accd9e2caf05e9f67.jpg?1426619104";}}', 'http://www.comprousa.com/en/surveillance/product/tn50/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn30w', 'TN30W', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/388/original/05df51a955a1ae1615531776bf5f9f3d.jpg?1426619093";}}', 'http://www.comprousa.com/en/surveillance/product/tn50/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'tn30', 'TN30', '13', '', '', '', '640x480', 'Cube', '', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/387/original/a463b0db990a1ebf1c6d22668ff23526.jpg?1426619076";}}', 'http://www.comprousa.com/en/surveillance/product/tn50/overview.html');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-m700f', 'VB-M700F', '14', '', '', '', '1280x960', 'Box', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/348/original/5959fdb512b1279c93ffd07ff54fa3b4.jpg?1426617819";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-M700F/index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-h710f', 'VB-H710F', '14', '', '', '', '1920x1080', 'Box', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/344/original/ac77f27686c03662d303fac7aaa01e4d.jpg?1426617815";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-H710F/index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-905f', 'VB-905F', '14', '', '', '', '1280x960', 'Box', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/339/original/e745cca05e1da98cb5cf9e5688e65744.jpg?1426617812";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB_S905F/Index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-s900f', 'VB-S900F', '14', '', '', '', '1920x1080', 'Box', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/352/original/b0cf73491a0d3e16462fb2b6f5dbb784.jpg?1426617808";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-S900F/Index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-m600d', 'VB-M600D', '14', '', '', '', '1280x960', 'Dome', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/346/original/748eb0ef6acc8f0feb43e439d1f0ce90.jpg?1426617804";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-M600D/');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-m600ve', 'VB-M600VE', '14', '', '', '', '1280x960', 'Dome', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/347/original/12cc86bf2dc87d172eb51d60db3b2292.jpg?1426617801";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-M600VE/');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-h610d', 'VB-H610D', '14', '', '', '', '1920x1080', 'Dome', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/342/original/f5eaf366d7e7aeb326fe19fb94adb000.jpg?1426617798";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-H610D/');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-h610ve', 'VB-H610VE', '14', '', '', '', '1920x1080', 'Dome', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/343/original/8781e3da102f118744d6afcaad58ee7c.jpg?1426617794";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-H610VE/');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-s800d', 'VB-S800D', '14', '', '', '', '1920x1080', 'Dome', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/351/original/620e2857dafe9811f743d15da2ecb243.jpg?1426617790";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-S800D/');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-s31d', 'VB-S31D', '14', '', '', '', '1920x1080', 'Dome', 'root', 'camera', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/350/original/56d0db6a5142bc1877146978e691859d.jpg?1426617786";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-S31D/Index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-s30d', 'VB-S30D', '14', '', '', '', '1920x1080', 'Dome', 'root', 'camera', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/349/original/a02e2dac5c6a1076314a8a5e8e390516.jpg?1426617783";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-S30D/Index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-c60', 'VB-C60', '14', '', '', '', '1280x960', 'Other', 'root', 'camera', '', 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/340/original/0723660b830d091d89d7be96b2551864.jpg?1426617780";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-C60');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-m40', 'VB-M40', '14', '', '', '', '1280x960', 'Other', 'root', 'camera', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/345/original/f07be90fa40c48d27706b0eea7dabd90.jpg?1426617776";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-M40/index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'vb-h41', 'VB-H41', '14', '', '', '', '1920x1080', 'Other', 'root', 'camera', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/341/original/4b7878e156024ec7d904bf9da3f74205.jpg?1426617771";}}', 'http://www.canon-europe.com/For_Home/Product_Finder/Web_Cameras/Web_Cameras/VB-H41/index.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-d1920c-dn-indoor-af', 'BIP2-D1920c-dn (Indoor, AF)', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1920x1440', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/250/original/03d5f34961c12f9adcfd9c03c7249544.jpg?1426618171";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-d1920c-dn-indoor', 'BIP2-D1920c-dn (Indoor)', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1920x1440', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/249/original/f4e2d4ac6922643c3ff55d962d83a7d6.jpg?1426618162";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-d1920c-dn-outdoor', 'BIP2-D1920c-dn (Outdoor)', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1920x1440', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/251/original/5932b0d1710ed0f9f871864c21a9c3ce.jpg?1426618154";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-d1920c-dn-outdoor-af', 'BIP2-D1920c-dn (Outdoor, AF)', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1920x1440', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/252/original/b8cbc326a55cf5539c2e3aeb7592c1f4.jpg?1426618146";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-d1300c-dn', 'BIP2-D1300c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/248/original/a788b7806cf643a18b59c30564e841ca.jpg?1426618139";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-d1000c-dn', 'BIP2-D1000c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1024x768', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/247/original/f3a32d58559ad97965fe3f9fb678bc8d.jpg?1426618129";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-2500c-dn', 'BIP2-2500c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '2560x1920', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/243/original/5fe91dd32571c52c8a0a5ab464c4b09e.jpg?1426618120";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-2500c', 'BIP2-2500c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '2560x1920', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/244/original/353d3db374e1100c8855c041d8938760.jpg?1426618113";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1920c-dn', 'BIP2-1920c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/241/original/069671047dc3b98bdbd0d9fb3ec48c04.jpg?1426618104";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1920c', 'BIP2-1920c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/242/original/ae907adc7b6a6e1ef30d5e90bc071e66.jpg?1426618182";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1600c-dn', 'BIP2-1600c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/239/original/39482054cf6f309864702ad4ac23fe50.jpg?1426618097";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1600-25c', 'BIP2-1600-25c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/238/original/607d9ba421a11b246073bfbe45ed6e17.jpg?1426618088";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1600-25c-dn', 'BIP2-1600-25c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/237/original/752023b6be7789f0a51773437c10b84d.jpg?1426618080";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1600c', 'BIP2-1600c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/240/original/1cada571cd0fedcf0ec7f174d5397c77.jpg?1426618073";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1300c-dn', 'BIP2-1300c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1280x960', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/235/original/5e023bcb02ec5b5d1aa80b8409cd9a20.jpg?1426618066";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1300c', 'BIP2-1300c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1280x960', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/236/original/876628a71e20bc61c007ef707ca16eca.jpg?1426618058";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1280c-dn', 'BIP2-1280c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1280x720', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/233/original/2e562ad5585e1443d64bbef3acdb35e7.jpg?1426618050";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1280c', 'BIP2-1280c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1280x720', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/234/original/0a4b324bd9023bfef87886823999d1c6.jpg?1426618042";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1000c-dn', 'BIP2-1000c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1024x768', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/231/original/895d2ee7edb2ab05e46c37526fbd1ecd.jpg?1426618037";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-1000c', 'BIP2-1000c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '1024x768', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/232/original/f977b5587d4432dba6646cf5c6e3ebb1.jpg?1426618030";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-640c-dn', 'BIP2-640c-dn', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '640x480', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/245/original/1caae1d816a9aeea83bfd6111bd8d512.jpg?1426618024";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bip2-640c', 'BIP2-640c', '15', 'cgi-bin/jpeg', 'cgi-bin/mjpeg', '', '640x480', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/246/original/cc310a65afc5cfd808dc32c03ef8e0ef.jpg?1426618018";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b85-5-ip2', 'B85-5-IP2', '16', '', '', '', '704x576', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/329/original/07c1f18f017e24ec9114bcddb595ba14.jpg?1426617932";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b85-2-ip2', 'B85-2-IP2', '16', '', '', '', '704x576', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/328/original/22f416986618f75010909fc7e2354bc4.jpg?1426617929";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd75-5', 'BD75-5', '16', '', '', '', '-', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/336/original/dfa3745e9608a75a871f4ce9f7bc45e8.jpg?1426617899";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b54-1-ip2', 'B54-1-IP2', '16', '', '', '', '704x576', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/327/original/f584b0efa18a1be35ca288f907ce0cac.jpg?1426617926";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6601', 'N6601', '16', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/338/original/ee152544c624036a9cd18ae1c7acfb7e.jpg?1426617923";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n13102', 'N13102', '16', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '1280x1024', 'Cube', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/580/original/409b914d9c5fc0338dcb7d41645e6862.jpg?1426617936";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n1250', 'N1250', '16', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Cube', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/337/original/dd02b9f10aa8fbb8edf7c886f620de9b.jpg?1426617919";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n1000', 'N1000', '16', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Cube', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/581/original/e4fc4156cbfe6ac92c5beb66c60e1f0e.jpg?1426617939";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd4330dvh', 'BD4330DVH', '16', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/335/original/bfa23c9ad303d01fd7a31393641499e9.jpg?1426617961";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd2070dv', 'BD2070DV', '16', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/330/original/4e20e8fe2cbe3cfa1bcdcb1737a1a639.jpg?1426617957";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd4330dh', 'BD4330DH', '16', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/334/original/63adfca24858d955db769825ee1d381e.jpg?1426617953";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd4330d', 'BD4330D', '16', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/333/original/78daa970c5302d61a9bc31c3e2d32009.jpg?1426617950";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd4070h', 'BD4070H', '16', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '1', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/331/original/9f8f7e76cf1b6beccc2480009efae2ec.jpg?1426617946";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'bd4330', 'BD4330', '16', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/332/original/d15fa93ff8d71fbb50eac55dcf7db5cc.jpg?1426617943";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b2-dot-920dx', 'B2.920DX', '16', '', '', '', '1600x1200', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/325/original/594e524615b9ef5df267a91d673f9c07.jpg?1426617917";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b2-dot-920f', 'B2.920F', '16', '', '', '', '1600x1200', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/326/original/a2111ceaafc197564375738bac5834d4.jpg?1426617914";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b1072d', 'B1072D', '16', '', '', '', '704x576', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/324/original/1c5e4d6ea3bb1d90bcaaede741fa05bd.jpg?1426617910";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b1055d', 'B1055D', '16', '', '', '', '704x576', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/322/original/0c3ee8cbb9834aa1df4332c07f01d5d4.jpg?1426617906";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'b1072', 'B1072', '16', '', '', '', '704x576', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/323/original/21ced91d32bf16f7fb349015b17a7070.jpg?1426617903";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cvmw3025-ir', 'CVMW3025-IR', '47', '', '', '', '2048x1536', 'Dome', 'root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/194/original/d4779f08b23f992a540fc42dfb0b99ac.jpg?1426617878";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cvms2025-ir', 'CVMS2025-IR', '47', '', '', '', '1920x1080', 'Dome', 'root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/193/original/35e50b735bfa2eea40cdbd2a8d32a809.jpg?1426617872";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccid1410-st', 'CCID1410-ST', '47', '', '', '', '640x480', 'Dome', 'root', '', '', 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/181/original/f6e5783ecc31b0637535b3e8acd46620.jpg?1426617868";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccid1445-dn36', 'CCID1445-DN36', '47', '', '', '', '720x576', 'Dome', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/184/original/9a3659597c587d2d33a49811707a493b.jpg?1426617864";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccid1445-dn28', 'CCID1445-DN28', '47', '', '', '', '720x576', 'Dome', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/183/original/69ca1ee54fa1d4c651f1897e0fb67598.jpg?1426617859";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccid1445-dn18', 'CCID1445-DN18', '47', '', '', '', '720x576', 'Dome', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/182/original/5d586bac4c06ac48ceaf484d2140cefc.jpg?1426617854";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cfmw3025', 'CFMW3025', '47', '', '', '', '2048x1536', 'Dome', 'root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/192/original/0a3fd9f214127c9295d98d62b5bb7a3e.jpg?1426617850";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cfms2025', 'CFMS2025', '47', '', '', '', '680x512', 'Dome', 'root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/190/original/c44e6040417ddafb5524974d61dcf348.jpg?1426617846";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cfmw1025', 'CFMW1025', '47', '', '', '', '680x512', 'Dome', 'root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/191/original/2be974989183f71f92064ed64ed4f630.jpg?1426617842";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cfis1425', 'CFIS1425', '47', '', '', '', '680x512', 'Dome', 'root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/189/original/a5c89aaf7cf97d33c0a95021328918a9.jpg?1426617837";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccic1410-law', 'CCIC1410-LAW', '47', '', '', '', '640x480', 'Box', 'root', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/180/original/bbcf58b0fffa75f1cf3995cb6e7d63fd.jpg?1426617834";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccmw3025', 'CCMW3025', '47', '', '', '', '2048x1536', 'Box', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/188/original/1af4ce9e8fa29f47f431f46db492f645.jpg?1426617829";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccms2025', 'CCMS2025', '47', '', '', '', '1920x1080', 'Box', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/186/original/19f674dae167a64c98d555b4cde4bd87.jpg?1426617825";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccmw1025', 'CCMW1025', '47', '', '', '', '1280x720', 'Box', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/187/original/018f7a0141867396876ab872100602bf.jpg?1426617822";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ccis1425', 'CCIS1425', '47', '', '', '', '680x512', 'Box', 'root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/185/original/54a7d1190bb6817df713571fd1bdb701.jpg?1426617818";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8012', 'N8012', '17', '', '', '', '2560x1920', 'Cube', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/446/original/cc036be635ae99787302a8378e559dab.jpg?1426619272";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8011', 'N8011', '17', '', '', '', '2560x1920', 'Cube', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/445/original/5c25fcdaf2c5cffe405b2072dbf28725.jpg?1426619267";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8032', 'N8032', '17', '', '', '', '2048x1536', 'Cube', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/448/original/adf07fadcf7edd8dc212a1e164a60208.jpg?1426619263";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8031', 'N8031', '17', '', '', '', '2048x1536', 'Cube', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/447/original/f617a914a4c7e771624996ba1d1fbcc0.jpg?1426619259";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8072-c', 'N8072-C', '17', '', '', '', '1600x1200', 'Cube', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/451/original/9fef3376e9f8fcc1fc5ac47f91a133df.jpg?1426619254";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8072', 'N8072', '17', '', '', '', '1600x1200', 'Cube', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/452/original/6843ba07ad4e86efaa71b472f53a4983.jpg?1426619250";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8071-c', 'N8071-C', '17', '', '', '', '1600x1200', 'Cube', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/449/original/29a04d6652830ec08151d9a818de34d0.jpg?1426619246";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n8071', 'N8071', '17', '', '', '', '1600x1200', 'Cube', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/450/original/785b25f2f2500c8e9cfc3d9577902856.jpg?1426619242";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n1011', 'N1011', '17', '', '', '', '2560x1920', 'Box', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/469/original/4e43af70ddcb66a04d87f5d8e27bf106.jpg?1426619237";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n1031', 'N1031', '17', '', '', '', '2048x1536', 'Box', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/480/original/8c59af927258a330a92ef9d7dccf7f55.jpg?1426619233";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n1073', 'N1073', '17', '', '', '', 'ntsc:720x480/pal:720x576', 'Box', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/481/original/0f57376f1b8fbb18d815b976b7cb544d.jpg?1426619228";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n1072', 'N1072', '17', '', '', '', '1600x1200', 'Box', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/482/original/487b25e9dae6abc7b229f3fdbf1935d4.jpg?1426619223";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6015', 'N6015', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/483/original/030dad27bfa5e92e8b36554976d8531d.jpg?1426619219";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6019', 'N6019', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/425/original/739a50836c3d8b2b3c44ef17bd4ef5bb.jpg?1426619214";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6013-a', 'N6013-A', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/484/original/b27e926dab2e48ae32c30d0930280e8f.jpg?1426619210";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6011', 'N6011', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/491/original/26bed188c37b625fd959bf212f54261a.jpg?1426619206";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6013-c', 'N6013-C', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/485/original/4d9688b2bd218e087d1ae3e64da95168.jpg?1426619201";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6013', 'N6013', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/486/original/bb4310842434b0fd9a35ef31b31398d4.jpg?1426619197";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6048', 'N6048', '17', '', '', '', '2048x1536', 'Bullet', 'root', 'root', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/432/original/f347ffa291add633c5c3e5e462f83992.jpg?1426619193";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6042', 'N6042', '17', '', '', '', '2560x1920', 'Bullet', 'root', 'root', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/431/original/73ec82066c2f719830824886b432eef4.jpg?1426619189";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6035', 'N6035', '17', '', '', '', '2048x1536', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/428/original/215b9409abc654bf50c15e3361b74e57.jpg?1426619185";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6031', 'N6031', '17', '', '', '', '2048x1536', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/426/original/3df07b600bdbd177b9674d13c702bba9.jpg?1426619180";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6033', 'N6033', '17', '', '', '', '2048x1536', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/427/original/9be6ab467d95987b0839aea3ec86a357.jpg?1426619175";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6038', 'N6038', '17', '', '', '', '2048x1536', 'Bullet', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/430/original/5a8bbcb770aba56fb0aa9a0c22272dd3.jpg?1426619171";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6037', 'N6037', '17', '', '', '', '2048x1536', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/429/original/e1d67b3cac469a37551244fac1737cdc.jpg?1426619167";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6071', 'N6071', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/433/original/826ab2003ccfd0d688b5977a4170656c.jpg?1426619162";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6073', 'N6073', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/435/original/665a5855e4c00fdd5437add2d28541c1.jpg?1426619158";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6072', 'N6072', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/434/original/30bb21b036eb98f203380818eab35613.jpg?1426619153";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6075', 'N6075', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/437/original/763b20060bf8a6123c49e6e5878ece0c.jpg?1426619148";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6074', 'N6074', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/436/original/82b43c59574b02a9301c405c84fd73cc.jpg?1426619143";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6077', 'N6077', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/440/original/b336590595bff1b9b35a8d6e2cffaaa5.jpg?1426619137";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6076-c', 'N6076-C', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/438/original/023a451db248b86600fcf50cd0945588.jpg?1426619132";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6076', 'N6076', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/439/original/3777ecfb9a8a268b5cc8b9ff9855b067.jpg?1426619127";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6079', 'N6079', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/443/original/c777b7fa666fc1fb95bbbcb3ac77fe6f.jpg?1426619123";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6078-c', 'N6078-C', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/441/original/d0230975cb78dbe8b183ee5e5b81bec2.jpg?1426619118";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6078', 'N6078', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/442/original/f03484c756196c5643b433df0626f60d.jpg?1426619113";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n6082', 'N6082', '17', '', '', '', '1600x1200', 'Bullet', 'root', 'root', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/444/original/0741f8c9f079602f126446eadcd940e8.jpg?1426619108";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3011-c', 'N3011-C', '17', '', '', '', '2560x1920', 'Dome', 'root', 'root', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/488/original/7b196930a2d54d2923b47e34b4919678.jpg?1426619103";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3011', 'N3011', '17', '', '', '', '2560x1920', 'Dome', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/487/original/4c9288c41c129cd39f1905e0b0e0b1cc.jpg?1426619098";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9042', 'N9042', '17', '', '', '', '2560x1920', 'Dome', 'root', 'root', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/460/original/f4fba0469272dcebab0ef35c46800aeb.jpg?1426619094";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9045', 'N9045', '17', '', '', '', '2560x1920', 'Dome', 'root', 'root', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/461/original/446936ffe1675bd2b762dcb3ed5f63f1.jpg?1426619088";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9012', 'N9012', '17', '', '', '', '2560x1920', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/453/original/83846948bd6827b57dbcc234e01db095.jpg?1426619083";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9041', 'N9041', '17', '', '', '', '2560x1920', 'Dome', 'root', 'root', '', 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/459/original/36cd125ee0f0a64808e6a6bf63ee98ee.jpg?1426619078";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3031', 'N3031', '17', '', '', '', '2048x1536', 'Dome', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/489/original/4b5f904c653f441b0204ceb988682af7.jpg?1426619073";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9034', 'N9034', '17', '', '', '', '2048x1536', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/458/original/6c80e32e90a1ba523a0722cc47848b90.jpg?1426619068";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9033', 'N9033', '17', '', '', '', '2048x1536', 'Dome', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/457/original/cc42915ad186f1b15b24ac8389978dd2.jpg?1426619063";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9032', 'N9032', '17', '', '', '', '2048x1536', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/456/original/7b5378596a9e10d499d82a100b6d93d7.jpg?1426619057";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3075', 'N3075', '17', '', '', '', 'ntsc:704x480/pal:704x576', 'Dome', 'root', 'root', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/490/original/289c0b87b9e0717801f5fd2c0abd236e.jpg?1426619053";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3074', 'N3074', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/468/original/89c3cc8aeee90f95c0fa0688966f05a4.jpg?1426619049";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3073', 'N3073', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/470/original/1051ac93e68431e783d1db0170c6745b.jpg?1426619313";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3072-c', 'N3072-C', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/471/original/bf16fd3d2c02d2a83b64421646c261e4.jpg?1426619309";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3072', 'N3072', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/472/original/a787d260fd829143a85df77b65ed62e5.jpg?1426619304";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n3071', 'N3071', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/473/original/3373711a96f80ba657f4cf60ab251028.jpg?1426619300";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9074', 'N9074', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/465/original/59c45405cd5caabb9922b496fe19c6ad.jpg?1426619295";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9073', 'N9073', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/464/original/225454fe6bb261fa6e27f287c855cba9.jpg?1426619291";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9082', 'N9082', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/466/original/78218b9cf3bf2bb0164692106a7ca4d9.jpg?1426619286";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9085', 'N9085', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/467/original/b8559fa155747bd2b000125afba7f0ff.jpg?1426619281";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9071-c', 'N9071-C', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/462/original/5378c8fbca50586d2dab3e534e613228.jpg?1426619044";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9071', 'N9071', '17', '', '', '', '1600x1200', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/463/original/2aa6a27f1617fb7314cb3e9215b129fe.jpg?1426619040";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9018', 'N9018', '17', '', '', '', '1920x1080', 'Dome', 'root', 'root', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/455/original/b1c5980a5dd31686354f330364ed8701.jpg?1426619036";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n9017', 'N9017', '17', '', '', '', '1920x1080', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/454/original/f5f80384d4002f10a85cedd5e2f6af3e.jpg?1426619032";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n5013', 'N5013', '17', '', '', '', 'ntsc:720x480/pal:720x576', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/474/original/fb1720f0e9e35965fb9b20dfe7b9e1a3.jpg?1426619027";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n5012', 'N5012', '17', '', '', '', '1920x1080', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/475/original/55cc38f87a94eec47450792780f77ce4.jpg?1426619023";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n5011', 'N5011', '17', '', '', '', '1280x720', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/476/original/9ca35921591167e6427449767047c5c7.jpg?1426619019";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n4013', 'N4013', '17', '', '', '', 'ntsc:704x480/pal:704x576', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/479/original/46a4cf155c48a2d5826bc8731c1b77cf.jpg?1426619277";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n4012', 'N4012', '17', '', '', '', '1920x1080', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/478/original/7c8754fffffbbc1437c4a9fc8c30cf4c.jpg?1426619011";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'n4011', 'N4011', '17', '', '', '', '1280x720', 'Dome', 'root', 'root', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/477/original/f6a02b7f4e124820f090236299c29944.jpg?1426619015";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ph-100ah-kit-b', 'PH-100Ah Kit-B', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x720', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/558/original/a1d59fc442ac7faf2664b50ee02a6de7.jpg?1426621254";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ph-100ah-kit-a', 'PH-100Ah Kit-A', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x720', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/557/original/be23b6f86a4fb5cdd3dc99d11069fa89.jpg?1426621234";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'pz-040e-12xp', 'PZ-040E 12xp', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', 'pal:720x576', 'Other', 'admin', 'admin', '', 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/560/original/c51472868093cf9540a5362dad6c4b24.jpg?1426621222";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'pz-040d-12xp', 'PZ-040D 12xp', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', 'ntsc:720x480', 'Other', 'admin', 'admin', '', 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/559/original/1108e3413c71d0bb6bc2ccd3bcdb3f25.jpg?1426621214";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'osd-200a-20xp-se', 'OSD-200A 20xp-SE', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/555/original/f5b63c0d6f582441e366ca78f384de87.jpg?1426621206";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'osd-200a-20xp', 'OSD-200A 20xp', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/556/original/4f81195327e066388c10b7cb5f8eeecd.jpg?1426621197";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'osd-040e-36xp', 'OSD-040E 36xp', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', 'pal:720x576', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/554/original/46804828f37bb27941daca6d8f8a9521.jpg?1426621189";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'osd-040d-36xp', 'OSD-040D 36xp', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', 'ntsc:720x480', 'Dome', 'admin', 'admin', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/553/original/939a7276ef26b34aa0da9b8f610f4c04.jpg?1426621180";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-502ap-v5', 'VD-502Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/584/original/168c26719d81d82d211783b0384dc7a5.jpg?1426621172";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-501af', 'VD-501Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/583/original/0c5e17515e7bbec62fca807eae144dba.jpg?1426621162";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-500ap-v5', 'VD-500Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/582/original/cd6c7bbcaf6adb156187101d4dbc3482.jpg?1426621151";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-500af', 'VD-500Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/581/original/5d1f8b8c978d2c16acbdcd053553c3c8.jpg?1426621141";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-302np-v5', 'VD-302Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/579/original/5eded3e27de451c3aef2f91e615488c4.jpg?1426621126";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-302np', 'VD-302Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/580/original/e57dfc774dd8bafb4d47a9655116b577.jpg?1426621106";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-302ap-v5', 'VD-302Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/578/original/48690110d5bde0c5ab79943463848920.jpg?1426621091";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-301af', 'VD-301Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/577/original/eecd852813523035b60bd2683455bf68.jpg?1426621080";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-300np-v5', 'VD-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/575/original/2931de8052f2fcbfe16c4ad496fa7684.jpg?1426621069";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-300np', 'VD-300Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/576/original/17af589f1a437aaa6be2f8008d92ced0.jpg?1426621057";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-300nf', 'VD-300Nf', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/574/original/22fbe4fb0166a6136bc310cddbc8ddbd.jpg?1426621048";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-300ap-v5', 'VD-300Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/573/original/8fd32fb3c2fbc221238225c3af0120a1.jpg?1426621037";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-300af', 'VD-300Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/572/original/1385eba7b40256639964f38dd7e60186.jpg?1426621026";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-202np-v5', 'VD-202Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/570/original/fdf546942680073d5be1eeefce80fb23.jpg?1426621015";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-202np', 'VD-202Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/571/original/ccd1f5d421be7e005bde2000fa265a00.jpg?1426621001";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-202ap-v5', 'VD-202Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/569/original/8f82736c5f392e5a916b7a26514addc2.jpg?1426620982";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-201af', 'VD-201Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/568/original/9dc4842189416beb56b2f5f8a7e43d08.jpg?1426620963";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-200np-v5', 'VD-200Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/566/original/5efa061ce9f959ac043b424e1f31d45b.jpg?1426620947";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-200np', 'VD-200Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/567/original/072e86011a0271fd3cb57f849d6dd2f0.jpg?1426620931";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-200nf', 'VD-200Nf', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/565/original/5cd7b3d4f4a28d002a5dc27e378d64f9.jpg?1426620918";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-200ap-v5', 'VD-200Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/564/original/b190d41a42d6df695e00c5a619277fdf.jpg?1426620904";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-200af', 'VD-200Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/563/original/f6652ffa3e775c2b88563aa21f6c0dbb.jpg?1426620890";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-131af', 'VD-131Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/562/original/0def299c1b064a2e3ba72004763bb4b5.jpg?1426620874";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'vd-130np', 'VD-130Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/561/original/50aa05c3ceebb9610dfc446759f37ad8.jpg?1426620859";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-502ap-v5', 'FD-502Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/503/original/47a4c0b2ff3fd553e0ca1563b59ca641.jpg?1426620844";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-501af', 'FD-501Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/502/original/e054e59ff4bca848837f95548cff55eb.jpg?1426620832";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-500ap-v5', 'FD-500Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/501/original/bda89e5c6deb538d4c90326517d6e72b.jpg?1426620818";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-302np-v5', 'FD-302Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/500/original/19a7f4eb75bfc48a08cba9b7528e100c.jpg?1426621326";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-302ap-v5', 'FD-302Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/499/original/e7b976abef106d71d1df6ccd5ced5c73.jpg?1426620806";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-301af', 'FD-301Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/498/original/d92a0d1c82fe03f0db7fd5991be739e2.jpg?1426620796";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-300np-v5', 'FD-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/497/original/5e28a8518f001a35b5d882f862c4ee35.jpg?1426620784";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-300ap-v5', 'FD-300Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/496/original/a836d2c4cfe1e6d90b2168211d1a58b6.jpg?1426620771";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-202np-v5', 'FD-202Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/495/original/14b1f5f3459101a7229d7149d76617a1.jpg?1426620759";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-202ap-v5', 'FD-202Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/494/original/99795a905d0d67b2c195527a128e0e59.jpg?1426620749";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-201af', 'FD-201Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/493/original/41c6059743b398de815dce195c404851.jpg?1426621315";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-200np-v5', 'FD-200Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/492/original/1e635161c3cec07c3409fa1a1ea0c6dd.jpg?1426620737";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-200ap-v5', 'FD-200Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/491/original/cfff9d43350b45f92730ce5142bbf829.jpg?1426620727";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-131af', 'FD-131Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/490/original/700a6046db49fbe1f914bf6771979981.jpg?1426620718";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fd-130np', 'FD-130Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/489/original/abfb38f81a285038e47eadf55b8efb9e.jpg?1426620707";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wmb-500ap', 'WMB-500Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/590/original/4c5810b9cf91a788730242e96242c78d.jpg?1426620696";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wmb-300ap', 'WMB-300Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/589/original/89d9beec93317ee4a1fad85abb2aabb4.jpg?1426620686";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wmb-200ap', 'WMB-200Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/588/original/b146255d3d4d8f25e76e1738b6d21538.jpg?1426620676";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wmb-130ap', 'WMB-130Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/587/original/ebe6e020d8f0b84b3511b91cf3d2d77c.jpg?1426620666";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'mb-500ap', 'MB-500Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/514/original/a78241030de5d9a24c53421f179f59db.jpg?1426620656";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'mb-300ap', 'MB-300Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/513/original/be9efccc97ef72ca921d980a450d7b1c.jpg?1426620646";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'mb-200ap', 'MB-200Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/512/original/c9071ea3dea931c5591b3492a615662d.jpg?1426620635";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'mb-130ap', 'MB-130Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/511/original/caf31a6fc377fdb669b986f2b9ca55dc.jpg?1426620623";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-500ap-360p', 'MD-500Ap-360P', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/522/original/41f5676d0d519f1ed7b7132cc8c59df8.jpg?1426620612";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-500ap', 'MD-500Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/523/original/8cca9eb88563bb4a41edef2e742c26cf.jpg?1426620601";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-300np-360p', 'MD-300Np-360P', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/520/original/b0f890a502506aababac1fc7d7d5ecb5.jpg?1426620590";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-300np', 'MD-300Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/521/original/0787a5ec33fc40d998d4f11e419cbf0e.jpg?1426620581";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-300ap', 'MD-300Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/519/original/7a6224ad69d97502c75a744929422662.jpg?1426620572";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-200np', 'MD-200Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/518/original/22254307fe54e20c294d22b096331700.jpg?1426620560";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-200ap', 'MD-200Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/517/original/37b2622bc0be75691833c47199fbd51e.jpg?1426620551";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-100ap', 'MD-100Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x800', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/516/original/ac7a2a12b2d2d2a9ad41ea2883903b05.jpg?1426620543";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'md-100ae', 'MD-100Ae', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x800', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/515/original/4e2eeffb5a8c812308ae72ae641ccf40.jpg?1426620535";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-500ap-v5', 'WOB-500Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/597/original/5c99f194445e484eb97714db689ad59b.jpg?1426620527";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-300np-v5', 'WOB-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/595/original/5b0cbec1beb5d8a6e5f6c38ef9885b24.jpg?1426620519";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-300np', 'WOB-300Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/596/original/205969c58959ed444970d0e25b9c29cf.jpg?1426620511";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-300ap-v5', 'WOB-300Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/594/original/08ab9b150efa7be71ee70b1b9cddd0ca.jpg?1426620503";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-200np-v5', 'WOB-200Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/592/original/e5abdf19a33aa205093ff7f36f7bbca8.jpg?1426620493";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-200np', 'WOB-200Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/593/original/599cd722740d1f4f8510ba741fccbd03.jpg?1426620484";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wob-200ap-v5', 'WOB-200Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/591/original/e937f7563af7c9a39ed364b45a393260.jpg?1426620474";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-502ap-v5', 'OB-502Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/552/original/d13cef4f3548e7dadec46a8c3c9c3299.jpg?1426620464";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-502ae-v5', 'OB-502Ae V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/551/original/2b68b98ea1e48a2d4211831c496cbfbb.jpg?1426620451";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-500ap-v5', 'OB-500Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/550/original/5129135e67250ac7d4c97ba1b4cad59f.jpg?1426620443";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-500af-v5', 'OB-500Af V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/548/original/05d667bb66eb38e580f285b7e0c166d4.jpg?1426621304";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-500af', 'OB-500Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/549/original/1c275a7ec84d3adcf1f5ed515f082abd.jpg?1426620435";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-302np-v5', 'OB-302Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/546/original/54df21c64c6633b027a842bc7ae5def1.jpg?1426620427";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-302np', 'OB-302Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/547/original/ea1906b31d7926b3591c2ccafc43332e.jpg?1426620419";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-302ne-v5', 'OB-302Ne V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/545/original/90bf9626ef3cacc097ddc8874474c883.jpg?1426620410";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-302ap-v5', 'OB-302Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/544/original/d947f6f4b5ca6715c4392bcd4add1db9.jpg?1426620402";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-302ae-v5', 'OB-302Ae V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/543/original/9957f23f7aa7eea63b84893b8c05c3f4.jpg?1426620395";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-300np-v5', 'OB-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/541/original/6db7002ec1e58302123fc21e12611a2e.jpg?1426620388";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-300np', 'OB-300Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/542/original/e8d08dd4a99f769cef110f3f9b211d3b.jpg?1426620381";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-300nf-v5', 'OB-300Nf V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/540/original/5b45f51cf20b83462e2acdc86217c3b6.jpg?1426620373";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-300ap-v5', 'OB-300Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/539/original/163afe5cb1b3e98bd25f5ef5b01b265e.jpg?1426620365";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-300af-v5', 'OB-300Af V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/537/original/e790ae64ac57309f4fc2e539c66e3fc5.jpg?1426620357";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-300af', 'OB-300Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/538/original/c1b4d32e14a91a7045f18e476f1ae3fe.jpg?1426621292";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-202np-v5', 'OB-202Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/535/original/aa1bbcac2a7f42df4141baa6428f9deb.jpg?1426620349";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-202np', 'OB-202Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/536/original/e8ea9d2c6425f0a0d608583cc79d6b41.jpg?1426620341";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-202ne-v5', 'OB-202Ne V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/534/original/29b7f937f61a8ca84de0937eb794e62c.jpg?1426620333";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-202ap-v5', 'OB-202Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/533/original/f18f367c1e80e1f09f2b76f6d45626fc.jpg?1426620326";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-202ae-v5', 'OB-202Ae V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/532/original/2bbd527267545be1efa7a9d72f3d2414.jpg?1426620318";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-200np-v5', 'OB-200Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/530/original/beccd4477e8b3cb847b1b23275ecf765.jpg?1426620309";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-200np', 'OB-200Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/531/original/4321db0ccf914bf81fd4f252e23e9fc3.jpg?1426620302";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-200nf-v5', 'OB-200Nf V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/529/original/95de08212a83ba65f5a543fa624dce77.jpg?1426620292";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-200ap-v5', 'OB-200Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/528/original/43dad026e981857c1c1230b27901148c.jpg?1426620285";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-200af-v5', 'OB-200Af V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/526/original/5726cc520d55d7eae9a889a163bcaa0d.jpg?1426620278";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-200af', 'OB-200Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/527/original/170d1ea3ced7bcfd669692666fbcb9da.jpg?1426620272";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-130np', 'OB-130Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/525/original/fa6a697579f56d27ee7c4b2c7c958f94.jpg?1426620264";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ob-130af', 'OB-130Af', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/524/original/4af5585f3a38835dda8374dbe64f5a63.jpg?1426620255";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-500ap-v5', 'GOB-500Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/510/original/1fe9259651ad46acc04892dfe2d48357.jpg?1426621279";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-300np-v5', 'GOB-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/508/original/66df7b4d9ee0e91a190cca6ac436a1a5.jpg?1426620247";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-300np', 'GOB-300Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/509/original/e8e83a9f6742c46ade2d641debe4d12d.jpg?1426620240";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-300ap-v5', 'GOB-300Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/507/original/ee5da0cf0272e350f9ff9341d9507681.jpg?1426620232";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-200np-v5', 'GOB-200Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/505/original/6272e6104094a41a79c5941821ae571d.jpg?1426620225";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-200np', 'GOB-200Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/506/original/496d137aa12ad3ea3eb809ec1913c535.jpg?1426620218";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'gob-200ap-v5', 'GOB-200Ap V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/504/original/08f0358e4275ac341fa4e3689c4a6e02.jpg?1426620211";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wfb-300np-v5', 'WFB-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/586/original/eee95bc7582865750acde817baa5a568.jpg?1426620202";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'wfb-130np', 'WFB-130Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/585/original/1a63be2e3f936083eaa72fc8c8e0e0a2.jpg?1426620193";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-500ap', 'FB-500Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/488/original/1394f65e917ffe8ea365f436df7ebac2.jpg?1426620186";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-300np-v5', 'FB-300Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/487/original/97fc981aed1b7ea02daca6b523e86559.jpg?1426620179";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-300ap', 'FB-300Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/583/original/acada3e3487c92d61c3ae9b0c4449514.jpg?1416302727";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/582/original/415f8ddfa7e6fb49e376b0b26f100d69.jpg?1426621264";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-205np', 'FB-205Np', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/486/original/10dd538179b1d3d160a49bdbb2276834.jpg?1426620172";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-200np-v5', 'FB-200Np V5', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/485/original/288ecb0f2be3433d81ef1c2454684f17.jpg?1426620165";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-200np-v4', 'FB-200Np V4', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/484/original/8aa7fc4ad494e8bd430209689c7405ef.jpg?1426620158";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-200ap', 'FB-200Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/483/original/89f2649fb89341629af6aae47568b9ad.jpg?1426620152";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fb-100ae', 'FB-100Ae', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x800', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/482/original/5dff09e88344523a78cce1d44b951a8b.jpg?1426620145";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-502ap', 'CB-502Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/481/original/5eced7a3325cb5c426e6ee9e0d4960b5.jpg?1426620135";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-500ap-360p', 'CB-500Ap-360P', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/479/original/71476aac55db556ae9fb1d6660065e26.jpg?1426620127";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-500ap', 'CB-500Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2592x1944', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/480/original/6d1d678d199c378c2430acbdc308ec2c.jpg?1426620120";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-302ap', 'CB-302Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/478/original/475e30664e4610027c0e73abab3623c1.jpg?1426620111";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-300ap', 'CB-300Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '2048x1536', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/477/original/e3be2344a786819325289aaac69f54d6.jpg?1426620104";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-202ap', 'CB-202Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/476/original/4aba3635471f86be403558c38d1d5b37.jpg?1426620097";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-200ap', 'CB-200Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1920x1080', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/475/original/f46e16bb3842cfb2a576676f0dfb29d5.jpg?1426620088";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-102ae-v2', 'CB-102Ae V2', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x800', 'Other', 'admin', 'admin', '', 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/474/original/bd45ba58ba9227a787130fbb10567466.jpg?1426620079";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-100ap', 'CB-100Ap', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x800', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/473/original/ee3de3f9468e8cf0fbaf0b98d6893ac0.jpg?1426620072";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-100ae-vga', 'CB-100Ae-VGA', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '640x480', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/471/original/e5bfc2587aba867bb41296263307a4d8.jpg?1426620066";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'cb-100ae', 'CB-100Ae', '18', 'cgi-bin/media.cgi?action=getSnapshot', 'channel2', 'channel1', '1280x800', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/472/original/fc8680561e1f3c16cb24d4d5b5eb5253.jpg?1426620059";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'mvc300', 'MVC300', '19', '', '', 'PSIA/Streaming/channels/2?videoCodecType=H.264', '1920x1080', 'Cube', '', '', '', 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/195/original/588cf1810f369fdd4a730e15347b0741.jpg?1426617116";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/001/861/original/f85895672eb7f4bb4681f4c79550b366.jpg?1414243536";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'mvc330', 'MVC330', '19', '', '', 'PSIA/Streaming/channels/2?videoCodecType=H.264', '1920x1080', 'Box', '', '', '', 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/196/original/aea292608341cb7d81c29455ec52ce29.jpg?1426617112";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/001/862/original/052055dab33fda817c6b14ff7d17cc6d.jpg?1414243539";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc2020n', 'TL-SC2020N', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/279/original/6045ba718cf4d07418e63a9182ca4651.jpg?1426617675";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/280/original/2643fa4092aad9f0a4f6fab2a721b1ae.jpg?1415626064";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/281/original/cbb749e5d19063d21305b99d13e9607e.jpg?1415626066";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/282/original/bdca0dca8fcb8d32150c6b5167df59d8.jpg?1415626068";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/283/original/3f54832f96fa76bd3d7e94b212358210.jpg?1415626069";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc2020', 'TL-SC2020', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/275/original/53147d0f5a941b737220d90db71545fd.jpg?1415626056";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/276/original/9fab63069258c7e0095657fc74fa2687.jpg?1415626058";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/277/original/0b206e578a90b17d43e6bb9d185ac767.jpg?1415626059";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/278/original/e6413c0bf4595cb73640790cba88415d.jpg?1415626061";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/274/original/5f08e702cea59605e9ed93599aaea0e3.jpg?1426617671";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc3171g', 'TL-SC3171G', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Box', 'admin', 'admin', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/288/original/25fdec1ec8fa32bef1d4e8f6974cd7f6.jpg?1426617667";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/289/original/da4b2b4b94e8f28036e89de8b2a0a2af.jpg?1415626080";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc3171', 'TL-SC3171', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Box', 'admin', 'admin', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/286/original/0fc8f88a826a0ac9b77f3740123fbeb3.jpg?1426617663";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/287/original/ab515aa01284830645a58f8771853c20.jpg?1415626076";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc3130g', 'TL-SC3130G', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/285/original/823e929fb5b1690fa9650c081a698d5b.jpg?1426617660";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc3130', 'TL-SC3130', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '640x480', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/284/original/14308b592b06ae4f180c7087e124157b.jpg?1426617657";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc3230n', 'TL-SC3230N', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '1280x1024', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/296/original/a7ed67fecb2ad514486446c44498c2fa.jpg?1426617653";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/297/original/14f7b31b1cbab94106180b2d984978c3.jpg?1415626093";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/298/original/341aee8e883130d1e030b1c9fb9d7a47.jpg?1415626094";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/299/original/8123756a9d604a712a2f846d28345dc1.jpg?1415626096";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/300/original/ad7c10ac8d470ff748a0aebad3e9b9a0.jpg?1415626098";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/301/original/b1f9d4907d7492868ea300500b73d119.jpg?1415626099";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'tl-sc3230', 'TL-SC3230', '20', 'jpg/image.jpg', 'video.mjpg', 'video.h264', '1280x1024', 'Other', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/290/original/af15beb0fef0bb423280b8605c39878a.jpg?1426617649";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/291/original/34821a857b60efc7528d92254d5a2dab.jpg?1415626083";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/292/original/0dda1dab3a9406af5e0be1ddfc1c9823.jpg?1415626085";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/293/original/7872d3fdb600864c0e74b0e74ea51bce.jpg?1415626086";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/294/original/41371d3cc11fd416e048b60ca4b6cdfe.jpg?1415626088";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/295/original/e018402fb89302911fcb123e52a9d924.jpg?1415626090";}}', 'http://www.tp-link.us/');
INSERT INTO "cameras" 
VALUES (NULL, 'uvc-pro', 'UVC-PRO', '21', 'snapshot.cgi', '', 'live/ch00_0', '1920x1080', 'Bullet', 'ubnt', 'ubnt', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/748/original/b04db9a16f8cb75a5e0966d51e56a344.gif?1426646855";}}', 'www.ubnt.com');
INSERT INTO "cameras" 
VALUES (NULL, 'uvc-dome', 'uvc-dome', '21', 'snapshot.cgi', '', 'live/ch00_0', '1280x720', 'Dome', 'ubnt', 'ubnt', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/902/original/8d9a6c3b854d03634ccb191e6fb520de.jpg?1426646850";}}', 'www.ubnt.com');
INSERT INTO "cameras" 
VALUES (NULL, 'uvc', 'UVC', '21', 'snapshot.cgi', '', 'live/ch00_0', '1280x720', 'Bullet', 'ubnt', 'ubnt', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/903/original/54b84260622513cd92b008d393f92206.jpg?1426646844";}}', 'www.ubnt.com');
INSERT INTO "cameras" 
VALUES (NULL, 'aircam-mini', 'airCam Mini', '21', 'snapshot.cgi', '', 'live/ch00_0', '1280x720', 'Other', 'ubnt', 'ubnt', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/905/original/94ace6b46b958d8372195a02cced9580.jpg?1426646838";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/906/original/b04557ca41afc0a52316a7ce77661afb.jpg?1415739322";}}', 'www.ubnt.com');
INSERT INTO "cameras" 
VALUES (NULL, 'aircam-dome', 'aircam dome', '21', 'snapshot.cgi', '', 'live/ch00_0', '1280x720', 'Dome', 'ubnt', 'ubnt', '', 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/904/original/b5c38c758533342ccfecb4801c53ca83.jpg?1426646828";}}', 'www.ubnt.com');
INSERT INTO "cameras" 
VALUES (NULL, 'aircam', 'airCam', '21', 'snapshot.cgi', '', 'live/ch00_0', '1280x720', 'Bullet', 'ubnt', 'ubnt', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/907/original/c8f8a6fde9d9ebe27c60a9d228854e16.jpg?1426646821";}}', 'www.ubnt.com');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-5320gsf', 'ANC-5320GSF', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Box', '', '', '', 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/543/original/3864b83b8307147e95749568c65c37c3.jpg?1426618652";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-5320vsf', 'ANC-5320VSF', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Box', '', '', '', 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/544/original/1397f5018bfd2a6f3152b4c69e348f1a.jpg?1426618647";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'adc-3018s', 'ADC-3018S', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/524/original/e56237fc2346fcef313d4ce0cf60c01c.jpg?1426618642";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'adc-3018m', 'ADC-3018M', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/522/original/9c4450ebb5475778f12fe82a4dfbae30.jpg?1426618637";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'adc-3018mbf', 'ADC-3018MBF', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/523/original/061f34e9e5abf1ccbdcb5dd686a0814c.jpg?1426618631";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'adc-3008mb', 'ADC-3008MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/521/original/db7aa44c1d65deadc0f66d1568d3870f.jpg?1426618627";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2860s', 'ANC-2860S', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/532/original/252cb7bbf1665517aa22ec4de10ef1cc.jpg?1426618622";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2860m', 'ANC-2860M', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/531/original/4a673b159cc7b7709b5240680c949c15.jpg?1426618618";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2160s', 'ANC-2160S', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/527/original/39f1315031742c5e6aef8fa0442bf5fe.jpg?1426618612";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2160m', 'ANC-2160M', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/525/original/b4be254ac0627c18e5fce862d2e26b2f.jpg?1426618607";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2160mf', 'ANC-2160MF', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/526/original/b3da18d1ea1bf381279cf24311b4c9ed.jpg?1426618602";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2260mb', 'ANC-2260MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/528/original/c56b01fd9ab28a52848e85d644030dee.jpg?1426618598";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2360mb', 'ANC-2360MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/529/original/84b892f8d9d85994f5d055ca6ce39b2e.jpg?1426618594";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-2460mb', 'ANC-2460MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Bullet', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/530/original/e5c83a1a71a7909d5d1573098d3cc2cd.jpg?1426618589";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3211s', 'ANC-3211S', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/538/original/6dea29a123c99b248938a576be0d23d2.jpg?1426618580";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3211m', 'ANC-3211M', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/537/original/2943f0f42dbb8a6047ee20a9b26a5f0b.jpg?1426618574";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3211ha', 'ANC-3211HA', '22', 'imagep/picture.jpg', '', '', '1280x900', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/536/original/40dee55bbe775165f270b4ae8e5443ea.jpg?1426618569";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3210s', 'ANC-3210S', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/535/original/6f2befd20051be4420f82b7817c29872.jpg?1426618566";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3210m', 'ANC-3210M', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/534/original/e478339d9d8cf12965d17f895a44dc76.jpg?1426618561";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3210ha', 'ANC-3210HA', '22', 'imagep/picture.jpg', '', '', '1280x900', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/533/original/166312e381efad1a5b1d27f77c2bb9ff.jpg?1426618557";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3311mb', 'ANC-3311MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/541/original/545a4d17723ed6eeaf38a5c3fd1bb7fe.jpg?1426618552";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3321mb', 'ANC-3321MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/542/original/9bac140e349f076ad9ed0c00285f8882.jpg?1426618546";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3221mb', 'ANC-3221MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/540/original/9cdc886e37e29231b0b04c6e57d65c71.jpg?1426618542";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-3220mb', 'ANC-3220MB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Dome', '', '', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/539/original/747476da7fa923811ad93da1fbb7e8a7.jpg?1426618537";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-606gs', 'ANC-606GS', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/546/original/fd42e5317c8c084ea23206d8bb76af5d.jpg?1426618530";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-606gm', 'ANC-606GM', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/545/original/4346cbcbc9962834332b19a0adb77415.jpg?1426618526";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-818gs', 'ANC-818GS', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/553/original/bf813dcad5ac4fef7f6f7a92bc8fe3e3.jpg?1426618521";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-818gm', 'ANC-818GM', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/552/original/9c0a6f850ebca29ec72804e09954ed1e.jpg?1426618657";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-818gha', 'ANC-818GHA', '22', 'imagep/picture.jpg', '', '', '1280x900', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/551/original/4afd492be847e63b2c6e5b2ff324cf41.jpg?1426618516";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-808gmb', 'ANC-808GMB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Other', '', '', '', 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/549/original/38538170aa5f219043c9bc07dfcb997e.jpg?1426618512";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-606vs', 'ANC-606VS', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/548/original/bc8f5f52e801d55d90edb359e1a3216f.jpg?1426618507";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-606vm', 'ANC-606VM', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/547/original/846bb897d0c9f35a19796adaf0bd6ff1.jpg?1426618503";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-818vs', 'ANC-818VS', '22', 'imagep/picture.jpg', '', '', '2560x1920', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/556/original/d790e10ebf93bd84414cd69eeff3af82.jpg?1426618498";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-818vm', 'ANC-818VM', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/555/original/003b000bcc02fee0fd790ac84c05175e.jpg?1426618494";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-818vha', 'ANC-818VHA', '22', 'imagep/picture.jpg', '', '', '1280x900', 'Other', '', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/554/original/81458ee9556b3887ce5668fcfaa8d2cc.jpg?1426618489";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'anc-808pmb', 'ANC-808PMB', '22', 'imagep/picture.jpg', '', '', '1920x1080', 'Other', '', '', '', 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/550/original/eeb22238147c87390588c9cf2d894a33.gif?1426618479";}}', 'http://www.afreey.com.tw/');
INSERT INTO "cameras" 
VALUES (NULL, 'a612-poe', 'A612-POE', '23', '', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/073/original/d8c266e441156b3ba8e551259aa6cab4.jpg?1426617735";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a512-poe', 'A512-POE', '23', '', 'videostream.cgi', '', '640x480', 'Other', 'admin', '', '', 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/070/original/e35531cdffa4462e924350bf0c4ebc7d.jpg?1415740701";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/069/original/f5ce202447d69486909c318da109a49a.jpg?1426617730";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a602w', 'A602W', '23', '', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/071/original/469b9b4f17b9524ad2fe746ae5a11e68.jpg?1426617725";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a502w', 'A502W', '23', '', 'videostream.cgi', '', '640x480', 'Other', 'admin', '', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/066/original/9a08f0e1232ccfaac97cb3ab58fd8e9b.jpg?1415740690";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/065/original/52fe1c90a75d4e9184fca85db951a6cf.jpg?1426617720";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a603w', 'A603W', '23', '', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/072/original/386088bdc5d7a7abb55006e966a3e9e6.jpg?1426617716";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'm105i', 'M105I', '23', '', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/075/original/aa21d5ee49992dd907d9f6ce8e0deacf.jpg?1426617713";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'm1bf', 'M1BF', '23', '', 'videostream.cgi', '', '640x480', 'Dome', 'admin', '', '', 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/568/original/0b8ebdfc32e9f316af65536b1397ff53.png?1426617707";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a500ww', 'A500WW', '23', '', 'videostream.cgi', '', '640x480', 'Other', 'admin', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/064/original/6153cd343571f382669fc2543db64a41.jpg?1426617702";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a500w', 'A500W', '23', '', 'videostream.cgi', '', '640x480', 'Other', 'admin', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/063/original/0ecd20d402d8bb8420734b32723434a4.jpg?1426617699";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a533w', 'A533W', '23', '', 'videostream.cgi', '', '1280x720', 'Other', 'admin', '', '', 0, 0, 1, 0, 1, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/567/original/3f9c257ce8428ae8c6880792cbfe9b6a.png?1426617691";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a503w', 'A503W', '23', '', 'videostream.cgi', '', '640x480', 'Other', 'admin', '', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/068/original/bf18a88620bf28a115322ae909ad9e21.jpg?1415740695";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/067/original/d13ef0f3be8a9df86cc246abe1850ad0.jpg?1426617686";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a622w', 'A622W', '23', '', 'videostream.cgi', '', '640x480', 'Dome', 'admin', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/074/original/a310f799e461317e85c009ac589039fb.jpg?1426617679";}}', 'http://agasio.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'a-ipbi02', 'A-IPBI02', '24', '', '', '', '1280x960', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/112/original/28a10cc58b5fcd706b20faab9eee8ccb.jpg?1426617587";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'a-ipbiv02', 'A-IPBIV02', '24', '', '', '', '1920x1080', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/114/original/8988969a398817c5dc980eba74091011.jpg?1426617580";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'a-ipmiv01', 'A-IPMIV01', '24', '', '', '', '1920x1080', 'Dome', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/118/original/8793ed22429eab2272f981dfbf2013c2.jpg?1426617574";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'a-ipbiv01', 'A-IPBIV01', '24', '', '', '', '1920x1080', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/113/original/bee2bb1859836b75fec729111d992b1e.jpg?1426617566";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'a-iph7a26w', 'A-IPH7A26W', '24', '', '', '', '1920x1080', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/115/original/93510e43ce918bf52a6f33bb98a755c7.jpg?1426617559";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'a-iph7a88', 'A-IPH7A88', '24', '', '', '', '2592x1920', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/116/original/50e4ea46b162da8e3b38c32d3a10dab1.jpg?1426617551";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'a-iphfe01', 'A-IPHFE01', '24', '', '', '', '2592x1920', 'Dome', 'admin', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/117/original/9b574c5ecd35290f6972dc3e2d17ed51.jpg?1426617545";}}', 'http://www.aposoniccctv.com/index.php');
INSERT INTO "cameras" 
VALUES (NULL, 'megacam-422m', 'Megacam 422M', '25', 'jpg/1/image.jpg', 'mjpg/1/video.mjpg', '', '1280x1024', 'Other', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/896/original/5fdeb8a7480328a4ae0e8d99dc7b4d2a.jpg?1426617382";}}', 'http://abs.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'megacam-4220', 'Megacam 4220', '25', 'jpg/1/image.jpg', 'mjpg/1/video.mjpg', '', '640x480', 'Other', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/895/original/a484da9030a6d2dc9fd51a56fe00281b.jpg?1426617378";}}', 'http://abs.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'megacam-421m', 'Megacam 421M', '25', 'jpg/1/image.jpg', 'mjpg/1/video.mjpg', '', '1280x1024', 'Other', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/894/original/00404efb138e290aae12b257307f6626.jpg?1426617376";}}', 'http://abs.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'megacam-4210', 'Megacam 4210', '25', 'jpg/1/image.jpg', 'mjpg/1/video.mjpg', '', '640x480', 'Other', 'admin', '', '', 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/893/original/00893b0cedf00733e36d69fca31cae5d.jpg?1426617373";}}', 'http://abs.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'megacam-312m', 'MegaCam 312M', '25', 'jpg/1/image.jpg', 'mjpg/1/video.mjpg', '', '1280x1024', 'Other', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/492/original/a8cab9ed978ebc40cb6faec1a8285570.jpg?1426617387";}}', 'http://abs.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'megacam-311m', 'MegaCam 311M', '25', 'jpg/1/image.jpg', 'mjpg/1/video.mjpg', '', '1280x1024', 'Other', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/493/original/68f025b09f0fbda5e068e0dd8c242b73.jpg?1426617384";}}', 'http://abs.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam635', 'CAM635', '26', 'getimage.cgi', 'getdata.cgi', '', '640x480', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/637/original/55d9409c940b2ff921e9a7e405d26917.png?1426618522";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam615', 'CAM615', '26', 'getimage.cgi', 'getdata.cgi', '', 'ntsc:720x480/pal:720x576', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/633/original/4b9d01d60669b73cf2ad1749557fa68e.png?1426618512";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam661h', 'CAM661H', '26', 'getimage.cgi', 'getdata.cgi', '', '1280x800', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/642/original/7fa1567dab747ada2c4e97a85b2f92bf.png?1426618503";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam662hir', 'CAM662HIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/644/original/43f2e6eeb5e58f2a153195a665e889df.png?1426618491";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6704hir', 'CAM6704HIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/647/original/5a1ec73a3103fa6295d4131d346b5e14.png?1426618480";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6714hir', 'CAM6714HIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/648/original/e2437afe8f17868cd8d85784f196d64c.png?1426618461";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam641', 'CAM641', '26', 'getimage.cgi', 'getdata.cgi', '', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/639/original/cd037134c8be8372f876521248012ce0.png?1426618452";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam619mir', 'CAM619MIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/635/original/2f0e269676335849ed9fd7a40a7ad909.png?1426618440";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam619m', 'CAM619M', '26', 'getimage.cgi', 'getdata.cgi', '', '1600x1200', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/634/original/808bcc13e9288460a36fa2e400ed6f33.png?1426618414";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam646mir', 'CAM646MIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/640/original/9b392a7f9da5d410051d738e2c3790f0.png?1426618401";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6923fir', 'CAM6923FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/656/original/1f99e4208ee7125c0290c2e9ff60bb36.png?1426618390";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6623fir', 'CAM6623FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/643/original/80087f69dce9a827eb22fc02a271310e.png?1426618172";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6723fir', 'CAM6723FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/649/original/0858b764731b29e0bcb1f4b228b3b610.png?1426618380";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6691ficr', 'CAM6691FICR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/646/original/4931c0fbdd6ac6aa36e49ee4fcb4cb72.png?1426618373";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6661fir', 'CAM6661FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/645/original/f9b505609a702ea0a254daec9636a225.png?1426618365";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6724fir', 'CAM6724FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/650/original/8d766292f225d9bcbca68f51a5a6b4da.png?1426618351";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6733f', 'CAM6733F', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/651/original/42adf086333bdfd36f820c2ac6e677a4.png?1426618339";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6734fir', 'CAM6734FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/652/original/11320ea66911211631b8a9680a3792ee.png?1426618314";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6801ticr', 'CAM6801TICR', '26', 'getimage.cgi', 'getdata.cgi', '', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/242/original/76360fc6b290b2dcd1f7cc0777f991ac.jpg?1426618290";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6833eir', 'CAM6833EIR', '26', 'getimage.cgi', 'getdata.cgi', '', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/653/original/41da335069cd1fb140dc66588a41be96.png?1426618278";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6834eir', 'CAM6834EIR', '26', 'getimage.cgi', 'getdata.cgi', '', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/655/original/0b6a3a8cc041f78081e40b0b71b61096.png?1426618264";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam748fir', 'CAM748FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/660/original/7d498c78fab90a2220eb63852353277b.png?1426618252";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam746fir', 'CAM746FIR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/579/original/6ff536f3d39efd974d31e13f23fa2f38.jpg?1426618534";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam743ficr', 'CAM743FICR', '26', 'getimage.cgi', 'getdata.cgi', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/657/original/a3486776b3038704a0c32712500f71a8.gif?1426618238";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam6833ev', 'CAM6833EV', '26', 'getimage.cgi', 'getdata.cgi', '', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/654/original/c3e713bc5239551b942b8c141abfd53a.png?1426618219";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam636mv', 'CAM636MV', '26', 'getimage.cgi', 'getdata.cgi', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/638/original/2daadf65a8c6f0bece1d73dc227b7587.png?1426618208";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam649mv', 'CAM649MV', '26', 'getimage.cgi', 'getdata.cgi', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/641/original/194b12160a29868554a99ecd02012afa.png?1426618192";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'cam619mv', 'CAM619MV', '26', 'getimage.cgi', 'getdata.cgi', '', '1600x1200', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/636/original/96426d1322f79274988a00f2f08161d5.png?1426618178";}}', 'http://www.a-soni.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncl-615w', 'NCL-615W', '27', 'snapshot.cgi', 'video.cgi', '', '640x480', 'Bullet', 'admin', '123456', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/414/original/a21591b8a10603fb294406627545a1a5.jpg?1426618065";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncl-611w', 'NCL-611W', '27', 'snapshot.cgi', 'video.cgi', '', '640x480', 'Other', 'admin', '123456', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/413/original/b82006ebbe8ed1221272841962395dec.jpg?1426618061";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncl-610w', 'NCL-610W', '27', 'snapshot.cgi', 'video.cgi', '', '640x480', 'Other', 'admin', '123456', '', 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/412/original/f3c1161cfc2a695c910c02277c88e5bc.jpg?1426618057";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-555mw', 'NCZ-555MW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 0, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/432/original/d743d96182c22629cf329c4db9c493cf.jpg?1426618052";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-554mw', 'NCZ-554MW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 0, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/431/original/d3d9cd9792d4f753ca09494d2c41651c.jpg?1426618045";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-553mw', 'NCZ-553MW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/430/original/4a3fa95bdd6ba2c3f1d034c5bc8bc339.jpg?1426618039";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-552mw', 'NCZ-552MW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/429/original/4813cf2fd7bba8ba8ef6a6e5298f72e4.jpg?1426618034";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-551mw', 'NCZ-551MW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Bullet', 'admin', '123456', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/428/original/472ae32315b4e6f21710771a8a2c7751.jpg?1426618026";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-550mw', 'NCZ-550MW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 0, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/426/original/7c397c0ec2c0337ee8f7d92cfaeeb420.jpg?1426618018";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-629w', 'NCM-629W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/425/original/f7072449bff47b44f08dfde28f344df9.jpg?1426618010";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-628w', 'NCM-628W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/424/original/b6b6fd8effe5ebd840b71984bbd0af41.jpg?1426618003";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-627w', 'NCM-627W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/423/original/899ba0d7273ea2cef3b49441877feebe.jpg?1426617998";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-626w', 'NCM-626W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/422/original/1f791690f9d382cf39346dde40e0d486.jpg?1426617993";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-625w', 'NCM-625W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/421/original/8dc6477901ea4573b61314710f3ae4e9.jpg?1426617989";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-624w', 'NCM-624W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/420/original/c9c7046676b6ae1982f0297b5c9ba1f8.jpg?1426617983";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-623w', 'NCM-623W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/419/original/ff326c99430ff3e545041b2aceb177b3.jpg?1426617978";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-622w', 'NCM-622W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/418/original/d1610b25de334e9a057f8e8e430baa83.jpg?1426617973";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-621kw', 'NCM-621KW', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/416/original/23590dc6e15d032ca2d084457f5a683f.jpg?1426617968";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-621w', 'NCM-621W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/417/original/b6868420d43af9b49e2a71d7041d2860.jpg?1426617964";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncm-620w', 'NCM-620W', '27', 'snapshot.cgi', 'video.cgi', '', '1280x720', 'Other', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/415/original/f0fb0a7fab82d1934753275fd540130d.jpg?1426617959";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'ncz-550w', 'NCZ-550W', '27', 'snapshot.cgi', 'video.cgi', '', '640x480', 'Other', 'admin', '123456', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/427/original/072b789318b8c640c63e6b852ade37e3.jpg?1426617954";}}', 'http://wansview.net/');
INSERT INTO "cameras" 
VALUES (NULL, 'lcam0336od', 'LCAM0336OD', '28', 'img/snapshot.cgi', 'img/video.mjpeg', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/966/original/3b1cb1019a08ffcfb8263f3219420f5a.jpg?1426617213";}}', 'http://www.linksys.com/en-eu/business');
INSERT INTO "cameras" 
VALUES (NULL, 'lcab03vlnod', 'LCAB03VLNOD', '28', 'img/snapshot.cgi', 'img/video.mjpeg', 'channel1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/963/original/19626d2a4e5901fa6584692f431dcdd0.jpg?1426617210";}}', 'http://www.linksys.com/en-eu/business');
INSERT INTO "cameras" 
VALUES (NULL, 'lcad03vlnod', 'LCAD03VLNOD', '28', 'img/snapshot.cgi', 'img/video.mjpeg', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/965/original/91992f8c66d79fa1a7554e60549d58aa.jpg?1426617207";}}', 'http://www.linksys.com/en-eu/business');
INSERT INTO "cameras" 
VALUES (NULL, 'lcad03fln', 'LCAD03FLN', '28', 'img/snapshot.cgi', 'img/video.mjpeg', 'channel1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/964/original/8366cc4939a83cd9d2568749b8ba0b91.jpg?1426617203";}}', 'http://www.linksys.com/en-eu/business');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-c101', 'BL-C101', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/017/original/0c350058e77105ef929925b5851ba6fc.jpg?1426619164";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-c121', 'BL-C121', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/018/original/cd1d8b4b355a1f0416e7d1290fa91d5b.jpg?1426619160";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-c140', 'BL-C140', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/019/original/40f81794570ba3d65ae3dfb938472e6f.jpg?1426619155";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-c160', 'BL-C160', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/020/original/15bddf3812604055d050f601edb4fb05.jpg?1426619152";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-c210', 'BL-C210', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/021/original/141f5721ccdf39e167eb1b51205cd231.jpg?1426619148";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-c230', 'BL-C230', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/022/original/fda0667038f3db953446ae4d2f577235.jpg?1426619144";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-vp101', 'BL-VP101', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '800x600', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/023/original/b53650ced2c2b80548c467bb40779508.jpg?1426619140";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-vp104', 'BL-VP104', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '800x600', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/024/original/0595bf770692f8049f2c60905cee277a.jpg?1426619136";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-vp104w', 'BL-VP104W', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '800x600', 'Other', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/025/original/aad05ece7537db8437a51a37901858b8.jpg?1426619131";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-vt164', 'BL-VT164', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Other', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/026/original/f873627d8900e040e001031d16667a22.jpg?1426619127";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'bl-vt164w', 'BL-VT164W', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Other', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/027/original/b5169f97f93c5b969570bc7cf037901a.jpg?1426619123";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'ddz3018-yyrpip-domera', 'ddz3018-yy/rp/ip domera', '29', 'live/image0.jpg', 'live/image0.jpg', '', 'ntsc:720x480/pal:720x576', 'Dome', 'f', '3', '', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/644/original/1dc25b72a38983d1f8ee1e9b35dcea30.jpg?1426617976";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddz3036-wmhsip-domera', 'ddz3036-wm/hs/ip domera', '29', 'live/image0.jpg', 'live/image0.jpg', '', 'ntsc:720x480/pal:720x576', 'Dome', 'f', '3', '', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/645/original/fba0f72b2ac802025684ee4abaff54b3.jpg?1426617962";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddz3026-yyhsip-domera', 'ddz3026-yy/hs/ip domera', '29', 'live/image0.jpg', 'live/image0.jpg', '', 'ntsc:720x480/pal:720x576', 'Dome', 'f', '3', '', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/646/original/271deb915d691ce62b2272ed55e669e6.jpg?1426617965";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddz3018-yyhsip-domera', 'ddz3018-yy/hs/ip domera', '29', 'live/image0.jpg', 'live/image0.jpg', '', 'ntsc:720x480/pal:720x576', 'Dome', 'f', '3', '', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/647/original/1ae998d06f5b3bedb23d379d4c924f77.jpg?1426617969";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddz4010-yyhshd-domera', 'ddz4010-yy/hs/hd domera', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1920x1080', 'Dome', 'f', '3', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/648/original/83c0b57f04d11b62234feb876a5c48ff.jpg?1426617959";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddz4020-yyhshd-domera', 'ddz4020-yy/hs/hd domera', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1920x1080', 'Dome', 'f', '3', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/649/original/2cfd94b3201febd3725e740644524bdf.jpg?1426617956";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4010hdv', 'DDF4010HDV', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1920x1080', 'Dome', 'f', '3', '', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/657/original/c8b741b77c2e217ee91a5923abace587.jpg?1426617953";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4820hdv-dn', 'DDF4820HDV-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '2048x1536', 'Dome', 'f', '3', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/662/original/ff77c10721376891f30d58d6f76587d4.jpg?1426617948";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4220hdv-picodome', 'ddf4220hdv picodome', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1280x960', 'Dome', 'f', '3', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/658/original/3d9fcebf5688d55ab11ded29907370ec.jpg?1426617945";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4320hd-dn', 'DDF4320HD-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1280x960', 'Dome', 'f', '3', '', 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/659/original/e6f6e165b552dc7515825ed99dc6a657.jpg?1426617941";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4620hdv-dn', 'DDF4620HDV-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1280x960', 'Dome', 'f', '3', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/661/original/b17cf69747506fbccad102fc5c9d24ee.jpg?1426617937";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4520hdv-dn', 'DDF4520HDV-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1280x960', 'Dome', 'f', '3', '', 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/660/original/aba9745a318ff857fd5315faeebdaf4e.jpg?1426617933";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'ddf4920hdv-dn', 'DDF4920HDV-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '2592x1920', 'Dome', 'f', '3', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/663/original/a2a3029e104f210ef470702e30811c31.jpg?1426617930";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'mdf4220hd', 'MDF4220HD', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1280x960', 'Box', 'f', '3', '', 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/667/original/a6c9601d2eb2b06fec722f89c9fe59da.jpg?1426617927";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'df4620hd-dn', 'DF4620HD-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '1280x960', 'Box', 'f', '3', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/664/original/934418248803efd7811df2b2803beea4.jpg?1426617923";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'df4820hd-dn', 'DF4820HD-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '2048x1536', 'Box', 'f', '3', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/665/original/3914db15d21fa7b2363d0daebcd7c21e.jpg?1426617920";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'df4920hd-dn', 'DF4920HD-DN', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '2592x1920', 'Box', 'f', '3', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/666/original/f3364672d0710311c8d3df9313c9241d.jpg?1426617917";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'df4920hd-dnir', 'DF4920HD-DN/IR', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '2048x1536', 'Box', 'f', '3', '', 1, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/650/original/b252772aff5d52517f075a470c3cbb5c.jpg?1426617972";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'panomera-s4', 'Panomera S4', '29', 'live/image0.jpg', 'live/image0.jpg', 'encoder1', '40mp', 'Box', 'f', '3', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/668/original/9aba893f78372c383d9fdae9365e3b45.jpg?1426617914";}}', 'dallmeier.com');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6466e-hn', 'DH-SD6466E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/589/original/cfca096af600d584a1e4d71e624198ee.jpg?1426621730";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6465e-hn', 'DH-SD6465E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/588/original/d3484ca8045db4bef41439107b39afd5.jpg?1426621769";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6463e-hn', 'DH-SD6463E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/587/original/9879d22214818599e3ea4bea0813a832.jpg?1426621723";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6470-hn', 'DH-SD6470-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/590/original/8b4c1b6de8897ce4b2becbc77aed7312.jpg?1426621717";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6436e-hn', 'DH-SD6436E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/586/original/dc44b0ac1291faa170db3cc154257b08.jpg?1426620415";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6423e-hn', 'DH-SD6423E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/585/original/5f8b5fd3fcb543e836a52e1f8abaf828.jpg?1426620420";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6423c-hn', 'DH-SD6423C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '640x480', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/584/original/5a5004c053f222b8ba196d0fc5ac16ea.jpg?1426621708";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6366e-hn', 'DH-SD6366E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/582/original/4d18814894df2a825aa7d658d7d5bd5d.jpg?1426621698";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6365e-hn', 'DH-SD6365E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/581/original/22e9a642fb658e6c203a2c05671c1d9e.jpg?1426621691";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6363e-hn', 'DH-SD6363E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/580/original/693dca3f6c06cd87e020e5eea5305fa5.jpg?1426621682";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6370-hn', 'DH-SD6370-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/583/original/3703280e404a371ede023c32230a8cde.jpg?1426621675";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6336e-hn', 'DH-SD6336E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/579/original/e8666acaeb0abc970e6597411cb61346.jpg?1426621664";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6323e-hn', 'DH-SD6323E-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', 'ntsc:976x494/pal:976x582', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/578/original/042677f7b4ea00a6cdf3240b71f3db62.jpg?1426621649";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6323c-hn', 'DH-SD6323C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '640x480', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/577/original/c80fe156f1152bb32adfab2910cc5137.jpg?1426621637";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd3282d-gn', 'DH-SD3282D-GN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/566/original/c006be0cf73b0cc403969126672c528f.jpg?1426621630";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd6981c-hn', 'SD6981C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/656/original/1bd8ce19ea60b91117b55ad1dd6b1ed2.jpg?1426620426";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd6981b-hn', 'SD6981B-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/655/original/2f2a7f50d5d2c754c98d74df74329cf5.jpg?1426621623";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6581c-hn', 'DH-SD6581C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/599/original/d430abe32a6ea594227e7b37c569655a.jpg?1426621615";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6581b-hn', 'DH-SD6581B-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/598/original/2cc47ff8799e6f63132cef67e494b241.jpg?1426621607";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'hd-sd6980c-hn', 'HD-SD6980C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/629/original/9bd970b7d7a2ce6b5b1da693c70f550e.jpg?1426620433";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'hd-sd6980-hn', 'HD-SD6980-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/628/original/b7c5e58a9eae2a914fd14dbcedf0403b.jpg?1426621599";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65c80c-hn', 'DH-SD65C80C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/604/original/58a227610e7b21d2c03e55e71b012115.jpg?1426621589";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65c80-hn', 'DH-SD65C80-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/603/original/06ff59566b01277ad103fa35196aff45.jpg?1426621580";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6580c-hn', 'DH-SD6580C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/597/original/8ef77764a18f874eb780a15f251c2803.jpg?1426621572";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6580-hn', 'DH-SD6580-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/596/original/84d4cc8196fc1ae58c1c599a03c6031a.jpg?1426621564";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dhsd-6982c-hn', 'DHSD-6982C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/627/original/d128c2e40817e1625e020cdbf9a1a6b4.jpg?1426621555";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6982a-hn', 'DH-SD6982A-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/609/original/da26d18fd02d9662d4bf3ddb22c1f886.jpg?1426621546";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65c82c-hn', 'DH-SD65C82C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/606/original/0e7f0e4df389b0880231a6b1ac04eba8.jpg?1426620440";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65c82a-hn', 'DH-SD65C82A-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/605/original/57f8c1a8c19dfcc9beba19fd4260e3ea.jpg?1426621536";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6582c-hn', 'DH-SD6582C-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/601/original/f893c9d68cacba5f4f7a9466d8c6109d.jpg?1426621527";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6582a-hn', 'DH-SD6582A-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/600/original/5ebf4d8fbada22317496910b81ff2653.jpg?1426621519";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6983a-hn', 'DH-SD6983A-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/610/original/450b299b186cf19b9ae4f1fd0f9a2141.jpg?1426621510";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6583a-hn', 'DH-SD6583A-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/602/original/9540adf82472e16d98a17c9146fffda6.jpg?1426621499";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6c220s-hn', 'DH-SD6C220S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/625/original/de3d7631bfb4c491311b934a73547fb4.jpg?1426621491";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd63220s-hn', 'DH-SD63220S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/575/original/6cc6ee7bb4c85b56aef318c70749b9ad.jpg?1426621482";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd42c212s-hn', 'DH-SD42C212S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/569/original/43def44ae79ebacaa255f66e8c19e66a.jpg?1426621475";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd42212s-hn', 'DH-SD42212S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/568/original/91e461585c938b5d230f1c3d39e92375.jpg?1426621469";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd40212s-hn', 'DH-SD40212S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/567/original/a542df58a0f93ba186217ca6e7fe8dde.jpg?1426621462";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6c120s-hn', 'DH-SD6C120S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/624/original/17bf5eeb337ec4fda85ec747f2b1de9a.jpg?1426621455";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd63120s-hn', 'DH-SD63120S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/574/original/f435d8c75957e3dc3131071d2c007449.jpg?1426620449";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6c230s-hn', 'DH-SD6C230S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/626/original/fc6a10d200dbdd115dae996212807f50.jpg?1426621443";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd63230s-hn', 'DH-SD63230S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/576/original/73e72cf228a205cf539689ec4e6bceb1.jpg?1426621430";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd59120s-hn', 'DH-SD59120S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '1', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/570/original/28981995817888423d1be99023e82207.jpg?1426621423";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd59230s-hn', 'DH-SD59230S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '1', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/573/original/7d3190db7102719c36d78b05e80b30cb.jpg?1426621417";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd59220s-hn', 'DH-SD59220S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '1', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/572/original/60ccb0248fb88da81c7ad37479dedfb3.jpg?1426621410";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd59212s-hn', 'DH-SD59212S-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '1', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/571/original/145b13fa33ce5aff34b749b5779b7fe8.jpg?1426621404";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6aw230-hn', 'DH-SD6AW230-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/621/original/88e10c3f26e53e188bea3e69b7ca9e44.jpg?1426621397";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6aw220-hn', 'DH-SD6AW220-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/619/original/1f805e0234fc42e020faab989d55b5ec.jpg?1426621390";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6aw230-hni', 'DH-SD6AW230-HNI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/622/original/93398891a301e9caef4ef952bcd7387f.jpg?1426621762";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6aw220-hni', 'DH-SD6AW220-HNI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/620/original/6cb82ad6721762e55d3a9ed0d1af0acf.jpg?1426621382";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6aw130-hn', 'DH-SD6AW130-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/618/original/5fe420b5c9da2763e1e6898b8676769b.jpg?1426621373";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6aw320-hn', 'DH-SD6AW320-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/623/original/b2aff7a6fd40bbddb1e1faab69b2ddb4.jpg?1426620458";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6a320-hn', 'DH-SD6A320-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/616/original/1d78abdba2276fd54430e03045d82b96.jpg?1426621365";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65320-hn', 'DH-SD65320-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/595/original/4566ab27ea6b345012229984bec68613.jpg?1426621357";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65s220-hni', 'DH-SD65S220-HNI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/608/original/e0b92bf4b5c5c795add7954b70b18e60.jpg?1426621347";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65230-hni', 'DH-SD65230-HNI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/594/original/f507ce37aea2071177ede0fe7da9028e.jpg?1426621339";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65220-hni', 'DH-SD65220-HNI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/592/original/104ad758ff43ce70fd6dbe43d2e6f34f.jpg?1426621331";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6a130-hn', 'DH-SD6A130-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/613/original/1641d2e5d7255010a8db7647be7b5301.jpg?1426621324";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6a120-hn', 'DH-SD6A120-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/612/original/1fab04eb8a71c1fc80bdc12ebe262afa.jpg?1426620467";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6a118-hn', 'DH-SD6A118-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/611/original/ff0de3e6dcc823a8bacf7754ec304810.jpg?1426621317";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd65130-hn', 'SD65130-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/654/original/307b01f1657765aa7699281c601f7b69.jpg?1426621310";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd65120-hn', 'SD65120-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/653/original/cbc7925f777729b15491c9c6de31c5cf.jpg?1426621303";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd65118-hn', 'SD65118-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/652/original/bc9bec6a2dd7010881a81f65eed1bfea.jpg?1426621295";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6as220-hn', 'DH-SD6AS220-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/617/original/2eaef15621d6e63be8975bafb773e3fa.jpg?1426620474";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6a230-hn', 'DH-SD6A230-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/615/original/b1ef05b852cbc8bc4c9e73c47d777dcb.jpg?1426621287";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd6a220-hn', 'DH-SD6A220-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/614/original/3dde6168f85875b6ac39c1fec354ab98.jpg?1426621279";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65s220-hn', 'DH-SD65S220-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/607/original/e89a7fe454b0674332ae7b9bc2b4d50e.jpg?1426621272";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65230-hn', 'DH-SD65230-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/593/original/097e28122f96c1fc7f6363c1dfb6bd8b.jpg?1426621264";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-sd65220-hn', 'DH-SD65220-HN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1944x1092', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/591/original/ab4504721f1f6a6263526c3e0499fc17.jpg?1426621255";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-k200w', 'DH-IPC-K200W', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/560/original/50637efd5bf088f1fc323ee2e0264077.jpg?1426621244";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-k200a', 'DH-IPC-K200A', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/559/original/e8ecd3dec9cd301e9051f5753c4c010a.jpg?1426621236";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-k200', 'DH-IPC-K200', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/558/original/709dca12a89bc5a0e2b189e5b245dc2c.jpg?1426621228";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-kw100w', 'DH-IPC-KW100W', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Other', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/564/original/40aecb77af9df56b4918657ded29b6b7.jpg?1426621221";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-kw100a', 'DH-IPC-KW100A', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Other', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/563/original/690020c4bf3fbccc2845cbc5b9e7e092.jpg?1426621213";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-kw100', 'DH-IPC-KW100', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Other', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/562/original/6854151fd011016cf606b3ccd6d7fe21.jpg?1426621205";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-k100w', 'DH-IPC-K100W', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/557/original/530cdfbe364f68b90955404fed73c7f0.jpg?1426620482";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-k100a', 'DH-IPC-K100A', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/556/original/05107773c686ac52692512eef4743c21.jpg?1426621196";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-k100', 'DH-IPC-K100', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/555/original/04809e939160124a3c169f97df27b2cf.jpg?1426621188";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-kw12w', 'DH-IPC-KW12(W)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/565/original/cd27317a950a57d3fe880184cfbed972.jpg?1426621180";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-kw10w', 'DH-IPC-KW10(W)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Other', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/561/original/0cdee622ba4cd274c25c6e9afa5751f6.jpg?1426621171";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw1105', 'DH-IPC-HFW1105', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/527/original/3e2ced0093cee70202a7f8e1f8899fc5.jpg?1426621164";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw1100', 'DH-IPC-HFW1100', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/525/original/110dd8a31e554881da63698af50cbc83.jpg?1426621156";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw1105s', 'DH-IPC-HDW1105S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/511/original/4ce61e404705de0a14938e50ec8250f8.jpg?1426621149";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw1100s', 'DH-IPC-HDW1100S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/510/original/c61871cd6baeb4f5928109d007ac8f85.jpg?1426621143";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hd1105c', 'DH-IPC-HD1105C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/489/original/2d39f1a0349efecf0cf42975bcc34629.jpg?1426621134";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hd1100c', 'DH-IPC-HD1100C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x720', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/488/original/dd03813ef3c23be762254a92fa0730c5.jpg?1426620401";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hd2200c', 'DH-IPC-HD2200C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/491/original/fe1a4c039c336e1150a2dfd2187c74aa.jpg?1426621125";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw2200s', 'DH-IPC-HDW2200S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/513/original/5cb1eedc273c17dec9698db9ce166b98.jpg?1426620490";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw2200-b', 'DH-IPC-HFW2200-B', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/531/original/54de534fe4526ff73f01934e4e1c6bbf.jpg?1426621117";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw2200', 'DH-IPC-HFW2200', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/532/original/b9a80e0eb62275e1e6c28c2f2bb0fd8f.jpg?1426621108";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw2100', 'DH-IPC-HDW2100', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/512/original/701c0acdae62474188a24840a9d5e896.jpg?1426621102";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hd2100', 'DH-IPC-HD2100', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/490/original/e9f64ca4d1500e6cb4f258d8bfe93d14.jpg?1426621094";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw2100', 'DH-IPC-HFW2100', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/529/original/926148ae2892ef105bfad9a6b32fe8a5.jpg?1426621087";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw2200s', 'DH-IPC-HFW2200S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/533/original/5ebdf18123b84e4be2a35c1317fa97a5.jpg?1426621079";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw2100s', 'DH-IPC-HFW2100S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/530/original/a48f1dcf0d60a3555ae24e8897e265ed.jpg?1426621073";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw1105s', 'DH-IPC-HFW1105S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/528/original/ecd980e5d6bd2bcdc8d771cb25006809.jpg?1426621066";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw1100s', 'DH-IPC-HFW1100S', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/526/original/48bfe5bdff828b00633b0e1bff0a47bc.jpg?1426620497";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb4300f-pt', 'DH-IPC-HDB4300F-PT', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/497/original/ea8bb220ee8c00f0eda064fae69abd41.jpg?1426620504";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb4200f-pt', 'DH-IPC-HDB4200F-PT', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/495/original/50adc27ef2d2ffd13f73512f1794e73a.jpg?1426621059";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb4100f-pt', 'DH-IPC-HDB4100F-PT', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/493/original/dec4360db0c91db770600647000c9401.jpg?1426621052";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5202n-di', 'IPC-HDBW5202N-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/639/original/ba3ef419ba40a5d4c4af606077d1b41e.jpg?1426621045";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5200n-di', 'IPC-HDBW5200N-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/637/original/90a9c9dd9ccc7b11ba046ff598244425.jpg?1426621037";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5202p-di', 'IPC-HDBW5202P-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/640/original/4c0d34d848130be17fa07b60f5eb87c3.jpg?1426621025";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5200p-di', 'IPC-HDBW5200P-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/638/original/1f3cfc47648f8cf36df2228a3f04e056.jpg?1426621015";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdb5202n-di', 'IPC-HDB5202N-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/632/original/a2944db66374a3578e289d12a2acb347.jpg?1426621009";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdb5200n-di', 'IPC-HDB5200N-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/630/original/c094fe65a67f802cedba99b63a4fe371.jpg?1426621003";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdb5202p-di', 'IPC-HDB5202P-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/633/original/452b122f856654d856f2669e674dfc38.jpg?1426620995";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdb5200p-di', 'IPC-HDB5200P-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/631/original/43705963dd437adc73b7edf4ee8944bb.jpg?1426620987";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4200c', 'DH-IPC-HDW4200C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/517/original/34ea5b6959f70b77c92469f991bc5e36.jpg?1426620511";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4100c', 'DH-IPC-HDW4100C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/514/original/e156374d49f15b84f333a75fa3206db1.jpg?1426620979";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4300c', 'DH-IPC-HDW4300C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2052x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/520/original/82af042151727e8243f7a891272fe64f.jpg?1426620972";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4300e', 'DH-IPC-HFW4300E', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2052x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/540/original/d645bddfba642b17b3d639434597f534.jpg?1426620965";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4200e', 'DH-IPC-HFW4200E', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/537/original/a69c84bd07881af9a2902e9d1c50d8b4.jpg?1426620957";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4100e', 'DH-IPC-HFW4100E', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/534/original/c365e73c372219ea257c34297783c93c.jpg?1426620948";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb4300c-a', 'DH-IPC-HDB4300C-(A)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2052x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/496/original/b060e7e1ed5b7de54cf8ec68d5c5edb6.jpg?1426620940";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb4200c-a', 'DH-IPC-HDB4200C-(A)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/494/original/3843b5e1660ee1f770021e45c01f376f.jpg?1426620932";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb4100c-a', 'DH-IPC-HDB4100C-(A)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/492/original/93980bad16704d7ac095b7d953a714c4.jpg?1426620925";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4300sn', 'DH-IPC-HDW4300SN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/521/original/5e696566d8b11aed43d8db343a31d04b.jpg?1426620919";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4300sp', 'DH-IPC-HDW4300SP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/522/original/9030ce12df2e681bdaaeccda36fc9744.jpg?1426620912";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4200sn', 'DH-IPC-HDW4200SN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/518/original/a6c053fec3daf6ab47a403c9b43158e8.jpg?1426620518";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4200sp', 'DH-IPC-HDW4200SP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/519/original/157a76ebbc97cdf6ebbacabd7bfaba52.jpg?1426620905";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4100sn', 'DH-IPC-HDW4100SN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/515/original/34e12bbb1f21c467edc55fb1508025a8.jpg?1426621754";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdw4100sp', 'DH-IPC-HDW4100SP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/516/original/1a82c650c91fc0a9e203344e3e842b7a.jpg?1426620899";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4300sn', 'DH-IPC-HFW4300SN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/541/original/3862569f08292bb22644ab09319a6eb6.jpg?1426620892";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4300sp', 'DH-IPC-HFW4300SP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/542/original/a83dab4ec83c7eae195c6f3cc259fa99.jpg?1426620881";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4200sn', 'DH-IPC-HFW4200SN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/538/original/f56347864d13a879ccbb25639d7fdff4.jpg?1426620872";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4200sp', 'DH-IPC-HFW4200SP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/539/original/e339a02993e1d60e7073413cdd328689.jpg?1426620864";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4100sn', 'DH-IPC-HFW4100SN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/535/original/94c311d5d83cd5dc3fd5f0e4c50d9f42.jpg?1426620857";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw4100sp', 'DH-IPC-HFW4100SP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/536/original/2b4636c2af84931cd02d042b309310f0.jpg?1426620847";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdbw5202n', 'DH-IPC-HDBW5202N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/508/original/699f621c656315710f351148f0243866.jpg?1426620838";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdbw5202p', 'DH-IPC-HDBW5202P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/509/original/06f733a5237457239e56dc2329c93dd9.jpg?1426620830";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdbw5200n', 'DH-IPC-HDBW5200N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/506/original/a84442e49cc4d1d2ea322a6e6bf284c5.jpg?1426620524";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdbw5200p', 'DH-IPC-HDBW5200P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/507/original/2f15ee2415be18d87ce0ea295e3f35c1.jpg?1426620822";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdbw5100n', 'DH-IPC-HDBW5100N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/504/original/b2d5cb556aa9c6c1cc64ad5c3ea7a2fa.jpg?1426620815";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdbw5100p', 'DH-IPC-HDBW5100P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/505/original/dcf6eeffb25614ad8e26a7c8f01fa080.jpg?1426620807";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb5202n', 'DH-IPC-HDB5202N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/502/original/5b0718c1dbfb48b80c7e972b35696b96.jpg?1426620532";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb5200n', 'DH-IPC-HDB5200N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/500/original/b059433378ba564fd85993f90808fe0b.jpg?1426620800";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb5202p', 'DH-IPC-HDB5202P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/503/original/9b06319b6d45e5decce588ba9ccf0329.jpg?1426620793";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb5200p', 'DH-IPC-HDB5200P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/501/original/9bda6df0780700cdb3786ffa3e351ae3.jpg?1426620785";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb5100n', 'DH-IPC-HDB5100N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/498/original/cd42c7a753f0b8fea783dbb8a930cb68.jpg?1426620777";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hdb5100p', 'DH-IPC-HDB5100P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/499/original/9c5e51b7dd90acd0d121ccefca06f93f.jpg?1426620770";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5202c', 'DH-IPC-HFW5202C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/554/original/f83f4fd6a3926395b4ff7d89ccc63665.jpg?1426620763";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5200c', 'DH-IPC-HFW5200C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/549/original/6bf922e326c04f827be91a0d83ca1b21.jpg?1426620757";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5100cn', 'DH-IPC-HFW5100CN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/543/original/00577d130cae031da4e65d75f6507bbc.jpg?1426620750";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5100cp', 'DH-IPC-HFW5100CP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/544/original/71c1be6c50624bd3e6c41ff219ffa59b.jpg?1426620540";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hf5200n', 'IPC-HF5200N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/648/original/1c8c8e5887193e3f6eff3e90804255fd.jpg?1426620744";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hf5200p', 'IPC-HF5200P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/649/original/d25a59763255441c47518a360a60e76a.jpg?1426620737";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hf5100n', 'IPC-HF5100N', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/646/original/bb56dc732ec1c01a6d58dc315d65dbdf.jpg?1426620727";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hf5100p', 'IPC-HF5100P', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/647/original/1f5c820d40fc44bf66b36f2065db4d6d.jpg?1426620718";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5200dn', 'DH-IPC-HFW5200DN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/550/original/304594e0ce0c88465ca13f7332868e1a.jpg?1426620711";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5200dp', 'DH-IPC-HFW5200DP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/551/original/d2074df26af73a245df2fd8987573663.jpg?1426620703";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5100dn', 'DH-IPC-HFW5100DN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/545/original/3e71d12cd5b70020aeeea3140f08c074.jpg?1426620695";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5100dp', 'DH-IPC-HFW5100DP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/546/original/2c57fd753d4440938ba0d8fa8785fb7c.jpg?1426620686";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5200n-ira', 'DH-IPC-HFW5200N-IRA', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/552/original/a133ea805bc4324c9be0d349811ee3ef.jpg?1426620681";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5200p-ira', 'DH-IPC-HFW5200P-IRA', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/553/original/dac232dc9acabba0f63d50d3381033c1.jpg?1426621745";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5100n-ira', 'DH-IPC-HFW5100N-IRA', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/547/original/b7dc169ef3163d95804294954f6c0670.jpg?1426620675";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw5100p-ira', 'DH-IPC-HFW5100P-IRA', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/548/original/450c0a6480c752399988c8f8c7f71433.jpg?1426620668";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5302', 'IPC-HDBW5302', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/644/original/b76b474342378dd5a20ee67d06a61bcf.jpg?1426620659";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5300', 'IPC-HDBW5300', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/642/original/aea7e31ad7cbcdd7109d77d1cc13f0d9.jpg?1426620408";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hfw5302c', 'IPC-HFW5302C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/651/original/9c840404446c3e5fa2c46a8806340c96.jpg?1426620651";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hfw5300c', 'IPC-HFW5300C', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/650/original/e42f2cc9db29f8a6b6ce19fcee9ff04c.jpg?1426620642";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw4100e-as', 'IPC-HDBW4100E-(A)(S)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/635/original/7ec4bae0679bf2a0d5ab78f721306f15.jpg?1426620630";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw4200e-as', 'IPC-HDBW4200E-(A)(S)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/636/original/19a896e39ba589856c05c3ef592bbc7e.jpg?1426620614";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw4300e-s', 'IPC-HDBW4300E-(S)', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2052x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/630/original/aa69552a47b09b7600906d69c0c363a8.jpg?1426621736";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5302-di', 'IPC-HDBW5302-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/643/original/84ca043405c753d8a1b6a76017c1561c.jpg?1426620602";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw5300-di', 'IPC-HDBW5300-DI', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/641/original/aa89ae1c1bb1a8024eb1ca990da2823e.jpg?1426620591";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdbw8301', 'IPC-HDBW8301', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/645/original/d3d6ac54a2a6ffc09d9cbd272193d049.jpg?1426620581";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'ipc-hdb8301', 'IPC-HDB8301', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Dome', 'admin', 'admin', '1', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/634/original/e389029e063869d917122650ae1668e6.jpg?1426620574";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hf8301en', 'DH-IPC-HF8301EN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Box', 'admin', 'admin', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/523/original/317829a925c2c62e0b98fbb996e7f3f7.jpg?1426620568";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hf8301ep', 'DH-IPC-HF8301EP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Box', 'admin', 'admin', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/524/original/7e6fd62148bc763ebc91f55bd5fe4d0b.jpg?1426620554";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw8301en', 'DH-IPC-HFW8301EN', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/631/original/fcb5be6ab04652817397a7d21298b244.jpg?1426620547";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'dh-ipc-hfw8301ep', 'DH-IPC-HFW8301EP', '30', 'onvif/media_service/snapshot', '', '/realmonitor?channel=1&subtype=1', '2048x1536', 'Bullet', 'admin', 'admin', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/632/original/bdafaa432c3eb257932b040ec2f03d27.jpg?1426620560";}}', 'http://www.dahuasecurity.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip81100', 'TVIP81100', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/468/original/16f6db1fb446371a7d431e72b55fa89f.jpg?1426618165";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip81000', 'TVIP81000', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/467/original/6e396c16442062f9e70e9bb37d122ee6.jpg?1426618160";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip82100', 'TVIP82100', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/470/original/22949c4c1f83f5fc9120a721b9948ea5.jpg?1426618155";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip82000', 'TVIP82000', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/469/original/8038cacab66d299d872824bc941d390b.jpg?1426618150";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip52502', 'TVIP52502', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/460/original/c00f6b97333992b4553a9325068dc6f0.jpg?1426618145";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip51550', 'TVIP51550', '31', '', 'video.mjpg', 'video.h264', '1280x1024', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/459/original/aeb8360122e741cf86aa37d37f88eaed.jpg?1426618139";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip60550', 'TVIP60550', '31', '', 'video.mjpg', 'video.h264', '640x480', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/461/original/0bc00a7998a5a05815ce3508ec127721.jpg?1426618135";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip62500', 'TVIP62500', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/462/original/1777594248b64e30521df741bb174772.jpg?1426618130";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip41550', 'TVIP41550', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 1, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/458/original/f4f0da5cf2ed8b4c8f279edfa1f5cb0b.jpg?1426618125";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip72000', 'TVIP72000', '31', '', 'video.mjpg', 'video.h264', '1600x1200', 'Dome', 'admin', '12345', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/465/original/ad8aa7ff809995d879de246a8e31bd7d.jpg?1426618119";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip71551', 'TVIP71551', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/464/original/8e5f06697b998acff35ff71c97402c20.jpg?1426618114";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip71501', 'TVIP71501', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/463/original/a6cce7b88ef1e84cf1b994cfb1c1b58f.jpg?1426618110";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip72500', 'TVIP72500', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/466/original/0d3c3b3b0a7fbd751991027bdfc8364a.jpg?1426618105";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip31001', 'TVIP31001', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/452/original/f413309f1e83a3680095d53ef38d23ad.jpg?1426618101";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip31551', 'TVIP31551', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/455/original/cd709056a32deafa419593f0bdba12fb.jpg?1426618096";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip31501', 'TVIP31501', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/454/original/585901be59ea817467be8054c5ac7185.jpg?1426618091";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip31050', 'TVIP31050', '31', '', 'video.mjpg', 'video.h264', '1280x1024', 'Dome', 'admin', '12345', '', 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/453/original/9ee981da8cd7e4b073c475d1dc1edfd0.jpg?1426618086";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip32500', 'TVIP32500', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/456/original/8a441fe1d0e7c46f5d342dab9a347828.jpg?1426618082";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip41500', 'TVIP41500', '31', '', 'video.mjpg', 'video.h264', '1280x960', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/457/original/47fa58f5e5e0c90f1673f74e3ea45f17.jpg?1426618077";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip10055b', 'TVIP10055B', '31', '', 'video.mjpg', 'video.h264', '640x480', 'Other', 'admin', '12345', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/446/original/fa96dad2a0dbba58dcfb44d48b65208b.jpg?1426618170";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip10005b', 'TVIP10005B', '31', '', 'video.mjpg', 'video.h264', '640x480', 'Other', 'admin', '12345', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/445/original/05fbc0cb0fcf838d580506c912ded273.jpg?1426618073";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip21552', 'TVIP21552', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/450/original/76e680972f2d99b157ac73bf50639413.jpg?1426618068";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip21502', 'TVIP21502', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/449/original/134a394da8657515d68b47274712980e.jpg?1426618061";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip22500', 'TVIP22500', '31', '', 'video.mjpg', 'video.h264', '1920x1080', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/451/original/3b927dc38b50ff9135598be1a210f41c.jpg?1426618056";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip11552', 'TVIP11552', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/448/original/2cca8de588aec9a8f414b6f9caa19613.jpg?1426618051";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'tvip11502', 'TVIP11502', '31', '', 'video.mjpg', 'video.h264', '1280x720', 'Other', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/447/original/92c6726abab219a641dc5849cdc24c5b.jpg?1426618046";}}', 'http://abus.com/');
INSERT INTO "cameras" 
VALUES (NULL, 'back-camera', 'Back Camera', '32', 'back.jpg', '', '', '-', 'Other', '-', '-', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'front-camera', 'Front Camera', '32', 'front.jpg', '', '', '-', 'Other', '-', '-', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8620', 'FI8620', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '729x576', 'Dome', 'admin', '', '', 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/600/original/150397cde8beb3d0adef8fdef3ed6526.jpg?1415742851";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/599/original/9956fde28e9fc96a066e75a0b983d194.jpg?1426618326";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/712/original/6c49982f575d5937e1e3e6f5aaa307cb.png?1415776169";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/713/original/3b1ad04aa026336fa807f981dc0f6e58.png?1415776175";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9819w', 'FI9819W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Dome', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/634/original/37bdd5d4c37bb9e7eeb1a53f98e109d0.jpg?1426618315";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9828w', 'FI9828W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x960', 'Dome', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/676/original/3b5a8faf883291fe23f6598db450533d.jpg?1415743157";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/677/original/7b2f0d4aca9c30d04a5ac9aac33bf2cf.jpg?1415743160";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/678/original/8ad04956b508e0eb3f4916e89cfab46f.jpg?1415743166";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/675/original/a65085cb73f1266ea6ded0d7fae16af3.jpg?1426618319";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/724/original/fd1f4a3ee07b8a4d215816f319d684a3.png?1415776242";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9851p', 'FI9851P', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Dome', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/683/original/77078b3af554d0b6bc674d97908509dc.jpg?1415743185";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/684/original/8f05b8b4f1889c2bcaeb16a4ee48e577.jpg?1415743189";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/682/original/940743284c4fff7f7df01d8025a04028.jpg?1426618304";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/685/original/b6ae78f96075a6e7ad846d8625099f63.jpg?1415743193";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8608wb', 'FI8608W(B)', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 1, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/636/original/3770f7b3b9ec166efcfb84e25aaa6410.jpg?1416308208";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/637/original/6d7195118575ab07eeaf3d5d373b4333.jpg?1416308210";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/635/original/1a3ca11bf69c9a6b332fbc6d10590585.png?1426618332";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8602ws', 'FI8602W(S)', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '729x576', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/638/original/d2fe15d5a05a72ad32d0b28ac435d8c8.jpg?1426618309";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8601ws', 'FI8601W(S)', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '729x576', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/639/original/25c09aefb0218771cd70337e2224ab78.jpg?1426618183";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9802w', 'FI9802W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/642/original/06b86b19136806ea843c18e2b2129634.jpg?1415743022";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/643/original/4a50cf417dd36cc2594e07c34ca36a8e.jpg?1415743026";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/641/original/e726b37a23c1a0fb50304b573d523f8d.jpg?1426618300";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9801w', 'FI9801W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/638/original/2185830c9d0d1e19b9cb8db7127eb2b3.jpg?1415743005";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/639/original/eb38607ea3ae7c7161283648aaf6c762.jpg?1415743008";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/640/original/989536492278b16fb81ea5746a4405c8.jpg?1415743013";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/637/original/683886dc218885994bbd32d7477d5202.jpg?1426618295";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8907w', 'FI8907W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/619/original/8985de591a08655a7cea1900c6a089c8.jpg?1415742926";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/618/original/aae47a71a687107216448f76d8441274.jpg?1426618288";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/620/original/180efb07f100f6fa3de3efb6ead9b883.jpg?1415742931";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8909w', 'FI8909W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/622/original/4e56bcf04b6b6beef1960a47d1a835fc.jpg?1415742939";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/623/original/013d034bc34b3c5f8d435567e2d5339e.jpg?1415742943";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/624/original/911396ccc8dd76eca76a2c4f0b19c744.jpg?1415742947";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/621/original/408fd3379635968390e3bc3f479d5dad.jpg?1426618284";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/714/original/ed5a8d9d5e5b54f584246e5c9c62d8a7.png?1415776184";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8904w', 'FI8904W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/602/original/6568e0b8872bda0096950699eb168754.jpg?1415742860";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/603/original/00adbafb730cf2ef7fb2d8ff41dd8ca7.jpg?1415742864";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/604/original/7e92c251737682823b9e6a82b825319a.jpg?1415742868";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/605/original/877719bf6000dbeab5d0e456a97a585e.jpg?1415742872";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/601/original/7e4b357cfec68fbb9c6537b8e69b0a2e.jpg?1426618279";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8905e', 'FI8905E', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/607/original/b4bbe9df70ca8142b49f9fb46f840919.jpg?1415742879";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/608/original/e0e25d8b8b88718f0a6f03ba4b5801e1.jpg?1415742883";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/609/original/8f6d2be800417120fa30d0aa2bbe3182.jpg?1415742887";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/606/original/50dd8a04ea2fb1a57f564aeb5ccadd08.jpg?1426618275";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8905w', 'FI8905W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/611/original/85608dc5162d02e61ccbe9221d509c2f.jpg?1415742895";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/612/original/0b873cdbfba656ecfafd741cce6f953d.jpg?1415742900";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/613/original/98197a9c36b179e14e6a67552fae996c.jpg?1415742903";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/610/original/89ce587937a68819d354998ad7981bcc.jpg?1426618270";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8906w', 'FI8906W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Bullet', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/615/original/7bae2e6a142ca2357f339217b7e60c6b.jpg?1415742910";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/616/original/cb12740182d64a5714a3859e22e7cb00.jpg?1415742913";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/617/original/8d4d58a5991e4da23cad424b18fb7a16.jpg?1415742918";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/614/original/fcb76934fad080b843831d7375dc66c1.jpg?1426618266";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8916w', 'FI8916W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/632/original/c081cbb6ce9e1f49153034616b309935.jpg?1415742980";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/633/original/d037c3dd4ba7ac58fb2dc0148b5e8b7e.jpg?1415742984";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/631/original/7e781dbb1e365e9d0e3cfbbec63ce9fd.jpg?1426618261";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/717/original/4ca2f0046467389e5b029cae4c6c986d.png?1415776198";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8918w', 'FI8918W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/635/original/767fbfb5762f02012a485e4de3edb332.jpg?1415742992";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/636/original/4d460b453bede99a7958194233042a0e.jpg?1415742997";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/634/original/47da6187461b7a884263d15aa4013e2c.jpg?1426618256";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/718/original/32f520812441806f35c72484cae5bc54.png?1415776204";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8910e', 'FI8910E', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/626/original/3834c1add0a5c939824f0b95209f4cdd.jpg?1415742956";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/627/original/947dadb241d6aea62bb08e2205043f11.jpg?1415742959";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/625/original/985169b4b972c020d5c6b2115eac8a99.jpg?1426618250";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/715/original/e02b953df184fd989cfd032eaef6673e.png?1415776188";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi8910w', 'FI8910W', '33', 'snapshot.cgi', 'videostream.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/629/original/96e8325127c841eabc6e111d9d011d60.jpg?1415742968";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/630/original/3fb08e801c69a76c562da8718b6eade5.jpg?1415742972";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/628/original/ed1fa69518194fde2c29484fb1da5148.jpg?1426618246";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/716/original/7093225651f2cd54f2351a40d1e257ea.png?1415776193";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9804w', 'FI9804W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/649/original/e58ec4a17c2726b08fccbcdfdfd8690f.jpg?1415743050";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/650/original/223fcb48ab560002841700e3f2aae8dc.jpg?1415743053";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/648/original/70a2927455ad604ede59564d9ccdeade.jpg?1426618239";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9805e', 'FI9805E', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x960', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/652/original/af92916a64636b4cea7fdb5a3d5fc56e.jpg?1415743062";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/653/original/22cf683307892400ee6a5f0ec3927bc8.jpg?1415743066";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/654/original/f56f49c4489a90060123cd1d58dbbce2.jpg?1415743070";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/651/original/8a3ab22da2e60bc928f59e9149f00314.jpg?1426618233";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/719/original/34f31d4abb51c31bf3f084a0b3a68653.png?1415776212";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9805w', 'FI9805W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x960', 'Bullet', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/656/original/feb265cf73c3694d9b8b9cafb78b255d.jpg?1415743079";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/657/original/faf83404f0d81068006a92f69c79778a.jpg?1415743083";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/655/original/3898b3d30eb7483ec028a1c0dc4a16f6.jpg?1426618226";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9803p', 'FI9803P', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Box', 'admin', '', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/645/original/0cd664aa05f6df581f7ec2d8b8048efd.jpg?1415743033";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/646/original/98ff32957f7540c9f5cb530279084e8a.jpg?1415743037";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/647/original/3a5dfacb14ed332756bfed0b9ee528d2.jpg?1415743040";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/644/original/71c0fa4ecb44927b373e6955f042bf58.jpg?1426618220";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9818w', 'FI9818W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/659/original/4a0cfe7eec8bbf70a06565329f2d6fc5.jpg?1415743091";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/660/original/8ac6f5730a442dfcd58c646bdccfff3c.jpg?1415743095";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/661/original/4aad4f027d40b0644e45acbd2eca3839.jpg?1415743099";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/662/original/370d33d2f31c9e6990060cfa9b7ceee4.jpg?1415743104";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/663/original/18afe14146f46264e604d4ce119931e1.jpg?1415743107";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/658/original/ac993cd54f6c012c731f5f561139c064.jpg?1426618215";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9821w', 'FI9821W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/669/original/ac494c2ef81342a9903b66db7ce83b11.jpg?1415743130";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/670/original/0bf7e7a5865a3de0223376cd074cbe77.jpg?1415743133";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/668/original/24f536f5592518f294003f212a3e7ce3.jpg?1426618210";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9821p', 'FI9821P', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/665/original/8668335a9e4dc11f5118daf649744bce.jpg?1415743116";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/666/original/f2afe90f5cb2bb89b077b258a96002d9.jpg?1415743119";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/667/original/be262b1861c84ddaad0f0f02ee6ee20f.jpg?1415743122";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/664/original/dde9fa8bdaaebe15e8fe0975fa9750e2.jpg?1426618205";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9831w', 'FI9831W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x960', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/680/original/122bb9d3ee31c5aaebcc9c193cb38dc4.jpg?1415743175";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/681/original/ba4c815437bd507eb920d8a4caa43526.jpg?1415743178";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/679/original/95d1b257bf0c267f9ab5762c3699ea7b.jpg?1426618199";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9826w', 'FI9826W', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x960', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/674/original/c8dd80137e38165cda177b9734c4e702.jpg?1415743149";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/673/original/c5e27f2070a6f0b004e6c5a6ccf34b2e.jpg?1426618194";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/721/original/cecb6174360be08d64cc55a237ed1eab.png?1415776225";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/722/original/23c86e0b7a9db54867e8e3d618bd646d.png?1415776231";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/723/original/adbbe506720e0abd0765a0877346e7b1.png?1415776236";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fi9826p', 'FI9826P', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x960', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/671/original/4cc17d91a308a82af64c54222cf9af69.jpg?1426618190";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/672/original/e94bef730b9cf9e0352c450f4231e408.jpg?1415743140";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/720/original/1e5c82e095d2921e4b9b5efd90da00ee.png?1415776220";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'fosbaby', 'Fosbaby', '33', 'cgi-bin/CGIProxy.fcgi?cmd=snapPicture2', 'cgi-bin/CGIStream.cgi?cmd=GetMJStream', 'videoMain', '1280x720', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/686/original/6f040ff98ea9aedaf769657f4c44ec0f.jpg?1426618187";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/687/original/00870f746a5a183de82e5a1949c58762.jpg?1415743200";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/725/original/770499c61d57b528766c3a89a896f0a5.png?1415776247";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'li175mb', 'Li175MB', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/993/original/e3b43bb6590d6b7487067d985decaffd.jpg?1426617710";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/994/original/60a4ff39348e284f411a3bbccb7315ff.jpg?1415744539";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/995/original/30d14cd389cceb36b124fb4da9f693a4.jpg?1415744542";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/996/original/468274df202f9d61895e8aba1d49c5c0.jpg?1415744545";}}', 'http://www.lumenera.com/products/surveillance-cameras/li175m.php');
INSERT INTO "cameras" 
VALUES (NULL, 'li175cb', 'Li175CB', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/989/original/f3733e17394d6d2e5b9f303736283af3.jpg?1426617707";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/990/original/7b92477c9a2bfd91e221ab94f47ce86e.jpg?1415744524";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/991/original/3ae9ba5fe7a117fb8080a9c19096e352.jpg?1415744527";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/992/original/633d68c0f2682d5d85f26c4d0610ff17.jpg?1415744530";}}', 'http://www.lumenera.com/products/surveillance-cameras/li175ca.php');
INSERT INTO "cameras" 
VALUES (NULL, 'li165', 'Li165', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '1376x1032', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/986/original/1425ee05bb6081f70df9f73596b4d8e5.jpg?1415744509";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/987/original/e7730839441362d2134e55ae5fb4a04a.jpg?1415744512";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/988/original/ce267fac23275557ca9151708d8f6dc0.jpg?1415744516";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/985/original/b8bbbc5c539a1aa1138cec9f26ac394c.jpg?1426617702";}}', 'http://www.lumenera.com/products/surveillance-cameras/li165.php');
INSERT INTO "cameras" 
VALUES (NULL, 'li045', 'Li045', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '720x480', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/982/original/8674307e4d3ca35d4a912939cd3b02e9.jpg?1415744488";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/983/original/46813e1b71dc2090be78afb901991340.jpg?1415744494";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/981/original/214acbde53ccf4025f2d11541a947b62.jpg?1426617699";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/984/original/630a5903c58b29588de4c40259590922.jpg?1415744499";}}', 'http://www.lumenera.com/products/surveillance-cameras/li045.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le575', 'Le575', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '2560x1920', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/980/original/e7e099e988a1c92afc3810a060b97606.jpg?1415744478";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/979/original/68db63759c1b9352dfab860634a5eabf.jpg?1426617694";}}', 'http://www.lumenera.com/products/surveillance-cameras/le575.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le375', 'Le375', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/978/original/b3005b311b4da76c10ba61d35de4fd9f.jpg?1415744471";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/977/original/fb451a3aa40c64acbf5dea29d85922fa.jpg?1426617691";}}', 'http://www.lumenera.com/products/surveillance-cameras/le375.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le175m', 'Le175M', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/975/original/e36d91e420c3fb5bca9faffb95bea97d.jpg?1415744460";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/976/original/4cd09d0b39cd3afec55ff6593f8b59ce.jpg?1426617686";}}', 'http://www.lumenera.com/products/surveillance-cameras/le175m.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le175ca', 'Le175CA', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/974/original/4cd40aa1216b82fcd21b65473b93db7b.jpg?1415744455";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/973/original/4c754cfd3c0beeb8075e499f8e8808e4.jpg?1426617682";}}', 'http://www.lumenera.com/products/surveillance-cameras/le175ca.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le165', 'Le165', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '1376x1032', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/972/original/648b63e382fd7df5957ab6d3d3198240.jpg?1415744447";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/971/original/3c66f52184e433e1ab76354d4a054f64.jpg?1426617714";}}', 'http://www.lumenera.com/products/surveillance-cameras/le165.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le075', 'Le075', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '640x460', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/970/original/d1e75fe5f92398b27e7db3e1aac77c7a.jpg?1415744436";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/969/original/69505dd56cf3ac0a73cb75d96cd7cd68.jpg?1426617678";}}', 'http://www.lumenera.com/products/surveillance-cameras/le075.php');
INSERT INTO "cameras" 
VALUES (NULL, 'le045', 'Le045', '34', 'cgi-bin/nph-image.jpg', 'cgi-bin/nph-video', '', '720x480', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/968/original/040120602f32efb52e5432850ea819ab.jpg?1415744425";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/967/original/6c8c14eb683cebfc9fb89a9b546b6386.jpg?1426617674";}}', 'http://www.lumenera.com/products/surveillance-cameras/le045.php');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm830w', 'ICA-HM830W', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/167/original/5e51c8d912bb4fb3685fc8c0174e78f9.jpg?1415745322";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/166/original/53c663f6104c44d3356c7d66a97e3501.jpg?1426618752";}}', 'http://www.planet.com.tw/en/product/product.php?id=48401');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-w8500', 'ICA-W8500', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1920', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/178/original/deb3deb90248df83140684d9cd559957.jpg?1415745371";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/179/original/e3b650c563a4edd4e04d372ed65d0777.jpg?1415745374";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/177/original/6f6df3bc29710fb4db722aa8fb7fa03f.jpg?1426618746";}}', 'http://www.planet.com.tw/en/product/product.php?id=48518');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-w8100-cld', 'ICA-W8100-CLD', '35', 'cgi-bin/jpg/image.cgi', '', '', '1280x720', 'Box', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/172/original/441ab9e881a42814115bf0ef188b5622.jpg?1415745347";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/173/original/9f59da76dd1dee9c16b0c89893098767.jpg?1415745351";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/171/original/180a778e30a6c12489ab8e395e058d1f.jpg?1426618741";}}', 'http://www.planet.com.tw/en/product/product.php?id=48464');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-8500', 'ICA-8500', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1920', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/139/original/72343f4854216713bbb110fbc3e32141.jpg?1415745189";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/140/original/0289710278a5c80bcea5b168da93c49a.jpg?1415745193";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/138/original/1b43695f68e8e832f4ac8e4450ed38cf.jpg?1426618736";}}', 'http://www.planet.com.tw/en/product/product.php?id=48508');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-8350', 'ICA-8350', '35', 'cgi-bin/jpg/image.cgi', '', '', '1536x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/137/original/6a29473c70e03a743d48eab3984bc088.jpg?1426618731";}}', 'http://www.planet.com.tw/en/product/product.php?id=45908');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm620', 'ICA-HM620', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/165/original/023a5bf1f87e2f47060119b4df14fbeb.jpg?1415745313";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/164/original/c84510a206215ab005152915a1aeaf3e.jpg?1426618725";}}', 'http://www.planet.com.tw/en/product/product.php?id=44938');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-h652', 'ICA-H652', '35', 'cgi-bin/jpg/image.cgi', '', '', 'ntsc720x480/pal720x576', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/142/original/cb759e9a44bfc5cbf9dd344e56d0e508.jpg?1415745204";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/141/original/005524ae2cd85a6cb5a9e53b82252233.jpg?1426618719";}}', 'http://www.planet.com.tw/en/product/product.php?id=48442');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm227w', 'ICA-HM227W', '35', 'cgi-bin/jpg/image.cgi', '', '', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/155/original/84fb93072ad3d61b7177aac84bfc59fb.jpg?1415745267";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/154/original/865aad7524e13957c888cc197ae048d4.jpg?1426618713";}}', 'http://www.planet.com.tw/en/product/product.php?id=42087');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm136', 'ICA-HM136', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/153/original/74a538cf1c36b66148fba207e3b9d8d4.jpg?1415745257";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/152/original/840f0344834750565953d7e9275e306d.jpg?1426618707";}}', 'http://www.planet.com.tw/en/product/product.php?id=33705');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-5550v', 'ICA-5550V', '35', 'cgi-bin/jpg/image.cgi', '', '', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/136/original/f60e6fe26933a57af6f8c9ec2eca2522.jpg?1426618701";}}', 'http://www.planet.com.tw/en/product/product.php?id=48428');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-5350v', 'ICA-5350V', '35', 'cgi-bin/jpg/image.cgi', '', '', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/135/original/a55daa4e598c7fcd2ab4b58051932d61.jpg?1426618696";}}', 'http://www.planet.com.tw/en/product/product.php?id=42578');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-5250v', 'ICA-5250V', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/134/original/76d5bad27f35c98b4d3b0c2d38d31c53.jpg?1426618690";}}', 'http://www.planet.com.tw/en/product/product.php?id=48427');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm132', 'ICA-HM132', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/151/original/ff363bf086b950303cac92d8edcaf621.jpg?1426618685";}}', 'http://www.planet.com.tw/en/product/product.php?id=35010');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-4500v', 'ICA-4500V', '35', 'cgi-bin/jpg/image.cgi', '', '', '2592x1944', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/131/original/b7aa8a3dbb5f779c937f10cdc573ebed.jpg?1426618680";}}', 'http://www.planet.com.tw/en/product/product.php?id=48250');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-4210p', 'ICA-4210P', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/127/original/8f8a20b3dac8bef6ffc75b37b6b8aabe.jpg?1426618673";}}', 'http://www.planet.com.tw/en/product/product.php?id=48551');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-4200v', 'ICA-4200V', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/126/original/915057b4c0a2e3d25f2bcd9c5f5d4fb2.jpg?1426618668";}}', 'http://www.planet.com.tw/en/product/product.php?id=45907');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm316w', 'ICA-HM316W', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/161/original/a4c0f2bfcddd782842f4d26752c01fd4.jpg?1415745295";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/162/original/7a110bf2228045f78d3a12c9ee1d06be.jpg?1415745299";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/160/original/b748201be564ba8fc55d073c30b71d58.jpg?1426618663";}}', 'http://www.planet.com.tw/en/product/product.php?id=47248');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm316', 'ICA-HM316', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/158/original/ff398f2919b13834489853ef1c932528.jpg?1415745283";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/159/original/76f125434ef71f500337ab2fbef4ce86.jpg?1415745286";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/157/original/0477c8c015ecc670ba23624a0447ae01.jpg?1426618657";}}', 'http://www.planet.com.tw/en/product/product.php?id=47382');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm312', 'ICA-HM312', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/156/original/5014e77dfa4f38320ea79927710afeab.jpg?1426618652";}}', 'http://www.planet.com.tw/en/product/product.php?id=38844');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-3550v', 'ICA-3550V', '35', 'cgi-bin/jpg/image.cgi', '', '', '2592x1944', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/120/original/3a2a2e1712797dffaa7c6266d601f357.jpg?1415745097";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/121/original/e89fbeb862f6de8772a7053eaca14879.jpg?1415745100";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/122/original/17375d0fb740ef81f12f22341bcb7219.jpg?1415745102";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/119/original/25e65d85af274f13744387ffb367e78d.jpg?1426618646";}}', 'http://www.planet.com.tw/en/product/product.php?id=48445');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-3350v', 'ICA-3350V', '35', 'cgi-bin/jpg/image.cgi', '', '', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/118/original/a8bb9c5dd8c838a949414c097423ef2f.jpg?1426618639";}}', 'http://www.planet.com.tw/en/product/product.php?id=42951');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-3260', 'ICA-3260', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/117/original/88329fc27ddc097bb60844c1f20df97e.jpg?1426618633";}}', 'http://www.planet.com.tw/en/product/product.php?id=48549');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-3250v', 'ICA-3250V', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/114/original/7aeda756d81a512fbc7cab42a879f226.jpg?1415745068";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/115/original/e1bad9c1b082579ab57bc5c453bd36a7.jpg?1415745073";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/116/original/a1ebc8cb0744a63867e6be8de915b05a.jpg?1415745077";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/113/original/6b81dcf845fffac6043845b630d7591b.jpg?1426618625";}}', 'http://www.planet.com.tw/en/product/product.php?id=45906');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm351', 'ICA-HM351', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/163/original/738e53b53efdd2f42509c36a02ecadc1.jpg?1426618617";}}', 'http://www.planet.com.tw/en/product/product.php?id=37829');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-2250vt', 'ICA-2250VT', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/104/original/b68c1a217c65c521c0490a4294de86e7.jpg?1415745022";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/103/original/36d9480a7d6b353288b95785c842bbca.jpg?1426618607";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/105/original/2c44a3adb774e70c56885f25ee645a9d.jpg?1415745026";}}', 'http://www.planet.com.tw/en/product/product.php?id=48514');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm127', 'ICA-HM127', '35', 'cgi-bin/jpg/image.cgi', '', '', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/148/original/c14343c24677773173a12ce8f5514253.jpg?1415745229";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/147/original/de8d57f2ce489bf1852794b4cb7337a8.jpg?1426618598";}}', 'http://www.planet.com.tw/en/product/product.php?id=39230');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-2500', 'ICA-2500', '35', 'cgi-bin/jpg/image.cgi', '', '', '2592x1944', 'Box', 'admin', 'admin', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/107/original/64d2e3ff98f481ec11d1c0a585985d05.jpg?1415745036";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/108/original/191696cc70aca6e05fb568ae49a61760.jpg?1415745038";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/106/original/461be9fab853c6862ba6790f36e27f78.jpg?1426618591";}}', 'http://www.planet.com.tw/en/product/product.php?id=44281');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-2200', 'ICA-2200', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/101/original/b36da1e326eea779706fde4ccbc34cc9.jpg?1415745008";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/102/original/8f72deee62de6dab0d31c10635bd7f6b.jpg?1415745013";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/100/original/d92cf524b89120d416e256a398606af9.jpg?1426618583";}}', 'http://www.planet.com.tw/en/product/product.php?id=42576');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-w8100', 'ICA-W8100', '35', 'cgi-bin/jpg/image.cgi', '', '', '1280x720', 'Box', 'admin', 'admin', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/175/original/cf51236009e0209b58afd6163cb53193.jpg?1415745360";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/176/original/2673500a86fde21e100c706fc0bee3e7.jpg?1415745363";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/174/original/8c7300750bf5ecd96aa60b0c728231f0.jpg?1426618575";}}', 'http://www.planet.com.tw/en/product/product.php?id=48447');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-w1200', 'ICA-W1200', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/169/original/90b8c2fcc2129b30e2c85add02bf8426.jpg?1415745332";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/170/original/a53e00ee83a48e9e25d71de33183714d.jpg?1415745336";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/168/original/14c98792b607bc62ca407232c1345bb9.jpg?1426618569";}}', 'http://www.planet.com.tw/en/product/product.php?id=48260');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm101w', 'ICA-HM101W', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/145/original/052cee29bcaec39e74803b2b3c30fd44.jpg?1426618564";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/146/original/dea4138a408d75684bbe1f9127ec9984.jpg?1415745219";}}', 'http://www.planet.com.tw/en/product/product.php?id=48536');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm101', 'ICA-HM101', '35', 'cgi-bin/jpg/image.cgi', '', '', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/144/original/8ae0b3a59e585429eecf35a311e25b7c.jpg?1415745211";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/143/original/2b68fbfde8b91aaf59df8c268694c47c.jpg?1426618559";}}', 'http://www.planet.com.tw/en/product/product.php?id=48535');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-1200', 'ICA-1200', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/098/original/00c4120c66b9e72b3d67b07a111ffb16.jpg?1415744995";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/099/original/888dfd7e4fa3cf2e5c24cb45520007f7.jpg?1415744998";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/097/original/de06142ea617c2cd768143c91ca90ced.jpg?1426618553";}}', 'http://www.planet.com.tw/en/product/product.php?id=47777');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-hm131', 'ICA-HM131', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/150/original/a4e340e2d863df73d02bf103e40b6d3f.jpg?1415745239";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/149/original/8c9b044cb6e92b94d0bf21c76f12b8b8.jpg?1426618548";}}', 'http://www.planet.com.tw/en/product/product.php?id=42712');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-5250', 'ICA-5250', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/133/original/e7b9d1a2e28d1200c9e8a45b1d7932d4.jpg?1426618542";}}', 'http://www.planet.com.tw/en/product/product.php?id=48399');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-4230s', 'ICA-4230S', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/129/original/ea60ee1cc5f2c0e17a416d50ac0d5d7a.jpg?1415745135";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/130/original/b97e3390249df2417765e807c0930250.jpg?1415745139";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/128/original/9b46412f000b8a538b2382b012269777.jpg?1426618536";}}', 'http://www.planet.com.tw/en/product/product.php?id=48540');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-3200', 'ICA-3200', '35', 'cgi-bin/jpg/image.cgi', '', '', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/112/original/66c77d92f1e63c57beb708468058cfef.jpg?1415745057";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/111/original/97540f003164ffb47298eda101bb048c.jpg?1426618530";}}', 'http://www.planet.com.tw/en/product/product.php?id=48438');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-5150', 'ICA-5150', '35', 'cgi-bin/jpg/image.cgi', '', '', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/132/original/6990ae04c00ae842b1126c95cbf69e8a.jpg?1426618524";}}', 'http://www.planet.com.tw/en/product/product.php?id=48533');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-4130s', 'ICA-4130S', '35', 'cgi-bin/jpg/image.cgi', '', '', '1280x960', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/124/original/f5d093a21ce2967aa443a9e8782f2dc8.jpg?1415745111";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/125/original/0df05922c845589a30668faf23c39775.jpg?1415745116";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/123/original/b89af133df375012cdfa92fa9d2d5efd.jpg?1426618764";}}', 'http://www.planet.com.tw/en/product/product.php?id=48539');
INSERT INTO "cameras" 
VALUES (NULL, 'ica-3110', 'ICA-3110', '35', 'cgi-bin/jpg/image.cgi', '', '', '1280x800', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/110/original/e50a2c7c6e2e1385fe8b981b199e22ad.jpg?1415745048";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/109/original/94d1d0c496d574f5c708c9650f987040.jpg?1426618518";}}', 'http://www.planet.com.tw/en/product/product.php?id=48532');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-7811', 'TCM-7811', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/115/original/22349447c56071fa125010e6a01a8f4e.jpg?1426626544";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-7811');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-7411', 'TCM-7411', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/114/original/baae3311263ad40a52d771453204a27c.jpg?1426626532";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-7411');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-6630', 'TCM-6630', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '720x480', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/557/original/c5e636040d2d7f06b9a7a2bbdd1f7f41.jpg?1426626793";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-6630');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-5611', 'TCM-5611', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/113/original/c16278494a4575249a1a3be6f40d37f2.jpg?1426626516";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-5611');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-5601', 'TCM-5601', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/558/original/25cf8631d6a3175553b5d3eff25953bc.jpg?1426626552";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-5601');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-5311', 'TCM-5311', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/559/original/fdd9fce6f75a0ebec39afb74e734e9b7.jpg?1426626560";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-5311');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-5111', 'TCM-5111', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/112/original/0de33bf53c4a422c57d9a8125d91613b.jpg?1426626508";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-5111');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-4511', 'TCM-4511', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/111/original/877eaa6096037894b47fd15773020581.jpg?1426626500";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-4511');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-4001', 'TCM-4001', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '640x480', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/110/original/3bbc93f8e953d840cf011b13206bd464.jpg?1426626491";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-4001');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-3511', 'TCM-3511', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/109/original/f80ca999a618eddf81b13c3f913a842a.jpg?1426626483";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-3511');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-3411', 'TCM-3411', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/560/original/7a2d32fe13377eb0a029cc46beecef15.jpg?1426626345";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-3401/TCM-3411');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-3401', 'TCM-3401', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/561/original/cf3d7a965bac3d80f9a30bb22e17a8d9.jpg?1426626353";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-3401/TCM-3411');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-3111', 'TCM-3111', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/108/original/aeb06bdc09ffd234f6f7e5f2a0838e86.jpg?1426626476";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-3111');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-1511', 'TCM-1511', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Bullet', 'admin', '123456', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/107/original/89c1f2cd72d4667c3d04f35d291ff15f.jpg?1426626468";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-1511');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-1231', 'TCM-1231', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/106/original/63f9f38e66aea1d4f3de101004aa68e6.jpg?1426626461";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-1231');
INSERT INTO "cameras" 
VALUES (NULL, 'tcm-1111', 'TCM-1111', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/105/original/6a41ba143ea4da614bb15076b86bf656.jpg?1426626447";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-1111');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-7211', 'KCM-7211', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/100/original/24da0b7dff4f3aa4c54d6a4b4207f98d.jpg?1426626438";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-7211');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-5311e', 'KCM-5311E', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/096/original/97b7a289640b539f94bcca4ac6bfa004.jpg?1426626430";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-5311E');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-5111', 'KCM-5111', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/093/original/658a3d526b8322c2eaec8856a8ce773f.jpg?1426626422";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-5111');
INSERT INTO "cameras" 
VALUES (NULL, 'e74', 'E74', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/008/original/f75be278fa849bf9a09346cd6ff7ef87.png?1426626413";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E74');
INSERT INTO "cameras" 
VALUES (NULL, 'e43', 'E43', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/562/original/a72fd0c38a08f4afb711beff949c5337.jpg?1426626362";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E43');
INSERT INTO "cameras" 
VALUES (NULL, 'e42', 'E42', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/965/original/5b09d369a420f5e16eef93c190e0d848.png?1426626404";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E42');
INSERT INTO "cameras" 
VALUES (NULL, 'e23', 'E23', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/563/original/9789bb6746054309c48f0d397514669e.png?1426626369";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E23');
INSERT INTO "cameras" 
VALUES (NULL, 'd22v', 'D22V', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/564/original/ebbe4c95e3592649538961308e84e4f5.png?1426626378";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D22V');
INSERT INTO "cameras" 
VALUES (NULL, 'd21v', 'D21V', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/565/original/42bdeafad046fc27d6dc3b121cbbe6a1.png?1426626386";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D21V');
INSERT INTO "cameras" 
VALUES (NULL, 'd21f', 'D21F', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/889/original/5935b00a5ffe30c1165212ca4f8707a2.png?1426626396";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D21F');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-8511', 'ACM-8511', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', 'ntsc:720x480/pal:720x576', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/815/original/fbc39ac0bfbafe979e33a5e51d3a0d5b.jpg?1426626317";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-8511');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-7411', 'ACM-7411', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/814/original/d8cfd8763ec83bc06b7025d9a74b505f.jpg?1426626310";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-7411');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-5811', 'ACM-5811', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', 'ntsc:720x480/pal:720x576', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/813/original/1304033755145457d2bc294924295f55.jpg?1426626302";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-5811');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-5611', 'ACM-5611', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/812/original/fca1af966b897f08da7e4016cb9957f6.jpg?1426626295";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-5611');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-5601', 'ACM-5601', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/811/original/b807cfa8b848b9c92cc809ea491b7b90.jpg?1426626288";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=TCM-5601');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-4201', 'ACM-4201', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Box', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/810/original/bc204c3923f16938da4f2680b0f62e4f.jpg?1426626280";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-4201');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-3703', 'ACM-3703', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/808/original/9424ec87abf3f9529f8b29d6d4fda55c.jpg?1426626272";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/809/original/d9965d932e649d20f1edd99b1b67d05d.jpg?1415812798";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-3703');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-3701e', 'ACM-3701E', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/806/original/263c83a7638f6b8c88d66dca09b90db0.jpg?1426626265";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/807/original/66fb9be7a021a6560739d96eaf8fb6ff.jpg?1415812784";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-3701E');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-3701', 'ACM-3701', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/804/original/0de8393d72d34e0cf8b12016fb1721f3.jpg?1426626257";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/805/original/ffd386391f41ae034a63313d61ed9ebd.jpg?1415812771";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-3701');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-3603', 'ACM-3603', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '640x480', 'Dome', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/802/original/143bf33284eb6c25234a0d2c860492a8.jpg?1426626250";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/803/original/eddd8443805df516609155d90baba1ee.jpg?1415812754";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-3603');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-3601', 'ACM-3601', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '640x480', 'Dome', 'admin', '123456', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/800/original/4b7cd24967b7bedd613345d76ded91bb.jpg?1426626243";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/801/original/0b180ec05d38838c4dcef8212fbce6ba.jpg?1415812740";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-3601');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-3311', 'ACM-3311', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', 'ntsc:720x480/pal:720x576', 'Dome', 'admin', '123456', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/799/original/4f131a2ebd52b8be242a750958aa48d6.jpg?1426626235";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-3311');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-1511', 'ACM-1511', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Bullet', 'admin', '123456', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/798/original/dff8c56c50184b6e508ac2c0285e23e7.jpg?1426626227";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-1511');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-1431', 'ACM-1431', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', 'ntsc:720x480/pal:720x576', 'Bullet', 'admin', '123456', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/797/original/fb077ef574851cfb9835357fad957a80.jpg?1426626218";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-1431');
INSERT INTO "cameras" 
VALUES (NULL, 'acm-1231', 'ACM-1231', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x1024', 'Bullet', 'admin', '123456', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/796/original/626b13614390cf2f520c4e551f6d893f.jpg?1426626208";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=ACM-1231');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-8211', 'KCM-8211', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/104/original/6e773de7307e4c4c8df3574e78613eaa.png?1426626200";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-8211');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-8111', 'KCM-8111', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/103/original/97ff8d3fa0f506c4c76769b663b1978d.jpg?1426626191";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-8111');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-7911', 'KCM-7911', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/102/original/3133b434f894a179fe4ce3ddc9d8bfe0.jpg?1426626184";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-7911');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-7311', 'KCM-7311', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/101/original/5521036f2de3c14086e9555bca9c670f.png?1426626173";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-7311');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-7111', 'KCM-7111', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/099/original/cfe1a6d8f38256dbcb133c3abf5c49de.jpg?1426626165";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-7111');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-5611', 'KCM-5611', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/566/original/9443b14663008ba3221aad67188dc4d5.jpg?1426626571";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-5611');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-5511', 'KCM-5511', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/567/original/a3e62133fdc1a5b50be45830ada0baf5.jpg?1426626579";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-5511');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-5211e', 'KCM-5211E', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/568/original/2e353936455607ebc1e4a16adaddb55e.jpg?1426626332";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-5211E');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-5211', 'KCM-5211', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/569/original/fa166605cf787b5edba8066361062d4e.jpg?1426626138";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-5211');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-3911', 'KCM-3911', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/092/original/5f6a5601a955fef4c630646378fbd0a4.jpg?1426626156";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-3911');
INSERT INTO "cameras" 
VALUES (NULL, 'kcm-3311', 'KCM-3311', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2032x1920', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/091/original/da3ba6bcd39a97f3b970ee99a2021dab.jpg?1426626147";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=KCM-3311');
INSERT INTO "cameras" 
VALUES (NULL, 'i98', 'I98', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/090/original/f8d3079eb86a0da076fd31f051edd2df.png?1426626123";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I98');
INSERT INTO "cameras" 
VALUES (NULL, 'i97', 'I97', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/089/original/cb2ffa219b6acaeb1b43d4c855cc3401.png?1426626115";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I97');
INSERT INTO "cameras" 
VALUES (NULL, 'i96', 'I96', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/088/original/f6c7828e606322ec3860b11a619765fd.png?1426626107";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I96');
INSERT INTO "cameras" 
VALUES (NULL, 'i95', 'I95', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/087/original/2882dac7849c66813811e8190d71f8e8.png?1426626098";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I95');
INSERT INTO "cameras" 
VALUES (NULL, 'i94', 'I94', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/086/original/97976702e4dcde4df96b488bbfc2630d.png?1426626088";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I94');
INSERT INTO "cameras" 
VALUES (NULL, 'i93', 'I93', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/085/original/90d8cc67084e50210e51ce55971971f3.png?1426626074";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I93');
INSERT INTO "cameras" 
VALUES (NULL, 'i928', 'I928', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/084/original/96de871cd90b5d8cb58e2bbe33fa3c4e.png?1426626058";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I928');
INSERT INTO "cameras" 
VALUES (NULL, 'i927', 'I927', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/083/original/14d199c5767c8035f0a30c8c1ffcbc95.png?1426626043";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I927');
INSERT INTO "cameras" 
VALUES (NULL, 'i925', 'I925', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/082/original/504e5ff3b79a56016a5738e1528d546f.png?1426626026";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I925');
INSERT INTO "cameras" 
VALUES (NULL, 'i920', 'I920', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/081/original/00fe41b3e596998261c85eff82b17abd.png?1426626010";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I920');
INSERT INTO "cameras" 
VALUES (NULL, 'i92', 'I92', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/080/original/e48354d48ba6e14cd3611abe4ce65050.jpg?1426625995";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I92');
INSERT INTO "cameras" 
VALUES (NULL, 'i919', 'I919', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/079/original/eb28d93bee21aafb3e22970cf07e6afc.png?1426625980";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I919');
INSERT INTO "cameras" 
VALUES (NULL, 'i917', 'I917', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/078/original/a9badcf0c5b7cda7fdf8630c672e4fee.png?1426625964";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I917');
INSERT INTO "cameras" 
VALUES (NULL, 'i916', 'I916', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/077/original/5bb750e01bf331f0e2a14b369ee59874.png?1426625956";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I916');
INSERT INTO "cameras" 
VALUES (NULL, 'i914', 'I914', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/076/original/52d9d9fad8c6b104d9cb87df64dc7810.png?1426625945";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I914');
INSERT INTO "cameras" 
VALUES (NULL, 'i913', 'I913', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/075/original/0e9f5be6c725deef92968c7360aa16b0.png?1426623064";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I913');
INSERT INTO "cameras" 
VALUES (NULL, 'i912', 'I912', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2688x1520', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/074/original/b20447e4632fb50e1b0e964dc42982dd.jpg?1426625937";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I912');
INSERT INTO "cameras" 
VALUES (NULL, 'i911', 'I911', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2688x1520', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/073/original/8aff72201c10505bdd5e2149cda6c0f4.png?1426625929";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I911');
INSERT INTO "cameras" 
VALUES (NULL, 'i910', 'I910', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2688x1520', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/072/original/1b1fa7c2bb6b067a0c944deda3cb0010.png?1426625922";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I910');
INSERT INTO "cameras" 
VALUES (NULL, 'i91', 'I91', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/071/original/11b970318535aea01e4830e70898ee53.jpg?1426625913";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I91');
INSERT INTO "cameras" 
VALUES (NULL, 'i88', 'I88', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/170/original/a07537b9fd13581afc925f153fda2a0f.jpg?1426625902";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I88');
INSERT INTO "cameras" 
VALUES (NULL, 'i87', 'I87', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2688x1520', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/132/original/bbbf073bc8202232831c8f9b60ff5281.png?1426626800";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I87');
INSERT INTO "cameras" 
VALUES (NULL, 'i86', 'I86', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/133/original/25b0e6ce51dcd5e644963ec1f1545034.jpg?1426626131";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I86');
INSERT INTO "cameras" 
VALUES (NULL, 'i85', 'I85', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/134/original/5d9614afab3080609313db04ea546674.jpg?1426625880";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I85');
INSERT INTO "cameras" 
VALUES (NULL, 'i84', 'I84', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/135/original/a1b4294a41eeb0967f8bb295bcd7c2ce.jpg?1426626758";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I84');
INSERT INTO "cameras" 
VALUES (NULL, 'i83', 'I83', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/136/original/3aab9525d043b2c3b6312ca55cc7359f.jpg?1426625888";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I83');
INSERT INTO "cameras" 
VALUES (NULL, 'i810', 'I810', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/137/original/3604dab8badb6ab1491521b334d298c0.png?1426625894";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I810');
INSERT INTO "cameras" 
VALUES (NULL, 'i75', 'I75', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/139/original/ba28e168550e8710fb486c78edd7fb09.png?1426623048";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I75');
INSERT INTO "cameras" 
VALUES (NULL, 'i74', 'I74', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/138/original/38e2ab3a813544a31693d6b0a1b9d5b6.png?1426623082";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I74');
INSERT INTO "cameras" 
VALUES (NULL, 'i73', 'I73', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/070/original/56c8ae705fa788f2f86b2c0c3e12c2e6.jpg?1426625865";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I73');
INSERT INTO "cameras" 
VALUES (NULL, 'i72', 'I72', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/069/original/97f2c4304827805a8d8ea49a2f42da32.jpg?1426625858";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I72');
INSERT INTO "cameras" 
VALUES (NULL, 'i71', 'I71', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/068/original/d184d1060a175e9770d34e3d18a4818e.jpg?1426625847";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I71');
INSERT INTO "cameras" 
VALUES (NULL, 'i53', 'I53', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/067/original/aefae9e6924fad592dbfc8a030dc32d7.png?1426625838";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I53');
INSERT INTO "cameras" 
VALUES (NULL, 'i52', 'I52', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/066/original/a93a24184df0d9fbacc7f5a6b60369f4.png?1426625830";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I52');
INSERT INTO "cameras" 
VALUES (NULL, 'i51', 'I51', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/065/original/2ce1c77932cf604ccb66442d532ff2c2.png?1426625822";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I51');
INSERT INTO "cameras" 
VALUES (NULL, 'i49', 'I49', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/064/original/8b09997b892798d4981c4940ec398e9b.png?1426625812";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I49');
INSERT INTO "cameras" 
VALUES (NULL, 'i48', 'I48', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/063/original/396eb0acc93c040c23d90a15b6db3156.png?1426625802";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I48');
INSERT INTO "cameras" 
VALUES (NULL, 'i47', 'I47', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2688x1520', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/062/original/c0cc08c9bfa376188fafe0e1c5ecae10.png?1426625790";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I47');
INSERT INTO "cameras" 
VALUES (NULL, 'i46', 'I46', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/061/original/2a07baf490bc94c6b76d2fec2099a20b.png?1426625771";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I46');
INSERT INTO "cameras" 
VALUES (NULL, 'i45', 'I45', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/570/original/f289529a145855027f2d5ee7f1085db0.jpg?1426626607";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I45');
INSERT INTO "cameras" 
VALUES (NULL, 'i44', 'I44', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/571/original/9596d17adb5b6598340a980c360d3089.png?1426625872";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I44');
INSERT INTO "cameras" 
VALUES (NULL, 'i43', 'I43', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/060/original/708f2f76ea6e30fe744ba4522ba61630.png?1426625752";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I43');
INSERT INTO "cameras" 
VALUES (NULL, 'i29', 'I29', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/059/original/42a33b509c6be1d21cb2bab478b044f4.png?1426625745";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I29');
INSERT INTO "cameras" 
VALUES (NULL, 'i28', 'I28', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/058/original/7b277c304d3da62d4b23584d71a4b0c2.png?1426625736";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I28');
INSERT INTO "cameras" 
VALUES (NULL, 'i27', 'I27', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2688x1520', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/057/original/fe6934e6279393536cf263fcaa6584f1.png?1426625728";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I27');
INSERT INTO "cameras" 
VALUES (NULL, 'i26', 'I26', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/056/original/db6036179b956a70d9b790eb27d1f997.png?1426625719";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I26');
INSERT INTO "cameras" 
VALUES (NULL, 'i25', 'I25', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/055/original/3a41852a360c0127645fb7ee931c86e3.png?1426625709";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I25');
INSERT INTO "cameras" 
VALUES (NULL, 'i24', 'I24', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/054/original/d71eff9b69d78f8c77f016f2db21b22a.png?1426625692";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I24');
INSERT INTO "cameras" 
VALUES (NULL, 'i23', 'I23', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/053/original/1c6f76c90171e07a691ac1c804b0839c.png?1426623073";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=I23');
INSERT INTO "cameras" 
VALUES (NULL, 'e99', 'E99', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/052/original/f4064e3daa2aedd9ffd8f31745c82320.png?1426625684";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E99');
INSERT INTO "cameras" 
VALUES (NULL, 'e98', 'E98', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/051/original/afb2822bf5738258bac598c1c05265ee.png?1426625677";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E98');
INSERT INTO "cameras" 
VALUES (NULL, 'e97', 'E97', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/050/original/407e00e4fb9c15848d607a9ad3f4eedc.png?1426625669";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E97');
INSERT INTO "cameras" 
VALUES (NULL, 'e96', 'E96', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/049/original/836511df777eeb47c2a5496405b63a14.png?1426625661";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E96');
INSERT INTO "cameras" 
VALUES (NULL, 'e95', 'E95', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/048/original/79a96c4cc9051f8292f5282c0b67f28d.png?1426625648";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E95');
INSERT INTO "cameras" 
VALUES (NULL, 'e94', 'E94', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/047/original/b54bc86c3ed46522f4af3c1e9af163e1.png?1426625622";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E94');
INSERT INTO "cameras" 
VALUES (NULL, 'e931', 'E931', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/572/original/7b28f6c96d883a8b49aa202cec60fb78.jpg?1426626617";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E931');
INSERT INTO "cameras" 
VALUES (NULL, 'e930', 'E930', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/573/original/92f6878f55af92e803977207f6e735f4.jpg?1426625634";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E930');
INSERT INTO "cameras" 
VALUES (NULL, 'e93', 'E93', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/046/original/b2484b91a4724af6da2d5e9f40ded6ff.png?1426625612";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E93');
INSERT INTO "cameras" 
VALUES (NULL, 'e929', 'E929', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/574/original/f87fd73dc55612e034ae8076bbec0545.jpg?1426625398";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E929');
INSERT INTO "cameras" 
VALUES (NULL, 'e928', 'E928', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/575/original/13f75f8b82737c055cfcb76d336e4c3d.jpg?1426625410";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E928');
INSERT INTO "cameras" 
VALUES (NULL, 'e927', 'E927', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/140/original/d03965e8bd6e53afb9f405ffcaa41216.jpg?1426625419";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E927');
INSERT INTO "cameras" 
VALUES (NULL, 'e926', 'E926', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/141/original/013f8a8910817ccbde5c26ec577e387b.jpg?1426625432";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E926');
INSERT INTO "cameras" 
VALUES (NULL, 'e925', 'E925', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/142/original/379bd187a01968d345c35a8993a8e510.jpg?1426625439";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E925');
INSERT INTO "cameras" 
VALUES (NULL, 'e924', 'E924', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/143/original/fc8d25606a2712f549d14de0de4db565.jpg?1426625452";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E924');
INSERT INTO "cameras" 
VALUES (NULL, 'e923m', 'E923M', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/045/original/8e24c6a1d9ba6260627169ee0041fa8d.png?1426625603";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E923M');
INSERT INTO "cameras" 
VALUES (NULL, 'e923', 'E923', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/044/original/0501d40bc2f782349fdd8455e2d52680.png?1426625595";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E923');
INSERT INTO "cameras" 
VALUES (NULL, 'e922m', 'E922M', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/043/original/540a751ebbbba65268611b5cc54b62f9.png?1426625586";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E922M');
INSERT INTO "cameras" 
VALUES (NULL, 'e922', 'E922', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/042/original/f48cc758a8df3cd586c706fbe845e16d.png?1426625578";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E922');
INSERT INTO "cameras" 
VALUES (NULL, 'e921m', 'E921M', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/041/original/d5756d463de959b2c4f1deb62781d915.png?1426625570";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E921M');
INSERT INTO "cameras" 
VALUES (NULL, 'e921', 'E921', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/040/original/397d98a0e2412d9d50dfada5b4a31c3a.png?1426625562";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E921');
INSERT INTO "cameras" 
VALUES (NULL, 'e920m', 'E920M', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/039/original/53fe9ec2105ba72851ef0fa055883c51.png?1426625554";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E920M');
INSERT INTO "cameras" 
VALUES (NULL, 'e920', 'E920', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/038/original/3ce6ca4c75f2c6602591b0d87a0239fe.png?1426625544";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E920');
INSERT INTO "cameras" 
VALUES (NULL, 'e92', 'E92', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/037/original/b96895ad2a7002d1ae5af99d78dbe3af.png?1426625536";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E92');
INSERT INTO "cameras" 
VALUES (NULL, 'e919m', 'E919M', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/036/original/69e3a73e5574335ea05af71ec4694a73.png?1426625528";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E919M');
INSERT INTO "cameras" 
VALUES (NULL, 'e919', 'E919', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/035/original/aff140c95dc920f671ea02e8e1ce5067.png?1426625520";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E919');
INSERT INTO "cameras" 
VALUES (NULL, 'e918m', 'E918M', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/034/original/127eab77951328644c185fb2fe62b48d.png?1426625511";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E918M');
INSERT INTO "cameras" 
VALUES (NULL, 'e918', 'E918', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/033/original/5a1f0ae7a1a3aa719644b5a8a8386e95.png?1426625501";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E918');
INSERT INTO "cameras" 
VALUES (NULL, 'e910', 'E910', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/032/original/631e41304469def49d5cd0895c8e12b1.png?1426625493";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E910');
INSERT INTO "cameras" 
VALUES (NULL, 'e91', 'E91', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/031/original/98820b72cda57000c213194a58b25dea.png?1426625484";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E91');
INSERT INTO "cameras" 
VALUES (NULL, 'e89', 'E89', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/030/original/d7c883f2a41ca328655baa8f26e02a2d.png?1426625475";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E89');
INSERT INTO "cameras" 
VALUES (NULL, 'e88', 'E88', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/029/original/fe8c5294ba29611887e104f7e8d8cc20.png?1426625466";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E88');
INSERT INTO "cameras" 
VALUES (NULL, 'e86a', 'E86A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/028/original/b8e815f26fbae4ae92828eb63eba6c19.png?1426625379";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E86A');
INSERT INTO "cameras" 
VALUES (NULL, 'e86', 'E86', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/027/original/9ee07bb5593e8fa3264165f661a30128.png?1426625368";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E86');
INSERT INTO "cameras" 
VALUES (NULL, 'e85', 'E85', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/026/original/7bf5f79405e956df3b99aa01a72cc69e.png?1426625357";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E85');
INSERT INTO "cameras" 
VALUES (NULL, 'e84a', 'E84A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/025/original/e7e1749d652c255e01e77bd1894a87b2.png?1426625348";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E84A');
INSERT INTO "cameras" 
VALUES (NULL, 'e84', 'E84', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/024/original/b43855272a83f16e47bae7b98fd3a916.png?1426625338";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E84');
INSERT INTO "cameras" 
VALUES (NULL, 'e83a', 'E83A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/023/original/9408b6a79070fdc71b2be79a7dee34f5.png?1426625330";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E83A');
INSERT INTO "cameras" 
VALUES (NULL, 'e83', 'E83', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/022/original/3a6c2adf0b7241d0ebd9afc8370ab098.png?1426625319";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E83');
INSERT INTO "cameras" 
VALUES (NULL, 'e82a', 'E82A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/021/original/7157081c7319cc10c23c4cb683a4e80c.png?1426625310";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E82A');
INSERT INTO "cameras" 
VALUES (NULL, 'e822', 'E822', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/020/original/ebaa6328a977889c501c5c30d3d0fbeb.png?1426625298";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E822');
INSERT INTO "cameras" 
VALUES (NULL, 'e821', 'E821', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/144/original/f7d6b87bb51e849ddb451c92d584aa0d.jpg?1426626627";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E821');
INSERT INTO "cameras" 
VALUES (NULL, 'e820', 'E820', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/145/original/69b9d5a79ef295e440307c140cc4a928.jpg?1426625389";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E820');
INSERT INTO "cameras" 
VALUES (NULL, 'e82', 'E82', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/019/original/0d13175bcaee3683bdc168a005720361.png?1426625289";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E82');
INSERT INTO "cameras" 
VALUES (NULL, 'e819', 'E819', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/018/original/23aa84e0765b90fce72884dfe9cd1bf4.png?1426625281";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E819');
INSERT INTO "cameras" 
VALUES (NULL, 'e817', 'E817', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/017/original/492800e4e48366526c5dcb06b5d8a9fc.png?1426625272";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E817');
INSERT INTO "cameras" 
VALUES (NULL, 'e816', 'E816', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/016/original/048dc1806ad6dfa6f8d2fa23fb535bc5.png?1426625264";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E816');
INSERT INTO "cameras" 
VALUES (NULL, 'e815', 'E815', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/015/original/a3fd909b0148ee0fda72b56a342766ad.png?1426625254";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E815');
INSERT INTO "cameras" 
VALUES (NULL, 'e814', 'E814', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/146/original/770fc7e30b9ae6ef85f9aac0c72ffbe1.jpg?1426625164";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E814');
INSERT INTO "cameras" 
VALUES (NULL, 'e810', 'E810', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/147/original/e33e07c621727a9f280514b3cdf8ae14.jpg?1426625170";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E810');
INSERT INTO "cameras" 
VALUES (NULL, 'e81', 'E81', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/014/original/0ad158b3fcd98c325b142beaf6707a6d.png?1426625242";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E81');
INSERT INTO "cameras" 
VALUES (NULL, 'e78', 'E78', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/013/original/b21f122cda2157ed4620f6f5bffa6112.png?1426625234";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E78');
INSERT INTO "cameras" 
VALUES (NULL, 'e77', 'E77', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/012/original/049923d91d011d0b9a69e88cad499dc0.png?1426625226";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E77');
INSERT INTO "cameras" 
VALUES (NULL, 'e76', 'E76', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/011/original/7a77e0c96b7b213a274eee9c2effa6f0.png?1426625219";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E76');
INSERT INTO "cameras" 
VALUES (NULL, 'e75', 'E75', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/010/original/45be17d6bcec4dca77199145e9c3cbae.png?1426625210";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E75');
INSERT INTO "cameras" 
VALUES (NULL, 'e74a', 'E74A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/009/original/b806542610b38a65641f606ff7213291.png?1426625202";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E74A');
INSERT INTO "cameras" 
VALUES (NULL, 'e73', 'E73', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/007/original/a89963c7aa9ed7adfe26fa4b339349d8.png?1426625194";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E73');
INSERT INTO "cameras" 
VALUES (NULL, 'e72a', 'E72A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/006/original/1e97c8f3d10bba09c92c7e076ae981d3.png?1426625185";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E72A');
INSERT INTO "cameras" 
VALUES (NULL, 'e72', 'E72', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/005/original/cd969cd4952ec54bf76ffb46c4ef7756.png?1426625178";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E72');
INSERT INTO "cameras" 
VALUES (NULL, 'e710', 'E710', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/004/original/a4e5b8caad4f9716a76084b3bfde4210.png?1426625157";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E710');
INSERT INTO "cameras" 
VALUES (NULL, 'e71', 'E71', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/003/original/58737cb98416504fd4257ee5486b675c.png?1426625150";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E71');
INSERT INTO "cameras" 
VALUES (NULL, 'e69', 'E69', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/002/original/8f94c9a161ce37f4e87ed42d6a394782.png?1426625142";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E69');
INSERT INTO "cameras" 
VALUES (NULL, 'e68', 'E68', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/001/original/c20b635fce2122c18a023a7c5e60025a.png?1426625132";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E68');
INSERT INTO "cameras" 
VALUES (NULL, 'e67', 'E67', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/000/original/3e92537ed060e0df21bbec0734518194.png?1426625122";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E67');
INSERT INTO "cameras" 
VALUES (NULL, 'e66a', 'E66A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/999/original/5fd3641bec6dce543e8d984d18cca3a0.png?1426625107";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E66A');
INSERT INTO "cameras" 
VALUES (NULL, 'e66', 'E66', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/998/original/c281beef0e83844d24f02fa4425455a4.png?1426625096";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E66');
INSERT INTO "cameras" 
VALUES (NULL, 'e65a', 'E65A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/997/original/91a38f6daf0a4cfba19e91bb42b7e984.png?1426625085";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E65A');
INSERT INTO "cameras" 
VALUES (NULL, 'e65', 'E65', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/996/original/4e916055b8a5da87f8fbbc0df7677209.png?1426625076";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E65');
INSERT INTO "cameras" 
VALUES (NULL, 'e64', 'E64', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/995/original/e97b62c02b7f44d77f50d38794d61de3.png?1426625067";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E64');
INSERT INTO "cameras" 
VALUES (NULL, 'e63a', 'E63A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/994/original/b95607a34adf65f904903da26c2d90ab.png?1426625058";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E63A');
INSERT INTO "cameras" 
VALUES (NULL, 'e63', 'E63', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/993/original/7d20057f79f54f1ff1b32b68f53a01ee.png?1426625050";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E63');
INSERT INTO "cameras" 
VALUES (NULL, 'e62a', 'E62A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/992/original/31ab21ab23ccd3ec4788facbf90fb699.png?1426625042";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E62A');
INSERT INTO "cameras" 
VALUES (NULL, 'e621', 'E621', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/991/original/ab5d56d01dab6493b2a7944fdd4f15f6.png?1426625033";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E621');
INSERT INTO "cameras" 
VALUES (NULL, 'e620', 'E620', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/990/original/92a48074de943d88401846bb385cf8ae.png?1426625025";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E620');
INSERT INTO "cameras" 
VALUES (NULL, 'e62', 'E62', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/989/original/d515d35d725adc79336daad6e9e2fbd3.png?1426625016";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E62');
INSERT INTO "cameras" 
VALUES (NULL, 'e618', 'E618', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/988/original/47f9bd4ff761ae4eb37decb4f399e76f.png?1426625008";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E618');
INSERT INTO "cameras" 
VALUES (NULL, 'e617', 'E617', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/987/original/9391585a71ece756792468fba92dd7f2.png?1426624997";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E617');
INSERT INTO "cameras" 
VALUES (NULL, 'e616', 'E616', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/986/original/2e35c31ece531950940c07ee5c96d8dc.png?1426624989";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E616');
INSERT INTO "cameras" 
VALUES (NULL, 'e611', 'E611', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/985/original/f88220340f65de76dfea46fd03bd41a4.png?1426624981";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E611');
INSERT INTO "cameras" 
VALUES (NULL, 'e610', 'E610', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/984/original/0eb9a7ff84855effa86fbc694a4d93a4.png?1426624973";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E610');
INSERT INTO "cameras" 
VALUES (NULL, 'e61', 'E61', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/983/original/8cdf2290da90f48b56cc494793b0f919.png?1426624966";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E61');
INSERT INTO "cameras" 
VALUES (NULL, 'e59', 'E59', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/982/original/6686419eac66741c60a1eced0c90187a.jpg?1426624958";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E59');
INSERT INTO "cameras" 
VALUES (NULL, 'e58', 'E58', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/981/original/b2c825d35ced9f7efece516291c2f832.jpg?1426624948";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E58');
INSERT INTO "cameras" 
VALUES (NULL, 'e57', 'E57', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/980/original/4333a5b0dfb460a5580c4a7254201794.jpg?1426624938";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E57');
INSERT INTO "cameras" 
VALUES (NULL, 'e56', 'E56', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/979/original/fd414804efa9a2aa1be53a0ea284060a.jpg?1426624931";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E56');
INSERT INTO "cameras" 
VALUES (NULL, 'e54', 'E54', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/978/original/92c287bf399f70be8b5b47a18b79a67f.png?1426626784";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E54');
INSERT INTO "cameras" 
VALUES (NULL, 'e53', 'E53', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/977/original/02faea5f50290df74974dfb813cc8393.png?1426624915";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E53');
INSERT INTO "cameras" 
VALUES (NULL, 'e52', 'E52', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/976/original/6ebfa02a5673b060f6a7daa215d9e99c.png?1426624906";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E52');
INSERT INTO "cameras" 
VALUES (NULL, 'e51', 'E51', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/975/original/c1e136ee4f18d105021b6aa4c230d640.png?1426624897";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E51');
INSERT INTO "cameras" 
VALUES (NULL, 'e49', 'E49', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/974/original/5628910a559e852e67c3e775a29bf122.png?1426624889";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E49');
INSERT INTO "cameras" 
VALUES (NULL, 'e48', 'E48', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/973/original/6901da7c15727bf20fea4ce48e779d95.png?1426624881";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E48');
INSERT INTO "cameras" 
VALUES (NULL, 'e47', 'E47', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/972/original/bde6a6d5801be19b9852deb44b39a84b.png?1426624873";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E47');
INSERT INTO "cameras" 
VALUES (NULL, 'e46', 'E46', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/971/original/b2aa1c76f54de6c9c2640d0bed4dbf90.png?1426624865";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E46');
INSERT INTO "cameras" 
VALUES (NULL, 'e45', 'E45', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/970/original/de543fa8e04ae9387283c12fd160ef95.png?1426624858";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E45');
INSERT INTO "cameras" 
VALUES (NULL, 'e44', 'E44', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/969/original/e8eecee9912a4d08676a71ec942d0651.png?1426624852";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E44');
INSERT INTO "cameras" 
VALUES (NULL, 'e43b', 'E43B', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/148/original/c2992f7567ff8bc329a2f98e815b7857.png?1426626767";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E43B');
INSERT INTO "cameras" 
VALUES (NULL, 'e43a', 'E43A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/968/original/f04b56c5c39f1adc99ed381e7cf18041.png?1426624844";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E43A');
INSERT INTO "cameras" 
VALUES (NULL, 'e42b', 'E42B', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/149/original/c2a8e76a109de689942cce5434535039.png?1426624923";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E41B');
INSERT INTO "cameras" 
VALUES (NULL, 'e42a', 'E42A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/967/original/93f4f66922e88cce3dbbaaffa23bf33b.png?1426624837";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E42A');
INSERT INTO "cameras" 
VALUES (NULL, 'e420', 'E420', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/966/original/7ceff4290ac1e05bcfb9d5e3b6d06779.png?1426624828";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E420');
INSERT INTO "cameras" 
VALUES (NULL, 'e41a', 'E41A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/964/original/2c08f423c505a82dbaec1e785e8dad8f.png?1426624821";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E41A');
INSERT INTO "cameras" 
VALUES (NULL, 'e418', 'E418', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/963/original/eab269d52e39d96cae64c751db6eeb76.png?1426624812";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E418');
INSERT INTO "cameras" 
VALUES (NULL, 'e417', 'E417', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/962/original/c0808bfbe7fc2a3a306d014025786250.png?1426624805";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E417');
INSERT INTO "cameras" 
VALUES (NULL, 'e415', 'E415', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/961/original/b56526bc5bce5cf2c14aa987738454e2.png?1426624797";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E415');
INSERT INTO "cameras" 
VALUES (NULL, 'e414', 'E414', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/960/original/eef0e6b178cf5adc06096c8fbab860e1.png?1426624790";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E414');
INSERT INTO "cameras" 
VALUES (NULL, 'e413', 'E413', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/959/original/09d74a8e4a17cc48413b0d3aaadfa814.png?1426624782";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E413');
INSERT INTO "cameras" 
VALUES (NULL, 'e41', 'E41', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/958/original/57e91e6664faf0497fcc6e0a1dee1932.png?1426624775";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E41');
INSERT INTO "cameras" 
VALUES (NULL, 'e38', 'E38', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/150/original/67e4d108533af51b2a9b689e36c6b767.jpg?1426624731";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E38');
INSERT INTO "cameras" 
VALUES (NULL, 'e37', 'E37', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/957/original/1898e475ed57a31ab47c43f78778445e.jpg?1426624768";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E37');
INSERT INTO "cameras" 
VALUES (NULL, 'e36', 'E36', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/956/original/9fecd1c270825255c057ed29413a7cb5.jpg?1426624761";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E36');
INSERT INTO "cameras" 
VALUES (NULL, 'e35', 'E35', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/955/original/81583ca3113b052741428731f2acf692.png?1426624754";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E35');
INSERT INTO "cameras" 
VALUES (NULL, 'e34', 'E34', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/954/original/eefb2847b19063ba9e4f2aca89007ce2.png?1426624745";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E34');
INSERT INTO "cameras" 
VALUES (NULL, 'e33', 'E33', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/953/original/04114eba31132a0263283d3281514ccf.png?1426624737";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E33');
INSERT INTO "cameras" 
VALUES (NULL, 'e32', 'E32', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/952/original/6f6a14e315d3ff97c88df8aee86ef22e.png?1426624722";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E32');
INSERT INTO "cameras" 
VALUES (NULL, 'e31', 'E31', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/951/original/7b2f8c7f90e64e4d50fe478e709837ff.png?1426624713";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E31');
INSERT INTO "cameras" 
VALUES (NULL, 'e281', 'E281', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/950/original/e3e8cf011aae733597eeec2fc91c2a78.png?1426624706";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E281');
INSERT INTO "cameras" 
VALUES (NULL, 'e280', 'E280', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/949/original/8e428a793e019a97bbc1a5c328dc6e66.png?1426624697";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E280');
INSERT INTO "cameras" 
VALUES (NULL, 'e271', 'E271', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/948/original/05fcfc98bb1e6397e937c6174cba8ab4.png?1426624687";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E271');
INSERT INTO "cameras" 
VALUES (NULL, 'e270', 'E270', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/947/original/fe1ab3171d02aaf0ffa17a8857de7742.png?1426624680";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E270');
INSERT INTO "cameras" 
VALUES (NULL, 'e25a', 'E25A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/946/original/4b3a3b7651a04e4ec8956a251de21185.jpg?1426624670";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E25A');
INSERT INTO "cameras" 
VALUES (NULL, 'e25', 'E25', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/945/original/d7397ae8f47776583321953396aac051.jpg?1426624659";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E25');
INSERT INTO "cameras" 
VALUES (NULL, 'e24a', 'E24A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/944/original/d4cf512eb7e6a6b433c8a2e5281dd1f1.jpg?1426624647";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E24A');
INSERT INTO "cameras" 
VALUES (NULL, 'e24', 'E24', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/943/original/412f2550bcf9b2c701579d16f2ff206c.jpg?1426624632";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E24');
INSERT INTO "cameras" 
VALUES (NULL, 'e23a', 'E23A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/942/original/169bd3b74ce6ab493f39350ceaf09d62.jpg?1426624621";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E23A');
INSERT INTO "cameras" 
VALUES (NULL, 'e22va', 'E22VA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/941/original/f7f7b6376fff359560b8a2cb9d5686ab.jpg?1426624608";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E22VA');
INSERT INTO "cameras" 
VALUES (NULL, 'e22v', 'E22V', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/940/original/2f3d65974ad6f3ad06a668b6b93ef07c.jpg?1426624599";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E22V');
INSERT INTO "cameras" 
VALUES (NULL, 'e22fa', 'E22FA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/939/original/938bd23eea009a6a442ca35dca6b2a64.jpg?1426624586";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E22FA');
INSERT INTO "cameras" 
VALUES (NULL, 'e22f', 'E22F', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/938/original/a329bf782fb621e855e61615d14edd35.jpg?1426624570";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E22F');
INSERT INTO "cameras" 
VALUES (NULL, 'e224', 'E224', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/937/original/13b3f22df2a16261b26e3a1fa54bd479.png?1426623104";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E224');
INSERT INTO "cameras" 
VALUES (NULL, 'e223', 'E223', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/936/original/cbefd830ed74e8e9679866d211e6d649.png?1426624556";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E223');
INSERT INTO "cameras" 
VALUES (NULL, 'e222', 'E222', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/935/original/5ed240c60569e1bcfa4f8a488af6977c.png?1426624548";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E222');
INSERT INTO "cameras" 
VALUES (NULL, 'e221', 'E221', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/934/original/4ba8f6e3e3b63e9d08f8d5cdc0c5be77.png?1426624540";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E221');
INSERT INTO "cameras" 
VALUES (NULL, 'e220', 'E220', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/933/original/fdb97afbd02356f8e911cc597fb41759.png?1426624531";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E220');
INSERT INTO "cameras" 
VALUES (NULL, 'e21va', 'E21VA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/932/original/f2a3c64400886cbaf3c1625a397b3acf.jpg?1426624520";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E21VA');
INSERT INTO "cameras" 
VALUES (NULL, 'e21v', 'E21V', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/931/original/a333044f5d81be844859f84d8fae1dfa.jpg?1426624507";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E21V');
INSERT INTO "cameras" 
VALUES (NULL, 'e21fa', 'E21FA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/930/original/0acec01a5787f40aef962c2690c3cbcc.jpg?1426624495";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E21FA');
INSERT INTO "cameras" 
VALUES (NULL, 'e21f', 'E21F', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/929/original/ee4d0011e65b5d905e0f7f3af9f4148f.jpg?1426624485";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E21F');
INSERT INTO "cameras" 
VALUES (NULL, 'e219', 'E219', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/928/original/797b74a18b47c4e6f455c3650cc1595c.png?1426624476";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E219');
INSERT INTO "cameras" 
VALUES (NULL, 'e217', 'E217', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/927/original/453220870d2e1411e97fd07a115e340f.png?1426624468";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E217');
INSERT INTO "cameras" 
VALUES (NULL, 'e215', 'E215', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/926/original/afc4feaf10632ef402cc6013a6c999b6.png?1426626775";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E215');
INSERT INTO "cameras" 
VALUES (NULL, 'e214', 'E214', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/925/original/8f3b3761c311074a9856d91d08f8d702.png?1426624461";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E214');
INSERT INTO "cameras" 
VALUES (NULL, 'e213', 'E213', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/924/original/1db566e8c848846b61a4fd11424b997d.png?1426624441";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E213');
INSERT INTO "cameras" 
VALUES (NULL, 'e212', 'E212', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/923/original/a4137be2b98ede1263e27aa8d1597f63.png?1426624424";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E212');
INSERT INTO "cameras" 
VALUES (NULL, 'e16', 'E16', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/922/original/0d9a38f867858cd968ccb8ba1c1df53a.png?1426624412";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E16');
INSERT INTO "cameras" 
VALUES (NULL, 'e15', 'E15', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/921/original/897eab99dd4f7ac6978a00646a5dceea.png?1426624401";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E15');
INSERT INTO "cameras" 
VALUES (NULL, 'e14', 'E14', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/920/original/6801f4febbc5a0e5c94372c9ad6b9388.png?1426624380";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E14');
INSERT INTO "cameras" 
VALUES (NULL, 'e13', 'E13', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/919/original/341f256fad463b0ec3987f6135b7ebbf.png?1426624369";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E13');
INSERT INTO "cameras" 
VALUES (NULL, 'e12', 'E12', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/918/original/3a6b9ac8497c7efb4da25f2f14380bcc.png?1426624356";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E12');
INSERT INTO "cameras" 
VALUES (NULL, 'e11', 'E11', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/917/original/99d8beb44338bd6452e13e2c96d8cd53.png?1426624344";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=E11');
INSERT INTO "cameras" 
VALUES (NULL, 'd92', 'D92', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/916/original/32c1e0c6f2daf24f7bd82c819678ac4b.png?1426624330";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D92');
INSERT INTO "cameras" 
VALUES (NULL, 'd91', 'D91', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/915/original/194da892a77a8577cf372e48394d769e.png?1426624317";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D91');
INSERT INTO "cameras" 
VALUES (NULL, 'd82a', 'D82A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/914/original/4f333b2c4870005dd23d3acd553fbbf1.png?1426624301";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D82A');
INSERT INTO "cameras" 
VALUES (NULL, 'd82', 'D82', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/913/original/d8801e66811c00f7212c3013e1d1299c.png?1426624288";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D82');
INSERT INTO "cameras" 
VALUES (NULL, 'd81a', 'D81A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/912/original/cbde845b8cf6a344f15858b47c2d2b97.png?1426624276";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D81A');
INSERT INTO "cameras" 
VALUES (NULL, 'd81', 'D81', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/911/original/a3ad08cafe9615d36144e2f3a9cf11c6.png?1426624264";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D81');
INSERT INTO "cameras" 
VALUES (NULL, 'd72a', 'D72A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/910/original/ef2ef7291677a9f98966f87dff23c753.png?1426624252";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D72A');
INSERT INTO "cameras" 
VALUES (NULL, 'd72', 'D72', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/909/original/4e99e116010f2f9926975cf736784e68.png?1426624239";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D72');
INSERT INTO "cameras" 
VALUES (NULL, 'd71a', 'D71A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/908/original/8d5c178e2da2516659b7e53ddb559c75.png?1426624228";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D71A');
INSERT INTO "cameras" 
VALUES (NULL, 'd71', 'D71', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/907/original/33c256bb49e2a36ec4d3f658ccf44985.png?1426624213";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D71');
INSERT INTO "cameras" 
VALUES (NULL, 'd65a', 'D65A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/906/original/4f39fca591d82ad83bbb5eee2b2ff1c2.png?1426624202";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D65A');
INSERT INTO "cameras" 
VALUES (NULL, 'd65', 'D65', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/905/original/7eb7c6089909c589e8fca66bc896f34f.png?1426624188";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D65');
INSERT INTO "cameras" 
VALUES (NULL, 'd64', 'D64', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/904/original/0fd7de4eec9cdfc507f63f1c0f0252b7.png?1426624174";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D64');
INSERT INTO "cameras" 
VALUES (NULL, 'd62', 'D62', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/903/original/72ff670127f94715e39378793d072419.png?1426624164";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D62');
INSERT INTO "cameras" 
VALUES (NULL, 'd61a', 'D61A', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/902/original/8cc2a55129619c7f82865153f06bfa2c.png?1426624152";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D61A');
INSERT INTO "cameras" 
VALUES (NULL, 'd61', 'D61', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/901/original/1738cefa68299f875c1e3958db900588.png?1426624141";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D61');
INSERT INTO "cameras" 
VALUES (NULL, 'd55', 'D55', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/900/original/7ce4a584d47f962bdcf7c3bce59d54cf.png?1426624131";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D55');
INSERT INTO "cameras" 
VALUES (NULL, 'd54', 'D54', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/899/original/346082dc4d2d94ca858ccb66241986aa.png?1426626748";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D54');
INSERT INTO "cameras" 
VALUES (NULL, 'd52', 'D52', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/898/original/0951e902c744386f09a58337c6b18e74.png?1426624111";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D52');
INSERT INTO "cameras" 
VALUES (NULL, 'd51', 'D51', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/897/original/1223e98443a74787480103fbc6eae367.png?1426624100";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D51');
INSERT INTO "cameras" 
VALUES (NULL, 'd42', 'D42', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/896/original/58740cdc9aa7ea830785fcddcaab41ba.png?1426624090";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D42');
INSERT INTO "cameras" 
VALUES (NULL, 'd41', 'D41', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/895/original/2fc7ea0a255b1c1e91a1732adfe9377f.png?1426624080";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D41');
INSERT INTO "cameras" 
VALUES (NULL, 'd32', 'D32', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/894/original/0d1a505ec505ee480d3d4dd9ab5b1a10.png?1426624070";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D32');
INSERT INTO "cameras" 
VALUES (NULL, 'd31', 'D31', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/893/original/73734f464e8513fea4d0257bf7e34443.png?1426624058";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D31');
INSERT INTO "cameras" 
VALUES (NULL, 'd22va', 'D22VA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/151/original/18e48549fb88f5d0b787cfc0bf99e786.png?1426626643";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D22VA');
INSERT INTO "cameras" 
VALUES (NULL, 'd22fa', 'D22FA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/892/original/673c3289fa61a7d417ac87e29420ba59.png?1426624046";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D22FA');
INSERT INTO "cameras" 
VALUES (NULL, 'd22f', 'D22F', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/891/original/7ad1a91c14fed4d9137b60001280b1c4.jpg?1426624032";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D22F');
INSERT INTO "cameras" 
VALUES (NULL, 'd21va', 'D21VA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/152/original/c3702a91344a5a857c1af373aef7e36b.png?1426624121";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D21VA');
INSERT INTO "cameras" 
VALUES (NULL, 'd21fa', 'D21FA', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/890/original/6b5a11b5a2b3d4055d4724ba70e153b2.png?1426624022";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D21FA');
INSERT INTO "cameras" 
VALUES (NULL, 'd12', 'D12', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/888/original/a9083e7c12db7b6026a18c07b06a8dc4.png?1426624013";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D12');
INSERT INTO "cameras" 
VALUES (NULL, 'd11', 'D11', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x720', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/887/original/31e28bef0b488c24849a08ac01ee0fd2.png?1426624004";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=D11');
INSERT INTO "cameras" 
VALUES (NULL, 'b99', 'B99', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/886/original/8f5dcadd2ff9edca40b4e6dd89770cdf.png?1426623992";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B99');
INSERT INTO "cameras" 
VALUES (NULL, 'b97', 'B97', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/885/original/8e5422b946b9d33f390bda0179685b8a.png?1426623984";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B97');
INSERT INTO "cameras" 
VALUES (NULL, 'b96', 'B96', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/884/original/46c336a7c3e2bda574af0987a8df03e7.png?1426623975";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B96');
INSERT INTO "cameras" 
VALUES (NULL, 'b95', 'B95', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/883/original/24e56db2a637874fae69115aac003ae5.png?1426623966";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B95');
INSERT INTO "cameras" 
VALUES (NULL, 'b94', 'B94', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/882/original/57f86837f428dfe1bc82f28fdbc12c96.png?1426623958";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B94');
INSERT INTO "cameras" 
VALUES (NULL, 'b937', 'B937', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/881/original/d0048fe5b5b3a8be78753b51f19e8900.png?1426623948";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B937');
INSERT INTO "cameras" 
VALUES (NULL, 'b936', 'B936', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/880/original/dd57c6c9026f290fd1a5ad826e7fa75c.png?1426623940";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B936');
INSERT INTO "cameras" 
VALUES (NULL, 'b933', 'B933', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/879/original/a400488f5f05cb0fa3505666303bfa10.png?1426623931";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B933');
INSERT INTO "cameras" 
VALUES (NULL, 'b932', 'B932', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/878/original/a3dcbc0eb1a552e37321ea4d42bbf116.png?1426623919";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B932');
INSERT INTO "cameras" 
VALUES (NULL, 'b931', 'B931', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/877/original/50a7d595baad1ff485841de03742b799.png?1426623911";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B931');
INSERT INTO "cameras" 
VALUES (NULL, 'b930', 'B930', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/876/original/59857b4190b5d9231892b1a0e85da87c.png?1426623901";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B930');
INSERT INTO "cameras" 
VALUES (NULL, 'b93', 'B93', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/153/original/df6ce2a7277a12d4ecf2d12b5d0475a1.png?1426623859";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B93');
INSERT INTO "cameras" 
VALUES (NULL, 'b929', 'B929', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/875/original/dbb2237b7990f184f8b1df77ff41f330.png?1426623889";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B929');
INSERT INTO "cameras" 
VALUES (NULL, 'b928', 'B928', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/874/original/c765260b7e07931dace714f2d1fa4deb.png?1426623876";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B928');
INSERT INTO "cameras" 
VALUES (NULL, 'b926', 'B926', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/873/original/e83f0e9a50352904dfd840cfa5cee629.png?1426623829";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B926');
INSERT INTO "cameras" 
VALUES (NULL, 'b925', 'B925', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/154/original/16134525cdfbb36ebde5d157b983f1bb.jpg?1426623037";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B925');
INSERT INTO "cameras" 
VALUES (NULL, 'b924', 'B924', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/155/original/7fa70cc6973ad4397b54bff666798e5e.png?1426623842";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B924');
INSERT INTO "cameras" 
VALUES (NULL, 'b921', 'B921', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/156/original/0833758f2af4d4bf3b44d2b6d0cbf673.jpg?1426623567";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B921');
INSERT INTO "cameras" 
VALUES (NULL, 'b920', 'B920', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/157/original/a9c1bdb8cc8793cb8952c07b6db0fb20.jpg?1426626656";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B920');
INSERT INTO "cameras" 
VALUES (NULL, 'b92', 'B92', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/158/original/51b5cec97c5c39c19ed04645fb3be317.jpg?1426623574";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B92');
INSERT INTO "cameras" 
VALUES (NULL, 'b919', 'B919', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/159/original/cae146520e7e18dbb2b3c82f483ed045.jpg?1426623582";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B919');
INSERT INTO "cameras" 
VALUES (NULL, 'b918', 'B918', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/160/original/66d456f828525fb89a16a4fec06fed6b.jpg?1426623590";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B918');
INSERT INTO "cameras" 
VALUES (NULL, 'b917', 'B917', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/161/original/7da92a728e193a4676e0122ebdb2df2e.jpg?1426623596";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B917');
INSERT INTO "cameras" 
VALUES (NULL, 'b916', 'B916', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/162/original/6dc6e094a69e6fd96c3ff9450cbd37af.jpg?1426623603";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B916');
INSERT INTO "cameras" 
VALUES (NULL, 'b915', 'B915', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Dome', 'admin', '123456', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/872/original/ba291537a1fb544baa8c74e5f3293434.png?1426623812";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B915');
INSERT INTO "cameras" 
VALUES (NULL, 'b914', 'B914', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/871/original/cd6accc740af0fb83f34e174c4defa44.png?1426623794";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B914');
INSERT INTO "cameras" 
VALUES (NULL, 'b913', 'B913', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/870/original/fa7afcb5201474c173a92bd36b77417f.png?1426623778";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B913');
INSERT INTO "cameras" 
VALUES (NULL, 'b910', 'B910', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/869/original/39e7713cc95b15d3522ebac8c5d10cdd.png?1426623114";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B910');
INSERT INTO "cameras" 
VALUES (NULL, 'b91', 'B91', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/163/original/8a926af677e3ec492b848bf1cfb86b29.png?1426623611";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B91');
INSERT INTO "cameras" 
VALUES (NULL, 'b89', 'B89', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/164/original/09dd4a4e0d2f8d0d848331c8af8c8b69.jpg?1426623623";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B89');
INSERT INTO "cameras" 
VALUES (NULL, 'b88', 'B88', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/165/original/9d09da1cf4b152b4f229a9a84820e314.jpg?1426623631";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B88');
INSERT INTO "cameras" 
VALUES (NULL, 'b87', 'B87', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/868/original/6db58ae98095d13620b65fc0fb0f46ab.png?1426623759";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B87');
INSERT INTO "cameras" 
VALUES (NULL, 'b85', 'B85', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/867/original/3e0cdc5b46d091cc41a6ee0b9903f489.png?1426623745";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B85');
INSERT INTO "cameras" 
VALUES (NULL, 'b84', 'B84', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/866/original/4e6529fa492299839165b0d19c8feb72.png?1426623733";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B84');
INSERT INTO "cameras" 
VALUES (NULL, 'b815', 'B815', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/166/original/957e8d2630cdadc57358db919f40d8a6.jpg?1426623638";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B815');
INSERT INTO "cameras" 
VALUES (NULL, 'b814', 'B814', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/167/original/816f20c184dd8e7779a54dbacf4604d6.png?1426623648";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B814');
INSERT INTO "cameras" 
VALUES (NULL, 'b813', 'B813', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/865/original/e1a76f027f4cc8d9b666a9d178a81269.png?1426623718";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B813');
INSERT INTO "cameras" 
VALUES (NULL, 'b812', 'B812', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/168/original/6d137f71caf11311d1369d00fb4e305b.jpg?1426623662";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B812');
INSERT INTO "cameras" 
VALUES (NULL, 'b811', 'B811', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/169/original/808fea0c2e30eaaccafca81b9114342f.jpg?1426623673";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B811');
INSERT INTO "cameras" 
VALUES (NULL, 'b81', 'B81', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/864/original/91e2919c5774b5b37d8c5ec1cc535844.png?1426623703";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B81');
INSERT INTO "cameras" 
VALUES (NULL, 'b74', 'B74', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/863/original/291065d20b317a2935b5c3408be619fb.jpg?1426623686";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B74');
INSERT INTO "cameras" 
VALUES (NULL, 'b69', 'B69', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/862/original/b7cd874058ae57b7e8bd85c2163fbf7c.png?1426623557";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B69');
INSERT INTO "cameras" 
VALUES (NULL, 'b68', 'B68', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/861/original/912752890bc49f9e5326acfd9a0501a6.png?1426623549";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B68');
INSERT INTO "cameras" 
VALUES (NULL, 'b67', 'B67', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/860/original/a1c7caa3e7868b2818b70f3c819f52b2.png?1426623542";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B67');
INSERT INTO "cameras" 
VALUES (NULL, 'b65', 'B65', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/859/original/a99a40137cd3fa0b1a40c87a361b1987.png?1426623534";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B65');
INSERT INTO "cameras" 
VALUES (NULL, 'b64', 'B64', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/858/original/15a324b7c181f719a995743912bf7693.png?1426623526";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B64');
INSERT INTO "cameras" 
VALUES (NULL, 'b614', 'B614', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/857/original/101e74184e726d42ac5f8409386d9914.png?1426623519";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B614');
INSERT INTO "cameras" 
VALUES (NULL, 'b613', 'B613', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/856/original/dcac4eadc05a9d6e1b582ed59ded838d.png?1426623121";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B613');
INSERT INTO "cameras" 
VALUES (NULL, 'b61', 'B61', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/855/original/763fb91d204fffd5dfcfc4ef46c3613e.png?1426623512";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B61');
INSERT INTO "cameras" 
VALUES (NULL, 'b59', 'B59', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/854/original/132fa5f28fef69792ad6d659946c28ee.png?1426623502";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B59');
INSERT INTO "cameras" 
VALUES (NULL, 'b56', 'B56', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/853/original/97b03e3617e8112ee55082a31f0cdcda.png?1426623491";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B56');
INSERT INTO "cameras" 
VALUES (NULL, 'b55', 'B55', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/852/original/5de8cc12dbb0ea75655b970f45a4de23.png?1426623483";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B55');
INSERT INTO "cameras" 
VALUES (NULL, 'b54', 'B54', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/851/original/6e11371193aab616b745543bdd5315fa.png?1426623474";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B54');
INSERT INTO "cameras" 
VALUES (NULL, 'b53', 'B53', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/850/original/f1e3ecc918e4cf3329d30f1f3642870c.png?1426623466";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B53');
INSERT INTO "cameras" 
VALUES (NULL, 'b52', 'B52', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/849/original/ae6ba27355c2ce2eefd12c9751e365c7.png?1426623455";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B52');
INSERT INTO "cameras" 
VALUES (NULL, 'b51', 'B51', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Dome', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/848/original/9155c81f5982c2e921611af86ea1034f.png?1426623443";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B51');
INSERT INTO "cameras" 
VALUES (NULL, 'b48', 'B48', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/847/original/e58b904577cd6d896512f88e9112490a.png?1426623427";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B48');
INSERT INTO "cameras" 
VALUES (NULL, 'b47', 'B47', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/846/original/40f0d9de24cff6fd66a3f0f7e14a26ed.png?1426623409";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B47');
INSERT INTO "cameras" 
VALUES (NULL, 'b45', 'B45', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/845/original/1a785ed944d62720398fa7daf25afad6.png?1426623392";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B45');
INSERT INTO "cameras" 
VALUES (NULL, 'b44', 'B44', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/844/original/0c179507b41d23f9b00f867ab67113c2.png?1426623385";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B44');
INSERT INTO "cameras" 
VALUES (NULL, 'b422', 'B422', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/843/original/abc43ce6dcb2756dec8b210ffe6b554a.png?1426623376";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B422');
INSERT INTO "cameras" 
VALUES (NULL, 'b421', 'B421', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/842/original/167938cf7a31ccfae016d4d60143c9f3.png?1426623367";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B421');
INSERT INTO "cameras" 
VALUES (NULL, 'b420', 'B420', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/841/original/467a5a18084266f48b6f1d9f5f297811.png?1426623358";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B420');
INSERT INTO "cameras" 
VALUES (NULL, 'b418', 'B418', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/840/original/784ea9699edd82481acf5d6ece6dec7c.png?1426623347";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B418');
INSERT INTO "cameras" 
VALUES (NULL, 'b417', 'B417', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/839/original/7d81bf36b35ea02f9b304faea2dd7890.png?1426623339";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B417');
INSERT INTO "cameras" 
VALUES (NULL, 'b416', 'B416', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/838/original/b5ceb98371777e87c7bc87c546d7815b.png?1426623331";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B416');
INSERT INTO "cameras" 
VALUES (NULL, 'b415', 'B415', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/837/original/9070fa94e62db0a4d16a3e4d58649210.png?1426623315";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B415');
INSERT INTO "cameras" 
VALUES (NULL, 'b414', 'B414', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/836/original/ef07f5af832587e547447e6d83cd5725.png?1426626734";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B414');
INSERT INTO "cameras" 
VALUES (NULL, 'b413', 'B413', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/835/original/769d07076bc877b56deb915ef8632fd6.png?1426623299";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B413');
INSERT INTO "cameras" 
VALUES (NULL, 'b411', 'B411', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/834/original/aff551d9be0c97c909783092f35e14df.png?1426623289";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B411');
INSERT INTO "cameras" 
VALUES (NULL, 'b410', 'B410', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/833/original/2ff965b08023429fc4e5e75e7aeb8136.png?1426623281";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B410');
INSERT INTO "cameras" 
VALUES (NULL, 'b41', 'B41', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Bullet', 'admin', '123456', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/832/original/09353dbf9c3f729899014eb2febbdbda.png?1426623273";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B41');
INSERT INTO "cameras" 
VALUES (NULL, 'b28', 'B28', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/831/original/a4798a075ad527603bbdfdf21cc16806.png?1426623266";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B28');
INSERT INTO "cameras" 
VALUES (NULL, 'b27', 'B27', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/830/original/b5a1bcd01cc650d529603769d1ff40ef.png?1426623257";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B27');
INSERT INTO "cameras" 
VALUES (NULL, 'b25', 'B25', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/829/original/e94e6564327f3a7f76392e7be00c0319.png?1426623247";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B25');
INSERT INTO "cameras" 
VALUES (NULL, 'b24', 'B24', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1280x960', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/828/original/d8668ad7849a899989ff7e9a8d5e497b.png?1426623238";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B24');
INSERT INTO "cameras" 
VALUES (NULL, 'b222', 'B222', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/827/original/700ab8889625c667cba6f5d5ab2a2c48.png?1426623227";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B222');
INSERT INTO "cameras" 
VALUES (NULL, 'b221', 'B221', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/826/original/a0720be7a1ca639ad78ebcb0d3a3cf0a.png?1426623216";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B221');
INSERT INTO "cameras" 
VALUES (NULL, 'b220', 'B220', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '-', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/825/original/dc5e707e32664f3773223bba0598347c.png?1426623132";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B220');
INSERT INTO "cameras" 
VALUES (NULL, 'b217', 'B217', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/824/original/73c37009a4c0eb4c7d1d7674ee2117d6.png?1426623205";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B217');
INSERT INTO "cameras" 
VALUES (NULL, 'b216', 'B216', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/823/original/1fd13f4bfa01d01b52cccb74b4ae471e.png?1426623193";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B216');
INSERT INTO "cameras" 
VALUES (NULL, 'b215', 'B215', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/822/original/be94c87add149b1e925a54205431eafb.png?1426623182";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B215');
INSERT INTO "cameras" 
VALUES (NULL, 'b214', 'B214', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '1920x1080', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/821/original/47c4b0ee7e42e946280c71b68ba7760b.png?1426623170";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B214');
INSERT INTO "cameras" 
VALUES (NULL, 'b213', 'B213', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '4000x3000', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/820/original/40b025e1136a0b36a9468c9e05a18da3.png?1426623162";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B213');
INSERT INTO "cameras" 
VALUES (NULL, 'b212', 'B212', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3072x2048', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/819/original/9a1677af8e97133292b09760bf166b24.png?1426626714";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B212');
INSERT INTO "cameras" 
VALUES (NULL, 'b211', 'B211', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2048x1536', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/818/original/b94ca64091da0ba6a424f86f8126d576.png?1426626698";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B211');
INSERT INTO "cameras" 
VALUES (NULL, 'b210', 'B210', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '3648x2736', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/817/original/1a8248cf5e7f5e1f96fcc2ac31441bec.png?1426623147";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B210');
INSERT INTO "cameras" 
VALUES (NULL, 'b21', 'B21', '36', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&SNAPSHOT', 'cgi-bin/encoder?USER=[USERNAME]&PWD=[PASSWORD]&GET_STREAM', '', '2592x1944', 'Box', 'admin', '123456', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/816/original/e07e6010ebc9bb6910884da9e93841ee.png?1426626676";}}', 'http://www.acti.com/corpweb/Product/ProductInfo.aspx?q=B21');
INSERT INTO "cameras" 
VALUES (NULL, 'iqr53nr-f9', 'IQR53NR-F9', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/962/original/e488842eaf0ddda830f141b136896bc0.jpg?1426619897";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqr52nr-f9', 'IQR52NR-F9', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/961/original/09bc3797dcd08f5717f57e6159e4e84b.jpg?1426619886";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqr51nr-f9', 'IQR51NR-F9', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/960/original/684905d00bb171ac1cfc180e6528dace.jpg?1426619876";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqm53wr-b5', 'IQM53WR-B5', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/959/original/a09cd8af701420475a907b66d38c9292.jpg?1426619869";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqm52wr-b5', 'IQM52WR-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/958/original/ca3bef4b9b75d2da137f4d4875f4c74b.jpg?1426619861";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqm51wr-b5', 'IQM51WR-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/957/original/2189483f4f36340c7cd45c8461a90f51.jpg?1426619853";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd53wv-f2', 'IQD53WV-F2', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/952/original/dbd1f9cd249476467c9d728b98d6279a.jpg?1426619847";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/953/original/805f93e0aee2bcbc6c2194add8bf3bc5.jpg?1415744341";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd52wv-f2', 'IQD52WV-F2', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/950/original/f4a1be666ed5ce7e0dab29a5f38dc80d.jpg?1426619841";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/951/original/933e5cbd73c5f6ed1eec8c81bed7b4dc.jpg?1415744334";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd51wv-f2', 'IQD51WV-F2', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/948/original/8dde3d2371fdb1ff774c3d5f24520e36.jpg?1426619835";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/949/original/d4faf29cf38458275c0f9f90adcb2272.jpg?1415744327";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq763wi-w2', 'IQ763WI-W2', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/742/original/b02185bf9e8f57929c8c926b04d0de4d.jpg?1426619928";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq763wi-v16', 'IQ763WI-V16', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/740/original/6aa17f684fde711c04141e65b4f0312d.jpg?1426619824";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq763wi-v6', 'IQ763WI-V6', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/741/original/7685f3439f878bd42db91b085a86d3f6.jpg?1426619817";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq762wi-w2', 'IQ762WI-W2', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/736/original/f91be75167900e4767e84ee80cbdb7c3.jpg?1426619811";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq762wi-v16', 'IQ762WI-V16', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/734/original/427003aa60714bd31db2f98e49d76300.jpg?1426619804";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq762wi-v6', 'IQ762WI-V6', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/735/original/facd541e58649fd620bcdc6e328c174e.jpg?1426619797";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq761wi-v16', 'IQ761WI-V16', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/729/original/621918f0fcb799c4795f4649f38635c7.jpg?1426619787";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq761wi-v6', 'IQ761WI-V6', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/730/original/86567c63eb963784968c30626abda7dc.jpg?1426619780";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq863we-w2', 'IQ863WE-W2', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/840/original/1d1f40aa26ad7179d099deb5125e86c2.jpg?1426619773";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/842/original/2fd1e8287f970e0fc003f66b316c0236.jpg?1415743838";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/843/original/41cf79bceee0ad6e58270771965b7eef.jpg?1415743841";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/846/original/04042ea455564b5a34ea164c8385a980.jpg?1415743851";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq863we-v16', 'IQ863WE-V16', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/825/original/f515247082807b0443de88d9b70dde74.jpg?1426619766";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/833/original/2979711860994345f2bbe7297f6e3e7e.jpg?1415743806";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq863we-v6', 'IQ863WE-V6', '37', '', '', '', '2048x1536', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/839/original/0d9f6d1fb3ef2688534a17eeec17e83e.jpg?1426619760";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/834/original/90426a255953f76e21c92ab3b3d8462b.jpg?1415743811";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/836/original/7867a4266e1c3701aea59a21dc8ec3a7.jpg?1415743817";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/837/original/e6d2c85f34842418ca660599b4ec0db3.jpg?1415743819";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq862we-w2', 'IQ862WE-W2', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/805/original/999f302a35c16f9990d05a15526d0e1d.jpg?1426619753";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq862we-v16', 'IQ862WE-V16', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/793/original/671a79c4ff527acb7231fb7fd71e0a69.jpg?1426619747";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq862we-v6', 'IQ862WE-V6', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/799/original/6c9e14f3e232d18300a6dcd4ac428075.jpg?1426619740";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq861we-v16', 'IQ861WE-V16', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/763/original/75d760be181143dd2cf5ec876ed706f0.jpg?1426619734";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq861we-v6', 'IQ861WE-V6', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/769/original/1bb723e4ebb2099eee307136290a5ac0.jpg?1426619727";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33wx-a3', 'IQA33WX-A3', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/920/original/26379b87f29b4b671805524804aba13b.jpg?1426619720";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32wx-a3', 'IQA32WX-A3', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/667/original/7c3f48ea337c49281b9623aac6f72cc6.jpg?1426619907";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33we-a3', 'IQA33WE-A3', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/705/original/f45f6c1931c5c8338936a918c5d08ff5.jpg?1426619830";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32we-a3', 'IQA32WE-A3', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/711/original/c545a064ffbbf53b81a9f687235956bf.jpg?1416321762";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/710/original/42a8c3b50cc0304aaf2f3e5c196cd183.jpg?1426619591";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31we-a3', 'IQA31WE-A3', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/712/original/ea92af77c6461db04b4eb97d770380b7.jpg?1426619596";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33wi-a3', 'IQA33WI-A3', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/916/original/d7db460095666561c9cb94659bae7078.jpg?1426619713";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32wi-a3', 'IQA32WI-A3', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/713/original/146593ab4ae02ee84411fd250c03f56c.jpg?1426619912";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31wi-a3', 'IQA31WI-A3', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/878/original/45d601d8495e92fff5d82d73f8ce8074.jpg?1426619707";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/879/original/e11760d709912e7211f245eadc457482.jpg?1415744005";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33wx-b5', 'IQA33WX-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/922/original/234b706ea601bd0a3d0a9bee26137d52.jpg?1426619701";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33we-b5', 'IQA33WE-B5', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/714/original/63db6b0e439df827add350ae5b95185e.jpg?1426619601";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32wx-b5', 'IQA32WX-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/715/original/2ed1fc40c2faa2951a0c21a0e7cfa570.jpg?1426619607";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32we-b5', 'IQA32WE-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/717/original/ebafd6f70d8e544e1569da1706bc5095.jpg?1416322058";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/716/original/6be969e2591412b1edd11e52db699e1d.jpg?1426619612";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31we-b5', 'IQA31WE-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/718/original/073391879e070641e09504c83f65d447.jpg?1426619616";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33wi-b5', 'IQA33WI-B5', '37', '', '', '', '2048x1536', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/918/original/6433296d3c6777de75e5865b5348bdd0.jpg?1426619695";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32wi-b5', 'IQA32WI-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/719/original/428a6309a2b6f4d1a3f06382624b36f1.jpg?1426619621";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31wi-b5', 'IQA31WI-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/720/original/d33299735f57719bb080dd87986c1179.jpg?1426619626";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa35nx-a3', 'IQA35NX-A3', '37', '', '', '', '2560x1920', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/933/original/896866407c018d3e139f45737139d404.jpg?1415744257";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/932/original/c5bdf6a13b6eb616f8a7e3f78a88ce90.jpg?1426619688";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa35ne-a3', 'IQA35NE-A3', '37', '', '', '', '2560x1920', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/925/original/ba555d72bd4a802dfdcef6e321067b5f.jpg?1426619683";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa35ni-a3', 'IQA35NI-A3', '37', '', '', '', '2560x1920', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/929/original/9838e0c93a0a4a0a051ffb2ad7d5f44c.jpg?1415744238";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/928/original/c5c2e24ee557011cd6bca8e66c646ecd.jpg?1426619676";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32nx-a3', 'IQA32NX-A3', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/721/original/fce4403d12d10d66309df06865766809.jpg?1426619631";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32ne-a3', 'IQA32NE-A3', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/722/original/73286c10e8a78445978b91f645c3dc27.jpg?1426619636";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32ni-a3', 'IQA32NI-A3', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/723/original/71b1b52bc4f9a12103372cd1b575e401.jpg?1426619643";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31ne-a3', 'IQA31NE-A3', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/724/original/b4705511e82374a9f342696eeda49040.jpg?1426619647";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31ni-a3', 'IQA31NI-A3', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/725/original/c26ce50230f50ceac41f79b279827747.jpg?1426619652";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd32sv-b7', 'IQD32SV-B7', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/944/original/4d3520f0d0733b1db13872ab18154cd8.jpg?1426619670";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/945/original/243515f1014e488567473f683b12d0bf.jpg?1415744312";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd31sv-b7', 'IQD31SV-B7', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/940/original/9369bd090f659f84a5011034189ccb64.jpg?1426619663";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/941/original/8c3eb2b12c01650efbb5f5f99780bf2c.jpg?1415744298";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd30sv-b7', 'IQD30SV-B7', '37', '', '', '', '720x480', 'Dome', 'root', 'system', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/936/original/867c09174e41eda9f8b995c767bf18b5.jpg?1426619657";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/937/original/03a03782d24a53422a7fc62d7e17d260.jpg?1415744273";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq031si-v11', 'IQ031SI-V11', '37', '', '', '', '1280x720', 'Box', 'root', 'system', '1', 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/725/original/0d226a8522875045f1e52949d1acc1f0.jpg?1426619306";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq865ne-w2', 'IQ865NE-W2', '37', '', '', '', '2560x1920', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/862/original/46cc76b16ec0eb92c72f3694e167840e.jpg?1426619580";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/859/original/64ff1086b57bcc35c7dd7398d2845908.jpg?1415743895";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/863/original/a8ca2066dc18ccbe7b9bdaff964c6056.jpg?1415743920";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/864/original/5e744833e180f8f9cc34b40f0c608e2d.jpg?1415743923";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/865/original/b4cbda0428484e01950c3dc2fc41dfc7.jpg?1415743926";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq865ne-v7', 'IQ865NE-V7', '37', '', '', '', '2560x1920', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/853/original/ac00ca78704db9e683697040449765f2.jpg?1426619574";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/855/original/c6557068fcf2ef30722cfc53bc7bc0c5.jpg?1415743882";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/856/original/099002141ca6e429ea1ca3236dfdd189.jpg?1415743885";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/857/original/1894ffcf3a68d4e1d4706d37706875e0.jpg?1415743888";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/858/original/dc435cc4809e6c6ad9835f4d3c452407.jpg?1415743890";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq863ne-w2', 'IQ863NE-W2', '37', '', '', '', '2560x1440', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/824/original/955fabcb23b6a4be6c8646dff46bf138.jpg?1426619567";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq863ne-v16', 'IQ863NE-V16', '37', '', '', '', '2560x1440', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/811/original/bd985ba65193d029c0ff50d6ac9a4de8.jpg?1426619561";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq862ne-w2', 'IQ862NE-W2', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/787/original/a319f2b2745c1386690b71ea0a951cb8.jpg?1426619554";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq862ne-v16', 'IQ862NE-V16', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/775/original/b361da6f63e1e5a2e477032789538da9.jpg?1426619548";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq861ne-v16', 'IQ861NE-V16', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/751/original/dda130e005c51303f540976087b96d1a.jpg?1426619542";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq761ni-v16', 'IQ761NI-V16', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/727/original/44da5f2694b86447c055db106cb4c99f.jpg?1426619534";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq762ni-v16', 'IQ762NI-V16', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/731/original/51d130934ca1ec3e83c9fdaba0a06168.jpg?1426619527";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq762ni-w2', 'IQ762NI-W2', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/733/original/edb15ca8bc33744eb6f87e694c0bf44a.jpg?1426619521";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq763ni-v16', 'IQ763NI-V16', '37', '', '', '', '2560x1440', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/737/original/e8c8d7e02745b71db43c29ab57168bc3.jpg?1426619514";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq763ni-w2', 'IQ763NI-W2', '37', '', '', '', '2560x1440', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/739/original/78e74eb7e60d922c494dda768d47c9ce.jpg?1426619507";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq765ni-v7', 'IQ765NI-V7', '37', '', '', '', '2560x1920', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/744/original/9ddba5440e62d9070d96ce9650b0b334.jpg?1426619500";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq765ni-w2', 'IQ765NI-W2', '37', '', '', '', '2560x1920', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/745/original/a3109d77f741a2ac9ba93a7d7e05078d.jpg?1426619493";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq030si-v11', 'IQ030SI-V11', '37', '', '', '', '720x480', 'Box', 'root', 'system', '1', 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/724/original/f0d38939f5eaeb46b2f3137509b46cdb.jpg?1426619486";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq032si-v11', 'IQ032SI-V11', '37', '', '', '', '1920x1080', 'Box', 'root', 'system', '1', 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/726/original/e9be179b77895663d32f22a09cb1cf55.jpg?1426619480";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq862ne-v6', 'IQ862NE-V6', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/776/original/d2f2fc8bc81f18f7599c55a457bbf801.jpg?1426619468";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/777/original/5f86b02d5659db20e0e057054dace132.jpg?1415743592";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/779/original/aad9b39782cfbeeac30001fda17a1da5.jpg?1415743601";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/780/original/f52debf4ebf0121869d44eb414e7cff1.jpg?1415743606";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/778/original/eda2d07b1fca657431a0fe0917127953.jpg?1415743597";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/781/original/4b4d87d21d8ad8fad16e6b71b2e36eb6.jpg?1415743610";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq765ni-v6', 'IQ765NI-V6', '37', '', '', '', '2560x1920', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/743/original/19a146bce647d3dbe86bea90efd2f42d.jpg?1426619455";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq763ni-v6', 'IQ763NI-V6', '37', '', '', '', '2560x1440', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/738/original/d4979799fa0a2cf6819ddf84b5fc4b33.jpg?1426619447";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq762ni-v6', 'IQ762NI-V6', '37', '', '', '', '1920x1080', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/732/original/acf86d0b055c6f3e433d9e64891391d9.jpg?1426619440";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq761ni-v6', 'IQ761NI-V6', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/728/original/20218c8d923fff70eca4c119b8d9d408.jpg?1426619430";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq865ne-v6', 'IQ865NE-V6', '37', '', '', '', '2560x1920', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/847/original/285cda26296ec59a40e54fb906f0ff73.jpg?1415743856";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/849/original/1c89b6286e119a3c0b9ac2934bf604c8.jpg?1415743863";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/851/original/6cf5c155dbf68f5ed3ebfe26b0492c1c.jpg?1415743869";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/852/original/03b0f88df9cf0ec73cb6d1dea9fee07f.jpg?1415743872";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/850/original/f2cb98b90191a3508b0d02e564e34eae.jpg?1426619423";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq863ne-v6', 'IQ863NE-V6', '37', '', '', '', '2560x1440', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/817/original/6e4bfdb8045e2c87820b802e45ed6a0f.jpg?1426619411";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iq861ne-v6', 'IQ861NE-V6', '37', '', '', '', '1280x720', 'Bullet', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/752/original/1194d215e6228e733bcd604b623c62be.jpg?1426619403";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/757/original/1ed1e23d10f840ed3520b1bd1b4b00da.jpg?1415743525";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa35nx-b6', 'IQA35NX-B6', '37', '', '', '', '2560x1920', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/934/original/6db0119d5a03c47b4357c9545fca7f37.jpg?1426619396";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/935/original/9a07537629e236ffd37b3fb7d356df2f.jpg?1415744266";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa35ne-b6', 'IQA35NE-B6', '37', '', '', '', '2560x1920', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/926/original/8bf03c3c0db3e1f00ff8414229eeb5ef.jpg?1426619390";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/927/original/fdba0dba86668748352ac12120da449e.jpg?1415744230";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33ne-b5', 'IQA33NE-B5', '37', '', '', '', '2560x1440', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/726/original/5659e7ffd62ce826af0c00d5f6e7bf12.jpg?1426619917";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32nx-b5', 'IQA32NX-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/728/original/531816c52773a21af396f5385de0f98a.jpg?1416322588";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/727/original/b24557f8605fccddad792ed88beec71f.jpg?1426619922";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32ne-b5', 'IQA32NE-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/729/original/c0624fac55d6cf1adf8ee70781fe9388.jpg?1426619586";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31ni-b5', 'IQA31NI-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/730/original/dcedc10613bf98865e7ac694d5ae6479.jpg?1426619311";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa31ne-b5', 'IQA31NE-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/731/original/69993978be2958bc22308fa19ad40ff9.jpg?1426619317";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd32sv-f1', 'IQD32SV-F1', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/946/original/635f0cf96adbc4f814d5df23a66717ba.jpg?1426619383";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/947/original/8d721e330179ae7d8f520d22d51bbb74.jpg?1415744319";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd31sv-f1', 'IQD31SV-F1', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/942/original/c0726426744f0482d3a5f5a37696642f.jpg?1426619376";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/943/original/b705859f22d22f6e3861a2c5eba74c80.jpg?1415744305";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqd30sv-f1', 'IQD30SV-F1', '37', '', '', '', '720x480', 'Dome', 'root', 'system', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/938/original/4ed6b150edeb39a09df784a15df26d62.jpg?1426619369";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/939/original/b949546ebecf5948fc2aecb8610368cb.jpg?1415744286";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa35ni-b6', 'IQA35NI-B6', '37', '', '', '', '2560x1920', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/931/original/b8704659a5e79a102900297019d04835.jpg?1426619362";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/930/original/fc0a45e307b0baac81c6ac7802681a82.jpg?1415744242";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa33ni-b5', 'IQA33NI-B5', '37', '', '', '', '2560x1440', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/732/original/9018dbf39b68aa5ce94232fdf00c2bf5.jpg?1426619321";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqa32ni-b5', 'IQA32NI-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/733/original/1c83addaa1497297551d7b73c84475c1.jpg?1426619326";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqm32ne-b5', 'IQM32NE-B5', '37', '', '', '', '1920x1080', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/956/original/8ce47edad87bb9c604752f3c9f5c2b82.jpg?1426619352";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqm31ne-b5', 'IQM31NE-B5', '37', '', '', '', '1280x720', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/955/original/6146cb60ab73ee67f02f510fcf4e4bc3.jpg?1426619342";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'iqm30ne-b5', 'IQM30NE-B5', '37', '', '', '', '720x480', 'Dome', 'root', 'system', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/954/original/69e791f8b4a4a701e3520ccf4aca1823.jpg?1426619332";}}', 'http://www.iqeye.com/products/product-selector-tool#');
INSERT INTO "cameras" 
VALUES (NULL, 'avn803ez', 'AVN803EZ', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/054/original/c0e2ba68d331082091dd9f2ba55bc81d.jpg?1426618860";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=282');
INSERT INTO "cameras" 
VALUES (NULL, 'avn701ez', 'AVN701EZ', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '640x480', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/053/original/c51fe6d9811c29a3913247af691feb7b.jpg?1426618856";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=224');
INSERT INTO "cameras" 
VALUES (NULL, 'avn815ez', 'AVN815EZ', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/059/original/54df25c4e8ba0c3ed06fb0f5a0cee4a8.jpg?1426618851";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=283');
INSERT INTO "cameras" 
VALUES (NULL, 'avm302a', 'AVM302A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/017/original/72e5b212cb9a5dad77c415cbd4d6260a.jpg?1426618847";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=239');
INSERT INTO "cameras" 
VALUES (NULL, 'avn812', 'AVN812', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/058/original/fc4905cc5888810fc4d5f815c9b2c67b.jpg?1426618843";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=73');
INSERT INTO "cameras" 
VALUES (NULL, 'avn80x', 'AVN80X', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/057/original/d2b00d5692fa51a89783154e6564cf1f.jpg?1426618839";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=46');
INSERT INTO "cameras" 
VALUES (NULL, 'avm500', 'AVM500', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/038/original/03f0c1835e99e6ff8c8aef6818ce735e.jpg?1426618834";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=243');
INSERT INTO "cameras" 
VALUES (NULL, 'avm417a', 'AVM417A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/032/original/4781f941572c7107b47ca9cb42316f0b.jpg?1426618830";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=225');
INSERT INTO "cameras" 
VALUES (NULL, 'avo402', 'AVO402', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/060/original/71703798628affe578ac5ecadf14fa97.jpg?1426618826";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=83');
INSERT INTO "cameras" 
VALUES (NULL, 'avn216', 'AVN216', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '640x480', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/562/original/bf3d788da6b7b7be7d8a8245560e0ffa.png?1426618821";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=80');
INSERT INTO "cameras" 
VALUES (NULL, 'avm400b', 'AVM400B', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/027/original/2e18d310e8fdd767af1a7507f3ac1c25.jpg?1426618817";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=78');
INSERT INTO "cameras" 
VALUES (NULL, 'avm317b', 'AVM317B', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/019/original/dd0150bf47e8f0b3485715dc6968d0c6.jpg?1426618812";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=77');
INSERT INTO "cameras" 
VALUES (NULL, 'avn806', 'AVN806', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/056/original/1e4f497ae9948e56927338a3166ad267.jpg?1426618808";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=72');
INSERT INTO "cameras" 
VALUES (NULL, 'avm332', 'AVM332', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/022/original/d1545388a8caa7b2de66eec1d97d9cf9.jpg?1426618805";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=349');
INSERT INTO "cameras" 
VALUES (NULL, 'avm401', 'AVM401', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/028/original/ec8908f26bd77cd1c3b8dd97ec833e4f.jpg?1426618801";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=339');
INSERT INTO "cameras" 
VALUES (NULL, 'avn320', 'AVN320', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/051/original/c2a29b715599900c655ea011a0ef04f5.jpg?1415740633";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/050/original/6a06dfbd0e95c4197767423521557f4f.jpg?1426618797";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=327');
INSERT INTO "cameras" 
VALUES (NULL, 'avn420', 'AVN420', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/052/original/47a16ba3b816ee7361f42514a92c59e5.jpg?1426618793";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=326');
INSERT INTO "cameras" 
VALUES (NULL, 'avm503', 'AVM503', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/039/original/0b1cb81324ec049844038c6468db7670.jpg?1426618789";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=325');
INSERT INTO "cameras" 
VALUES (NULL, 'avm402', 'AVM402', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/029/original/5e93818177f9083a0189ed123390c18b.jpg?1426618784";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=320');
INSERT INTO "cameras" 
VALUES (NULL, 'avm542b', 'AVM542B', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/043/original/4753c72b65c80d2e8f8904ca56a0ca7b.jpg?1426618780";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=278');
INSERT INTO "cameras" 
VALUES (NULL, 'avm428d', 'AVM428D', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/033/original/e72305eee34d1487602a0e7f779bf73e.jpg?1426618776";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=273');
INSERT INTO "cameras" 
VALUES (NULL, 'avm328d', 'AVM328D', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/021/original/734111ed18b52ef4bb077852991d80a6.jpg?1426618771";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=272');
INSERT INTO "cameras" 
VALUES (NULL, 'avm511', 'AVM511', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/040/original/72b1b63dc03c319b718901169187f18d.jpg?1426618767";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=264');
INSERT INTO "cameras" 
VALUES (NULL, 'avm542a', 'AVM542A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/042/original/00bedbc8699ccab3078772d929a8f1ad.jpg?1426618763";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=255');
INSERT INTO "cameras" 
VALUES (NULL, 'avm311', 'AVM311', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/018/original/ce46cb6b5a3f335ccaa920592057dc31.jpg?1426618759";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=248');
INSERT INTO "cameras" 
VALUES (NULL, 'avm521a', 'AVM521A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/041/original/43993ed34dcbf69b7cadf55b6c1b1567.jpg?1426618755";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=242');
INSERT INTO "cameras" 
VALUES (NULL, 'avm411', 'AVM411', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/031/original/82e7b6e50b61c1e486982b69136ebfce.jpg?1426618751";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=263');
INSERT INTO "cameras" 
VALUES (NULL, 'avn805', 'AVN805', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/055/original/33fb67fea8ea1c3ffb66a0d68530b490.jpg?1426618745";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=61');
INSERT INTO "cameras" 
VALUES (NULL, 'avo403', 'AVO403', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/061/original/ad1925aa4202b20d6bbb6a4268b6ec69.jpg?1426618741";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=65');
INSERT INTO "cameras" 
VALUES (NULL, 'avm328b', 'AVM328B', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/020/original/392a9cf4330822e2939d6d82bf624532.jpg?1426618736";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=63');
INSERT INTO "cameras" 
VALUES (NULL, 'avm583', 'AVM583', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/049/original/d0710e1247fd96d932045bd900692096.jpg?1426618732";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=328');
INSERT INTO "cameras" 
VALUES (NULL, 'avp571', 'AVP571', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/062/original/b397980fd22c2630b6bf0631e9512e62.jpg?1426618728";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=280');
INSERT INTO "cameras" 
VALUES (NULL, 'avm458c', 'AVM458C', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/035/original/32aeef352d76fd63b9fb38f2edfb195e.jpg?1426618723";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=333');
INSERT INTO "cameras" 
VALUES (NULL, 'avm358c', 'AVM358C', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/024/original/0228637f422350b0cfa79329c1c72641.jpg?1426618720";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=332');
INSERT INTO "cameras" 
VALUES (NULL, 'avm459c', 'AVM459C', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/037/original/f2120af674af8df81775249a9a571736.jpg?1426618716";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=324');
INSERT INTO "cameras" 
VALUES (NULL, 'avm403', 'AVM403', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/030/original/2119caa11b2f8b9a9b8775589ecd9b27.jpg?1426618712";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=321');
INSERT INTO "cameras" 
VALUES (NULL, 'avm552b', 'AVM552B', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/044/original/e0a0a5a8be37906c8c66e7bd71888b38.jpg?1426618707";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=279');
INSERT INTO "cameras" 
VALUES (NULL, 'avm459b', 'AVM459B', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/036/original/5c7953f6e37d06f3a9ebf42fdfd91227.jpg?1426618702";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=277');
INSERT INTO "cameras" 
VALUES (NULL, 'avm552c', 'AVM552C', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/045/original/9af1d5f0a0971a2a5a7dc75f3f9cc583.jpg?1426618698";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=292');
INSERT INTO "cameras" 
VALUES (NULL, 'avm359a', 'AVM359A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/025/original/9080a1276ea8df186fca48bd537339ec.jpg?1426618693";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=56');
INSERT INTO "cameras" 
VALUES (NULL, 'avn257', 'AVN257', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '640x480', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/563/original/e14e0f6c6710564e1049d37ab7110734.png?1426618686";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=55');
INSERT INTO "cameras" 
VALUES (NULL, 'avm457a', 'AVM457A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/034/original/b89bde34dd8e0678ccfefeaa7b348eb0.jpg?1426618681";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=54');
INSERT INTO "cameras" 
VALUES (NULL, 'avm357a', 'AVM357A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/023/original/6f6df2686ff5272bdc206a0e086417e6.jpg?1426618676";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=53');
INSERT INTO "cameras" 
VALUES (NULL, 'avm561', 'AVM561', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/046/original/e6f3192d67ac64d82bb0c70dabe79a1a.jpg?1426618672";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=240');
INSERT INTO "cameras" 
VALUES (NULL, 'avm565a', 'AVM565A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/048/original/16f4b5d4e33a0fbf3c8a6bef1e08ac76.jpg?1415740620";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/047/original/9f7b62afd4ed56815e7d86834a544623.jpg?1426618667";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=70');
INSERT INTO "cameras" 
VALUES (NULL, 'avm365a', 'AVM365A', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x800', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/026/original/b56c5654cd0be1ef7f3b3784dbcb18fc.jpg?1426618663";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=68');
INSERT INTO "cameras" 
VALUES (NULL, 'avn362v', 'AVN362V', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/564/original/f9d7e973f72185779e9d60649f468ac3.png?1426618658";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=67');
INSERT INTO "cameras" 
VALUES (NULL, 'avn363v', 'AVN363V', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '1280x1024', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/565/original/619eb489b3255086ac982ed33cd15f31.png?1426618652";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=66');
INSERT INTO "cameras" 
VALUES (NULL, 'avm265', 'AVM265', '38', 'cgi-bin/guest/Video.cgi?media=jpeg', 'live/mjpeg', 'live/h264', '720x576', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/016/original/dc79fb50ac7fc2a389935f5e1d5e30cc.jpg?1426618647";}}', 'http://www.avtech.com.tw/index.php?option=com_k2&view=item&id=52');
INSERT INTO "cameras" 
VALUES (NULL, 'q1602', 'Q1602', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '768x576', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:8:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/155/original/25fe46c9f0fdc18043f7a4f1bd176dc1.jpg?1415793761";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/156/original/f8c08bdc76134e19cb66a4f2cc1d95e0.jpg?1415793762";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/157/original/ae327c8be839e6018650ebe09ed7b3b6.jpg?1415793764";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/158/original/e8a261fec38677e0deea258634220ae7.jpg?1415793766";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/159/original/35e3bbce3551b7bce156de1e107f93fe.jpg?1415793767";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/160/original/acd7460ee902085564b8ca2186c86c10.jpg?1415793769";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/161/original/c6b2fb36990f54a5f067726b10a4e24b.jpg?1415793771";}i:7;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/154/original/c2b778fc2cc1a335f418907ee3c5f24f.jpg?1426621137";}}', 'http://www.axis.com/products/cam_q1602/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd732f-e', 'DS-2CD732F(-E)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '704x576', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/205/original/dd9ec25f1217756d86666fb36bc0e66d.jpg?1426620248";}}', 'http://www.hikvision.com/en/products_show.asp?id=30');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd762mf-ifbh', 'DS-2CD762MF-(I)FB(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/338/original/572f5350425744a07c1fdbba106904b2.jpg?1426620237";}}', 'http://www.hikvision.com/en/products_show.asp?id=484');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd752mf-ifbh', 'DS-2CD752MF-(I)FB(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/330/original/e0d208d5b5c4a6dbf4a5fc77ac0f4433.jpg?1426620232";}}', 'http://www.hikvision.com/en/products_show.asp?id=494');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd702712pnf-e', 'DS-2CD702/712P(N)F-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'ntsc:704x480/pal:704x576', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/206/original/63b684d62c3d39873a2f2b01f40751d2.jpg?1426620253";}}', 'http://www.hikvision.com/en/products_show.asp?id=1922');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd832f-e', 'DS-2CD832F(-E)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '704x576', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/347/original/abd63f9de3bb3bc49932cce9078368db.jpg?1426620227";}}', 'http://www.hikvision.com/en/products_show.asp?id=27');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd752mf-e', 'DS-2CD752MF-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/333/original/60836ef722d4380e3e0f6311a33569a0.jpg?1426620222";}}', 'http://www.hikvision.com/en/products_show.asp?id=28');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8133f-e', 'DS-2CD8133F-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/207/original/8d6725464c0c70004199dcd9d4b0866a.jpg?1426620242";}}', 'http://www.hikvision.com/en/products_show.asp?id=412');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd763pnf-eiz', 'DS-2CD763P(N)F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/208/original/7abcda0b0b3e320ddea0962f9c2f62ad.jpg?1426620186";}}', 'http://www.hikvision.com/en/products_show.asp?id=503');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7133-e', 'DS-2CD7133-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/209/original/d5e7c649722117dc315a908fa5ed2396.jpg?1426620191";}}', 'http://www.hikvision.com/en/products_show.asp?id=504');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7353f-ei', 'DS-2CD7353F-E(I)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/211/original/87d7eb4fe193f91bb62eea0e4b3684df.jpg?1416389481";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/210/original/f3ae5df77934a60351806610497fa076.jpg?1426620199";}}', 'http://www.hikvision.com/en/products_show.asp?id=7364');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812892pn-ir1', 'DS-2CD802/812/892P(N)-IR1', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'ntsc:704x480/pal:704x576', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/212/original/291b9fc6a5b6843a11df180d2e95fce4.jpg?1426620205";}}', 'http://www.hikvision.com/en/products_show.asp?id=497');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812892pn-ir3', 'DS-2CD802/812/892P(N)-IR3', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'ntsc:704x480/pal:704x576', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/214/original/15b3a45284e31b3132ccea9f98ff37e6.jpg?1416390135";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/213/original/0876be51a3da66b27ae983ca857b5547.jpg?1426620211";}}', 'http://www.hikvision.com/en/products_show.asp?id=499');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812892pn-ir5', 'DS-2CD802/812/892P(N)-IR5', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'ntsc:704x480/pal:704x576', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/216/original/78f8023824f2e3a469110b9c70926981.jpg?1416390165";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/215/original/c4209e08a002504bc2977db85617ce6f.jpg?1426620216";}}', 'http://www.hikvision.com/en/products_show.asp?id=502');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812pnf-ew', 'DS-2CD802/812P(N)F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'ntsc:704x480/pal:704x576', 'Box', 'admin', '12345', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/218/original/334124ad520d0f7cd7e5282f9a5f3dba.jpg?1416390198";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/217/original/5136ab04c236bedc95e094da8d904549.jpg?1426620181";}}', 'http://www.hikvision.com/en/products_show.asp?id=481');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd863pnf-ew', 'DS-2CD863P(N)F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/352/original/39786524168eed8ccf5183368c60e1e9.jpg?1426620176";}}', 'http://www.hikvision.com/en/products_show.asp?id=500');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd876bfmf', 'DS-2CD876BF(MF)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/360/original/0b3a2fbcc4b07ba74865551c4573f5d9.jpg?1426620172";}}', 'http://www.hikvision.com/en/products_show.asp?id=90');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8153f-e', 'DS-2CD8153F-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/342/original/04dd4639701d6963a9da30e1b39ac2ec.jpg?1426620167";}}', 'http://www.hikvision.com/en/products_show.asp?id=410');
INSERT INTO "cameras" 
VALUES (NULL, 'fe-200cu', 'FE-200CU', '39', 'cgi-bidmin/snapshot.cgi', '', '', '1600x1200', 'Box', 'admin', 'airlive', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/086/original/5b564e695bf551074a2773e746d25b4f.jpg?1426618349";}}', 'http://www.airlivesecurity.com/product/FE-200CU');
INSERT INTO "cameras" 
VALUES (NULL, 'wn-150cam', 'WN-150CAM', '39', 'cgi-bin/jpg/image', 'video.mjpg', '', '640x480', 'Box', 'admin', 'airlive', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/109/original/2d034d4ba772595831a2c844dc696f28.jpg?1426618345";}}', 'http://www.airlivesecurity.com/product/WN-150CAM');
INSERT INTO "cameras" 
VALUES (NULL, 'cu-720pir', 'CU-720PIR', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1280x720', 'Box', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/083/original/bddb77ec2bae0c05f4f0544196b40e3a.jpg?1426618308";}}', 'http://www.airlivesecurity.com/product/CU-720PIR');
INSERT INTO "cameras" 
VALUES (NULL, 'ip-200phd-24', 'IP-200PHD-24', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1600x1200', 'Box', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/089/original/5dde50851dc65bdfd3cab77fcc5358fc.jpg?1426618304";}}', 'http://www.airlivesecurity.com/product/IP-200PHD-24');
INSERT INTO "cameras" 
VALUES (NULL, 'wn-200hd', 'WN-200HD', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1600x1200', 'Box', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/110/original/d8c63ab9a5ce43eca12170e3c1dc4ddb.jpg?1426618300";}}', 'http://www.airlivesecurity.com/product/WN-200HD');
INSERT INTO "cameras" 
VALUES (NULL, 'cw-720', 'CW-720', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1280x720', 'Box', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/084/original/7cac6bdf7606337d22c6b32941b8508c.jpg?1426618296";}}', 'http://www.airlivesecurity.com/product/CW-720');
INSERT INTO "cameras" 
VALUES (NULL, 'wl-350hd', 'WL-350HD', '39', 'cgi-bin/jpg/image', 'video.mjpg', 'video.h264', '1280x1024', 'Box', 'admin', 'airlive', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/107/original/247d114807af7fb2ad0b0d9169730e65.jpg?1426618292";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/108/original/99b54699569f19e97a010a7b4838c2b8.jpg?1415740872";}}', 'http://www.airlivesecurity.com/product/WL-350HD');
INSERT INTO "cameras" 
VALUES (NULL, 'bu-720', 'BU-720', '39', 'cgi-bin/jpg/image', '', 'video.pro1', '1280x800', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/082/original/d32ef4c016be33b8ae52c1e58e89d681.jpg?1426618340";}}', 'http://www.airlivesecurity.com/product/BU-720');
INSERT INTO "cameras" 
VALUES (NULL, 'od-2025hd', 'OD-2025HD', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1920x1080', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/094/original/bee096f048c38b2a98cf59236c788e60.jpg?1426618288";}}', 'http://www.airlivesecurity.com/product/OD-2025HD');
INSERT INTO "cameras" 
VALUES (NULL, 'bu-3025', 'BU-3025', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/stream1.cgi', '2048x1536', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/078/original/edea7930ebb8aac316bdb58921c5af27.jpg?1426618284";}}', 'http://www.airlivesecurity.com/product/BU-3025');
INSERT INTO "cameras" 
VALUES (NULL, 'bu-3025v2', 'BU-3025v2', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/stream1.cgi', '2048x1536', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/079/original/426c68cc5967248671542bf693005c90.jpg?1426618279";}}', 'http://www.airlivesecurity.com/product/BU-3025v2');
INSERT INTO "cameras" 
VALUES (NULL, 'bu-2015', 'BU-2015', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/stream1.cgi', '1920x1080', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/077/original/5bfc3f06ea043863509e203ed6e36d00.jpg?1426618274";}}', 'http://www.airlivesecurity.com/product/BU-2015');
INSERT INTO "cameras" 
VALUES (NULL, 'bu-3026', 'BU-3026', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'axis-media/media.amp?videocodec=h264', '2048x1536', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/081/original/db101cd8f9e3839a4a831dddcb9e6d88.jpg?1426618270";}}', 'http://www.airlivesecurity.com/product/BU-3026');
INSERT INTO "cameras" 
VALUES (NULL, 'bu-3026-ivs', 'BU-3026-IVS', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'axis-media/media.amp?videocodec=h264', '2048x1536', 'Bullet', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/080/original/d514006cc983c76a403d129ba9a0544a.jpg?1426618266";}}', 'http://www.airlivesecurity.com/product/BU-3026-IVS');
INSERT INTO "cameras" 
VALUES (NULL, 'poe-200cam-v2', 'POE-200CAM v2', '39', 'cgi-bin/jpg/image', 'video.mjpg', '', '640x480', 'Dome', 'admin', 'airlive', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/577/original/0ecbc4737d867651c073a62c6ac00db9.jpg?1416298653";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/576/original/98e26a094b72c639b6e996379b8fe7d6.jpg?1426618353";}}', 'http://www.airlivesecurity.com/product/POE-200CAMv2');
INSERT INTO "cameras" 
VALUES (NULL, 'poe-250hd', 'POE-250HD', '39', 'jpg/image.jpg', 'mjpg/video.mjpg', 'h264/media.amp', '1280x1024', 'Dome', 'admin', 'airlive', '', 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/100/original/d01ec2677afcca725969aabd621df914.jpg?1426618262";}}', 'http://www.airlivesecurity.com/product/POE-250HD');
INSERT INTO "cameras" 
VALUES (NULL, 'poe-260cam', 'POE-260CAM', '39', 'cgi-bin/jpg/image', 'video.mjpg', '', '640x480', 'Dome', 'admin', 'airlive', '', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/103/original/281da3fc6171730fb6578be1e522f362.jpg?1426618336";}}', 'http://www.airlivesecurity.com/product/POE-260CAM');
INSERT INTO "cameras" 
VALUES (NULL, 'wn-2600hd', 'WN-2600HD', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1920x1080', 'Dome', 'admin', 'airlive', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/111/original/5a38ad7271c1ea16ff7d7eb55692ea8c.jpg?1426618258";}}', 'http://www.airlivesecurity.com/product/WN-2600HD');
INSERT INTO "cameras" 
VALUES (NULL, 'poe-2600hd', 'POE-2600HD', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1920x1080', 'Dome', 'admin', 'airlive', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/101/original/9a5ccd7d16bc2b1c3a736220b62f4f9c.jpg?1426618253";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/102/original/8f2c677425dc480ff4353f0920a795a6.jpg?1415740847";}}', 'http://www.airlivesecurity.com/product/POE-2600HD');
INSERT INTO "cameras" 
VALUES (NULL, 'dm-720', 'DM-720', '39', 'cgi-bin/jpg/image', '', 'video.pro1', '1280x800', 'Dome', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/085/original/a50384ee5b8aca39f90034fc23d71243.jpg?1426618333";}}', 'http://www.airlivesecurity.com/product/DM-720');
INSERT INTO "cameras" 
VALUES (NULL, 'od-2060hd', 'OD-2060HD', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1920x1080', 'Dome', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/097/original/680c613be0f41d4d978dfb8344a17244.jpg?1415740827";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/096/original/ab7c36651a1b612d4fab237630770e06.jpg?1426618249";}}', 'http://www.airlivesecurity.com/product/OD-2060HD');
INSERT INTO "cameras" 
VALUES (NULL, 'fe-200dm', 'FE-200DM', '39', 'cgi-bidmin/snapshot.cgi', '', '', '1600x1200', 'Dome', 'admin', 'airlive', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/087/original/6765dafdaca85796f5a9959d15c2b20a.jpg?1426618329";}}', 'http://www.airlivesecurity.com/product/FE-200DM');
INSERT INTO "cameras" 
VALUES (NULL, 'fe-200vd', 'FE-200VD', '39', 'cgi-bidmin/snapshot.cgi', '', '', '1600x1200', 'Dome', 'admin', 'airlive', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/088/original/4b59f9cdacf084b1d1790f18f8adc322.jpg?1426618324";}}', 'http://www.airlivesecurity.com/product/FE-200VD');
INSERT INTO "cameras" 
VALUES (NULL, 'od-2050hd', 'OD-2050HD', '39', 'image.jpg', 'video.mjpg', 'h264/media.amp', '1920x1080', 'Dome', 'admin', 'airlive', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/095/original/f73230561efc0d0540da58045ce8f525.jpg?1426618243";}}', 'http://www.airlivesecurity.com/product/OD-2050HD');
INSERT INTO "cameras" 
VALUES (NULL, 'md-720', 'MD-720', '39', 'cgi-bin/jpg/image', '', 'video.pro1', '1280x800', 'Dome', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/093/original/72764a3d14908c4180806c67956b1208.jpg?1426618320";}}', 'http://www.airlivesecurity.com/product/MD-720');
INSERT INTO "cameras" 
VALUES (NULL, 'sd-2020', 'SD-2020', '39', 'cgi-bin/jpg/image.cgi?', 'cgi-bin/jpg/image.cgi?', '', '1920x1080', 'Dome', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/105/original/f43c7b39de5d8fd7bd3b22a8671c0cab.jpg?1426618316";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/106/original/aa02ac470e92993a90e7304c7ff58fff.jpg?1415740864";}}', 'http://www.airlivesecurity.com/product/SD-2020');
INSERT INTO "cameras" 
VALUES (NULL, 'md-3025', 'MD-3025', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/h264.cgi', '2048x1536', 'Dome', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/092/original/272b112b7447a52de8d46cab6c98cd11.jpg?1426618238";}}', 'http://www.airlivesecurity.com/product/MD-3025');
INSERT INTO "cameras" 
VALUES (NULL, 'md-3025-ivs', 'MD-3025-IVS', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/h264.cgi', '2048x1536', 'Dome', 'admin', 'airlive', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/578/original/da8125b444200639e9d4cf2f487224c9.jpg?1426618312";}}', 'http://www.airlivesecurity.com/product/MD-3025-IVS');
INSERT INTO "cameras" 
VALUES (NULL, 'poe-100hd-icr', 'POE-100HD-ICR', '39', 'jpg/image.jpg', 'mjpg/video.mjpg', 'h264/media.amp', '1280x1024', 'Box', 'admin', 'airlive', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/099/original/c81f8074dd3b6a4a8bfde42d5be8d34c.jpg?1415740835";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/098/original/e26e5a292ddf81301e6b017dbe02df2b.jpg?1426618233";}}', 'http://www.airlivesecurity.com/product/POE-100HD-ICR');
INSERT INTO "cameras" 
VALUES (NULL, 'poe-5010hd', 'POE-5010HD', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/h264.cgi', '2592x1920', 'Box', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/104/original/abef9bfbe2a60a84b717843f0a1ceb96.jpg?1426618228";}}', 'http://www.airlivesecurity.com/product/POE-5010HD');
INSERT INTO "cameras" 
VALUES (NULL, 'bc-5010', 'BC-5010', '39', 'cgi/jpg/image.cgi', 'cgi/mjpg/mjpeg.cgi', 'cgi/h264/h264.cgi', '2592x1920', 'Box', 'admin', 'airlive', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/076/original/99550890223ce914e5715fc163fbf25a.jpg?1426618224";}}', 'http://www.airlivesecurity.com/product/BC-5010');
INSERT INTO "cameras" 
VALUES (NULL, 'av8365', 'AV8365', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/229/original/3796cc9c72fa25b0a2c5f2ec02bb8a6e.jpg?1426648352";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8365');
INSERT INTO "cameras" 
VALUES (NULL, 'av8360', 'AV8360', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/228/original/c2fab043b91439f2a6c2a90a14456619.jpg?1426648344";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8360');
INSERT INTO "cameras" 
VALUES (NULL, 'av8185', 'AV8185', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/227/original/44b01c5f559ddb77dd82aa58788e3cf9.jpg?1426648337";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8185');
INSERT INTO "cameras" 
VALUES (NULL, 'av8180', 'AV8180', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/226/original/67b0d697d86a22c8fc2f319d151750b0.jpg?1426648329";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8180');
INSERT INTO "cameras" 
VALUES (NULL, 'av40185dn', 'AV40185DN', '40', '', '', 'h264.sdp', '14592x2752', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/608/original/7fc319f2ea5cc4703e223e1b5fc6f692.png?1426648320";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV40185DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av20365dn', 'AV20365DN', '40', '', '', 'h264.sdp', '10240x1920', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/582/original/20127bde9d361a503f7eb0e78e32af69.png?1426648311";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV20365DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av20365co', 'AV20365CO', '40', '', '', 'h264.sdp', '10240x1920', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/581/original/7e9714c9c143ab1e2ec91ed55413dc39.png?1426648302";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV20365CO');
INSERT INTO "cameras" 
VALUES (NULL, 'av20185dn', 'AV20185DN', '40', '', '', 'h264.sdp', '10240x1920', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/580/original/e4085681c4bd85c6206c38e295ed004e.png?1426648293";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV20185DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av20185co', 'AV20185CO', '40', '', '', 'h264.sdp', '10240x1920', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/579/original/f7d30cfb91dfe3776838a7dfa75080d0.png?1426648284";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV20185CO');
INSERT INTO "cameras" 
VALUES (NULL, 'av12366dn', 'AV12366DN', '40', '', '', 'h264.sdp', '8192x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/576/original/169e0cec11f54e7a5842b252003551e4.png?1426648275";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV12366DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av12186dn', 'AV12186DN', '40', '', '', 'h264.sdp', '8192x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/132/original/8137888a0ba6889a973b8cf70b465990.jpg?1426648267";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV12186DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av8365dn', 'AV8365DN', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/620/original/d51c7e798e08c6fc538fb0f5074b21f4.png?1426648255";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8365DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av8365co', 'AV8365CO', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/619/original/825f62e35b57c48be2309099099cf78e.png?1426648244";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8365CO');
INSERT INTO "cameras" 
VALUES (NULL, 'av8185dn', 'AV8185DN', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/618/original/eb65e5d761a3150c51bb015fc0c853bc.png?1426648235";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8185DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av8185co', 'AV8185CO', '40', '', '', 'h264.sdp', '6400x1200', 'Dome', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/617/original/d860f47c0b38bb58011957321c2ed741.png?1426648226";}}', 'http://www.arecontvision.com/product/SurroundVideo+Series/AV8185CO');
INSERT INTO "cameras" 
VALUES (NULL, 'av5455dn-s', 'AV5455DN-S', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/225/original/31e57a0dcf62443db1b5293f904d0f80.jpg?1426648218";}}', 'http://www.arecontvision.com/product/microdome/av5455dn-s');
INSERT INTO "cameras" 
VALUES (NULL, 'av5455dn-f', 'AV5455DN-F', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/224/original/7064e8ac85c33c91127896d251f01e99.jpg?1426648211";}}', 'http://www.arecontvision.com/product/microdome/av5455dn-f');
INSERT INTO "cameras" 
VALUES (NULL, 'av3456dn-s', 'AV3456DN-S', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/205/original/136dc8d1791ed85673cad2d6dad2793e.jpg?1426648204";}}', 'http://www.arecontvision.com/product/microdome/av3456dn-s');
INSERT INTO "cameras" 
VALUES (NULL, 'av3456dn-f', 'AV3456DN-F', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/204/original/5c3d79a5b0f81ac0ed401f8da2a5a0f5.jpg?1426648197";}}', 'http://www.arecontvision.com/product/microdome/av3456dn-f');
INSERT INTO "cameras" 
VALUES (NULL, 'av3455dn-s', 'AV3455DN-S', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/203/original/0beb19f25f07113b30166fcd1ae71be8.jpg?1426648190";}}', 'http://www.arecontvision.com/product/microdome/av3455dn-s');
INSERT INTO "cameras" 
VALUES (NULL, 'av3455dn-f', 'AV3455DN-F', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/202/original/aaf37a93245951af23186279704451f7.jpg?1426648183";}}', 'http://www.arecontvision.com/product/microdome/av3455dn-f');
INSERT INTO "cameras" 
VALUES (NULL, 'av2456dn-s', 'AV2456DN-S', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/169/original/d2afd561da771d9b684ae69989eed4f0.jpg?1426648176";}}', 'http://www.arecontvision.com/product/microdome/av2456dn-s');
INSERT INTO "cameras" 
VALUES (NULL, 'av2456dn-f', 'AV2456DN-F', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/168/original/23910b98868db29e384ef4a76ef6a82f.jpg?1426648169";}}', 'http://www.arecontvision.com/product/microdome/av2456dn-f');
INSERT INTO "cameras" 
VALUES (NULL, 'av2455dn-s', 'AV2455DN-S', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/167/original/06661ead26b997843b48f0a496602caf.jpg?1426648161";}}', 'http://www.arecontvision.com/product/microdome/av2455dn-s');
INSERT INTO "cameras" 
VALUES (NULL, 'av2455dn-f', 'AV2455DN-F', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/166/original/cd77abc7d99d0cfddb6d3f9dd4c06ecd.jpg?1426648154";}}', 'http://www.arecontvision.com/product/microdome/av2455dn-f');
INSERT INTO "cameras" 
VALUES (NULL, 'av1455dn-s', 'AV1455DN-S', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/140/original/ad37703ce16d32b13814ee578e703eba.jpg?1426648147";}}', 'http://www.arecontvision.com/product/microdome/av1455dn-s');
INSERT INTO "cameras" 
VALUES (NULL, 'av1455dn-f', 'AV1455DN-F', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/139/original/6de8b1bc7e92e75eb4cb765c3edec9e8.jpg?1426648140";}}', 'http://www.arecontvision.com/product/microdome/av1455dn-f');
INSERT INTO "cameras" 
VALUES (NULL, 'av10255pmtir-h', 'AV10255PMTIR-H', '40', '', '', 'h264.sdp', '3648x2753', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/571/original/ecce7613e4d0bdc1c96c6fe612715041.png?1426648131";}}', 'http://www.arecontvision.com/product/megadome2/av10255pmtir-h');
INSERT INTO "cameras" 
VALUES (NULL, 'av10255amir', 'AV10255AMIR', '40', '', '', 'h264.sdp', '3648x2752', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/570/original/d64f4aed60bc759685646b601243d03f.png?1426648123";}}', 'http://www.arecontvision.com/product/megadome2/av10255amir');
INSERT INTO "cameras" 
VALUES (NULL, 'av5255pmtir-h', 'AV5255PMTIR-H', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/616/original/dac8cdcb891c86a9db461c318ba7c2f2.png?1426648114";}}', 'http://www.arecontvision.com/product/megadome2/av5255pmtir-h');
INSERT INTO "cameras" 
VALUES (NULL, 'av5255am', 'AV5255AM', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/615/original/c3e6f9013edd5e84f8c51c9da42e7f4c.png?1426648106";}}', 'http://www.arecontvision.com/product/megadome2/av5255am');
INSERT INTO "cameras" 
VALUES (NULL, 'av3256pmtir', 'AV3256PMTIR', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/607/original/50f057df263ee9df9a3aeaf6f01d8837.png?1426648097";}}', 'http://www.arecontvision.com/product/megadome2/av3256pmtir');
INSERT INTO "cameras" 
VALUES (NULL, 'av3256pm', 'AV3256PM', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/606/original/53d28a3af2d234effb7631648490a341.png?1426648089";}}', 'http://www.arecontvision.com/product/megadome2/av3256pm');
INSERT INTO "cameras" 
VALUES (NULL, 'av3255pmtir-h', 'AV3255PMTIR-H', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/605/original/eea6687451fd15c91aa2503d826abb8b.png?1426648079";}}', 'http://www.arecontvision.com/product/megadome2/av3255pmtir-h');
INSERT INTO "cameras" 
VALUES (NULL, 'av3255am', 'AV3255AM', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/604/original/ed29424646b6932539c04dc464721500.png?1426648068";}}', 'http://www.arecontvision.com/product/megadome2/av3255am');
INSERT INTO "cameras" 
VALUES (NULL, 'av2256pmtir', 'AV2256PMTIR', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/595/original/5809d0c82f08404dcf7bcd26dd67fd84.png?1426648060";}}', 'http://www.arecontvision.com/product/megadome2/av2256pmtir');
INSERT INTO "cameras" 
VALUES (NULL, 'av2256pm', 'AV2256PM', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/594/original/010f2e46ab00c79e26792fa3ea76844a.png?1426648051";}}', 'http://www.arecontvision.com/product/megadome2/av2256pm');
INSERT INTO "cameras" 
VALUES (NULL, 'av2255pmtir-h', 'AV2255PMTIR-H', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/593/original/0705a5cc19c7589eff883b8e839b7b0f.png?1426648040";}}', 'http://www.arecontvision.com/product/megadome2/av2255pmtir-h');
INSERT INTO "cameras" 
VALUES (NULL, 'av2255am', 'AV2255AM', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/592/original/b52d27257b19927460cc75f0090b48ba.png?1426648032";}}', 'http://www.arecontvision.com/product/megadome2/av2255am');
INSERT INTO "cameras" 
VALUES (NULL, 'av1255am', 'AV1255AM', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/577/original/6edecfa4025fd884446a87c0e1ee1cd5.png?1426648382";}}', 'http://www.arecontvision.com/product/megadome2/av1255am');
INSERT INTO "cameras" 
VALUES (NULL, 'av5155', 'AV5155', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/613/original/bec173469f63929cc1a4074f468e8131.png?1426648014";}}', 'http://www.arecontvision.com/product/megadome+series/av5155');
INSERT INTO "cameras" 
VALUES (NULL, 'av3155', 'AV3155', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/600/original/4b6a866f44c2f0dc0a11448de8b63ec2.png?1426648006";}}', 'http://www.arecontvision.com/product/megadome+series/av3155');
INSERT INTO "cameras" 
VALUES (NULL, 'av2155', 'AV2155', '40', '', '', 'h264.sdp', '1600x1200', 'Dome', '', '', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/588/original/0f876daf329eeba422b2a7c0ba9f221c.png?1426647997";}}', 'http://www.arecontvision.com/product/megadome+series/av2155');
INSERT INTO "cameras" 
VALUES (NULL, 'av1355', 'AV1355', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/578/original/704b430eb85cb6348aa568151787254c.png?1426647988";}}', 'http://www.arecontvision.com/product/megadome+series/av1355');
INSERT INTO "cameras" 
VALUES (NULL, 'av10225pmtir', 'AV10225PMTIR', '40', '', '', 'h264.sdp', '3648x2752', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/569/original/58ffc87297aa6615b59dd18c21ffdcac.png?1426647980";}}', 'http://www.arecontvision.com/product/MegaView2/AV10225PMTIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av10225pmir', 'AV10225PMIR', '40', '', '', 'h264.sdp', '3648x2752', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/122/original/ff83c9195cdee375411d739e353d5d1e.jpg?1426647972";}}', 'http://www.arecontvision.com/product/MegaView2/AV10225PMIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av5225pmtir', 'AV5225PMTIR', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/614/original/93623b3bf7affa1ba164627977498c34.png?1426647963";}}', 'http://www.arecontvision.com/product/MegaView2/AV5225PMTIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av5225pmir', 'AV5225PMIR', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/217/original/0af79a1913fc36165e49a943c9f13b41.jpg?1426647955";}}', 'http://www.arecontvision.com/product/MegaView2/AV5225PMIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av3226pmtir', 'AV3226PMTIR', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/602/original/d371387abb1dce690fe81e6874251f41.png?1426647942";}}', 'http://www.arecontvision.com/product/MegaView2/AV3226PMTIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av3226pmir', 'AV3226PMIR', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/195/original/ba72c636d9bacb2046771e22250ff00a.jpg?1426647933";}}', 'http://www.arecontvision.com/product/MegaView2/AV3226PMIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av3225pmtir', 'AV3225PMTIR', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/601/original/aa9d21942c3b0d309420e4d5d12c62ed.png?1426647922";}}', 'http://www.arecontvision.com/product/MegaView2/AV3225PMTIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av3225pmir', 'AV3225PMIR', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/194/original/72c2f1b05db0cc3c6b1b2e4755fd711d.jpg?1426647913";}}', 'http://www.arecontvision.com/product/MegaView2/AV3225PMIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av2226pmtir', 'AV2226PMTIR', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/591/original/5b12a9ff86b61c3dc05f71d3d2c94c9f.png?1426647904";}}', 'http://www.arecontvision.com/product/MegaView2/AV2226PMTIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av2226pmir', 'AV2226PMIR', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/159/original/9bddb7a4958da7fbb38e45e6b1854dea.jpg?1426647895";}}', 'http://www.arecontvision.com/product/MegaView2/AV2226PMIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av2225pmtir', 'AV2225PMTIR', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/590/original/c5419c1816727849e3f61e4e5ee37b44.png?1426647885";}}', 'http://www.arecontvision.com/product/MegaView2/AV2225PMTIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av2225pmir', 'AV2225PMIR', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/158/original/6c379b0fe6115c267efc6b0148658651.jpg?1426647877";}}', 'http://www.arecontvision.com/product/MegaView2/AV2225PMIR');
INSERT INTO "cameras" 
VALUES (NULL, 'av5125irv1', 'AV5125IRv1', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/611/original/3f06d56f4b5f9b8b87959add5dd1db5d.png?1426647869";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV5125IRv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av5125dnv1', 'AV5125DNv1', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/609/original/fe7d52850eb5f7edfd6ea040542085d0.png?1426647860";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV5125DNv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av5125', 'AV5125', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/211/original/35c3d049078891454fb572c2e29ae113.jpg?1426647853";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV5125');
INSERT INTO "cameras" 
VALUES (NULL, 'av3125irv1', 'AV3125IRv1', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/598/original/faf090a061fb5fa7280f0496400f6acc.png?1426647845";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV3125IRv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av3125dnv1', 'AV3125DNv1', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/596/original/550ff2e530d93ae866a715a6be465e03.png?1426647835";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV3125DNv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av3125', 'AV3125', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/181/original/a657e967701f204453d056f7ce4d523d.jpg?1426647828";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV3125');
INSERT INTO "cameras" 
VALUES (NULL, 'av2825', 'AV2825', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/172/original/0bb08870a2ec7d77c9d95948ddfa3495.jpg?1426647822";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV2825');
INSERT INTO "cameras" 
VALUES (NULL, 'av2125irv1', 'AV2125IRv1', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/118/original/aaa313787b4ad1ebfde375bc96ba778b.png?1426648359";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV2125IRv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av2125dnv1', 'AV2125DNv1', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/583/original/91b3fa12929a10f6fe63c83b8b514a6e.png?1426647813";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV2125DNv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av2125', 'AV2125', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/149/original/2c51871da9ea9008adacfabab469b646.jpg?1426647806";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV2125');
INSERT INTO "cameras" 
VALUES (NULL, 'av1325', 'AV1325', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/138/original/088ad0268ae95a94e352d4d933b654b8.jpg?1426647799";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1325');
INSERT INTO "cameras" 
VALUES (NULL, 'av1125irv1', 'AV1125IRv1', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/119/original/1b00d1fd6da53ad3f1b2ac69acb30d55.png?1426648023";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1125IRv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av1125ir', 'AV1125IR', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/126/original/9ee104a959589bab1349e41243465bee.jpg?1426647793";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1125IR');
INSERT INTO "cameras" 
VALUES (NULL, 'av1125dnv1', 'AV1125DNv1', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/572/original/35cdaba92980f46e67c51602dc47c214.png?1426647783";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1125DNv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av1125', 'AV1125', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/125/original/20ddebe4080ff0901d822bc2a6814a5a.jpg?1426647776";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1125');
INSERT INTO "cameras" 
VALUES (NULL, 'av5125irv1x', 'AV5125IRv1x', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/612/original/9fa7681cab90c92ec0544e1fd2032b47.png?1426647768";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV5125IRv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av5125dnv1x', 'AV5125DNv1x', '40', '', '', 'h264.sdp', '2592x1944', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/610/original/49824f9e60d9dc874fd3f80f21d5aba6.png?1426647759";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV5125DNv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av3125irv1x', 'AV3125IRv1x', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/599/original/a95d7906719f8e589061e90da202f6cc.png?1426647751";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV3125IRv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av3125dnv1x', 'AV3125DNv1x', '40', '', '', 'h264.sdp', '2048x1536', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/597/original/a2439c5928cb23467f7e4dedd811868a.png?1426647740";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV3125DNv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av2125irv1x', 'AV2125IRv1x', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/120/original/944a74d8f0083a299462a24580248c60.png?1426647709";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV2125IRv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av2125dnv1x', 'AV2125DNv1x', '40', '', '', 'h264.sdp', '1920x1080', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/584/original/d660f3d4b74a7cefe9dee67616ad39ee.png?1426647732";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV2125DNv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av1125irv1x', 'AV1125IRv1x', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/121/original/c33f25e6fe19ed8dc08ed9797ccc2a76.png?1426647716";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1125IRv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av1125dnv1x', 'AV1125DNv1x', '40', '', '', 'h264.sdp', '1280x1024', 'Bullet', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/573/original/1087f04899036cf863b4eae766ae8f2d.png?1426647724";}}', 'http://www.arecontvision.com/product/MegaView+Series/AV1125DNv1x');
INSERT INTO "cameras" 
VALUES (NULL, 'av5245pm-w', 'AV5245PM-W', '40', '', '', 'h264.sdp', '2592x1944', 'Other', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/223/original/13bc770ebc1907bc0ac4edac4fb42706.jpg?1426647694";}}', 'http://www.arecontvision.com/product/MegaBall2/AV5245PM-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av5245pm-d-lg', 'AV5245PM-D-LG', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/221/original/e536ee66bb1391897ef343d97158cdda.jpg?1426647687";}}', 'http://www.arecontvision.com/product/MegaBall2/AV5245PM-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av5245pm-d', 'AV5245PM-D', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/222/original/ae8219381940b2acaa700fb6b8c41d82.jpg?1426647680";}}', 'http://www.arecontvision.com/product/MegaBall2/AV5245PM-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av5245dn-01-w', 'AV5245DN-01-W', '40', '', '', 'h264.sdp', '2592x1944', 'Other', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/220/original/27916858f970ed9c521ff26e31ab914a.jpg?1426647674";}}', 'http://www.arecontvision.com/product/MegaBall2/AV5245DN-01-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av5245dn-01-d-lg', 'AV5245DN-01-D-LG', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/218/original/9ee0e9b617ba3e988b10e183949f2e3a.jpg?1426647666";}}', 'http://www.arecontvision.com/product/MegaBall2/AV5245DN-01-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av5245dn-01-d', 'AV5245DN-01-D', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/219/original/791b421ed5c38664e9c2c470f0038276.jpg?1426647659";}}', 'http://www.arecontvision.com/product/MegaBall2/AV5245DN-01-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av3246pm-w', 'AV3246PM-W', '40', '', '', 'h264.sdp', '2048x1536', 'Other', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/201/original/b18dc5f4b78c60db536ddb6ac844e484.jpg?1426647652";}}', 'http://www.arecontvision.com/product/MegaBall2/AV3246PM-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av3246pm-d-lg', 'AV3246PM-D-LG', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/199/original/878cf474eab7de70d7b2bad0662280bd.jpg?1426647645";}}', 'http://www.arecontvision.com/product/MegaBall2/AV3246PM-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av3246pm-d', 'AV3246PM-D', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/200/original/5870579d7b5ae5225376b0691677172a.jpg?1426647639";}}', 'http://www.arecontvision.com/product/MegaBall2/AV3246PM-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av3245pm-w', 'AV3245PM-W', '40', '', '', 'h264.sdp', '2048x1536', 'Other', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/198/original/8532a40d6368f1ae9188a2d7c38ff2ac.jpg?1426647632";}}', 'http://www.arecontvision.com/product/MegaBall2/AV3245PM-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av3245pm-d-lg', 'AV3245PM-D-LG', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/196/original/0bcce4ad4795f15b085abebd228f6f9c.jpg?1426647625";}}', 'http://www.arecontvision.com/product/MegaBall2/AV3245PM-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av3245pm-d', 'AV3245PM-D', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/197/original/b2810eec42b10bd99b4c459ed5a1b601.jpg?1426647617";}}', 'http://www.arecontvision.com/product/MegaBall2/AV3245PM-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av2245pm-d', 'AV2245PM-D', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/161/original/1532adda756b883f2ac0a581026ea20c.jpg?1426647610";}}', 'http://www.arecontvision.com/product/MegaBall2/AV2245PM-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av2246pm-w', 'AV2246PM-W', '40', '', '', 'h264.sdp', '1920x1080', 'Other', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/165/original/fdaa7b6781fe19cef3c8abe40f3d7e7d.jpg?1426647603";}}', 'http://www.arecontvision.com/product/MegaBall2/AV2246PM-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av2246pm-d-lg', 'AV2246PM-D-LG', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/163/original/57f83ca15c0cc4060692ee494082728d.jpg?1426647596";}}', 'http://www.arecontvision.com/product/MegaBall2/AV2246PM-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av2246pm-d', 'AV2246PM-D', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/164/original/901692870d79677cd50e3854da475713.jpg?1426647589";}}', 'http://www.arecontvision.com/product/MegaBall2/AV2246PM-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av2245pm-w', 'AV2245PM-W', '40', '', '', 'h264.sdp', '1920x1080', 'Other', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/162/original/924b8cc98fdeac5c89dee3ef14af7dce.jpg?1426647582";}}', 'http://www.arecontvision.com/product/MegaBall2/AV2245PM-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av2245pm-d-lg', 'AV2245PM-D-LG', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/160/original/7e01763d9a952380c6276ad5b3be4317.jpg?1426647575";}}', 'http://www.arecontvision.com/product/MegaBall2/AV2245PM-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av5145-3310-w', 'AV5145-3310-W', '40', '', '', 'h264.sdp', '2592x1944', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/213/original/e0ad13adf48da07682cd150bf9f55647.jpg?1426647568";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV5145-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av5145-3310-d', 'AV5145-3310-D', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/212/original/42c865d0b28c8e670c5f69aa573c1a28.jpg?1426647562";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV5145-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av3145-3310-w', 'AV3145-3310-W', '40', '', '', 'h264.sdp', '2048x1536', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/122/original/f9e29d3ab3af4a4fca0a9b8498315a06.jpg?1426648367";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3145-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av3145-3310-d', 'AV3145-3310-D', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/184/original/7cee27d334e3e967fe5da060574fa3d4.jpg?1426647554";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3145-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av2145-3310-w', 'AV2145-3310-W', '40', '', '', 'h264.sdp', '1920x1080', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/131/original/962ce6c2742267c8f15dc678e5b87c4a.jpg?1426647469";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2145-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av2145-3310-d', 'AV2145-3310-D', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/150/original/ad04f9ae044c53d48d186a2903befb07.jpg?1426647546";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2145-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av1145-3310-w', 'AV1145-3310-W', '40', '', '', 'h264.sdp', '1280x1024', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/123/original/21a2b967c0894ced6c8d18c191ec73c0.jpg?1426647701";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV1145-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av1145-3310-d', 'AV1145-3310-D', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/127/original/a1a3a00b8a949b87c01ad93a8ecd9bdf.jpg?1426647539";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV1145-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av5145dn-3310-w', 'AV5145DN-3310-W', '40', '', '', 'h264.sdp', '2592x1944', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/216/original/1a1ae948fc8ee8a5f4142a81f562faf1.jpg?1426647532";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV5145DN-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av5145dn-3310-d-lg', 'AV5145DN-3310-D-LG', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/214/original/dc4c1653a1f1f840ac702fbcddb8b1f5.jpg?1426647526";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV5145DN-3310-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av5145dn-3310-d', 'AV5145DN-3310-D', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/215/original/43d98e23ce04e804aac1cc011201c5b8.jpg?1426647519";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV5145DN-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av3146dn-3310-w', 'AV3146DN-3310-W', '40', '', '', 'h264.sdp', '2048x1536', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/193/original/175ef9fa9b4179d20932f4b29e519c92.jpg?1426647511";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3146DN-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av3146dn-3310-d-lg', 'AV3146DN-3310-D-LG', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/191/original/acfc28f3c101ba547e8467cacb72f72d.jpg?1426647503";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3146DN-3310-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av3146dn-3310-d', 'AV3146DN-3310-D', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/192/original/3959e96d14cfb2c9d656a2ebd5eb2119.jpg?1426647496";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3146DN-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av3145dn-3310-w', 'AV3145DN-3310-W', '40', '', '', 'h264.sdp', '2048x1536', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/124/original/9d8ba17c74a1b113b1853a1b564592e6.jpg?1426647455";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3145DN-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av3145dn-3310-d-lg', 'AV3145DN-3310-D-LG', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/187/original/ada99dcfbf88debcc143d1111deb4633.jpg?1426647489";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3145DN-3310-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av3145dn-3310-d', 'AV3145DN-3310-D', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/188/original/2b23db5023262784d0ed4763917c5f98.jpg?1426647483";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV3145DN-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av2146dn-3310-w', 'AV2146DN-3310-W', '40', '', '', 'h264.sdp', '1920x1080', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/125/original/a996f01d56f1aa0958478c95f39c2785.jpg?1426647462";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2146DN-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av2146dn-3310-d-lg', 'AV2146DN-3310-D-LG', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/155/original/39f079e349038236e37d1a388ad9f2e4.jpg?1426647476";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2146DN-3310-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av2146dn-3310-d', 'AV2146DN-3310-D', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/156/original/0ac31785e344e840c8b35456b891a0b5.jpg?1426647441";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2146DN-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av2145dn-3310-w', 'AV2145DN-3310-W', '40', '', '', 'h264.sdp', '1920x1080', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/126/original/a8f209a6e5763436b7959b75588b163e.jpg?1426648373";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2145DN-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av2145dn-3310-d-lg', 'AV2145DN-3310-D-LG', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/152/original/17f8b01e021c034b23019c3e58170d8e.jpg?1426647434";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2145DN-3310-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av2145dn-3310-d', 'AV2145DN-3310-D', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/153/original/f893e99a6971644eba3663c4714ba837.jpg?1426647427";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV2145DN-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av1145dn-3310-w', 'AV1145DN-3310-W', '40', '', '', 'h264.sdp', '1280x1024', 'Other', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/127/original/9a73cd1e2f7738b6205fae7a871ce91b.jpg?1426647448";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV1145DN-3310-W');
INSERT INTO "cameras" 
VALUES (NULL, 'av1145dn-3310-d-lg', 'AV1145DN-3310-D-LG', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/129/original/1e1f173e518c5681066eacbe9521b718.jpg?1426647420";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV1145DN-3310-D-LG');
INSERT INTO "cameras" 
VALUES (NULL, 'av1145dn-3310-d', 'AV1145DN-3310-D', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/130/original/08ad5d8267910047a83a7fee0803005f.jpg?1426647413";}}', 'http://www.arecontvision.com/product/MegaBall+Series/AV1145DN-3310-D');
INSERT INTO "cameras" 
VALUES (NULL, 'av10115', 'AV10115', '40', '', '', 'h264.sdp', '3648x2752', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/120/original/5cc44bbe88972c8c6ae635582bf63252.jpg?1426647407";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV10115');
INSERT INTO "cameras" 
VALUES (NULL, 'av5115', 'AV5115', '40', '', '', 'h264.sdp', '2592x1944', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/209/original/ca6223954ec2be5276c31deb7417ae5e.jpg?1426647400";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV5115');
INSERT INTO "cameras" 
VALUES (NULL, 'av3115', 'AV3115', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/178/original/2200f004d3cc6a7234994f32c3933a8a.jpg?1426647394";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV3115');
INSERT INTO "cameras" 
VALUES (NULL, 'av2815', 'AV2815', '40', '', '', 'h264.sdp', '1920x1080', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/171/original/0016b5e9f40fb169ed8bcfcb37b1e51b.jpg?1426647386";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV2815');
INSERT INTO "cameras" 
VALUES (NULL, 'av2116dn', 'AV2116DN', '40', '', '', 'h264.sdp', '1920x1080', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/147/original/1f60b3a0e05cc5b233754db70cb20d99.jpg?1426647378";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV2116DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av2115', 'AV2115', '40', '', '', 'h264.sdp', '1920x1080', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/145/original/3bb4495857888d7ded11d4dc539ec7d5.jpg?1426647371";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV2115');
INSERT INTO "cameras" 
VALUES (NULL, 'av1315', 'AV1315', '40', '', '', 'h264.sdp', '1280x1024', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/137/original/c001553b13796b452d5b77e0e94ee294.jpg?1426647363";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV1315');
INSERT INTO "cameras" 
VALUES (NULL, 'av1115', 'AV1115', '40', '', '', 'h264.sdp', '1280x1024', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/123/original/74bc4edad9b767d839da754e28314866.jpg?1426647357";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV1115');
INSERT INTO "cameras" 
VALUES (NULL, 'av10115v1', 'AV10115v1', '40', '', '', 'h264.sdp', '3648x2752', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/121/original/0d170c5c07e11a67eaf0c050530bf529.jpg?1426647349";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV10115v1');
INSERT INTO "cameras" 
VALUES (NULL, 'av5115v1', 'AV5115v1', '40', '', '', 'h264.sdp', '2592x1944', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/210/original/f72be9b996308c7ef29156f1752b5804.jpg?1426647342";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV5115v1');
INSERT INTO "cameras" 
VALUES (NULL, 'av5110', 'AV5110', '40', '', '', '', '2592x1944', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/208/original/a184a17220e720cf29163eec20443147.jpg?1426647335";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV5110');
INSERT INTO "cameras" 
VALUES (NULL, 'av3236dn', 'AV3236DN', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/603/original/7323bf0bcbd459a745f6db77c75865c8.png?1426647326";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV3236DN');
INSERT INTO "cameras" 
VALUES (NULL, 'av3116dnv1', 'AV3116DNv1', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/180/original/9ba1d931dcf45861f48752c84608b611.jpg?1426647318";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV3116DNv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av3115v1', 'AV3115v1', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/179/original/6c0f398f0a161dcfe1dff927334aba3a.jpg?1426647310";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV3115v1');
INSERT INTO "cameras" 
VALUES (NULL, 'av3110', 'AV3110', '40', '', '', '', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/128/original/d62132518c3e3f75a1f587466b6984b7.jpg?1426647191";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV3110');
INSERT INTO "cameras" 
VALUES (NULL, 'av2116dnv1', 'AV2116DNv1', '40', '', '', 'h264.sdp', '1920x1080', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/148/original/d4861c9cf6bc1d9e518c77d875c746db.jpg?1426647301";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV2116DNv1');
INSERT INTO "cameras" 
VALUES (NULL, 'av2115v1', 'AV2115v1', '40', '', '', 'h264.sdp', '1920x1080', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/146/original/1b872f23bea5fe862e082119e5fe53f2.jpg?1426647294";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV2115v1');
INSERT INTO "cameras" 
VALUES (NULL, 'av2110', 'AV2110', '40', '', '', '', '1600x1200', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/129/original/8d2e5f07975353eef60f2a6b809a4615.jpg?1426647198";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV2110');
INSERT INTO "cameras" 
VALUES (NULL, 'av1310', 'AV1310', '40', '', '', '', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/130/original/663cb2837da6ba084cd589ef4598bb51.jpg?1426647205";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV1310');
INSERT INTO "cameras" 
VALUES (NULL, 'av1115v1', 'AV1115v1', '40', '', '', 'h264.sdp', '1280x1024', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/124/original/db188008ac060542a088720a15ab396c.jpg?1426647286";}}', 'http://www.arecontvision.com/product/MegaVideo+Compact+Series/AV1115v1');
INSERT INTO "cameras" 
VALUES (NULL, 'av10005', 'AV10005', '40', '', '', 'h264.sdp', '3648x2752', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/119/original/589972c2c743c2ddeec0e4044bfe73c2.jpg?1426647279";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV10005');
INSERT INTO "cameras" 
VALUES (NULL, 'av5105', 'AV5105', '40', '', '', 'h264.sdp', '2592x1944', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/207/original/d3989b26e784a328b46f0aa70b121ece.jpg?1426647272";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV5105');
INSERT INTO "cameras" 
VALUES (NULL, 'av5100', 'AV5100', '40', '', '', 'h264.sdp', '2592x1944', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/206/original/9379fb7f8c4602ebdafd50ebf58e272b.jpg?1426647265";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV5100');
INSERT INTO "cameras" 
VALUES (NULL, 'av3130', 'AV3130', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/182/original/e2962f162a90735e03b02f0226a048ac.jpg?1426647258";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV3130');
INSERT INTO "cameras" 
VALUES (NULL, 'av3105', 'AV3105', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/175/original/a794e9b3a08ff9ed716387dd669aa447.jpg?1426647251";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV3105');
INSERT INTO "cameras" 
VALUES (NULL, 'av3100m', 'AV3100M', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/174/original/91ca7ca80b64926578c5b4fb020c387a.jpg?1426647245";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV3100M');
INSERT INTO "cameras" 
VALUES (NULL, 'av3100', 'AV3100', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/173/original/b13ece7b515514f70873241ca9c0bee4.jpg?1426647238";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV3100');
INSERT INTO "cameras" 
VALUES (NULL, 'av2805', 'AV2805', '40', '', '', 'h264.sdp', '1920x1080', 'Box', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/170/original/3c4bb95605fbb1b7180b92a793e3c191.jpg?1426647231";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV2805');
INSERT INTO "cameras" 
VALUES (NULL, 'av2105', 'AV2105', '40', '', '', 'h264.sdp', '1600x1200', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/143/original/2cd2bd4bcddd131ed88597fab4168988.jpg?1426647225";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV2105');
INSERT INTO "cameras" 
VALUES (NULL, 'av2100m', 'AV2100M', '40', '', '', 'h264.sdp', '1600x1200', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/142/original/44df9398dc5509e8272b59f9a3dd5e02.jpg?1426647218";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV2100M');
INSERT INTO "cameras" 
VALUES (NULL, 'av2100', 'AV2100', '40', '', '', 'h264.sdp', '1600x1200', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/141/original/35bd44f1379a2ae38aa1ecd4f3b5bc4c.jpg?1426647211";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV2100');
INSERT INTO "cameras" 
VALUES (NULL, 'av1305', 'AV1305', '40', '', '', 'h264.sdp', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/135/original/2c545ebd60f874a4816ba2d0d0c8f21e.jpg?1426647183";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV1305');
INSERT INTO "cameras" 
VALUES (NULL, 'av1300m', 'AV1300M', '40', '', '', 'h264.sdp', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/134/original/f4fad8773f920d6cd0bc55de8bf06744.jpg?1426647176";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV1300M');
INSERT INTO "cameras" 
VALUES (NULL, 'av1300', 'AV1300', '40', '', '', 'h264.sdp', '1280x1024', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/133/original/a380c5ed0203ae34d6a527a0f97d2df1.jpg?1426647170";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV1300');
INSERT INTO "cameras" 
VALUES (NULL, 'av3135', 'AV3135', '40', '', '', 'h264.sdp', '2048x1536', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/183/original/5701476ac7d130feb0e29d1c7a1b18ac.jpg?1426647163";}}', 'http://www.arecontvision.com/product/MegaVideo+Series/AV3135');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av5115-3312', 'D4SO-AV5115-3312', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/241/original/1596535fc500b10b4e9c6cc7664859fd.jpg?1426647155";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV5115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av5115-3312', 'D4S-AV5115-3312', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/237/original/a5e4ce4f25e7bb4c165e26b7e6c1d665.jpg?1426647148";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV5115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av5115-3312', 'D4F-AV5115-3312', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/233/original/f9e4ea96ff092669215fe5d5a79a378d.jpg?1426647141";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV5115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av3115-3312', 'D4SO-AV3115-3312', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/240/original/e3a7e9eb42c5f3cfd29113f0f4579bd9.jpg?1426647134";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV3115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av3115-3312', 'D4S-AV3115-3312', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/236/original/c6fe4329cb22c64f021bc8df3a11c0df.jpg?1426647128";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV3115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av3115-3312', 'D4F-AV3115-3312', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/232/original/9e6b19a762bf81a7b05f90809d846905.jpg?1426647121";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV3115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av2115-3312', 'D4SO-AV2115-3312', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/239/original/1206e6f91a2c95f3ca17d5d2913c8a9c.jpg?1426647114";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV2115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av2115-3312', 'D4S-AV2115-3312', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/235/original/c7f3a93939453e73846d2b723585b279.jpg?1426647107";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV2115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av2115-3312', 'D4F-AV2115-3312', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/231/original/1b6807e20d4eb16cadc1bedaa860774a.jpg?1426647100";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV2115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av1115-3312', 'D4SO-AV1115-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/238/original/703fafa7d01f87d4900e4d99d8ae36c0.jpg?1426647093";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV1115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av1115-3312', 'D4S-AV1115-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/234/original/ca3834458a8594c894a2b032cc802866.jpg?1426647086";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV1115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av1115-3312', 'D4F-AV1115-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/230/original/cf1c9dfe9791b542db44d4ebfbeadd6e.jpg?1426647080";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV1115-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av5115v1-3312', 'D4SO-AV5115v1-3312', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/632/original/0a4431c8ec598452b8d7e22d60007c8d.png?1426647069";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV5115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av5115v1-3312', 'D4S-AV5115v1-3312', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/628/original/aaab9c0585164ae97e4ce8d7cbcda719.png?1426647060";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV5115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av5115v1-3312', 'D4F-AV5115v1-3312', '40', '', '', 'h264.sdp', '2592x1944', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/624/original/0e981a82b7c7a90f9cff9bc7446899d7.png?1426647052";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV5115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av3115v1-3312', 'D4SO-AV3115v1-3312', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/631/original/06b487251b62d51a67e7bce4e747461a.png?1426647043";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV3115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av3115v1-3312', 'D4S-AV3115v1-3312', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/627/original/1885104e48eb71a25c2d3c11dcd4bc4a.png?1426647035";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV3115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av3115v1-3312', 'D4F-AV3115v1-3312', '40', '', '', 'h264.sdp', '2048x1536', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/623/original/183d88b3c681b98db2e71baade34c4eb.png?1426647027";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV3115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av2115v1-3312', 'D4SO-AV2115v1-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/630/original/c788a68c96e395cb0e8ed3e923032a56.png?1426647018";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV2115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av2115v1-3312', 'D4S-AV2115v1-3312', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/626/original/312e63aa614d0aa36626926c66efd050.png?1426647009";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV2115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av2115v1-3312', 'D4F-AV2115v1-3312', '40', '', '', 'h264.sdp', '1920x1080', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/622/original/8685fee3c420d7c714e2a6c9493629ce.png?1426647001";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV2115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4so-av1115v1-3312', 'D4SO-AV1115v1-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/629/original/598eccd69ad20c71abcc7b851a01fba2.png?1426646991";}}', 'http://www.arecontvision.com/product/D4+Series/D4SO-AV1115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4s-av1115v1-3312', 'D4S-AV1115v1-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/625/original/ac580b069ca10548f2b26a3fad6ee470.png?1426646982";}}', 'http://www.arecontvision.com/product/D4+Series/D4S-AV1115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'd4f-av1115v1-3312', 'D4F-AV1115v1-3312', '40', '', '', 'h264.sdp', '1280x1024', 'Dome', '', '', '1', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/621/original/0b77929e8ac666571c158aa523ae074c.png?1426646974";}}', 'http://www.arecontvision.com/product/D4+Series/D4F-AV1115v1-3312');
INSERT INTO "cameras" 
VALUES (NULL, 'sncxm637', 'SNCXM637', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/381/original/0cb36fdf877264ec4362b9f9e556eded.jpg?1426619211";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncxm636', 'SNCXM636', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/380/original/982982cc1f1f0f8099bb15120f11df45.jpg?1426619207";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncxm632', 'SNCXM632', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/379/original/a9e205263bd2dc4b871920cefe824593.jpg?1426619202";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncwr632', 'SNCWR632', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/378/original/ac69501723f7ec1d2a09e31c1ae5220d.jpg?1426619198";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncwr630', 'SNCWR630', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:114:"http://s3.amazonaws.com/cambase/images/files/000/007/651/original/5386b53832f7c47ac249b0b8913b7940.jpeg?1426619220";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncwr602', 'SNCWR602', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/377/original/898f7c27fadac57391efa0a25695f8ea.jpg?1426619193";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncwr600', 'SNCWR600', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/498/original/31e56b427b64801fac8cc894e7a52e6c.jpg?1426619189";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/499/original/9ae4df427f5bfffcec376b3e9ca76c52.jpg?1416232878";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm632r', 'SNCVM632R', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/375/original/cc134eec5fb69526c826c9f563dc4f41.jpg?1426619185";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm631', 'SNCVM631', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:114:"http://s3.amazonaws.com/cambase/images/files/000/007/652/original/cef8c28ced5486b4660f514ef8846a67.jpeg?1426619216";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm630', 'SNCVM630', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/374/original/d324cc81d972d811640d3f23c86a8e94.jpg?1415956944";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/373/original/73b461b88eff38f4f921301dd7fcf6b1.jpg?1426619180";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm602r', 'SNCVM602R', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/372/original/f717e55178e4dbbcc079c28f5018086d.jpg?1426619176";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm601b', 'SNCVM601B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/371/original/8a3e6d4d2a026472dfc2ed02d1fb35ad.jpg?1426619172";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm601', 'SNCVM601', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/370/original/0401d69c15832de3eab008ca71de2678.jpg?1426618951";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm600b', 'SNCVM600B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/367/original/7598157bf1c66dde91cba44970cef701.jpg?1415956926";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/368/original/47475fa585e78417c0da68b53bab6d79.jpg?1415956928";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/369/original/b9291333b031010874466efbdf7d9c43.jpg?1415956930";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/366/original/3b0dc3145bd82243cf0c01874d3103d0.jpg?1426618958";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvm600', 'SNCVM600', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/363/original/bb9a39cb42dce7b4948c3a36ae0f5bab.jpg?1415956919";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/364/original/13e4e5fe748b02c1584b668324a517d6.jpg?1415956921";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/365/original/21b050547564f83b0d506bc58941ed0d.jpg?1415956922";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/362/original/f22d4a13ea5eb4fa888875429992e500.jpg?1426619234";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncrh164', 'SNCRH164', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/353/original/f74cef6bee83fe0afea82458a34b7659.jpg?1415956900";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/354/original/80c7af1f668783ee6d61c97c1a7b0989.jpg?1415956902";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/352/original/3dd15d816404f32f1cf3ae39573e4d01.jpg?1426618954";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncrh124', 'SNCRH124', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/349/original/6ae4409a63a6561b38a5d018c16a3650.jpg?1415956893";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/350/original/f90ac76fc720e7041858a05494d69084.jpg?1415956895";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/351/original/d332040c21e100aa2fa1797b9461e965.jpg?1415956896";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/348/original/b715d3e56d86ff36b17582eb149a1044.jpg?1426619164";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snchm662', 'SNCHM662', '41', 'oneshotimage.jpg', '', 'media/video1', '2560x1920', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/347/original/85c8f0bd8154da45efb984adb5706c12.jpg?1426619159";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncem632r', 'SNCEM632R', '41', '', '', 'media/video1', '14592x2752', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/346/original/9fed5f48fdb9957b567d5574e33117ad.jpg?1426619155";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncem631', 'SNCEM631', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/345/original/111a6812c0e8f257fe1021786d76f29e.jpg?1426619151";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncem602r', 'SNCEM602R', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/344/original/21f460a5997854506b037fc6200c8b93.jpg?1426619147";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncem601', 'SNCEM601', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/343/original/949b21044a5c7e63276b422072c02423.jpg?1426619143";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncem600', 'SNCEM600', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/342/original/b8342ac80e5a97579a1c60ec1391e74d.jpg?1426619139";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh280', 'SNCDH280', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/335/original/a7e8b50f83eb73bbc24bf94dbd109a4b.jpg?1426619135";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/336/original/39994308796ed9bb0abaf10ffcf85c13.jpg?1415956870";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/337/original/c4329476616aa803db79446622190f35.jpg?1415956871";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh260', 'SNCDH260', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/497/original/ccc6a0d93ad7bab3f502bd241a81e25b.jpg?1416232871";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/496/original/15886783b5fdbf194ae99539e2945ac6.jpg?1426619130";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh240t', 'SNCDH240T', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/332/original/21170124dce759ca27a09d95538bceb7.jpg?1426619125";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/333/original/ccc9f64bb70ce00b88cf29cda687e713.jpg?1415956863";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/334/original/fde854a5fe8f9936871b6ba3f1d529cd.jpg?1415956865";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh240', 'SNCDH240', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/328/original/58529d6bc60fddc45246b8aac0dd2b44.jpg?1426619120";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/329/original/4977072f73852cdb179f564d1ac02ea1.jpg?1415956856";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/330/original/bbf3d8ab3868af631c4e9d11db21f48f.jpg?1415956858";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/331/original/53bdad480e3000ce1fec30c9d3d70c45.jpg?1415956859";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh220t', 'SNCDH220T', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/324/original/181e72ac2885198f5ddc5b805c125a0e.jpg?1426619116";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/325/original/3a67cf2d2900a8dc7c9f0d06ad4cb5e7.jpg?1415956849";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/326/original/27e10fe0a4f983555a9755f52ab8e2ae.jpg?1415956851";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/327/original/0ad92d887075e1c0a5b8739d15ee7cb3.jpg?1415956853";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh220', 'SNCDH220', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/321/original/ae5bd497477696bf96f079d1aac8fc58.jpg?1426619112";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/322/original/5c351bfe8243fcb251f8c63a1cb2adbd.jpg?1415956845";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/323/original/0eb73f7e406a40f219c810356ae4f946.jpg?1415956846";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh210tw', 'SNCDH210T/W', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/653/original/cc5a81fc5153e917860b3ecaf26a59ae.jpg?1426619224";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh210tb', 'SNCDH210T/B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/654/original/2b19065a235069a015abae41b8c7f218.jpg?1426619168";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh210w', 'SNCDH210/W', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/655/original/a1c050029645fc50ce36c47ed3048ed4.jpg?1426618962";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh210b', 'SNCDH210/B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/666/original/0f0ce694a06abf6de9835d05f98db345.jpg?1426618967";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/656/original/52674c5cbb183f9cce51dbd73f575b36.jpg?1416319007";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh180', 'SNCDH180', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/318/original/74e88b4e9a1fa63af8374ac14ae3897a.jpg?1426619107";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/319/original/ffa7e868ad0417c55f2b79d7d4536365.jpg?1415956839";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/320/original/f9da73cf57beea1c7697d84017470e29.jpg?1415956841";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh160', 'SNCDH160', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/315/original/aa5a756e5833411e83d490933e50ef31.jpg?1426619102";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/316/original/462a9dd5ecd989ef145fb6d8dde657a0.jpg?1415956833";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/317/original/e5ebb0a8c77d4bb350167358d2b8cd01.jpg?1415956835";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh140t', 'SNCDH140T', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/312/original/cb0faddeb9ad0220c29d46a594d30e0e.jpg?1426619097";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/313/original/bb7923f856c037a7be7e6624a03b8887.jpg?1415956829";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/314/original/306a611db08c8555443aa2c99f1d4924.jpg?1415956830";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh140', 'SNCDH140', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/308/original/3995c0a3ca7c39b5b26d2590fb7acd59.jpg?1426619093";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/309/original/ab0d1a904c68c0e4784eb2d744cd5b7d.jpg?1415956821";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/310/original/31dacbd3a6f8d5f95863ce969e8f5cea.jpg?1415956823";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/311/original/67631858374dae77ccd2a8b90b19d7a7.jpg?1415956825";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh120t', 'SNCDH120T', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/304/original/071c88fa32ec1bc7cc21d07ced35a25b.jpg?1426619088";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/305/original/72e3de27f69c0ae63e34b6e5e5c71848.jpg?1415956815";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/306/original/c1da617182fd9ae8c62da9e1ace272f7.jpg?1415956816";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/307/original/6a3c94d15a4f99facf349ff5182a961d.jpg?1415956818";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh120', 'SNCDH120', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/301/original/1d771f1ee57fb1f2bdd88e7ee62877fb.jpg?1415956808";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/302/original/56b4363d1d07a917496d7148b6ef1059.jpg?1415956809";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/303/original/a098aa3e52d453e149de7b661cc0891a.jpg?1415956811";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/300/original/a07e90a1036d63155e127d952dea4085.jpg?1426619084";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh110tw', 'SNCDH110T/W', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Dome', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/657/original/6e8ee9a91763764d2f0540544b09a8ff.jpg?1426619229";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh110tb', 'SNCDH110T/B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/658/original/c2859d76ddd3d8d6c783d161f666b888.jpg?1426618971";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh110w', 'SNCDH110/W', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/660/original/2ca60043acb78ea946f67a6a21e2c35b.jpg?1416318600";}i:1;a:1:{s:3:"url";s:114:"http://s3.amazonaws.com/cambase/images/files/000/007/659/original/e64c611eda575fee57e9a451c4a4badd.jpeg?1426618975";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncdh110b', 'SNCDH110/B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x960', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/662/original/291a85b5e4de6c3f82007d55beca2656.jpg?1426618981";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch280', 'SNCCH280', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/294/original/b4964babde4557bcb771dd20bab55657.jpg?1426619080";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/295/original/be049cacd9612870ff676d04e69c6de4.jpg?1415956781";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/296/original/99c3bddbc0812fb65bd49b5d86c75872.jpg?1415956782";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/297/original/d587bb242617ddfbaeb1a62c6b651792.jpg?1415956784";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch260', 'SNCCH260', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/292/original/37e04727ff11c0cb99553c331fafab92.jpg?1426619075";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/293/original/e96e694784a6eddd37edca571303fe7f.jpg?1415956777";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch180', 'SNCCH180', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/283/original/e4a8f5cc8e8f809c3c8fb2e8fa09f446.jpg?1426619070";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/284/original/cb4d30f3c4265fcb921226a0907cdffd.jpg?1415956751";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/285/original/7c467bdb85fd16631d0da174786ef3d1.jpg?1415956753";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/286/original/6c9c18d64683920d12b3f341bce31112.jpg?1415956755";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch160', 'SNCCH160', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Bullet', 'admin', 'admin', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/280/original/108aceae16b0cf276ab05f1a69c322d4.jpg?1415956744";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/281/original/58d64ab126b40a404b013f5542b21517.jpg?1415956746";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/282/original/09848bc7c8078455d6250d09c3c751dc.jpg?1415956748";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/279/original/57d5093224eb12c4fea3d98700a066d5.jpg?1426619066";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvb635', 'SNCVB635', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/361/original/1cb3618804970de1b9d4708a8a3f309c.jpg?1426619061";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvb630', 'SNCVB630', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/360/original/082ec05d5428ecaf78a3a2eedfe6c2fd.jpg?1415956913";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/359/original/47a105fd6ada550e58cb1cd89195d3fd.jpg?1426619057";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvb600b', 'SNCVB600B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/358/original/e53b09c9bcc88562acdbaf9a5d3a9007.jpg?1415956909";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/357/original/c661d1e71af4efd95e3efd1c8a9190a7.jpg?1426619053";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncvb600', 'SNCVB600', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/356/original/23fcdd32809a72a2db132d688c9bcc7b.jpg?1415956905";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/355/original/af0f2dbefa58b9a5f26b265bca8a7d8c.jpg?1426619048";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snceb630b', 'SNCEB630B', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/341/original/1ee05a2e5096a2c0768a7d2aaa40d6ff.jpg?1426619044";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snceb630', 'SNCEB630', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/340/original/f285207617e768cf311d3742ea59484a.jpg?1426619038";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snceb600b', 'SNCEB600B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/339/original/16595cb6648a4c63478727f35a16dccd.jpg?1426619034";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snceb600', 'SNCEB600', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/338/original/49e64c81eb32e62e72e68a8dafea123a.jpg?1426619029";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snccx600w', 'SNCCX600W', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/495/original/07ef22648ec41d6ab27eb1f9e67f6156.jpg?1416232866";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/494/original/f2e713f241a095c44b970a4f800e66c3.jpg?1426619023";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snccx600', 'SNCCX600', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x720', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/298/original/08e3aa6f1dfb611b3fb928c5fb3be539.jpg?1426619018";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/299/original/daa2ab2e0d06258bdb7c65fa4d8379c0.jpg?1415956789";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch240', 'SNCCH240', '41', 'oneshotimage.jpg', '', 'media/video1', '1921x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/288/original/a5e114dcb558df9b44289658260b1c05.jpg?1426619014";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/289/original/762d504d4a14b6ccd41952c7b20d7712.jpg?1415956764";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/290/original/1cd2e5128c344371559d17a8f5130fad.jpg?1415956768";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/291/original/6e0169ec311cdd942400c4ecbd04ab55.jpg?1415956771";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch220', 'SNCCH220', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/287/original/dd517b96e3587a124987f15fea1fe0f2.jpg?1426619010";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch210s', 'SNCCH210/S', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/664/original/dfd82dfeac0f4ed19fd77a0d5ea35f4f.jpg?1416318725";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/663/original/950052db1e913386dc725173ac5c2920.jpg?1426618989";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch210b', 'SNCCH210/B', '41', 'oneshotimage.jpg', '', 'media/video1', '1920x1080', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/665/original/325fb73d2f9100708ef4c1cc96d1229d.jpg?1426618995";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch140', 'SNCCH140', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/275/original/a74d4f81040e22aeb274d115c86d9290.jpg?1426619006";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/276/original/5a37c9dddb4354e1dde5ab9ac1129aed.jpg?1415956736";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/277/original/ae51cbe6f1999c5804e0fbe1571a7d3a.jpg?1415956738";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/278/original/45d97071dd961cf2bab3c0a92a5179c1.jpg?1415956740";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch120', 'SNCCH120', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x1024', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/272/original/e495d5bfe16f1e2c1912914ad5af80c5.jpg?1415956727";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/273/original/0b01eeac4e107796bd0a8a3997f65d6d.jpg?1415956729";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/274/original/7734aac6b4ad0bc91f0710c4b2beb90c.jpg?1415956731";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/271/original/7a039cbcce3ee5b747ee884e9c6ddb39.jpg?1426619001";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch110s', 'SNCCH110/S', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x960', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'sncch110b', 'SNCCH110/B', '41', 'oneshotimage.jpg', '', 'media/video1', '1280x960', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:0:{}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-942l', 'DCS-942L', '46', 'image/jpeg.cgi', 'video/mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/711/original/60cd485e95856bb1db0727ad0d5c208c.png?1426618929";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-942l-enhanced-day-night-cloud-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-933l', 'DCS-933L', '46', 'image.jpg', 'mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/710/original/69bf37b129d6d014da3ac2f4c2fc1152.png?1426618922";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-933l-day-night-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-932l', 'DCS-932L', '46', 'image.jpg', 'mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/709/original/467565fc8da5eff443f24640a8634c26.png?1426618916";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-932l-day-night-cloud-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-932', 'DCS-932', '46', 'image.jpg', 'mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/708/original/19e93f7579172df84098f4863dc1fed9.png?1426618911";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-932-wireless-n-day-and-night-home-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-930l', 'DCS-930L', '46', 'image.jpg', 'mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/707/original/b6a51e7fd60a0fe4a26a34ca1feb304a.png?1426618905";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-930l-wireless-n-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-930', 'DCS-930', '46', 'image.jpg', 'mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/706/original/49b5a747ef96d012fc45221a323a01f7.png?1426618901";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-930-wireless-n-home-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-900', 'DCS-900', '46', 'image.jpg', 'mjpeg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/705/original/8e84c23c939b062534f8aa688cdf1ea0.png?1426618895";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-900-internet-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-5605', 'DCS-5605', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'play.sdp', 'ntsc:704x480/pal:704x576', 'Box', 'admin', '', '', 0, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/686/original/18d4e9c22890f9e02f62bd2774766c21.png?1426618871";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-5605-securicam-h-264-ptz-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-5230', 'DCS-5230', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'play.sdp', '1280x1024', 'Box', 'admin', '', '', 0, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/685/original/8e2eda88253e06bccd6192e3a74f4898.png?1426618866";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-5230-wireless-n-ptz-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-5222l', 'DCS-5222L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'play.sdp', '1280x720', 'Box', 'admin', '', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/684/original/b9346390e7acd945a06fec7025231038.png?1426618861";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-5222l-pan-tilt-zoom-cloud-camera?revision=deu_revb');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-5020l', 'DCS-5020L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/683/original/27ff72c8bbc65b2f50d8889dfcd55d11.png?1426618889";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-5020l-pan-tilt-day-night-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2332l', 'DCS-2332L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x800', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/677/original/c340714ed9cebb017c0be9a33271841d.png?1426618856";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2332l-outdoor-hd-wireless-day-night-cloud-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2330l', 'DCS-2330L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x720', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/676/original/f7e6be0e0e90c82a59b2fd1e56d7a5de.png?1426618852";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2330l-outdoor-hd-wireless-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2310l', 'DCS-2310L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x800', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/675/original/46d78ea832e477906b4c90c85c0d35d2.png?1426618847";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2310l-outdoor-hd-poe-day-night-cloud-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2230', 'DCS-2230', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1920x1080', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/674/original/132b96bcd668a95375e0d308e35531e3.png?1426618842";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2230-full-hd-wireless-day-night-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2210', 'DCS-2210', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1920x1080', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/673/original/064820f2973c2e1bf7c7a3abba1e7d34.png?1426618837";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2210-full-hd-poe-day-night-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2136l', 'DCS-2136L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x720', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/672/original/c351e3f0cef9ba98a5d8e29150e45b52.png?1426618832";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2136l-hd-wireless-day-night-camera-with-color-night-vision');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2132l', 'DCS-2132L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x800', 'Box', 'admin', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/671/original/cab89a58b3c6e565b777fa977646417d.png?1426618827";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2132l-hd-wireless-cloud-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2130', 'DCS-2130', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x800', 'Box', 'admin', '', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/633/original/1ffd59fe96a5f8b6172c7b7fdea3eb52.jpg?1426618935";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2130-hd-wireless-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2121', 'DCS-2121', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/668/original/d074e56520840586310881e6fa9882e5.png?1426618883";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2121-megapixel-wireless-internet-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2120', 'DCS-2120', '46', 'cgi-bin/video.jpg', '', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/667/original/c594b91d92cad2e801ae907d280abd0b.png?1426618876";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2120-wireless-internet-camera-with-3g-mobile-video-support');
INSERT INTO "cameras" 
VALUES (NULL, 'f3215', 'F3215', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1922x1080', 'Box', '', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/880/original/3ff27a0a81d0b402027927535cbb2166.jpg?1415792315";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/881/original/e6181195cdde7025388d88ec09c7659b.png?1415792317";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/879/original/a96908bd930a024166892622575f8a2f.png?1426618462";}}', 'http://zavio.com/product.php?id=84');
INSERT INTO "cameras" 
VALUES (NULL, 'f3210', 'F3210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1921x1080', 'Box', '', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/877/original/5b4fe452af39b69699f9353cd0ebaca5.png?1415792302";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/878/original/cef5b8f0bea87d5d66c71490534f3538.jpg?1415792304";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/876/original/2c6a15d6b4466f2336da98efe2260204.png?1426618456";}}', 'http://zavio.com/product.php?id=70');
INSERT INTO "cameras" 
VALUES (NULL, 'f3206', 'F3206', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/875/original/5f609ff161ab3700bf1df3db9c03d55b.png?1426618450";}}', 'http://zavio.com/product.php?id=29');
INSERT INTO "cameras" 
VALUES (NULL, 'f3201', 'F3201', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/874/original/b3869c3fa4cec6f2d6c086ac5310816c.png?1426618442";}}', 'http://zavio.com/product.php?id=28');
INSERT INTO "cameras" 
VALUES (NULL, 'f3115', 'F3115', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/873/original/b851fd8214ddef4c97179892776d1348.jpg?1415792271";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/872/original/8e4cb9e13251be6038781aacc276a7ac.png?1426618435";}}', 'http://zavio.com/product.php?id=64');
INSERT INTO "cameras" 
VALUES (NULL, 'f3110', 'F3110', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Box', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/871/original/67801001ad3d45b6b690f93770f0a5f1.jpg?1415792262";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/870/original/fcdbf17c3a92a708ea4ac872fe031a14.png?1426618428";}}', 'http://zavio.com/product.php?id=63');
INSERT INTO "cameras" 
VALUES (NULL, 'f3107', 'F3107', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/869/original/61b6f54b2063d0ebaab4e1a6d75672d9.jpg?1415792252";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/868/original/44c85516117bc512ceb4baa84125076e.png?1426618422";}}', 'http://zavio.com/product.php?id=66');
INSERT INTO "cameras" 
VALUES (NULL, 'f3102', 'F3102', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/867/original/0426a101d356aa75273fa82a9aba0a18.jpg?1415792242";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/866/original/aba97d9fbef5259684a78f908b2fd047.png?1426618412";}}', 'http://zavio.com/product.php?id=65');
INSERT INTO "cameras" 
VALUES (NULL, 'f3005', 'F3005', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '640x480', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/864/original/8fdd5ff0b650a1b74234339d483329c5.png?1426618404";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/865/original/a744d455c19194007135409108c6de93.png?1415792233";}}', 'http://zavio.com/product.php?id=68');
INSERT INTO "cameras" 
VALUES (NULL, 'f3000', 'F3000', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '640x480', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/863/original/5eea60d932f5c4f26c27073f31dba249.png?1415792224";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/862/original/bec5d5d3c80a5e828f29c5d106a571e6.png?1426618398";}}', 'http://zavio.com/product.php?id=67');
INSERT INTO "cameras" 
VALUES (NULL, 'f1105', 'F1105', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x720', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/859/original/f5e149906c95eaef5bf8f2d882cbc926.png?1415792209";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/860/original/263f1ec17423eb8d0f807f1935926c41.png?1415792212";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/861/original/6991e24095c9e66e68661bc275ba58a3.png?1415792215";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/858/original/99629369ab12c495d5866386c16126dc.png?1426618384";}}', 'http://zavio.com/product.php?id=58');
INSERT INTO "cameras" 
VALUES (NULL, 'f1100', 'F1100', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x720', 'Box', 'admin', 'admin', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/855/original/bed4d3b44ba02c7b44ee69843bef7cb5.png?1415792196";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/856/original/6e043e70e6f1b1c55a4ad304b573981b.png?1415792198";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/857/original/cc5ecb27704310cac91eef1d462f8b9a.png?1415792201";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/854/original/40c6722ce6ab6763996084971b997e2c.png?1426618372";}}', 'http://zavio.com/product.php?id=56');
INSERT INTO "cameras" 
VALUES (NULL, 'pz8121w', 'PZ8121W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Box', 'Root', '', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/025/original/bbea249eb5f78a4369bad36334f1d80c.jpg?1426620874";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/026/original/c7285e607c973cdcbf57ae68d3c09e99.png?1416380310";}}', 'http://www.vivotek.com/pz81x1w/');
INSERT INTO "cameras" 
VALUES (NULL, 'pz8121', 'PZ8121', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Box', 'Root', '', '', 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/023/original/bbfa2e64420616c10ba5c59c312cbdd2.jpg?1426620866";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/024/original/871b5a1beafc1a872dae24ad0fd50a32.png?1416380299";}}', 'http://www.vivotek.com/pz81x1/');
INSERT INTO "cameras" 
VALUES (NULL, 'pz8111w', 'PZ8111W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Box', 'Root', '', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/020/original/c89cb376473acb12a2e50b3a59818d0b.jpg?1426620856";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/022/original/a1e535236249cdc70aa35a4bfca70bb2.png?1416380280";}}', 'http://www.vivotek.com/pz81x1w/');
INSERT INTO "cameras" 
VALUES (NULL, 'pz8111', 'PZ8111', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Box', 'Root', '', '', 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/019/original/bcfed063d75d97a18b3d4b67faea8920.png?1416380268";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/018/original/4b396e1ce634e144f94bc9f0f9f62def.jpg?1426620835";}}', 'http://www.vivotek.com/pz81x1/');
INSERT INTO "cameras" 
VALUES (NULL, 'pt8133w', 'PT8133W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/017/original/41cd26f61d3a80e36f1880b0a3320389.png?1416380256";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/016/original/94c7805594613dd39d8fe4c7cbc931f8.jpg?1426620826";}}', 'http://www.vivotek.com/pt8133w/');
INSERT INTO "cameras" 
VALUES (NULL, 'pt8133', 'PT8133', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/015/original/1ed086ef902883464ea08602c0de0b87.png?1416380243";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/014/original/94997e9ff8088ce82712b57b3d535699.jpg?1426620819";}}', 'http://www.vivotek.com/pt8133/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8336w', 'IP8336W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/977/original/dba14768fa2ce841d2fd53f816939201.jpg?1416379970";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/976/original/a374ca05c48d1df1b92d36ae019067cc.png?1426620794";}}', 'http://www.vivotek.com/ip8336w/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8133w', 'IP8133W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/950/original/38410c0ca7b81438440bcc808b9961f2.jpg?1426620784";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/951/original/724898b4b8de2b84cf071c7643bdc4e7.png?1416379662";}}', 'http://www.vivotek.com/ip8133w/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8133', 'IP8133', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/949/original/f97e44029dc821335adf27f86e9451bf.png?1416379652";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/948/original/2dcf6fcb60c9d0a33bab2d4cb57df06f.jpg?1426620776";}}', 'http://www.vivotek.com/ip8133/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8131w', 'IP8131W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/946/original/259b05ef5f52e4223d7df95300f84daa.png?1426620754";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/947/original/bf9d645d73799eaca93f241c5d290964.jpg?1416379643";}}', 'http://www.vivotek.com/ip8131w/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8131', 'IP8131', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/944/original/cf37455f5bb08e703de52e56ba179ff9.jpg?1426620740";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/945/original/8a03bde8efe60473e3211b72ad3378db.png?1416379610";}}', 'http://www.vivotek.com/ip8131/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8130w', 'IP8130W', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/942/original/054e4e313ea25f92a0ef4211a931342a.jpg?1426620724";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/943/original/dbce82f517bcc64c6c1a2cbee5cfb5a5.png?1416379593";}}', 'http://www.vivotek.com/ip8130w/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8130', 'IP8130', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/941/original/9075d3856a3cc7f0201668eecc301fe9.png?1416379579";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/940/original/504fc1aed4d22de785fc5c693c00c0fa.jpg?1426620711";}}', 'http://www.vivotek.com/ip8130/');
INSERT INTO "cameras" 
VALUES (NULL, 'cc8130', 'CC8130', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Box', 'Root', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/387/original/d52cdfb6425a1b8d7cb4a7fa455fc2f0.png?1426620697";}}', 'http://www.vivotek.com/cc8130/');
INSERT INTO "cameras" 
VALUES (NULL, 'sf8174v', 'SF8174V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/076/original/6a3df55fbb3e18dc3c54f00eadac42d9.png?1416380620";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/075/original/898fbd10a427d344c040f5fe1642cb54.jpg?1426620685";}}', 'http://www.vivotek.com/sf8174v/');
INSERT INTO "cameras" 
VALUES (NULL, 'sf8174', 'SF8174', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/073/original/2d3c6c52f3390a6b2c34bc20372682d1.jpg?1426620666";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/074/original/50fa22edf29878a664ba6d90bd1033e3.png?1416380612";}}', 'http://www.vivotek.com/sf8174/');
INSERT INTO "cameras" 
VALUES (NULL, 'sf8172v', 'SF8172V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/071/original/495ee7f20f71fa0c1c351f13bf4ee97e.jpg?1426620654";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/072/original/6cdf5da2b9e9f2deec9eec2766e9b342.png?1416380596";}}', 'http://www.vivotek.com/sf8172v/');
INSERT INTO "cameras" 
VALUES (NULL, 'sf8172', 'SF8172', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/069/original/0cc7bc18b47371f88af457bae5265e0c.jpg?1426620645";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/070/original/07ea10187b5cc0d20077ff6304334de3.png?1416380580";}}', 'http://www.vivotek.com/sf8172/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8363e', 'SD8363E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/064/original/2573e406926ae8cdf7901ca8960c8381.jpg?1426620637";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/065/original/644db35015ca6b5773b325d7c77e7389.png?1416380553";}}', 'http://www.vivotek.com/sd8363e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8362e-ss', 'SD8362E-SS', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/061/original/dd0c57a90dfab30b1488832732876509.png?1416380531";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/060/original/65b1bae06c87303d58e935ae55608629.jpg?1426620629";}}', 'http://www.vivotek.com/sd8362e-ss/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8362e', 'SD8362E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/063/original/19d0a661d5d1fd9027f9f2313e3c3097.jpg?1416380542";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/062/original/6ca5cd04cb191a154b2cb8cf6c5a2bbf.png?1426620615";}}', 'http://www.vivotek.com/sd8362e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8326e', 'SD8326E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', 'Root', '', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/059/original/2b2c832de8e2de402f707fc707458bcc.png?1426620579";}}', 'http://www.vivotek.com/sd83x6e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8324e', 'SD8324E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', 'Root', '', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/057/original/198077215bd0d2a007cdac98e80a21a2.jpg?1426620559";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/058/original/9382aa054e80df7bd2676b478ec37477.png?1416380494";}}', 'http://www.vivotek.com/sd83x4e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8323e', 'SD8323E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/055/original/f7f682ba80341c9e4287341061099cf6.jpg?1426620552";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/056/original/16d203366dd703a83ed445c22ac81887.png?1416380476";}}', 'http://www.vivotek.com/sd83x3e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8322e', 'SD8322E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/051/original/460d0d0994b265e17e6480ee91e51343.jpg?1426620541";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/052/original/293037c8e2de5b8605653c74d3dfc46b.png?1416380459";}}', 'http://www.vivotek.com/sd83x2e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8321e', 'SD8321E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/049/original/392f89053d3ed120b484679734bbc4be.jpg?1426620532";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/050/original/741c954ac94231eda9dd5ca58ac21355.png?1416380447";}}', 'http://www.vivotek.com/sd83x1e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8316e', 'SD8316E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Dome', 'Root', '', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/047/original/922378b118ad5bb4abc019ed3ef2c943.jpg?1426620524";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/048/original/a0273ebbe5409ecb0e4ba72c78b69fe8.png?1416380418";}}', 'http://www.vivotek.com/sd83x6e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8314e', 'SD8314E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Dome', 'Root', '', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/042/original/a503feb8337b18bb1817df6c4540a063.png?1416380398";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/041/original/3aef15fdcc70ff5902ed7812d8c71b38.jpg?1426620517";}}', 'http://www.vivotek.com/sd83x4e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8313e', 'SD8313E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/039/original/a0c129ac6c1c010c5ce8bcdd145cdc44.jpg?1426620508";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/040/original/572fa5756f3d00888767406970ecc8ba.png?1416380384";}}', 'http://www.vivotek.com/sd83x3e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8312e', 'SD8312E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/036/original/8da77b15f49ec3d1caf6adcc388d1fd0.jpg?1426620496";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/037/original/22ed79dc8e9772aba875e52f3518abc0.png?1416380373";}}', 'http://www.vivotek.com/sd83x2e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8311e', 'SD8311E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/035/original/33b6db66fb2cf0d9e25fe3780cb03055.png?1416380361";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/034/original/d97f139a71b9c297847a9b0f874a2fa9.jpg?1426620485";}}', 'http://www.vivotek.com/sd83x1e/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8121', 'SD8121', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/033/original/5195de40ee2ff9cb3192c41d6ca04287.png?1416380350";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/032/original/e09eb42069be94402c5e19833573f516.jpg?1426620475";}}', 'http://www.vivotek.com/sd81x1/');
INSERT INTO "cameras" 
VALUES (NULL, 'sd8111', 'SD8111', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'ntsc720x480', 'Dome', 'Root', '', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/031/original/684148401c87227627673e0311176fc5.png?1416380336";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/030/original/83b0a86dcedf1e52fe9cc346772c0c28.jpg?1426620467";}}', 'http://www.vivotek.com/sd81x1/');
INSERT INTO "cameras" 
VALUES (NULL, 'pd8136', 'PD8136', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/012/original/9fcfb00b3591e83eae6db5fc3ecd7b77.jpg?1426620459";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/013/original/8590bc734328f09a70ab013608caa814.png?1416380228";}}', 'http://www.vivotek.com/pd8136/');
INSERT INTO "cameras" 
VALUES (NULL, 'md8562', 'MD8562', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/010/original/cbc64ba5e3e6e63a7028a2d75b0ed811.jpg?1426620449";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/011/original/a9e469a4d6c95536f32c01d8876ae8a5.png?1416380214";}}', 'http://www.vivotek.com/md8562/');
INSERT INTO "cameras" 
VALUES (NULL, 'md8531h', 'MD8531H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x960', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/008/original/298eab90514eb0a57ae5f3082fcb9fed.jpg?1426620440";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/009/original/ce36e92a1beb86794cd9f1f67534b46e.png?1416380200";}}', 'http://www.vivotek.com/md8531h/');
INSERT INTO "cameras" 
VALUES (NULL, 'md7560x', 'MD7560X', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', '', '1600x1200', 'Dome', 'Root', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/007/original/892ee44cba2b0482fd05da9b406b4a4c.png?1416380185";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/006/original/bd4d49e697c32140050580c56b5aac2d.jpg?1426620843";}}', 'http://www.vivotek.com/md7560x/');
INSERT INTO "cameras" 
VALUES (NULL, 'md7560', 'MD7560', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', '', '1600x1200', 'Dome', 'Root', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/005/original/b8933f3461fad7e5c6f8c40b73b80cd6.png?1416380174";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/004/original/19fa415664c0f134699e3a819e94088a.jpg?1426620906";}}', 'http://www.vivotek.com/md7560/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8372', 'IP8372', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2560x1920', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/003/original/b23b846171c53660d047d48a2f5bbbbe.png?1416380159";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/002/original/7eec3d19aefb92c6709788b8bfac71ed.jpg?1426620431";}}', 'http://www.vivotek.com/ip8372/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8371e', 'IP8371E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2048x1536', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/001/original/50d441695fe7be7c3488a37f1804ab96.jpg?1416380155";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/997/original/2b9852a9e087c269a61e147275119439.png?1426620412";}}', 'http://www.vivotek.com/ip8371e/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8371', 'IP8371', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2048x1536', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/995/original/0f4604eec2fba067c58ec0064bb58157.png?1426620384";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/996/original/305074f80d0ae41c899d41ea6b082239.jpg?1416380129";}}', 'http://www.vivotek.com/ip8371/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8365eh', 'IP8365EH', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/993/original/d6b04c145acb7cdd9317dbbfa0a58392.jpg?1426620375";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/994/original/90c30e995688628251e2c652749dbcbf.png?1416380090";}}', 'http://www.vivotek.com/ip8365eh/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8364-c', 'IP8364-C', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/991/original/9c1eb690371a97a07d16392c5bd3331d.jpg?1426620367";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/992/original/e1fc419cdb1ad22cd4b58fdd79b35c0b.png?1416380071";}}', 'http://www.vivotek.com/ip8364-c/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8362', 'IP8362', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/989/original/aab62131ba9deab0010482d151fb75b8.jpg?1426620341";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/990/original/fc64d3bf4ae235089227ad36798477fa.png?1416380051";}}', 'http://www.vivotek.com/ip8362/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8361', 'IP8361', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1600x1200', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/984/original/453029c6b9d8272bba7c69b25615e2f4.jpg?1426620332";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/985/original/28db4b8c49cce410d265b6cf8ce17e37.png?1416380032";}}', 'http://www.vivotek.com/ip8361/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8355eh', 'IP8355EH', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/982/original/6e442a48995fc99829420b5ec99206f4.jpg?1426620321";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/983/original/a02af1f6563156ef331a9cff5f416e0c.png?1416380013";}}', 'http://www.vivotek.com/ip8355eh/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8352', 'IP8352', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/980/original/a4cac420097a5c6fbb5edf675ad65d75.jpg?1426620313";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/981/original/73db0550cada61cd00d2fb22d26a8508.png?1416379996";}}', 'http://www.vivotek.com/ip8352/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8337h-c', 'IP8337H-C', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/978/original/5b76f1701d6de0a49d57319b9ab14392.jpg?1426620305";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/979/original/965322bfd585f3c65cfc415ac6143e42.png?1416379975";}}', 'http://www.vivotek.com/ip8337h-c/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8335h', 'IP8335H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Bullet', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/974/original/127e28f7c5beabd8dd71d3e4c9665b2a.jpg?1426620298";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/975/original/569e6bd7482cd6aef9f31a89c12a075d.png?1416379862";}}', 'http://www.vivotek.com/ip8335h/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8332-c', 'IP8332-C', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/971/original/64c979cb095d7de49573b393da2c7d0b.png?1416379839";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/970/original/bca7f0f18e3215aecc00b686b5f018ad.jpg?1426620289";}}', 'http://www.vivotek.com/ip8332-c/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8332', 'IP8332', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/973/original/7b86fa3e5f4208eea42a7f2cc30908d9.png?1416379852";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/972/original/f6820c20c29cbb2847a4b58f5da09d99.jpg?1426620281";}}', 'http://www.vivotek.com/ip8332/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8331', 'IP8331', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '640x480', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/969/original/b9e2caa31edc94e53cf5d21e74b2ed18.png?1426620266";}}', 'http://www.vivotek.com/ip8331/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8173h', 'IP8173H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2048x1536', 'Box', 'Root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/966/original/13e7248b1df7113ac47566c2639454dd.jpg?1426620257";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/967/original/fb424ebb1ac28d4981ad385123443a06.png?1416379794";}}', 'http://www.vivotek.com/ip8173h/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8172p', 'IP8172P', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2560x1920', 'Box', 'Root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/965/original/3ff96e11bd90832fcf781fe923e939cd.png?1416379777";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/964/original/7f0ecdfe09f9ae9164681246955d99df.jpg?1426620249";}}', 'http://www.vivotek.com/ip8172p/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8172', 'IP8172', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2560x1920', 'Box', 'Root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/963/original/74ecc5d788578e4c1ec6ba754f84a757.png?1426620237";}}', 'http://www.vivotek.com/ip8172/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8162p', 'IP8162P', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Box', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/962/original/1b86242831d20d8e2616be7e06d0d393.jpg?1416379743";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/961/original/0ff50ea587e5e42496f5f11721eef311.png?1426620223";}}', 'http://www.vivotek.com/ip8162p/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8162', 'IP8162', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Box', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/960/original/04cfcdaf53e4fff11ed0ab6bb919b0e1.png?1426620210";}}', 'http://www.vivotek.com/ip8162/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8161', 'IP8161', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1600x1200', 'Box', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/958/original/4845b0592e4733bf7c92b7ca4ae69694.png?1416379715";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/957/original/e7ccba8991c0586f9daf761ab7d919a5.jpg?1426620202";}}', 'http://www.vivotek.com/ip8161/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8152', 'IP8152', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Box', 'Root', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/955/original/49240fb3fe9994dd7e4265899b1b44c0.jpg?1426620194";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/956/original/8e42c7bc75aebf87a1d2b5b51a0fc96c.png?1416379702";}}', 'http://www.vivotek.com/ip8152/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8151p', 'IP8151P', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Box', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/954/original/444e327719534d883b75aa16e7443134.png?1416379687";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/953/original/f468a673fd1083519a29f96b4da973c9.jpg?1426620186";}}', 'http://www.vivotek.com/ip8151p/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip8151', 'IP8151', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Box', 'Root', '', '', 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/952/original/09c618082177b4da8b360ddc0c3f55dd.png?1426620172";}}', 'http://www.vivotek.com/ip8151/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip7361', 'IP7361', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', '', '1600x1200', 'Bullet', 'Root', '', '', 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/939/original/21075ca1db34afd41e99faeb899a5479.png?1426620892";}}', 'http://www.vivotek.com/ip7361/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip7161', 'IP7161', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', '', '1600x1200', 'Box', 'Root', '', '', 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/938/original/e05cbce15ee5f57e0ce0a6cf362c3e3e.jpg?1416379558";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/937/original/66bee38fdbf6510fd10ac722504b56bd.png?1426620350";}}', 'http://www.vivotek.com/ip7161/');
INSERT INTO "cameras" 
VALUES (NULL, 'ip7160', 'IP7160', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', '', '1600x1200', 'Box', 'Root', '', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/936/original/6c87df7cf7f7f0f47335371637412eb2.png?1416379542";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/935/original/833c9e9fbd68ea8c5ad1e3eb38d736b0.jpg?1426620882";}}', 'http://www.vivotek.com/ip7160/');
INSERT INTO "cameras" 
VALUES (NULL, 'ib8354-c', 'IB8354-C', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Bullet', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/934/original/67c158750ba6f6a2d2d5c79e69a4e808.png?1416379527";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/933/original/e543c150b66e49ca66cdba49df2798f0.jpg?1426620163";}}', 'http://www.vivotek.com/ib8354-c/');
INSERT INTO "cameras" 
VALUES (NULL, 'ib8168', 'IB8168', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Bullet', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/932/original/e5f29ee6b08a25b82ad506ef460767f4.png?1426620144";}}', 'http://www.vivotek.com/ib8168/');
INSERT INTO "cameras" 
VALUES (NULL, 'ib8156', 'IB8156', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Bullet', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/931/original/bbbd3efcb5daef370c068e9a98e9750d.png?1426620122";}}', 'http://www.vivotek.com/ib8156/');
INSERT INTO "cameras" 
VALUES (NULL, 'fe8174v', 'FE8174V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/929/original/3573edb063602e953590c102870bce84.png?1426620100";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/930/original/a78673212eafdaf087ccf96f0457cd6b.jpg?1416379493";}}', 'http://www.vivotek.com/fe8174v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fe8174', 'FE8174', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/927/original/8e9bba3e73cc7a42ba05ae131d6ca2ec.png?1416379437";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/926/original/a55ad78ad540dd37477196502619218a.jpg?1426620088";}}', 'http://www.vivotek.com/fe8174/');
INSERT INTO "cameras" 
VALUES (NULL, 'fe8173', 'FE8173', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1536x1536', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/925/original/0ea440949d7e281283e1c1446a51d10f.png?1416379421";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/924/original/8eff4430724a5f15c7a82ebb92b44254.jpg?1426620080";}}', 'http://www.vivotek.com/fe8173/');
INSERT INTO "cameras" 
VALUES (NULL, 'fe8172v', 'FE8172V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/922/original/ccc90fc276cd3d291b3479fd76c27000.jpg?1426620074";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/923/original/cec38b044f4656ec1d8368be32831907.png?1416379406";}}', 'http://www.vivotek.com/fe8172v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fe8172', 'FE8172', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', 'Root', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/920/original/d37becd27a8b15bfc21bdd3e55a2d337.jpg?1426620067";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/921/original/9d117abc8dd3a436bcfbeadfffd5a3e0.png?1416379388";}}', 'http://www.vivotek.com/fe8172/');
INSERT INTO "cameras" 
VALUES (NULL, 'fe8171v', 'FE8171V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1536x1536', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/918/original/efd3ea582524c881deec34e28b25f29b.jpg?1426620060";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/919/original/736da4cc59fccabc4606907049b2ed64.png?1416379375";}}', 'http://www.vivotek.com/fe8171v');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8372', 'FD8372', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2560x1920', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/916/original/1472d9bb49604bf09d4e06096037738a.jpg?1426620052";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/917/original/92d38ae707b248e428b1d3db552cc871.png?1416379360";}}', 'http://www.vivotek.com/fd8372/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8371v', 'FD8371V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2048x1536', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/915/original/f1ab0a762e0b0de0f5fc2986762fc1a1.png?1416379331";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/914/original/0d7b9bad1cd586ba47dd21b5178b4915.jpg?1426620045";}}', 'http://www.vivotek.com/fd8371v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8371ev', 'FD8371EV', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2048x1536', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/912/original/8b6831393aa762c34c2f7121a523e8a3.png?1426620012";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/913/original/2fb6a1144f19160aee1b3e035691097d.jpg?1416379326";}}', 'http://www.vivotek.com/fd8371ev/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8365ehv', 'FD8365EHV', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/910/original/4ccb95bb5d6f3a89987a6b4623ed3a03.jpg?1426620000";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/911/original/2dd96d885d10956c673c6580d18cf88f.png?1416379288";}}', 'http://www.vivotek.com/fd8365ehv/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8363', 'FD8363', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/909/original/e0e0a55cdc5e70ecbb38d90db7a10b5b.png?1416379264";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/908/original/9298ea2cc553fccd774dd2869bf8afc8.jpg?1426619990";}}', 'http://www.vivotek.com/fd8363/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8362e', 'FD8362E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/907/original/9e6ac1cd9d08806362be5c5da28e9103.jpg?1416379260";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/906/original/1d4ceb6877d58ce6b61e563354081607.png?1426619980";}}', 'http://www.vivotek.com/fd8362e/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8362', 'FD8362', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/904/original/ed1245688f5334e90ed22c950db97075.png?1426619965";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/905/original/bd2b1930c7995956fed99264f6bfee2b.jpg?1416379246";}}', 'http://www.vivotek.com/fd8362/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8361l', 'FD8361L', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1600x1200', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/903/original/d9b81b7887874f8e0581ad5863617f6f.jpg?1416379225";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/902/original/060784c79e3db8848337d97a7801b9a7.jpg?1426619955";}}', 'http://www.vivotek.com/fd8361l/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8361', 'FD8361', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1600x1200', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/901/original/c74c9af483378bedc907b70285238a7d.jpg?1416379206";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/900/original/794b7b361f3a1f37093b2138ca15b80f.png?1426619940";}}', 'http://www.vivotek.com/fd8361/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8355ehv', 'FD8355EHV', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/898/original/c7c62b0b20d0745780b927dace8d3f7d.jpg?1426619931";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/899/original/f30ec421c084f32e3d679e9b8c365d24.png?1416379178";}}', 'http://www.vivotek.com/fd8355ehv/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8335h', 'FD8335H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/410/original/3d84ab9983df0bbe52f08e98b0e32c71.png?1426619920";}}', 'http://www.vivotek.com/fd8335h/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8171', 'FD8171', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '2048x1536', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/409/original/200e1af222819f4f741f09881de54aed.png?1426619897";}}', 'http://www.vivotek.com/fd8171/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8168', 'FD8168', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/408/original/506146fd3262c3cbca3601a835dee20b.png?1426619878";}}', 'http://www.vivotek.com/fd8168/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8166', 'FD8166', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/407/original/cd99f2afde078a57b47e6dcfd01f5f1e.png?1426619859";}}', 'http://www.vivotek.com/fd8166/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8164v', 'FD8164V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/406/original/000354010fa9e8af3690d0822c879a92.png?1426619835";}}', 'http://www.vivotek.com/fd8164v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8164', 'FD8164', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/405/original/3c7d0728b09632d5371fbc2b160aa8da.png?1426619814";}}', 'http://www.vivotek.com/fd8164/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8163', 'FD8163', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/404/original/1710bc6087cd0f05180212fe49dbdd72.png?1426619793";}}', 'http://www.vivotek.com/fd8163/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8162', 'FD8162', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/403/original/4cb2c73fcc4e426a9ee249d7147bce24.png?1426619778";}}', 'http://www.vivotek.com/fd8162/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8161', 'FD8161', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1600x1200', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/402/original/cd1adb17bf002f145d316b0ea2fc2918.png?1426619764";}}', 'http://www.vivotek.com/fd8161/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8156', 'FD8156', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/401/original/3e41291842cc7c07de189d35d62a4071.png?1426619752";}}', 'http://www.vivotek.com/fd8156/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8154v', 'FD8154V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/400/original/172e749a21ee72f071e5231ffbdb96c8.png?1426619725";}}', 'http://www.vivotek.com/fd8154v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8154', 'FD8154', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/399/original/559fb3a2fdc54b915fc7a5717ab27026.png?1426619698";}}', 'http://www.vivotek.com/fd8154/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8151v', 'FD8151V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x1024', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/398/original/68af14add633863125b74f6c7213d7a0.png?1426619685";}}', 'http://www.vivotek.com/fd8151v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8137hv', 'FD8137HV', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/397/original/ae94494f6a619d32cda406bf9eeb3c5b.png?1426619660";}}', 'http://www.vivotek.com/fd8137hv/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8137h', 'FD8137H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/396/original/6985393cb01d5eeda6e7603a1a339037.png?1426619638";}}', 'http://www.vivotek.com/fd8137h/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8136', 'FD8136', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/395/original/b2b6e4c9ee105ff4b323883f174e5f76.png?1426619624";}}', 'http://www.vivotek.com/fd8136/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8135h', 'FD8135H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/394/original/837df43981d066d4b97182a9447ef068.png?1426619615";}}', 'http://www.vivotek.com/fd8135h/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8134v', 'FD8134V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/393/original/6e986d26fe6a4496cec79bb8752f3f36.png?1426619604";}}', 'http://www.vivotek.com/fd8134v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8134', 'FD8134', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/392/original/7a296d88eacff18b46e24abc0d24df51.png?1426619589";}}', 'http://www.vivotek.com/fd8134/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8133v', 'FD8133V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/391/original/d2055d2acbf690a62411521ab06eb604.png?1426619573";}}', 'http://www.vivotek.com/fd8133v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8133', 'FD8133', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/390/original/fc03223d02bd4a417aadae7a54725fdd.png?1426619558";}}', 'http://www.vivotek.com/fd8133/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8131v', 'FD8131V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/389/original/2e734fcf61078660787b84183c8dd034.png?1426619541";}}', 'http://www.vivotek.com/fd8131v/');
INSERT INTO "cameras" 
VALUES (NULL, 'fd8131', 'FD8131', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', 'Root', '', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/388/original/0057962023f2052f93d94bea09533b59.png?1426619524";}}', 'http://www.vivotek.com/fd8131/');
INSERT INTO "cameras" 
VALUES (NULL, 'bs5332e', 'BS5332E', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', 'pal720x576', 'Dome', '', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/386/original/579498ec56102855bfae76cf0fabe55b.png?1426619509";}}', 'http://www.vivotek.com/bs5332e/');
INSERT INTO "cameras" 
VALUES (NULL, 'bd5336', 'BD5336', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/385/original/58747e21a11aa97564b424e2cb56ad02.png?1426619496";}}', 'http://www.vivotek.com/bd5336/');
INSERT INTO "cameras" 
VALUES (NULL, 'bd5115', 'BD5115', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Dome', '', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/384/original/69c94de653b3de4bb34cef9963e74292.png?1426619482";}}', 'http://www.vivotek.com/bd5115/');
INSERT INTO "cameras" 
VALUES (NULL, 'bb5315', 'BB5315', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Bullet', '', '', '', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/383/original/7ded76eee59ce449f8771c2fe02a1650.png?1426619468";}}', 'http://www.vivotek.com/bb5315/');
INSERT INTO "cameras" 
VALUES (NULL, 'bb5116', 'BB5116', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1600x1200', 'Box', '', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/382/original/ccf2e651201e9b64de8449ac87a9bbce.png?1426619456";}}', 'http://www.vivotek.com/bb5116/');
INSERT INTO "cameras" 
VALUES (NULL, 'af5127v', 'AF5127V', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', '', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/381/original/af9833d11e8c61e8f6d0558a0aae2cf6.png?1426619441";}}', 'http://www.vivotek.com/af5127v/');
INSERT INTO "cameras" 
VALUES (NULL, 'af5127', 'AF5127', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1920x1920', 'Dome', '', '', '', 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/380/original/354b1082077577f7ed34972f2625a6f0.png?1426619428";}}', 'http://www.vivotek.com/af5127/');
INSERT INTO "cameras" 
VALUES (NULL, 'ab5353h', 'AB5353H', '42', 'cgi-bin/viewer/video.jpg', 'video.mjpg', 'live.sdp', '1280x800', 'Bullet', '', '', '', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/379/original/26a6dcae5273e91a6edd6a5996438719.png?1426619416";}}', 'http://www.vivotek.com/ab5353h/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw115', 'WV-SW115', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/071/original/8de456512b1be28a3d5911fbeb6dfb37.jpg?1415744862";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/072/original/92e719a5798be54503addcce968ba964.jpg?1415744866";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/070/original/a61e35cc678fe3c839c91b11e121bab7.jpg?1426619113";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sfr611l', 'WV-SFR611L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/735/original/166605a570c3df9f57552cdb80d0181e.png?1415776351";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/736/original/ab4ba3d6897865d53245551ee15de186.png?1415776355";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/737/original/6710e224404f4183eaffcc789adde180.png?1415776359";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/734/original/1996aead2436f36d09ec319900611725.png?1426619108";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sfr631l', 'WV-SFR631L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/640/original/e198ef76a4b12cbd5c286309967f3dcd.jpg?1426619169";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sfv631l', 'WV-SFV631L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/739/original/5dc19f05efb711d4272ba96bb70eac6c.png?1415776367";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/740/original/24327b8abbc5a9df00f6e706a990c3aa.png?1415776370";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/741/original/99717256e7a881dcd4aad54108566b4c.png?1415776374";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/738/original/11919fc8510227fb5d5cb75023284179.png?1426619103";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sfv611l', 'WV-SFV611L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/642/original/6b470a91e26fa45cdcd1b3fd5aa46181.png?1416311293";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/643/original/bd163dbe0216eb1a27faa8d81f3cf3ff.png?1416311294";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/641/original/f11a2e47d7f714b7b92fe33838017e77.png?1426619119";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw158', 'WV-SW158', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/076/original/232de7c41bf3252cf2cdd9e62749083f.jpg?1415744885";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/077/original/6117452f74db8226b64449fd455a997d.jpg?1415744889";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/075/original/5bf0310760083fbef9499a2f7cf8d23b.jpg?1426619097";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw559', 'WV-SW559', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/095/original/594ba32c52b86ac569a4278e7ac08246.jpg?1426619092";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw558', 'WV-SW558', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/094/original/3a2995be0b4ea44746c9da5bc89aef18.jpg?1426619087";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw155', 'WV-SW155', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/074/original/7de3b0dffd33eaa8424f82a19395f48a.jpg?1426619082";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw152', 'WV-SW152', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/073/original/ed63d41ba3b7d8759805b5c236e63648.jpg?1426619077";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw352', 'WV-SW352', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/088/original/9bf522cb4872836486c5db059920c2b3.jpg?1426619072";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw355', 'WV-SW355', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/089/original/ab5c0549c38893074e5090fc96ee61b2.jpg?1426619067";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf346', 'WV-SF346', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Dome', 'admin', '12345', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/044/original/428f8f7516c20215f4e1494b9f864cec.jpg?1426619062";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf342', 'WV-SF342', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x720', 'Dome', 'admin', '12345', '', 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/043/original/8c7175ccfb9ff7dca6420668cbd8e248.jpg?1426619057";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-nw502s', 'WV-NW502S', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/031/original/e5d5f0263446d2c520fcdc97316c9e21.jpg?1426619051";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sc588', 'WV-SC588', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/036/original/9052c9e69d36430e589a806ac7591b88.jpg?1415744686";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/035/original/ecfd382c9e78d069b080b4778dec11f1.jpg?1426619046";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-cw594a', 'WV-CW594A', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/030/original/edca868f87c465d87e6ada64bccf0ded.jpg?1426619039";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw395a', 'WV-SW395A', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/091/original/a7f62e113a893887fa135a061f253acc.jpg?1426619033";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw396a', 'WV-SW396A', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/746/original/6bfcbdc0530082eada845e4c4e0d7174.png?1426619025";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw598', 'WV-SW598', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/747/original/edd4627def87209914f66faa1c301c2b.png?1426619019";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/096/original/0975b780636aeb4f32b551ea9976f971.jpg?1415744983";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw458', 'WV-SW458', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/093/original/b1a1ba1de96df1c2253c6a6d213a653e.jpg?1426619013";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf438', 'WV-SF438', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/045/original/e36648389eeb17f34a6c71502e0bbee5.jpg?1426619007";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sc386', 'WV-SC386', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/034/original/638b1f8ffe0deb566a70aa1d4e0e34e8.jpg?1426619003";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sc384', 'WV-SC384', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/032/original/135585a4581a73ad8827da39dc6abc38.jpg?1426618998";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw396', 'WV-SW396', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/092/original/ca22f3825a3905975a601d7c47a1f5e8.jpg?1426618992";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw395', 'WV-SW395', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/090/original/fb0e6f802815636bae520aa54cd5abf4.jpg?1426618987";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sc385', 'WV-SC385', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/033/original/96fed905f7ac83372c6a884c0160e42a.jpg?1426618979";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-cp310', 'WV-CP310', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '976x494', 'Dome', 'admin', '12345', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/029/original/ae599b406b834a4996f91a74c863a500.jpg?1426618972";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf549', 'WV-SF549', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '2048x1536', 'Dome', 'admin', '12345', '', 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/049/original/4caa07ea0204fdf869b5cbb3b3435fea.jpg?1426618966";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf548', 'WV-SF548', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/048/original/ab1c6340320180ddb63017074515439b.jpg?1426618962";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf539', 'WV-SF539', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/047/original/1fb36648ff440d357f6208e3912c98f4.jpg?1426618957";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf538', 'WV-SF538', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/046/original/6c5300318d9d523f1b97cbb9ff1101d4.jpg?1426618952";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-cp300', 'WV-CP300', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '-', 'Dome', 'admin', '12345', '', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/028/original/c50432a9826b412949af34bdc8dfa231.jpg?1426618947";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf138', 'WV-SF138', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/039/original/fa5636cd21b84e51a1fde9d9028c101f.jpg?1426618942";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf135', 'WV-SF135', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/038/original/7cb8ac398b826e87bb9088993378d28a.jpg?1426618937";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf132', 'WV-SF132', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Dome', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/037/original/20102527067db96d6a9cb7ab712e576f.jpg?1426618931";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf336', 'WV-SF336', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/042/original/371c634cf087d8674a0dadf0515342bd.jpg?1426618925";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf335', 'WV-SF335', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/041/original/2c7ddf101e511ef13952cee0c16ba21b.jpg?1426618921";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sf332', 'WV-SF332', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '800x600', 'Dome', 'admin', '12345', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/040/original/92a3d3707e42d4e7e97de15f3fd755ba.jpg?1426618916";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sfn631l', 'WV-SFN631L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '2048x1536', 'Dome', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/053/original/d193c13faa1087d19e6e36f93e4fa61b.jpg?1415744776";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/052/original/687f347ffbb0ec23a44f9693e2c1640e.jpg?1426618911";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sfn611l', 'WV-SFN611L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Dome', 'admin', '12345', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/051/original/00fa02e3e5548708274365e4dfb30e18.jpg?1415744767";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/050/original/aa35381696235b5d0da1ff2c98c8f23c.jpg?1426618906";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw174w', 'WV-SW174W', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/081/original/8f3f6fa934f6f2fd81150c4f00dcc5d0.jpg?1426618900";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw316l', 'WV-SW316L', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/087/original/53d2e70e9f7307f0bf4c2e2e69ad747a.jpg?1426618895";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sp509', 'WV-SP509', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Box', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/063/original/93c65352f3131f3c3a0f4cc31a73bc76.jpg?1426618889";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sp508', 'WV-SP508', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1920x1080', 'Box', 'admin', '12345', '', 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/062/original/b022b69c1dd4a595d16b3c715bf86270.jpg?1426618885";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw316', 'WV-SW316', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/745/original/2580d7daad5896e25f13453b7443e7fd.gif?1415776398";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/744/original/80dc58d3d2c9b0206e34a82f15464a84.gif?1426618879";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/086/original/af011f5e1c8e329dce977dca0cc19a69.jpg?1415744934";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw314', 'WV-SW314', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/742/original/2cbbfe4dfef3f2f0c3d3c8b1ba87db24.gif?1426618872";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/743/original/486a62aa30b90189bc396e94e53cbede.gif?1415776387";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/085/original/309b3ae5934413ccbb81ca689ab6ba0d.jpg?1415744929";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-st165', 'WV-ST165', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/068/original/aed5a8c2c084376adaa5c0e18e8e5bcd.jpg?1415744850";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/069/original/7c11682c81304e6c48f22b751b31d542.jpg?1415744854";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/067/original/4e3c0ecf7bf15fc1dc57fea3989fc8fa.jpg?1426618868";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw175', 'WV-SW175', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/083/original/7c896b467856aeacae5714f1d4cc7a52.jpg?1415744919";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/084/original/945051e417faa15ce461e440015266a7.jpg?1415744923";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/082/original/c069d4e898c93759296c281682deb4a4.jpg?1426618834";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-st162', 'WV-ST162', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '800x600', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/064/original/32d549df7e96ab02314f79786707f299.jpg?1426618864";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/065/original/41d133b1ea346ac8963c1c6a7ffa7bf4.jpg?1415744838";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/066/original/06d3264157aff14fa6c65a31446ae204.jpg?1415744841";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sw172', 'WV-SW172', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '800x600', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/079/original/60ce30d053990d596b8eb9043395bfa1.jpg?1415744899";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/080/original/b4d5f9c1aca00ec536b31f8f2a3291ec.jpg?1415744903";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/078/original/8046e3636771d0d16558a24e57ea1c24.jpg?1426618859";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sp306', 'WV-SP306', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/061/original/68d462e692a5d478795412117d46d079.jpg?1426618855";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sp305', 'WV-SP305', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/060/original/8c3ab60956ca36faa18e046680ae766c.jpg?1426618851";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sp105', 'WV-SP105', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '1280x960', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/059/original/d12e935be7d02dae8848bab5fac7f700.jpg?1426618847";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'wv-sp102', 'WV-SP102', '43', 'SnapshotJPEG', 'nphMotionJpeg', 'MediaInput/h264', '640x480', 'Box', 'admin', '12345', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/058/original/12e8e295b5ad1e262250879c48c4a982.jpg?1426618842";}}', 'http://security.panasonic.com/pss/security/');
INSERT INTO "cameras" 
VALUES (NULL, 'd24', 'D24', '44', 'record/current.jpg', 'cgi-bin/faststream.jpg', '', '2048x1536', 'Box', 'admin', 'meinsm', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/213/original/60863a2057fa371f73bd3afa76bf9022.jpg?1426617466";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/214/original/657dcd8eaf0abc3c3eff0921c5c89d46.jpg?1415797633";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/215/original/6dc85a50ae0070246c22542102d8485e.jpg?1415797635";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/216/original/15dcf6a6dee607376252664d8855e059.jpg?1415797636";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'd15', 'D15', '44', 'record/current.jpg', 'cgi-bin/faststream.jpg', '', '2048x1536', 'Box', 'admin', 'meinsm', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/210/original/0ba43f05dbd926a675cd9eb84511b0b0.jpg?1415797625";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/209/original/dcdfd1553ed195553b19d8ab34974776.jpg?1426617462";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/211/original/8d3ad1797fab0735a47acc97f9f41bf1.jpg?1415797627";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/212/original/d8f54de21c9297f70623e2b33cd70eb7.jpg?1415797629";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm24', 'M24', '44', 'record/current.jpg', 'cgi-bin/faststream.jpg', '', '2048x1536', 'Box', 'admin', 'meinsm', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/221/original/c4d1d58704b5bbca1279bc57499bf687.jpg?1426617459";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/222/original/abd473408f689d6f12e0d4f35220e8da.jpg?1415797648";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/223/original/d7d0dfb6dccc8facfd9f8d8131f363eb.jpg?1415797650";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/224/original/d796e86df16d222cd63575e24bc6fcbe.png?1415797653";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm12', 'M12', '44', 'record/current.jpg', 'cgi-bin/faststream.jpg', '', '2045x1536', 'Box', 'admin', 'meinsm', '', 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/217/original/cb01b8372f604e1e6ac7d17afa53c445.jpg?1426617456";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/218/original/09cd5dfbe8eb6c2b59ee21fc577cd669.jpg?1415797640";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/219/original/c0ef52f4e5f23e25c308e50927c1e81e.jpg?1415797642";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/220/original/947ff58b0b7838eda2b604658b091d7e.png?1415797644";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q24', 'Q24', '44', 'record/current.jpg', 'cgi-bin/faststream.jpg', '', '2048x1536', 'Dome', 'admin', 'meinsm', '', 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/226/original/e3f7c4ff8426bb1180d91e3ec5611854.jpg?1415797657";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/227/original/5031557a2c6aa2ec85628275f10e23b6.jpg?1415797659";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/225/original/30101d3a4acdaf95c3672146b41de3d4.jpg?1426617452";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 's15', 'S15', '44', 'record/current.jpg', 'cgi-bin/faststream.jpg', '', '2048x1536', 'Box', 'admin', 'meinsm', '', 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/229/original/3c2bcedf9dbef9c40377a810e150589b.jpg?1415797664";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/230/original/ef339a9f9d7d8cfa16676066427234b3.jpg?1415797666";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/231/original/1950acad7cd719eaafaec80caa655615.png?1415797668";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/228/original/b84f3e74e34696805bb9d2732fd99874.jpg?1426617449";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p6210', 'P6210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/891/original/4faafc7c633fbe2716b2712d18a6cf51.png?1415792371";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/892/original/6b848d6ba8f3dbb47f68b4d5ca016dfa.png?1415792375";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/890/original/dd2e42da59e3d4d881d5ceb21ba697e4.png?1426618358";}}', 'http://www.zavio.com/product.php?id=85');
INSERT INTO "cameras" 
VALUES (NULL, 'p5210', 'P5210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/889/original/486640f9b6df918ce4e113c52e02de27.jpg?1415792351";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/888/original/321bb86535b8ad989e7339ce160245b4.jpg?1426618352";}}', 'http://www.zavio.com/product.php?id=74');
INSERT INTO "cameras" 
VALUES (NULL, 'p5116', 'P5116', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/887/original/0165256eaa187d844be177b42e7f031c.jpg?1415792343";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/886/original/c93458835e8f23d1683552d4c90a6f44.jpg?1426618347";}}', 'http://www.zavio.com/product.php?id=73');
INSERT INTO "cameras" 
VALUES (NULL, 'p5111', 'P5111', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/885/original/006030006b9f69512d1a15d4760c7c02.jpg?1415792335";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/884/original/e36d6dc22ebdbead5d612b56ba75bea6.jpg?1426618342";}}', 'http://www.zavio.com/product.php?id=72');
INSERT INTO "cameras" 
VALUES (NULL, 'f7210', 'F7210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Box', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/883/original/9ab5435773b27c7ff7f628ecef6fe156.png?1415792326";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/882/original/9216fbd099661a0e75e754f8f2cf0d38.png?1426618335";}}', 'http://www.zavio.com/product.php?id=51');
INSERT INTO "cameras" 
VALUES (NULL, 'd7510', 'D7510', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '2560x1920', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/853/original/af6a532ce21bac442591bbd4b9a91a77.png?1415792187";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/852/original/fbcc65f755427ce56fe38085c61baa0e.png?1426618328";}}', 'http://www.zavio.com/product.php?id=87');
INSERT INTO "cameras" 
VALUES (NULL, 'd7320', 'D7320', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '2048x1536', 'Dome', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/850/original/16ff9fc1d36dbe9daaedf03176447fe0.png?1426618322";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/851/original/1e0e905eea9972aa4eda4a3df752eaff.jpg?1415792178";}}', 'http://www.zavio.com/product.php?id=80');
INSERT INTO "cameras" 
VALUES (NULL, 'd7210', 'D7210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/846/original/615503dc5907bf2f8f86a130d76fef5d.jpg?1426618316";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/847/original/7f76346be631c75e0d1e8dd47aed0509.png?1415792163";}}', 'http://www.zavio.com/product.php?id=62');
INSERT INTO "cameras" 
VALUES (NULL, 'd7111', 'D7111', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/845/original/4430a986e1e3fd04f8314767f5f4cdcd.png?1415792155";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/843/original/d0097e1d05986777efc51a991f709768.jpg?1426618311";}}', 'http://www.zavio.com/product.php?id=60');
INSERT INTO "cameras" 
VALUES (NULL, 'd5210', 'D5210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/842/original/fa6c7e9fbf8aedabb1399ecaa7804256.png?1426618304";}}', 'http://www.zavio.com/product.php?id=61');
INSERT INTO "cameras" 
VALUES (NULL, 'd5113', 'D5113', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/841/original/dcc4cd74090ddc61436983f7fbce5ec2.png?1415792139";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/840/original/4b8fff7343e2e9f6e3b90f676464daa3.png?1426618297";}}', 'http://www.zavio.com/product.php?id=59');
INSERT INTO "cameras" 
VALUES (NULL, 'd4210', 'D4210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Dome', '', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/838/original/8556b64dce7af0dc40369dedb4117dfd.jpg?1415792122";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/839/original/8f83a64b92003ca25eab198d55beec4d.jpg?1415792125";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/837/original/f363f2dc0d9539da9431244a670fa140.jpg?1426618289";}}', 'http://www.zavio.com/product.php?id=83');
INSERT INTO "cameras" 
VALUES (NULL, 'd3200', 'D3200', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/836/original/7c2e01bb5e167af60b2b16e31f66884a.jpg?1415792116";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/835/original/ff55098deb7bc02ea91fdb8e20660bfd.png?1426618283";}}', 'http://www.zavio.com/product.php?id=75');
INSERT INTO "cameras" 
VALUES (NULL, 'd3100', 'D3100', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/834/original/4ab11a0bfb1c68878befc00f081e92d3.png?1426618276";}}', 'http://www.zavio.com/product.php?id=76');
INSERT INTO "cameras" 
VALUES (NULL, 'b7510', 'B7510', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '2560x1920', 'Bullet', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/832/original/eef516545ac4872e4516cdeed7529c08.png?1426618270";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/833/original/6573a259517281edc72431c8a2c31d16.png?1415792099";}}', 'http://www.zavio.com/product.php?id=88');
INSERT INTO "cameras" 
VALUES (NULL, 'b7320', 'B7320', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '2048x1536', 'Bullet', '', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/831/original/de175b5fdd765c19d0484538fa52c554.png?1415792089";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/829/original/4375c371a3bdeabb807e95a324cf693e.png?1426618262";}}', 'http://www.zavio.com/product.php?id=86');
INSERT INTO "cameras" 
VALUES (NULL, 'b7210', 'B7210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/828/original/d3360c405428266a4bf7c1f45a7dbbb7.png?1415792080";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/827/original/0fec5dd18564d939cbb17453c1613429.jpg?1426618256";}}', 'http://www.zavio.com/product.php?id=45');
INSERT INTO "cameras" 
VALUES (NULL, 'b5210', 'B5210', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/826/original/67e2b0f628bd6205feaf8ef8d01fe015.jpg?1426618250";}}', 'http://www.zavio.com/product.php?id=79');
INSERT INTO "cameras" 
VALUES (NULL, 'b5111', 'B5111', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '1280x800', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/825/original/b6f1413d4dc89afd34f8ac03df13eb6d.jpg?1426618244";}}', 'http://www.zavio.com/product.php?id=71');
INSERT INTO "cameras" 
VALUES (NULL, 'b5010', 'B5010', '45', 'jpg/image.jpg', 'video.mjpg', 'video.pro[profile_number]', '640x480', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/824/original/404221bc750344c56d2126f0d3b2e09f.jpg?1426618239";}}', 'http://www.zavio.com/product.php?id=78');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-7513', 'DCS-7513', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', '1920x1080', 'Bullet', 'admin', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/704/original/14bf07db5e24736a1e84a3046459c6ab.png?1426618823";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-7513-outdoor-full-hd-wdr-poe-day-night-fixed-bullet-camera-with-ir-led');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-7510', 'DCS-7510', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', 'ntsc:704x480/pal:704x576', 'Box', 'admin', '', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/703/original/d64ab1e4788244e760e32ef6892a3efd.png?1426618818";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-7510-day-and-night-outdoor-poe-network-camera-with-icr');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-7413', 'DCS-7413', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1920x1080', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/702/original/c987bafcc30b61a2b6b080c6a3736397.png?1426618814";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-7413-outdoor-full-hd-poe-day-night-fixed-bullet-camera-with-ir-led?revision=deu_reva');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-7410', 'DCS-7410', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', 'ntsc:704x480/pal:704x576', 'Box', 'admin', '', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/701/original/85c64759c290c1af7db4fc76c20239eb.png?1426618940";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-7410-securicam-day-and-night-outdoor-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-7110', 'DCS-7110', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x800', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/700/original/d2c903a25a26a1b7b4e982da8502e65e.png?1426618808";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-7110-outdoor-hd-poe-day-night-fixed-bullet-camera-with-ir-led?revision=deu+reva');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-7010l', 'DCS-7010L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x800', 'Bullet', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/699/original/cf1a786e89ce56098cbfe4aedf60effc.png?1426618804";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-7010loutdoor-hd-poe-day-night-fixed-mini-bullet-cloud-camera-with-ir-led');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6915', 'DCS-6915', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', '1920x1080', 'Dome', 'admin', '', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/698/original/27d6668c6c13d4c5394fd4d92db7739b.png?1426618799";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6915-outdoor-20x-full-hd-wdr-day-night-speed-dome-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6818', 'DCS-6818', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', 'pal:704x576', 'Dome', 'admin', '', '', 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/697/original/eac1be750f7ae6c295314c59c0990bf4.png?1426618764";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6818-outdoor-36x-wdr-day-night-speed-dome-camera?revision=deu_reva');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6815', 'DCS-6815', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', 'ntsc:704x480/pal:704x576', 'Dome', 'admin', '', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/696/original/0e378361c40315ed479ddcbcfc8476d0.png?1426618760";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6815-outdoor-18x-wdr-day-night-speed-dome-camera?revision=deu_reva');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6616', 'DCS-6616', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', 'ntsc:704x480/pal:704x576', 'Dome', 'admin', '', '', 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/695/original/c8802e0a8057545df864df6b47f40cfc.png?1426618756";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6616-12x-wdr-day-night-speed-dome-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6513', 'DCS-6513', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '2048x1536', 'Dome', 'admin', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/694/original/0e1029e449f519ee629833621d6185e6.png?1426618752";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6513-full-hd-wdr-day-night-outdoor-dome-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6511', 'DCS-6511', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x1024', 'Dome', 'admin', '', '', 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/693/original/6f8fc97ec681ba834df2386ed0a7e123.png?1426618747";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6511-outdoor-hd-poe-day-night-vandal-resistant-fixed-dome-camera-with-ir-led');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6314', 'DCS-6314', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1920x1080', 'Dome', 'admin', '', '', 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/692/original/74607cb7165891949bc32c6dc8df43a3.png?1426618743";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6314-full-hd-wdr-varifocal-day-night-outdoor-dome-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6210', 'DCS-6210', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1920x1080', 'Dome', 'admin', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/691/original/72df526a39bf975d27750b822fff3178.png?1426618738";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6210-outdoor-hd-poe-day-night-vandal-resistant-fixed-dome-camera-with-ir-led');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6113', 'DCS-6113', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', '1920x1080', 'Dome', 'admin', '', '', 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/690/original/3c1001212cf22815b578f6e32a5d3e5e.png?1426618794";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6113-full-hd-poe-day-night-fixed-dome-camera-with-ir-led');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6111', 'DCS-6111', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '640x480', 'Dome', 'admin', '', '', 0, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/689/original/3fa5ef042fdbd85ea46cd77fb87553c0.png?1426618732";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6111-wdr-poe-day-night-fixed-dome-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6110', 'DCS-6110', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '640x480', 'Dome', 'admin', '', '', 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/688/original/8cdc6c7ff6fd9adae0c15000958f03e7.png?1426618726";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6110-fixed-dome-poe-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-6010l', 'DCS-6010L', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1600x1200', 'Dome', 'admin', '', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/687/original/7f44c2a1c5e6cb10879e026626bdbc93.png?1426618720";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-6010l-2-megapixel-panoramic-wireless-cloud-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-3716', 'DCS-3716', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1920x1080', 'Box', 'admin', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/682/original/9756c54cc670d7cbec33be1b6f4e1fd3.png?1426618715";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-3716-full-hd-wdr-poe-day-night-fixed-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-3710', 'DCS-3710', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '1280x1024', 'Box', 'admin', '', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/681/original/300de3284fa5567d10d1fb2e02eb8437.png?1426618711";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-3710-hd-wdr-poe-day-night-fixed-camera?revision=deu_reva');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-3430', 'DCS-3430', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', 'live.sdp', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/680/original/88650c00fd86406c0d05c65821b3e705.png?1426618707";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-3430-wireless-day-night-fixed-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-3110', 'DCS-3110', '46', 'cgi-bin/video.jpg', 'video/mjpg.cgi', 'live.sdp', '1280x1024', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/679/original/6160ec9bd9fe73bbbcb38b8e486be586.png?1426618702";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-3110-megapixel-poe-fixed-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-3010', 'DCS-3010', '46', 'image/jpeg.cgi', 'video/mjpeg.cgi', 'live.sdp', '1280x800', 'Box', 'admin', '', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/678/original/93ad9e380359d632eb0edff9693f8cc9.png?1426618698";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-3010-hd-poe-fixed-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2100g', 'DCS-2100G', '46', 'cgi-bin/video.jpg', '', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/666/original/c18d1740852341f0bd5a474ea930c04e.png?1426618791";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2100g-wireless-g-internet-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2100', 'DCS-2100+', '46', 'cgi-bin/video.jpg', 'video/mjpg.cgi', '', '640x480', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/665/original/b2b9f81fe1b8d663ef47131bea5425bb.png?1426618785";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2100plus-enhanced-2-4ghz-802-11b-wireless-internet-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-2000', 'DCS-2000', '46', 'cgi-bin/video.jpg', 'video/mjpg.cgi', '', '640x480', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/598/original/bd6549813c8215570b3ce9abb228d5c1.jpg?1426618781";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-2000-internet-camera-with-audio-monitoring');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-1130', 'DCS-1130', '46', 'image/jpeg.cgi', 'video/mjpg.cgi', '', '640x480', 'Box', 'admin', '', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/664/original/b0230f8c03787848856324a2e09d7f0a.png?1426618777";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-1130-wireless-n-network-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-1000w', 'DCS-1000W', '46', 'image.jpg', 'video.cgi', '', '640x480', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/663/original/2658735e38f774dc0e8f403e9b354b9e.png?1426618773";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-1000w');
INSERT INTO "cameras" 
VALUES (NULL, 'dcs-1000', 'DCS-1000', '46', 'image.jpg', 'video.cgi', '', '640x480', 'Box', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/662/original/520390f832e976e4f119fa1b166c6d06.png?1426618769";}}', 'http://www.dlink.com/rs/sr/support/product/dcs-1000-internet-securty-camera');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3601-hd', 'GXV3601_HD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1600x1200', 'Bullet', 'admin', 'admin', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/727/original/179a2f03039da1520c789a9e53856308.png?1415776255";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/728/original/ac0aecd2d34695121f0fab45791d0671.png?1415776260";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/726/original/eabe0d97117d474eb1c235dc03a97abf.png?1426647063";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3601-hd');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3611-hd', 'GXV3611_HD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1600x900', 'Dome', 'admin', 'admin', '', 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/730/original/e42e2bba7fa9d7ac250df329a54a1091.png?1415776270";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/731/original/6bbedf739d258bb3a825483889cc8bea.png?1415776275";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/729/original/9ac4b56294eefe02c61f937d3e6d0354.png?1426647055";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3611-hd');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3615w', 'GXV3615W', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', 'ntsc:704x480/pal:704x576', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/733/original/620f132534416741fbf618342bf569c0.png?1426647048";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3615');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3615', 'GXV3615', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', 'ntsc:704x480/pal:704x576', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/732/original/6f393c800ed6e2dadb2a0857ea6ab087.png?1426647042";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3615');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3615wp-hd', 'GXV3615WP_HD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1600x1200', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/695/original/37f0f621f537d476f718177eec42c05d.jpg?1415743239";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/696/original/31e39ca205276e200afbd01161902011.jpg?1415743242";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/694/original/ac497650c8cb4057d8073fe259087d99.jpg?1426647033";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3615wp_hd');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3662-fhd', 'GXV3662_FHD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/701/original/58cc6b71191b53dfa716d29c349047fe.jpg?1415743263";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/702/original/cb7782807957749338c8feaac09d68a5.jpg?1415743266";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/700/original/a4aa49f9dfc4e04eaf17356b267cd19a.jpg?1426647026";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3662');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3662-hd', 'GXV3662_HD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/704/original/8bafe392d524cd3f3e0beeb1ca0dc878.jpg?1415743273";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/705/original/0bca1317e27d4da3620a2255d42ea375.jpg?1415743275";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/703/original/503cbedccc2019df0ec90c4a6c7d953f.jpg?1426647020";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3662');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3651-fhd', 'GXV3651_FHD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '2592x1944', 'Box', 'admin', 'admin', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/698/original/564a0f6ca48fe6a517fcc8ac0db6a9c7.jpg?1415743251";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/699/original/e5de267ac8e3ee74666e3f0763dd8002.jpg?1415743254";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/697/original/bd16a6b950f9e696ca5fb55cf24f28b3.jpg?1426647015";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3651');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3610-fhd', 'GXV3610_FHD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '2048x1536', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/689/original/1b21ef4acb365e50758b5d1236f10933.jpg?1415743211";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/690/original/a1aefae238134325bb6bf6d5738b0a06.jpg?1415743215";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/688/original/b3d789e09203a719363fc351a500ea91.jpg?1426647009";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3610');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3610-hd', 'GXV3610_HD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1280x960', 'Dome', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/692/original/0d8e905fe823382aaf0dbef29cf8827a.jpg?1415743223";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/693/original/f3d730694f9d88953db876a73b7cfbcb.jpg?1415743225";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/691/original/99677b8cbb8fa49436851fc6d9034c08.jpg?1426647001";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3610');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3674-fhd-vf', 'GXV3674_FHD_VF', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '2048x1536', 'Box', 'admin', 'admin', '', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/718/original/fc6ef5c20ea93f56a5cedd2f94b35634.jpg?1426646994";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/719/original/925d34dccf228bcd2505bfbfb6bc1df1.jpg?1415743324";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/720/original/4feb3ec0c043099ae61397a7a0b5c953.jpg?1415743329";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3674');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3674-hd-vf', 'GXV3674_HD_VF', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1280x960', 'Box', 'admin', 'admin', '', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/722/original/dc5d4cdedd6a0a4857307f4376029dab.jpg?1415743337";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/723/original/39fed32e058cd44031a81dc3d3e7323e.jpg?1415743340";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/721/original/9716a5c04d42505d6904f2740db8c991.jpg?1426646988";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3674');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3672-fhd-36', 'GXV3672_FHD_36', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '2048x1536', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/710/original/889c2abca04c73b9084ec1ab4953b1c6.jpg?1415743296";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/711/original/57fdf3e5ff02ab61cf6c108b6091dbd0.jpg?1415743298";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/709/original/7e86a3c10d9716374994c133a4390e2f.jpg?1426646981";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3672');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3672-hd-36', 'GXV3672_HD_36', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1280x960', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/716/original/f4155396b0506f5f7d7305b297f294c8.jpg?1415743314";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/717/original/93005bc6b40c8802b02d2df92d66d173.jpg?1415743316";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/715/original/941890a83d4881ff98ceb8fef7c831c1.jpg?1426646975";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3672');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3672-fhd', 'GXV3672_FHD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1920x1080', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/707/original/d0e42e681def48e8840ba5e33c50580a.jpg?1415743283";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/708/original/532f9c85ac6d60389b9cfc321a5fcae5.jpg?1415743288";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/706/original/41089d7af2d9ae51fe2399bac8373884.jpg?1426646969";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3672');
INSERT INTO "cameras" 
VALUES (NULL, 'gxv3672-hd', 'GXV3672_HD', '48', 'snapshot/view[CHANNEL].jpg', 'goform/stream?cmd=get&channel=[CHANNEL]', 'ipcam_h264.sdp', '1280x720', 'Bullet', 'admin', 'admin', '', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/713/original/9e537aa0fdff79b147f3a17ca1bcf86e.jpg?1415743304";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/714/original/84c4138b62af1e206e680228d021c797.jpg?1415743307";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/004/712/original/eeee31b463abfdd8245c248b1231c826.jpg?1426646963";}}', 'http://www.grandstream.com/index.php/products/ip-video-surveillance/gxv3672');
INSERT INTO "cameras" 
VALUES (NULL, 'bullet-hd-1080-2nd-gen', 'bullet hd 1080 (2nd gen)', '49', 'live/0/jpeg.jpg', 'live/0/mjpeg.jpg', 'live/0/h264.sdp', '1920x1080', 'Bullet', 'admin', '1234', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/507/original/c4de526a5e3a0e5b3aa12133985ef2ec.jpg?1426617896";}}', 'http://www.y-cam.com/y-cam-bullet-hd-1080-2nd-gen/');
INSERT INTO "cameras" 
VALUES (NULL, 'bullet-hd-720-2nd-gen', 'bullet hd 720 (2nd gen)', '49', 'live/0/jpeg.jpg', 'live/0/mjpeg.jpg', 'live/0/h264.sdp', '1280x720', 'Bullet', 'admin', '1234', '', 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/509/original/527de33d802ceda2b1a5ae89cb2ae97f.jpg?1426617891";}}', 'http://www.y-cam.com/y-cam-bullet-hd-720-2nd-gen/');
INSERT INTO "cameras" 
VALUES (NULL, 'cube-hd-1080', 'Cube HD 1080', '49', 'live/0/jpeg.jpg', 'live/0/mjpeg.jpg', 'live/0/h264.sdp', '1920x1080', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/512/original/92a87ebd4815d4a5ca02561cc8cfb7ce.jpg?1426617886";}}', 'http://www.y-cam.com/y-cam-cube-hd-1080/');
INSERT INTO "cameras" 
VALUES (NULL, 'cube-hd-720', 'Cube HD 720', '49', 'live/0/jpeg.jpg', 'live/0/mjpeg.jpg', 'live/0/h264.sdp', '1280x720', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/513/original/47d7f6283857d850794468bb5dadc8ef.jpg?1426617881";}}', 'http://www.y-cam.com/y-cam-cube-hd-720/');
INSERT INTO "cameras" 
VALUES (NULL, 'cube', 'Cube', '49', 'live/0/jpeg.jpg', 'live/0/mjpeg.jpg', 'live/0/h264.sdp', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/514/original/81bc5aa7fa88f7291b1bf084eb1571eb.jpg?1426617876";}}', 'http://www.y-cam.com/y-cam-cube/');
INSERT INTO "cameras" 
VALUES (NULL, 'bullet-hd-1080', 'bullet hd 1080', '49', 'snapshot.jpg', 'cgi-bin/snapshot.fcgi', '', '1920x1080', 'Bullet', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/508/original/fdec2c920f7e3a6b501557dad2ebc6bb.jpg?1426617980";}}', 'http://www.y-cam.com/y-cam-bullet-hd-1080/');
INSERT INTO "cameras" 
VALUES (NULL, 'bullet-hd-720', 'bullet hd 720', '49', 'snapshot.jpg', 'stream.jpg', 'live_h264.sdp', '1280x720', 'Bullet', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/510/original/165e541417cac7e93a1bec0a4383fd17.jpg?1426617870";}}', 'http://www.y-cam.com/y-cam-bullet-hd/');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8264fwd-eiz', 'DS-2CD8264FWD-EI(Z', '52', '', '', '', '-', 'Other', '-', '-', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/265/original/78e6dd2c7eb324dc4f4ac0a64f3071e6.jpg?1416391202";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/264/original/d64e8f023436ef880e3e4d14a71cbdbf.jpg?1426619953";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'knight-sd', 'Knight SD', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/517/original/da5f8f490bd9e19d7bd87bf3185ca28b.jpg?1426617972";}}', 'http://www.y-cam.com/y-cam-knight-sd/');
INSERT INTO "cameras" 
VALUES (NULL, 'knight-s', 'Knight S', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/516/original/77d8cfcff17cf6813ed6782e381120a5.jpg?1426617964";}}', 'http://www.y-cam.com/y-cam-knight-s/');
INSERT INTO "cameras" 
VALUES (NULL, 'black-s', 'Black S', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/500/original/7b9a80f2cc477f25803b314f6022d9ba.jpg?1426617954";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/501/original/c55cbf00043b6410ec9a17c9a68e2546.jpg?1416232921";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/502/original/612660ec028c958f908522624c2b8ca7.jpg?1416232926";}}', 'http://www.y-cam.com/y-cam-black-s/');
INSERT INTO "cameras" 
VALUES (NULL, 'white-s', 'White S', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/519/original/b95f12e0adc3bf00c166ebc20587614d.jpg?1426617947";}}', 'http://www.y-cam.com/y-cam-white-s/');
INSERT INTO "cameras" 
VALUES (NULL, 'white-sd', 'White SD', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/520/original/3a939cf798a754cab4b462b8f20e89ed.jpg?1426617940";}}', 'http://www.y-cam.com/y-cam-white-sd/');
INSERT INTO "cameras" 
VALUES (NULL, 'black-sd', 'Black SD', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 0, 1, 0, 1, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/505/original/9683e4dd29e013cf0da06565f540ba87.jpg?1416232944";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/504/original/12157ac5151e85f2261a13a69c7ee075.jpg?1426617933";}}', 'http://www.y-cam.com/y-cam-black-sd/');
INSERT INTO "cameras" 
VALUES (NULL, 'eyeball', 'EyeBall', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/515/original/1f115e6d281bcd2f0238c0fa29fbc091.jpg?1426617927";}}', 'http://www.y-cam.com/y-cam-eyeball/');
INSERT INTO "cameras" 
VALUES (NULL, 'bullet-white', 'bullet white', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/511/original/52b085b2ca9420c28cb05e3647f9a2c6.jpg?1426617920";}}', 'http://www.y-cam.com/y-cam-bullet-white/');
INSERT INTO "cameras" 
VALUES (NULL, 'bullet-black', 'bullet black', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/506/original/aa9b993d3ad5ef527c0d55c09cfce421.jpg?1426617915";}}', 'http://www.y-cam.com/y-cam-bullet-white/');
INSERT INTO "cameras" 
VALUES (NULL, 'black-sd-poe', 'Black SD POE', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 1, 0, 1, 1, 1, 1, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/503/original/f84f931459dc16be1262d6aa6bff4e3f.jpg?1426617909";}}', 'http://www.y-cam.com/y-cam-black-sd-poe/');
INSERT INTO "cameras" 
VALUES (NULL, 'white-s-poe', 'White S POE', '49', 'snapshot.jpg', 'stream.jpg', '', '640x480', 'Box', 'admin', '1234', '', 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/518/original/bad37b4dd37a7934cf0058236a28526e.jpg?1426617903";}}', 'http://www.y-cam.com/y-cam-white-s-poe/');
INSERT INTO "cameras" 
VALUES (NULL, '207', '207', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/117/original/995c5bedd99f26f890609521ebdd3c9d.jpg?1426621110";}}', 'http://www.axis.com/techsup/cam_servers/cam_207/');
INSERT INTO "cameras" 
VALUES (NULL, 'm1031-w', 'M1031-W', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Box', 'root', 'pass', '', 1, 0, 1, 0, 0, 1, 0, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/138/original/2486c522aee559a4097a5ced9b942f9b.jpg?1426621088";}}', 'http://www.axis.com/products/cam_m1031w/');
INSERT INTO "cameras" 
VALUES (NULL, '207w', '207W', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/119/original/6ec01e578a3af0a62d3ec65bacfb13cd.jpg?1426621103";}}', 'http://www.axis.com/products/cam_207w/');
INSERT INTO "cameras" 
VALUES (NULL, '207mw', '207MW', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x1024', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/118/original/9f3a7ad5e88fa56cf1a2f155fef62686.jpg?1426621079";}}', 'http://www.axis.com/products/cam_207mw/');
INSERT INTO "cameras" 
VALUES (NULL, 'm1011', 'M1011', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/136/original/4f486e40b5d0390e8cd6a76bccb64ff1.jpg?1426621073";}}', 'http://www.axis.com/products/cam_m1011/');
INSERT INTO "cameras" 
VALUES (NULL, '213-ptz', '213 PTZ', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '704x576', 'Box', 'root', 'pass', '', 0, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/125/original/1301d7c48ace6bce0c995b90785bb205.jpg?1426621066";}}', 'http://www.axis.com/products/cam_213/');
INSERT INTO "cameras" 
VALUES (NULL, '205', '205', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/116/original/410a8f3bf10ecc9cbbe92a689329b769.jpg?1426621150";}}', 'http://www.axis.com/products/cam_205/');
INSERT INTO "cameras" 
VALUES (NULL, '210a', '210A', '50', 'axis-cgi/jpg/image.cgi', '', '', '640x480', 'Box', 'root', 'pass', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/121/original/e5f5e6ed8cc57be8c0cd0fdb57d30f38.jpg?1426621059";}}', 'http://www.axis.com/en/products/cam_210a/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, '233d', '233D', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', 'ntsc:704x480/pal:704x576', 'Dome', 'root', 'pass', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/132/original/185cb92c6152a41f6be8eb5fb5134c72.jpg?1426621052";}}', 'http://www.axis.com/en/products/cam_233d/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, '221', '221', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Box', 'root', 'pass', '', 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/131/original/55958746bcea5d7300e92147a653d248.jpg?1426621164";}}', 'http://www.axis.com/products/cam_221/');
INSERT INTO "cameras" 
VALUES (NULL, '211w', '211W', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Box', 'root', 'pass', '', 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/122/original/bf975a9131ce6b17bf6bd8f462055c62.jpg?1426621043";}}', 'http://www.axis.com/products/cam_211w/');
INSERT INTO "cameras" 
VALUES (NULL, 'm1025', 'M1025', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/137/original/76ac3655983e166bae4aef23be406e7b.jpg?1426620742";}}', 'http://www.axis.com/products/cam_m1025/');
INSERT INTO "cameras" 
VALUES (NULL, '215-ptz-e', '215 PTZ-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', 'ntsc:704x480/pal:704x576', 'Dome', 'root', 'pass', '', 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/127/original/25b17b0634c160c0e544af5fdb0b4c33.jpg?1426620735";}}', 'http://www.axis.com/en/products/cam_215e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, '215-ptz', '215 PTZ', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', 'ntsc:704x480/pal:704x576', 'Dome', 'root', 'pass', '', 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/128/original/76ca869d226d48eac6de5c064f9f7847.jpg?1426620730";}}', 'http://www.axis.com/products/cam_215/');
INSERT INTO "cameras" 
VALUES (NULL, '216mfd', '216MFD', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '1280x1024', 'Dome', 'root', 'pass', '', 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/130/original/e116f3f9a8ef6a5e0f46d61e232a6ba9.jpg?1426621037";}}', 'http://www.axis.com/en/products/cam_216mfd/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, '216fd', '216FD', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Dome', 'root', 'pass', '', 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/129/original/cebfda3e0465a041e278466d2d7f04b8.jpg?1426621031";}}', 'http://www.axis.com/en/products/cam_216/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, '209fd', '209FD', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', '', '640x480', 'Dome', 'root', 'pass', '', 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/120/original/ffd9a1dc4ea8ca995b3a1867d7038ba5.jpg?1426621022";}}', 'http://www.axis.com/products/cam_209fd/');
INSERT INTO "cameras" 
VALUES (NULL, 'q1931-e', 'Q1931-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '384x288', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/198/original/38f2c0e03d3e7d0f266b0f5b66d62b44.jpg?1426620722";}}', 'http://www.axis.com/products/cam_q1931e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1922-e', 'Q1922-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/199/original/a3c38dbdd69944c4e327586294476ad4.jpg?1415793880";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/200/original/631e4f910e8ae8b9254c5b8a36172f3d.jpg?1415793882";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/198/original/cf4c0e71c44360bfbf79a2c73ca61abc.jpg?1426620716";}}', 'http://www.axis.com/products/cam_q1922e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1922', 'Q1922', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/202/original/48dab0f55f8f39a804b25ad44dd79178.jpg?1415793888";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/203/original/482aa9844d02704f64b16afc162e0769.jpg?1415793890";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/204/original/cd580da8c3c696eaf84ea2b4c5b83c4a.jpg?1415793892";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/201/original/58f512e2aa177811e8f5638d4ff4f18d.jpg?1426620710";}}', 'http://www.axis.com/products/cam_q1922/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1921-e', 'Q1921-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '384x288', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/192/original/3a181bee1335e7f6b1cc34cd56956794.jpg?1415793856";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/193/original/79bd0b2da2f108a6e34b9258ddbdbe0f.jpg?1415793860";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/191/original/45e095411a16598401c78efd6cd496ab.jpg?1426620704";}}', 'http://www.axis.com/products/cam_q1921e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1921', 'Q1921', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '384x288', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/195/original/dd77d27e0ae99a8438fc4ae6e392e662.jpg?1415793869";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/194/original/854aaa2d5841ad82cd4800cf9b7377ba.jpg?1426620699";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/196/original/5036cd3e55dd7db97da94dd930b2c91d.jpg?1415793873";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/197/original/b672a607ab8685ff560ef6630bf7c88b.jpg?1415793875";}}', 'http://www.axis.com/products/cam_q1921/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1910-e', 'Q1910-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '160x128', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/190/original/127ae2e6ce69d8fcfbc9e171c88066e4.jpg?1415793848";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/189/original/97f0a3b54a62ddd5f66afe4611c43c60.jpg?1426620689";}}', 'http://www.axis.com/products/cam_q1910e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1910', 'Q1910', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '160x128', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/197/original/fc6eb7499bd8dd5470987b2330c3e906.jpg?1426620679";}}', 'http://www.axis.com/products/cam_q1910/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q8722-e', 'Q8722-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/212/original/51e3af255e277b9491811fbc169bb0a0.jpg?1426621016";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q8721-e', 'Q8721-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/211/original/76de188b64ff82c5aed1561cc7800227.jpg?1426621001";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6045-s', 'Q6045-S', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/209/original/17f241b86b9efec7db528ad72f462fe3.jpg?1426620993";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6045-c', 'Q6045-C', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/207/original/1102ca083558983ba152987bde7d2e66.jpg?1426620972";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6045-e', 'Q6045-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/208/original/802645fd7494f1438d7ebc8de572b58d.jpg?1426620957";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6045', 'Q6045', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/210/original/740cdee47456b0402adb5ec99bcf8d95.jpg?1426620930";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6044-s', 'Q6044-S', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/205/original/cb3cb2f7bca79425fb4a27fe04653f1d.jpg?1426620905";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6044-c', 'Q6044-C', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/203/original/c095298fdaf153e6cb5863e4345a1ca4.jpg?1426620897";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6044-e', 'Q6044-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/204/original/08a5ae84f5e00affa9a97534bca74fb1.jpg?1426620890";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6044', 'Q6044', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/206/original/3d7037888bf4c67987d2870d64b932a0.jpg?1426620884";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6042-s', 'Q6042-S', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '736x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/201/original/40ea088a618ca436e8191c034bf194ce.jpg?1426620878";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6042-c', 'Q6042-C', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '736x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/199/original/2423634a650739c6d3a0120cb9ad5acd.jpg?1426620872";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6042-e', 'Q6042-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '736x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/200/original/782d329fadd5e6866e772b0c812fa499.jpg?1426620857";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'q6042', 'Q6042', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '736x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/202/original/f9f3eb8398e7f7d39df0b074e8db4393.jpg?1426620830";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5544', 'P5544', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/194/original/f1da30d071f971fecb646a66ce4ef0d5.jpg?1426620819";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5534-e', 'P5534-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/192/original/245c13fe3617d45483218456b9e31b26.jpg?1426620811";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5534', 'P5534', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/193/original/d849749e308b91a3df12ac47dcec28a1.jpg?1426620798";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5532-e', 'P5532-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '720x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/190/original/d01676b68b60904f951e61572c8dd399.jpg?1426620790";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5532', 'P5532', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '720x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/191/original/ef4cedbb4839fe6798f4886e4c1eb08b.jpg?1426620783";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5522-e', 'P5522-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '720x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/188/original/73d0e1cf1adb2e48dc6da30e81d72fcd.jpg?1426620776";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5522', 'P5522', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '720x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/189/original/7da62c93a344fc422963eb19d3de0a53.jpg?1426620769";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5512-e', 'P5512-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '704x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/186/original/04b91c576467b6a38f2e4fbf11ceb065.jpg?1426620763";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5512', 'P5512', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '704x576', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/187/original/04be17e3f1f707db26702f4329e23a1b.jpg?1426620429";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5415-e', 'P5415-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/185/original/c1819b292ac761c1b281c522ebb897eb.jpg?1426620672";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p5414-e', 'P5414-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/184/original/9fa675102df3f4033d91b98e8c5183d2.jpg?1426620666";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, '214-ptz', '214 PTZ', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '704x576', 'Dome', 'root', 'pass', '', 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/126/original/ffef6823c8cc91a1ec3791b113ce9c38.jpg?1426620645";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm5014-v', 'M5014-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/166/original/c610c12f7343f54b4b6c0fbaf928dee7.jpg?1426620637";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm5014', 'M5014', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/167/original/034a0d4b800272422b2e998594be6cfa.jpg?1426620629";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm5013-v', 'M5013-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/164/original/530555a921a9668024cc1614a99e4cb9.jpg?1426620624";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm5013', 'M5013', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/165/original/e73dd7186435adc136d10a278b25ed32.jpg?1426620618";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, '212-ptz-v', '212 PTZ-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/123/original/aabf1b1a69f6ea2d1c19eef2da088d85.jpg?1426620594";}}', 'http://www.axis.com/products/cam_212v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, '212-ptz', '212 PTZ', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Dome', 'root', 'pass', '', 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/124/original/0106cc0ae3afce1732ec28643eabd553.jpg?1426620589";}}', 'http://www.axis.com/products/cam_212/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3367-ve', 'P3367-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:7:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/135/original/14323a5db1a4c61beba322943c2a3d76.jpg?1426620584";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/136/original/994c2821c5fe6ba30539fe1f4025d312.jpg?1415793720";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/137/original/b9d283994bdb2dd0daa4c4bc12ed3ad0.jpg?1415793723";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/139/original/016b7ad1988572044bf969788561d7ae.jpg?1415793728";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/140/original/f60b15fb364fe86ecd4912e70f0d2154.jpg?1415793731";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/141/original/0e1ee6d781dd40d93de5868f3cf98598.jpg?1415793734";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/142/original/99dd9f23ceeccfcf74b872b709153908.jpg?1415793737";}}', 'http://www.axis.com/products/cam_p3367ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3367-v', 'P3367-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/130/original/ab08e06dccb896181e7e825b84512a13.jpg?1415793703";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/131/original/910cb50db4d126ec08111662eaa440eb.jpg?1415793705";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/132/original/2a3362b21db593fcd59805226d786e32.jpg?1415793706";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/133/original/0ca9651c0204e0ca7926621abd2078d5.jpg?1415793709";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/134/original/65d55fbc513614b3d72cb06649406b7d.jpg?1415793712";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/129/original/753a5fb71fb30529f80104c8a2fccfd9.jpg?1426620576";}}', 'http://www.axis.com/products/cam_p3367v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3346-ve', 'P3346-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2048x1536', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/095/original/4e015b5638d1935cd5e553f057d03354.jpg?1415793633";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/096/original/6f4fb2cf18fab61cabac50ff3eb87e16.jpg?1415793634";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/094/original/e32114052aed010875fc895861fddae3.jpg?1426620570";}}', 'http://www.axis.com/products/cam_p3346ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3346-v', 'P3346-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2048x1536', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/089/original/06f4b85ce4d80ae646ab6498d3425117.jpg?1415793623";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/088/original/a47c7eba90695cda10e0ed974f8e22b9.jpg?1426620562";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/090/original/4da7d5e6f5b77ce14c6fd87d47231586.jpg?1415793624";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/091/original/8eddf7c2f035a25bc34b470eb866feee.jpg?1415793626";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/092/original/839cc608ae4b908edae3f0f6d4632486.jpg?1415793628";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/093/original/d51ab79ff5b1603260d240386bc8c5fa.jpg?1415793629";}}', 'http://www.axis.com/products/cam_p3346v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3346', 'P3346', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2048x1536', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/098/original/3fe205b4ccdedeb33409df8f1acd6073.jpg?1415793638";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/097/original/ff4735af9e1c3f5d0cd5cc88177ecab8.jpg?1426620557";}}', 'http://www.axis.com/products/cam_p3346/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3384-ve', 'P3384-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/148/original/9efb1671ee2a3d3543bc79aa25a11929.jpg?1426620552";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/149/original/e95b8146f2922bc81ee02a8aa120a310.jpg?1415793749";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/150/original/0bd1a47ebe8f60d0a5d55eeea40c4a24.jpg?1415793751";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/151/original/1efc2d13b65afe92d6ec08901432affa.jpg?1415793753";}}', 'http://www.axis.com/products/cam_p3384ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3384-v', 'P3384-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/144/original/0f44f71d1c8569518078a4177dceae4e.jpg?1415793741";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/145/original/7eaefe4d8511332df7c71906a82ff128.jpg?1415793743";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/146/original/abb48e6054a310f0a681249777005a12.jpg?1415793744";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/147/original/a7aa607e2e233292e4c1946817fbf41e.jpg?1415793746";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/143/original/8fbb5ea8cf618f58817e2a925e73c8b4.jpg?1426620546";}}', 'http://www.axis.com/products/cam_p3384v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3364-ve', 'P3364-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/124/original/8d338d4987201578f36ad9a707c7c5f9.jpg?1426620541";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/125/original/085d666fc498a6ab5e7fbb4c43b1745c.jpg?1415793690";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/126/original/87555c11b6c51ded683c106e00a8a798.jpg?1415793692";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/127/original/0dd2b184f70f9435dbcc576ac70700ff.jpg?1415793694";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/128/original/78768cf1305c152df35e94fedbbeb040.jpg?1415793696";}}', 'http://www.axis.com/products/cam_p3364ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3364-v', 'P3364-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/122/original/ee67cf3283d33f8f7b7d6701f1de9679.jpg?1415793684";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/123/original/98682158e5ef09b7ea548a67bb24ef49.jpg?1415793686";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/121/original/bce10559bc38e5cb597b35acff834887.jpg?1426620535";}}', 'http://www.axis.com/products/cam_p3364v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3354', 'P3354', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 'a:7:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/107/original/249409914c9a6ac692601068e3341d31.jpg?1415793654";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/108/original/b791a9e3777ea5d34fb1f5f9540d14c3.jpg?1415793656";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/109/original/7e79b4171d2800e7a05f4c0e0c9fc86f.jpg?1415793658";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/110/original/d18a4f1f69b005e43befa01caf0fd693.jpg?1415793660";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/111/original/b340a4334b235a4ae9cbdb7b3efec85a.jpg?1415793662";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/112/original/1f4ac9f2a5bc428102b26ce5b22fb291.jpg?1415793664";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/106/original/fefbf184c29ed6e0f248932c8e1bc70f.jpg?1426620528";}}', 'http://www.axis.com/products/cam_p3354/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3363-ve', 'P3363-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/117/original/ca30b653c86add2fe79e07dab4f6ee1c.jpg?1415793676";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/118/original/d8bc3f59f902275b3abf0c10ec2f267a.jpg?1415793677";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/119/original/3c82a42ded5967a1446616db5aa86e7d.jpg?1415793679";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/120/original/805c3da09f45d1ab8b4c53b4d1ae40a5.jpg?1415793681";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/116/original/ef3d037f48573e90240e503bb5711fe4.jpg?1426620519";}}', 'http://www.axis.com/products/cam_p3363ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3363-v', 'P3363-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/114/original/04512cef314b79c2d83a4d579ad5adc1.jpg?1415793670";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/115/original/e9899ecdba531020ed2cfe3560708d84.jpg?1415793672";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/113/original/f188d20e7d92bbe8db0c4aa725d682be.jpg?1426620506";}}', 'http://www.axis.com/products/cam_p3363v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3353', 'P3353', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 'a:7:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/100/original/b58ad2e4292be8627275b71c97d71fd9.jpg?1415793642";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/101/original/f54d18ddc5a02252450e991919655599.jpg?1415793643";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/102/original/bb0cc3e8fc4154c91dad7da676aa091b.jpg?1415793645";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/103/original/120cd8bc317c60c7798b2e9f53f06f86.jpg?1415793647";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/104/original/8110efae0a4401655aac076868aa6236.jpg?1415793649";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/105/original/013ecc075f0829b24ea83b5a03e4c33d.jpg?1415793650";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/099/original/ad9639d698fe3b80c3eb34752e688ef9.jpg?1426620499";}}', 'http://www.axis.com/products/cam_p3353/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p3304-v', 'P3304-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/175/original/2533789054b08ffec42a1568b512f7b8.jpg?1426620612";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p3304', 'P3304', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/176/original/8f0c0dc3fab7dcaa88be6db9cd9dd8f0.jpg?1426620606";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p3301-v', 'P3301-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/173/original/2b780f24e1980284402664e3010aa1a8.jpg?1426620600";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'p3301', 'P3301', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '640x480', 'Dome', 'root', 'pass', '', 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/174/original/ab49b22e7e28306293ebd8e111e68d40.jpg?1426621156";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm3204-v', 'M3204-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/035/original/34718444bbacc064828112d245bc8ef5.jpg?1415793507";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/034/original/4bd14e84d52855a188eacfa1d925b56e.jpg?1426620494";}}', 'http://www.axis.com/products/cam_m3204v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3204', 'M3204', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/037/original/3aa04a17e3e27afd7f83af825972ec48.jpg?1415793511";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/038/original/df7ef140f0f53db60059cd9484ef990e.jpg?1415793512";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/039/original/96d1289e13aa68a70c66418c52548710.jpg?1415793514";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/036/original/a9a99a3f1e1d6fe41d2cd5c35d18784a.jpg?1426620489";}}', 'http://www.axis.com/products/cam_m3204/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3203-v', 'M3203-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/029/original/07fda2f3301838eaccc3840d4453d47e.jpg?1415793498";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/028/original/2f80a2a48c5374b4dd984a7140d1ff99.jpg?1426620484";}}', 'http://www.axis.com/products/cam_m3203v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3203', 'M3203', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/031/original/d0a09392cdc8abb9e5e2590589804069.jpg?1415793501";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/032/original/48e88e9de4902929f29ba29dce4227b6.jpg?1415793503";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/033/original/525dbb1c2cfd494f296bb3dea94e6ca3.jpg?1415793504";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/030/original/01d5a66cde8d81a972452f92209614fa.jpg?1426620478";}}', 'http://www.axis.com/products/cam_m3203/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3114-ve', 'M3114-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/027/original/a508135f49e22393c886f3ccce4c63bd.jpg?1426620472";}}', 'http://www.axis.com/products/cam_m3114ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3113-ve', 'M3113-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/023/original/a6364b4f2a43722c99b38d8288b765aa.jpg?1426620466";}}', 'http://www.axis.com/products/cam_m3113ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3114-r', 'M3114-R', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/025/original/0ee63c294d743534fd8773d4bbd59077.jpg?1415793491";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/026/original/96a8cbc0b6d975ddaa21cd1383a119fa.jpg?1415793493";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/024/original/ace58401c6b706a19c402e7d6235cacd.jpg?1426620461";}}', 'http://www.axis.com/products/cam_m3114r/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3113-r', 'M3113-R', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/020/original/c66ebc99d844fb0f611b9d0e7c89b6fd.jpg?1426620455";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/021/original/eb965567383e4999f312112a0c2d79a3.jpg?1415793484";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/022/original/cc7b0e33d8d952be12912fadada9b02e.jpg?1415793486";}}', 'http://www.axis.com/products/cam_m3113r/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3014', 'M3014', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/001/original/07a1782b2ba1520552a79bd0da7be201.jpg?1426620450";}}', 'http://www.axis.com/products/cam_m3014/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3027-pve', 'M3027-PVE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/018/original/d56314173a796c57315f236a0bd59dae.jpg?1415793479";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/019/original/5bb70879514002258c34c173ff2bb8f3.jpg?1415793481";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/017/original/c53acf4374b3c8436f932971a7f0a8e0.jpg?1426620445";}}', 'http://www.axis.com/products/cam_m3027pve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3026-ve', 'M3026-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2048x1536', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/012/original/567c62b0d15d31ce4be17abd365271da.jpg?1426620325";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/013/original/2036e72cc85ca90b8b7b27d0a0ed5213.jpg?1415793471";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/014/original/fbed27346084e27214096292f128fa2e.jpg?1415793473";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/015/original/dbb79ec4686b8da3b4e0506c9724929e.jpg?1415793474";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/016/original/4070fd82a8e520aeb835ee3ca4aaff14.jpg?1415793476";}}', 'http://www.axis.com/products/cam_m3026ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3025-ve', 'M3025-VE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/007/original/bb8234989171f190d87b8c1d83e33d6f.jpg?1426620319";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/008/original/28c047fec43cc4d65dcf14d8e2e996ca.jpg?1415793463";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/009/original/240004fd00c2a1a8244636770769d69a.jpg?1415793465";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/010/original/c54bb4a347c78d0728d0063faadb90bd.jpg?1415793466";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/011/original/5b532bb9af783755abd0c31e285dc2e5.jpg?1415793468";}}', 'http://www.axis.com/products/cam_m3025ve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3024-lve', 'M3024-LVE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/002/original/d37da87fe001bfaf02a9561403f55d07.jpg?1426620314";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/003/original/45c3dd3b196a5768a86c5deeff73d993.jpg?1415793455";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/004/original/e5b62de07e7569ab87bb55a75fcdba84.jpg?1415793457";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/005/original/b16eaa7395521c25e4fbf60c85b2c4f3.jpg?1415793459";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/006/original/ee1f410c139bd81d2dd9cd6a516335c3.jpg?1415793460";}}', 'http://www.axis.com/products/cam_m3024lve/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3007-pv', 'M3007-PV', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/996/original/1b991cae34e3f3787910426c61c07eed.jpg?1426620307";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/997/original/290cdcbbc46e5fb901cf6d87403c7fb9.jpg?1415793445";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/998/original/ff71dbfef0999e2c96f199fe170fd545.jpg?1415793446";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/999/original/bf6860ea9b6d3efe872a26163571fb78.jpg?1415793448";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/000/original/7649c2ad01de565dbbf00be550856d8f.jpg?1415793450";}}', 'http://www.axis.com/products/cam_m3007pv/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3007-p', 'M3007-P', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/994/original/8d1aa3843a3d18220ac6ede518313636.jpg?1415793440";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/995/original/21e531b918f88e44d9d2880329b57718.jpg?1415793442";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/993/original/00c07b5ba2f732d31e7931941cea6b96.jpg?1426620302";}}', 'http://www.axis.com/products/cam_m3007p/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3006-v', 'M3006-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2048x1536', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/988/original/3bc1e99ba1463fb2127d4b6cd794fe22.jpg?1426620297";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/989/original/eeeeb00ff67809796a5abc16e2bf252f.jpg?1415793432";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/990/original/fffd641af2e31ec43eb35334c06359f4.jpg?1415793434";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/991/original/7657ff289ae90ed346bcd310748015ac.jpg?1415793435";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/992/original/b199042bee007706e9484c6cd529c86b.jpg?1415793437";}}', 'http://www.axis.com/products/cam_m3006v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3005-v', 'M3005-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/983/original/e4f0014999be6c56f69a91daca43a4e8.jpg?1426620291";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/984/original/1a20850e40c688195e3c52d255632f67.jpg?1415793423";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/985/original/f04bc17dbcbfc1d3c3f6f8d6daddcdfe.jpg?1415793425";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/986/original/9dfea173c4710b56ae06422cf3ebe39d.jpg?1415793426";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/987/original/94bbcaafbe042090bcb9980ee74816d0.jpg?1415793428";}}', 'http://www.axis.com/products/cam_m3005v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm3004-v', 'M3004-V', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Dome', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/978/original/b2fb699a803629af11b5efb2b82de7ae.jpg?1426620285";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/979/original/85d2f2c5174c8b298632a238f5e85bc9.jpg?1415793414";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/980/original/4a30f6d2c4c00a9466df407a535f59b5.jpg?1415793417";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/981/original/7e29b0fe7848c339d47f3e6ec15779df.jpg?1415793418";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/982/original/13fb8e938b229cd61045ac3e7a005aeb.jpg?1415793420";}}', 'http://www.axis.com/products/cam_m3004v/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p8514', 'P8514', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/195/original/03ba765c5fced4095200e86c9967fb77.jpg?1426620280";}}', 'http://www.axis.com/products/cam_p8514/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1765-le', 'Q1765-LE', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/188/original/377b6d07bd915dc43e227f89643b4536.jpg?1415793841";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/187/original/f2827252041d6d0787e07239deb57870.jpg?1426620274";}}', 'http://www.axis.com/products/cam_q1765le/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1755-e', 'Q1755-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/180/original/c2cf552c912a8c564ea5b904f7984c8d.jpg?1415793813";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/181/original/1dce266a0c7fdc425f199a1b6cfede7f.jpg?1415793815";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/182/original/ad4d62088e1c3b3c874c8821d0298703.jpg?1415793819";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/183/original/aba02cdc37d6d77b4de23ea33ea62641.jpg?1415793823";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/179/original/4d348a2864c700f9bd188a90a82917f7.jpg?1426620418";}}', 'http://www.axis.com/products/cam_q1755e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1755', 'Q1755', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/185/original/aad2584a60a520810e95a4539125dab7.jpg?1415793832";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/186/original/2f3baa48501bc01262a7fd5b8359e616.jpg?1415793836";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/184/original/fc754a82af14998abb83696bdf07bada.jpg?1426620413";}}', 'http://www.axis.com/products/cam_q1755/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1614-e', 'Q1614-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/173/original/339d28f81599173d803873fcf5d12a27.jpg?1415793791";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/172/original/f95874debbf4572a5518578cb5a6566c.jpg?1426621143";}}', 'http://www.axis.com/products/cam_q1614e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1614', 'Q1614', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/175/original/f14a3ae8d45e1953c348e1580bf7410a.jpg?1415793795";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/176/original/f7950ac798642d2eba063d0e2bfcb607.jpg?1415793798";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/177/original/28af9340dab6a37f6cd7f2cfebece520.jpg?1415793801";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/178/original/f4727f401790fcb44639d406dc80e441.jpg?1415793804";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/174/original/0ebaa9d97bc7755db048028f5475b8ce.jpg?1426620409";}}', 'http://www.axis.com/products/cam_q1614/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1604-e', 'Q1604-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/163/original/f7f0809dbe79543ac67e2e045224696f.jpg?1415793774";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/162/original/fca5e5eea4c8a6734dac2b9da31104a5.jpg?1426620404";}}', 'http://www.axis.com/products/cam_q1604e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1604', 'Q1604', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:8:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/164/original/874878b858d8d72b7b3cb723556921b8.jpg?1426620397";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/165/original/2c865d83e4b72216a94712699667c7cc.jpg?1415793778";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/166/original/deb3db87c42f6aef4af25f5bec10ac82.jpg?1415793779";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/167/original/90d4cca3282ad380774b9662145f9149.jpg?1415793781";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/168/original/ba15df389eadca971c40ed1f301dff66.jpg?1415793783";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/169/original/5596035f503c9226d39b9b399ebe5fee.jpg?1415793784";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/170/original/48d1347c27be4d5dedac689e553bcdbf.jpg?1415793786";}i:7;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/171/original/5374b98339001e2c9b8812787b6b83bf.jpg?1415793788";}}', 'http://www.axis.com/products/cam_q1604/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1602-e', 'Q1602-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '768x576', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/153/original/a49193e23366923416f5fc39bc302983.jpg?1415793757";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/152/original/0070fa4dec018630b15cb85f36450948.jpg?1426620392";}}', 'http://www.axis.com/products/cam_q1602e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'q1602-a', 'Q1602(a', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '768x576', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/196/original/2d20c9ad5067f4676fe08ac8ab44416a.jpg?1426620269";}}', 'http://www.axis.com/products/cam_q1602/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1357-e', 'P1357-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/073/original/1adf0d3f30df37cf3f0f7671e8c7e6a4.jpg?1415793588";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/074/original/37aa071e4e092a523a2e9d1e7c32f3e0.jpg?1415793590";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/072/original/638e6e602094cb6bc21b7128f3b7c289.jpg?1426620386";}}', 'http://www.axis.com/products/cam_p1357e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1357', 'P1357', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '2592x1944', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:7:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/076/original/7e8d648a99a9f8c3177b3ec3c0f21a89.jpg?1415793594";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/078/original/a8696adb706d5ca0aac16bca9a0151d7.jpg?1415793599";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/080/original/04479e22403d31f51a3de2f6738dd771.jpg?1415793603";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/082/original/0b3231d1df00ed7e96ea4f156698290d.jpg?1415793610";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/084/original/af6864e3a59a11153696f6411bb6d140.jpg?1415793613";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/086/original/635e9d082b5fab7747a8c2d94a2a7a60.jpg?1415793617";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/075/original/ea2e6485ae190a3925c2eb5da3971705.jpg?1426620376";}}', 'http://www.axis.com/products/cam_p1357/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1355-e', 'P1355-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/063/original/10c82dd0be7c446bbb6256f879c5cd61.jpg?1415793557";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/064/original/cb038cfce32a71b64d7e1479265fc10b.jpg?1415793560";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/062/original/fa80026184801273e249f2330dd91f64.jpg?1426620367";}}', 'http://www.axis.com/products/cam_p1355e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1355', 'P1355', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1920x1080', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:7:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/066/original/ce25e718824a02830e9381b55a8305ac.jpg?1415793567";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/067/original/a9a2bd60dd60a9011c406c028a8d4643.jpg?1415793571";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/065/original/c8e89172b24d83e06e8f388353990d4f.jpg?1426620358";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/068/original/bc2cd567fd9e057d3cf8de000fb6edc1.jpg?1415793573";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/069/original/c4b272e1726f09bbdafd5246b8e61591.jpg?1415793579";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/070/original/2b764e982370b3a6eb3eb5c1ddd3df92.jpg?1415793581";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/071/original/7f906eafd856c64f52ebb9ad5f046706.jpg?1415793584";}}', 'http://www.axis.com/products/cam_p1355/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1354-e', 'P1354-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/052/original/99779abc0c831b0b076388a1eac4ba2a.jpg?1415793536";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/053/original/f7540f8b18a02921e923f24c43082baa.jpg?1415793537";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/051/original/5f42af613c91140709518fe22763aeee.jpg?1426620351";}}', 'http://www.axis.com/products/cam_p1354e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1354', 'P1354', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x960', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:7:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/054/original/cf0561de9a7dbb7bdef78fa6eeaf631d.jpg?1426620346";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/055/original/484f196e240e503603a06b41d0f66799.jpg?1415793540";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/056/original/cd334f3a4718bc3aedb76c7d892c511a.jpg?1415793542";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/057/original/cd3372583c175a896baa0ed71931c42b.jpg?1415793544";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/059/original/e38f1d9f69960bbd59cc9e6ffd2885cf.jpg?1415793547";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/060/original/bd7ae5e3d2a6ad9def3ba21a29b6638f.jpg?1415793549";}i:6;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/061/original/ea727178e200bce26280f80581138874.jpg?1415793552";}}', 'http://www.axis.com/products/cam_p1354/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1353-e', 'P1353-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/168/original/8c31f2331ed1a659d397d8ff651c1fbc.jpg?1426620337";}}', 'http://www.axis.com/products/cam_p1353e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1353', 'P1353', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/047/original/298a5043f07862a631106cff49a1e230.jpg?1415793527";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/048/original/6547f1ea5250c9abe7e1830325762e5e.jpg?1415793529";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/049/original/f7f8350498a306f214bdef21090f36d0.jpg?1415793530";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/050/original/89ca164d94e99ec04d56e90166d7c7ce.jpg?1415793532";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/046/original/0737a364379cf7d21adfe8d889d12a8b.jpg?1426620331";}}', 'http://www.axis.com/products/cam_p1353/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1224-e', 'P1224-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x723', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/045/original/6359f107cabc0a9c91a14b0ab9df8a6a.jpg?1426620262";}}', 'http://www.axis.com/products/cam_p1224e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1214', 'P1214', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x722', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/044/original/ea858d961917e8525dcef32ab78406a9.jpg?1415793522";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/043/original/67fa44a2902b6bca21175d8d6b7feb5c.jpg?1426620256";}}', 'http://www.axis.com/products/cam_p1214/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1214-e', 'P1214-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x721', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/042/original/c34cbdf8cadd42542e1b3cd8ba87bfb9.jpg?1426620249";}}', 'http://www.axis.com/products/cam_p1214e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'p1204', 'P1204', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/041/original/a0f4f89bc4b27657264a74a31793d384.jpg?1415793517";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/040/original/cabe2182a426f8491b67ae776ff57cb0.jpg?1426620243";}}', 'http://www.axis.com/products/cam_p1204/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm2014-e', 'M2014-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x720', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/973/original/56d1eea8b7dd5f8188d99b308b9b7eb5.jpg?1415793405";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/974/original/cc35314f5b7320f7d454d143fef42949.jpg?1415793407";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/975/original/99eacdf8174d3acb0cef39e93bd241f7.jpg?1415793408";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/976/original/a95678b2bc040f294b474d027a919b57.jpg?1415793410";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/977/original/883b8efaf0516f81a6b8e1f7e52d4c54.jpg?1415793411";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/972/original/fe8b37677cf27614724c4064e958f657.jpg?1426620237";}}', 'http://www.axis.com/products/cam_m2014e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1144-l', 'M1144-L', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/971/original/bc66293c741bfb6957b022a82edba465.jpg?1415793402";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/970/original/5122711e49a6109e73616d7909aa3eee.jpg?1426620232";}}', 'http://www.axis.com/products/cam_m1144l/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1143-l', 'M1143-L', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/969/original/45008ef9bec1555dc46a6427602224a7.jpg?1415793397";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/968/original/41e2ff1ea747f615292442932c87721e.jpg?1426620424";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'm1114-e', 'M1114-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/958/original/c639eddf515cccaaaf21f8b0a64845f9.jpg?1415793380";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/959/original/bfca44a6db4b75c85403abaed521f808.jpg?1415793382";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/960/original/14714e14fe3efaf3fd7836206ddeb9f6.jpg?1415793383";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/961/original/2506921c0119f86cf7b9f83af1c54616.jpg?1415793385";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/957/original/aaa76cc4a89ef205f22f560733995b71.jpg?1426621130";}}', 'http://www.axis.com/products/cam_m1114/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1114', 'M1114', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/963/original/fe3db8ab05430f5eaf0cb8beccb86b21.jpg?1415793388";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/964/original/6bf48bd452d0cdef740cd5c362aa4ee8.jpg?1415793390";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/965/original/aaa05c3ed20c74d7188a52b80b555d81.jpg?1415793391";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/966/original/4a565cedb342f45ac2153fc6caf14d69.jpg?1415793393";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/962/original/f6bc8cdcfa59320d84726ed7713ae61c.jpg?1426621122";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/967/original/9c338376c21a19a35828f4a94dfa4c81.jpg?1415793394";}}', 'http://www.axis.com/products/cam_m1114/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1113-e', 'M1113-E', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/949/original/c7f4a2fc8ec1f92e6e6eee9da86f1835.jpg?1415793365";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/950/original/37e721a8b3122bab1bf2a61afc68fa06.jpg?1415793367";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/951/original/d28f760ef5c6c756c951dd6ce211e24d.jpg?1415793369";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/948/original/412d0f8d31c3daa141af73d5b1aa45d6.jpg?1426620226";}}', 'http://www.axis.com/products/cam_m1113e/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1113', 'M1113', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/952/original/647642b1866fa39bd64b6c84d2d3c456.jpg?1426621116";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/953/original/63b338e5dec18be5f6f3b81a5441b559.jpg?1415793372";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/954/original/9064b81541d03f9e36491e7bfa293928.jpg?1415793374";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/955/original/7b9702a5a4953f648404e7df19509b54.jpg?1415793375";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/956/original/8b0aae8d4935eb4ec91bfab5f5180da7.jpg?1415793377";}}', 'http://www.axis.com/products/cam_m1113/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1104', 'M1104', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/947/original/13f5aec6efa80a17627b9c950ee02125.jpg?1426620220";}}', 'http://www.axis.com/products/cam_m1104/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1103', 'M1103', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/946/original/a71b2a4b0cb13c34d79c64a4959e0f75.jpg?1426620214";}}', 'http://www.axis.com/products/cam_m1103/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1054', 'M1054', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/943/original/204def9f84dfb39b317e8db6e12dac23.jpg?1415793353";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/944/original/abb471e5c52841373458aa674f24f8a2.jpg?1415793354";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/945/original/1849fd2875f680b28d1d0deb77c8e2de.jpg?1415793356";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/942/original/935965a644846662f7d45ceb4d39e1ea.jpg?1426620208";}}', 'http://www.axis.com/products/cam_m1054/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1034-w', 'M1034-W', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/937/original/89694dc7fadcd9c47adeabe8e8b22cfa.jpg?1415793342";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/938/original/f7b59d4769781dc7429e3a1bff3c7228.jpg?1415793344";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/939/original/bc797c8ab3d1163df87ad3cec835e12f.jpg?1415793346";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/940/original/2403e2cedd832859a5dac2663732fec0.jpg?1415793347";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/936/original/118275ebadd62433ecf9f6852eeed9bc.jpg?1426620202";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/941/original/c2a3d808657dbf5464eb88371110ff9a.jpg?1415793349";}}', 'http://www.axis.com/products/cam_m1034w/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1033-w', 'M1033-W', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 'a:6:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/931/original/bb77337e6a6d2a29c83fe2567b4d8293.jpg?1415793333";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/932/original/a168b34bd470ce31ab4d1e49c1b1f60a.jpg?1415793334";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/933/original/28a280249222a91c8e8e0f1b093701fa.jpg?1415793336";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/934/original/6ca4ebe846b3f3f4f9cda21b7dc92467.jpg?1415793338";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/935/original/8607f39b4b727f72d1e5023bf73af3c0.jpg?1415793339";}i:5;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/930/original/33cc6ddd452d3065098af60ab26e980a.jpg?1426620197";}}', 'http://www.axis.com/products/cam_m1033w/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1014', 'M1014', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '1280x800', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/926/original/0ac5ca97d12eab1120db17cc53f648f9.jpg?1415793324";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/927/original/d3c6fdf357f625251193972d19796d4c.jpg?1415793326";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/928/original/fca814479a030648c033692303b24840.jpg?1415793328";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/929/original/93c5bfaf9a73f74331ffbef51027525f.jpg?1415793329";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/925/original/edef97ae3998a64ea2af74185eaeae2a.jpg?1426620191";}}', 'http://www.axis.com/products/cam_m1014/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'm1013', 'M1013', '50', 'axis-cgi/jpg/image.cgi', 'axis-cgi/mjpg/video.cgi', 'axis-media/media.amp', '800x600', 'Box', 'root', 'pass', '', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:5:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/920/original/a0360313c53b316e35038f41f36f5975.jpg?1426620186";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/921/original/108012f2959a56ad36d808b6fffb64e4.jpg?1415793315";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/922/original/e3f7815300200a06c02fd34be450365a.jpg?1415793317";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/923/original/a55d338eeb6b348996a29b715feac1f8.jpg?1415793318";}i:4;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/005/924/original/20a0be911bfec39248fbbbe80b99cdac.jpg?1415793320";}}', 'http://www.axis.com/products/cam_m1013/index.htm');
INSERT INTO "cameras" 
VALUES (NULL, 'snh-1011', 'SNH-1011', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Box', 'admin', '4321', '', 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/810/original/3807113068a9ef65b1411838697b29f1.jpg?1426619679";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/811/original/f030940e7b676c0ee0d2c68c1fe7ef59.jpg?1416378387";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/wireless-ip-cameras/SNH-1011.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snh-p6410bn', 'SNH-P6410BN', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Box', 'admin', '4321', '', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/813/original/ca7d2e0c93ad1f5ccf90d90e5fb78cce.jpg?1416378390";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/812/original/185dde06c1e6ba087998b8bef863b728.jpg?1426619674";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/wireless-ip-cameras/SNH-P6410BN.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-3122', 'SNP-3122', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/891/original/df58dccd900b23cb55b336c2a34727f0.jpg?1426619701";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-3120vh.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-3121', 'SNP-3121', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/894/original/4d2140908573dcb1cdb72b4b7e75ccdc.jpg?1426619685";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-3120v.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-3120', 'SNP-3120', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/819/original/81b1128677d2f5212723a5f0a24c6f04.jpg?1426619668";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-3120.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-3302h', 'SNP-3302H', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/821/original/c47731234e9edcab87774d866c56c453.jpg?1416378401";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/820/original/e7d551774fbe559b029a9b2168ff1466.jpg?1426619663";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-3302h.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-3371', 'SNP-3371', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/822/original/08ab3abdbcdc3aa1c0dac7a3c050cf00.jpg?1426619653";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-3371.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-3371th', 'SNP-3371TH', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/823/original/d3bb146f0c09ef01259318214c79b61e.jpg?1426619648";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-3371th.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-5200h', 'SNP-5200H', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/825/original/7e9d0e1587cab8e7586e2ba4e2a958b8.jpg?1426619640";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/826/original/29becab8232e9ea8ee59d06d8f1dba2e.jpg?1416378407";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-5200h.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-5200', 'SNP-5200', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/824/original/34d8c683075d26ce6f9576a60fa8df6e.jpg?1426619629";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-5200.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6200', 'SNP-6200', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/829/original/630d27dd64d041b82b095a94fab19399.jpg?1426619616";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6200.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6200h', 'SNP-6200H', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/831/original/63e52f827078c67252bc955a678ef35e.jpg?1416378414";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/830/original/473e36fbe962243428f83a69b833de66.jpg?1426619607";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6200h.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6201h', 'SNP-6201H', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/835/original/e999815f06dfe103c975951d2e5f1e75.jpg?1426619601";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6201h.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6201', 'SNP-6201', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/834/original/b93ed51b22aaea66759db66ad90a5e7b.jpg?1426619596";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6201.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-5300h', 'SNP-5300H', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/828/original/7ab1859cca2548e6ed9cc1b372070c9b.jpg?1426619589";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-5300h.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-5300', 'SNP-5300', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/827/original/cca68fd173a6cfe13d0c28f8203e18b5.jpg?1426619583";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-5300.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6200rh', 'SNP-6200RH', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/833/original/88ee624df7ccec4ba70eb37762d95b40.jpg?1416378417";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/832/original/790963dcc2777605e7fa5bc7a37abec0.jpg?1426619578";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6200rh.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6320h', 'SNP-6320H', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/837/original/1f6be66f7f5201ebf4a3c84ca114ca1e.jpg?1426619572";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6320h.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snp-6320', 'SNP-6320', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/836/original/c42e0a4a32c276682d001b1acbc04014.jpg?1426619565";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ptz-domes/snp-6320.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-1080r', 'SNV-1080R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/839/original/f946a8683100547ceb4288d4760c5aec.jpg?1426619560";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-1080r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-1080', 'SNV-1080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/838/original/6480811687462c680758558578fc90ad.jpg?1426619555";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-1080.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-3080', 'SNV-3080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '-', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/841/original/f7d1086f4c7b46501b934cf7a5c06eb5.jpg?1416378429";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/840/original/8d97f66f8b9e974ecdc0b172d4628ca8.jpg?1426619549";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-3080.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-3120', 'SNV-3120', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '-', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/843/original/6871e02f4509dd4be7f307e461dc4f0e.jpg?1426619544";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/844/original/cab3828128b293f1b893ed46ed044b91.jpg?1416378433";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-3120.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-3082', 'SNV-3082', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '-', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/842/original/bb23d8d7840ffa4c3b0471ee94e3ad7c.jpg?1426619538";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-3082.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-5010', 'SNV-5010', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/846/original/a370fe75c23d223b3ca6c9a0e46d2b08.jpg?1416378435";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/847/original/017d86d1533ca0013967e8787f7e40c6.jpg?1416378437";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/845/original/7cb15359f28fdb2f92240443ff4b020c.jpg?1426619532";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-5010.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-5080', 'SNV-5080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/849/original/2f9dafc3aba4fcdbf65db512537b26b7.jpg?1416378440";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/848/original/299ebc0b87e8299b43db36f657207635.jpg?1426619527";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-5080.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-7080r', 'SNV-7080R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/861/original/bc406ceebb5a94046a7a3fe2718df5ed.jpg?1426619522";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-7080r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-7082', 'SNV-7082', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/862/original/4e9e2317c8eae673d78f320a317a0085.jpg?1426619517";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/863/original/c25a3c0e168eeb11f33c88cefc8418f2.jpg?1416378459";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-7082.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-7080', 'SNV-7080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/859/original/e99bd32b23f35fb4b97c16dc90d7a6ad.jpg?1426619511";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/860/original/7197ce3c672d46c1e73fe5ef9cc9eb50.jpg?1416378455";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-7080.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-6084r', 'SNV-6084R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/858/original/eb45edaa0d8a73d2443624a8352b6f03.jpg?1426619504";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-6084r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-6084', 'SNV-6084', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/857/original/787b5fc8bc931c21c3a5f310a6f76ee1.jpg?1426619498";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-6084.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-5084', 'SNV-5084', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/850/original/0ca809b68d963021c96e2d3ceff2e9c4.jpg?1426619490";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-5084.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-6012m', 'SNV-6012M', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/852/original/e97174f94b61e2ba1f66a2c9d1734a02.jpg?1416378444";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/853/original/7ab43badb2aad7f110c769be4f42ea9e.jpg?1416378445";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/851/original/000cddf89ed0bb561ff662a03d1cb5ab.jpg?1426619483";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-6012m.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-7084r', 'SNV-7084R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/865/original/3a17be7c0f48dbcc1209287f729ba6b8.jpg?1426619476";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-7084r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-7084', 'SNV-7084', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/864/original/ab2a745787eae8dff751e997f19011c8.jpg?1426619467";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-7084.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snv-6013', 'SNV-6013', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/855/original/0324a20f7f73c6a691f425cd728a2857.jpg?1416378448";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/856/original/0a6328b8d0e442953ea00e105ae6d4f2.jpg?1416378450";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/854/original/3df3ce9c2cb8a67a2785d94856150763.jpg?1426619459";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/ip-vandal-resistant-domes/snv-6013.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-1011', 'SND-1011', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/772/original/68e415128a1409cb1681416b55287b14.jpg?1416378322";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/771/original/dff78e15f71098bfc858a1488f150641.jpg?1426619454";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-1011.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-1080', 'SND-1080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/773/original/4eda850930cee01ae8aa3623938e0d0a.jpg?1426619448";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-1080.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-3080c', 'SND-3080C', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '-', 'Dome', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/707/original/d670dac770978a6437bedef4cd006897.jpg?1426619442";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/708/original/0777346c45f5abb97542a00627cd7275.jpg?1415738758";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/709/original/24eb1368259bac85acb1ddee8f164fcf.jpg?1415738760";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/710/original/0ab671727ec86c4fa6b60546dea7f2d9.jpg?1415738762";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-3080c-cf.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-3080', 'SND-3080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '-', 'Dome', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/775/original/e6c3cb74aea06d21c65a304f8a0c6381.jpg?1416378327";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/776/original/c37a0835f067ea6cd27a4ef7b39afc28.jpg?1416378328";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/774/original/6d9c5c2aa684dd99a890d6395e418dc8.jpg?1426619437";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/777/original/7b6fb1e7dfe24c9105b6a192ca5f2c7c.jpg?1416378330";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-3080-%20f.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-3082', 'SND-3082', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '-', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/782/original/ae33f07b87c8d572169823e6b913d1a4.jpg?1426619417";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/783/original/ed3092bf919cd274684be46eb1e445cb.jpg?1416378338";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/784/original/d271c16f6d399ea82fb79920849bdfad.jpg?1416378340";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/785/original/2a253c7636d76fe68de8c748c0e71579.jpg?1416378341";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-3082-f.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-5011', 'SND-5011', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/787/original/1d1131f15cc2da060d784f715e2f6646.jpg?1426619411";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/786/original/26d3c48eceb47536affabd64f252f65d.jpg?1416378343";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-5011.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-5061', 'SND-5061', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/788/original/a54e4e18153fbe92190fb84fca35eaa8.jpg?1426619406";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-5061.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-5080', 'SND-5080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/718/original/26d5b0da3eda80de39a862a274477cc5.jpg?1426619400";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/719/original/5809aa52cf9e1952127bdf41c837a1c3.jpg?1415738791";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/720/original/810b4e588dd851154ba533c574131bcc.jpg?1415738793";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/721/original/fd23c6d5e838f5cd54a1738f8dc96ea4.jpg?1415738795";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-5080-f.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-7011', 'SND-7011', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/794/original/00246920e839a114373e1fd28c4cf566.jpg?1426619395";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/795/original/7a747fc902b6625cb2c1b334f3e9d371.jpg?1416378360";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-7011.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-7061', 'SND-7061', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/796/original/8b89fca2d3e7316e48fb989771d310e5.jpg?1426619390";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/797/original/87dfb95fa4240fd26b00d3ec8abe65a0.jpg?1416378363";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-7061.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-7082', 'SND-7082', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/735/original/b42bc8410926830a1f8d2861229514ac.jpg?1426619383";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/736/original/70b7e92e578f9e83117dc3b34e450fab.jpg?1415738833";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/737/original/150c70784cc5e4f37874b95e752d8f5a.jpg?1415738835";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/738/original/24884a98aa3c5a47a636a7c128c95e6a.jpg?1415738837";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-7082.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-7080', 'SND-7080', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/731/original/1dabc0c40fd193fa7b5162e404c57d5e.jpg?1426619374";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/732/original/84d4b2173e824490a3711d2fe99c22ef.jpg?1415738825";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/733/original/6f9fff0f56cd2e20e04bbd6778bae683.jpg?1415738827";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/734/original/23aed78d620046d6bc9f9e9d7a6ef135.jpg?1415738829";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-7080.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-6011r', 'SND-6011R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/790/original/6f3ea0d79f12eb39efb37e91f6295dc1.jpg?1426619363";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-6011r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-6084r', 'SND-6084R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/793/original/37640fb4729b2bab96927303ea18b0ae.jpg?1426619355";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-6084r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-6084', 'SND-6084', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/792/original/56b91b949c8f625ee70129317e372a68.jpg?1426619349";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-6084.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-6083', 'SND-6083', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/791/original/98749ed5597931191cd053e60814d628.jpg?1426619343";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-6083.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-5084', 'SND-5084', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Dome', 'admin', '4321', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/789/original/9616d5bcf9cfc61dfada6783825a19ba.jpg?1426619337";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-5084.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-7084r', 'SND-7084R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/868/original/4445728d6bdcc01f3ad394e1555e91b0.jpg?1426619691";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-7084r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snd-7084', 'SND-7084', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/803/original/5c9db1b5b6e8745a0970d5cc2a3c2588.jpg?1416378376";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/802/original/16e69112becbacc4b02f1d6d54b4bb2d.jpg?1426619331";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snd-7084.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snf-7010-vm', 'SNF-7010-VM', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/869/original/3f302a4cd7e8b7f5c4c05f64b21a54ac.jpg?1426619430";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snf-7010v', 'SNF-7010V', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/746/original/88841cd07841bf1a51bf82977f9b76ee.jpg?1415738861";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/745/original/a4043d87ba8212325828e748bcee2801.jpg?1426619424";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'snf-7010', 'SNF-7010', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Dome', 'admin', '4321', '', 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/804/original/e3c92b3725db1407c1eadc49d57be9ea.jpg?1426619326";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/805/original/87d960359fa470b2b7e47a9e28b6a266.jpg?1416378379";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/806/original/8d35d2e6f4bbce4e1b981786df0afe10.jpg?1416378381";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/fixed-domes/snf-7010.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'sno-6011r', 'SNO-6011R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Bullet', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/814/original/a6fa492e4b21024f486a29644476eba4.jpg?1426619320";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/bullet-camera/sno-6011r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'sno-6084r', 'SNO-6084R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Bullet', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/815/original/5919ae4c3fcb43f9a0579b141af02f26.jpg?1426619314";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/bullet-camera/sno-6084r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'sno-7080r', 'SNO-7080R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Bullet', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/816/original/1eda03106c268cb3861aa46d7b0d3516.jpg?1426619309";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/bullet-camera/sno-7080r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'sno-7082r', 'SNO-7082R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Bullet', 'admin', '4321', '', 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/817/original/9906d284441d7bfec31a0f7e5aa58ed1.jpg?1426619304";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/bullet-camera/sno-7082r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'sno-7084r', 'SNO-7084R', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Bullet', 'admin', '4321', '', 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/818/original/cbc319a84e25acff59a20f24afb0e630.jpg?1426619300";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/bullet-camera/sno-7084r.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snz-5200', 'SNZ-5200', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/866/original/b147351974e3c4dbb3dc27ec8cd83f5d.jpg?1426619295";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/867/original/7c5179f25ef41cfbd2fa5c68a03cc2e6.jpg?1416378465";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snz-5200.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-2000', 'SNB-2000', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Box', 'admin', '4321', '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/742/original/c639b5621f4d2c3fdeddc7aad091017b.jpg?1426619288";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-2000.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-1001', 'SNB-1001', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '640x480', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/741/original/1cf931ef2bd127dfe2fdb31c81faf325.jpg?1416378279";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/740/original/367629f8d2159faaeb3627528aa4f93a.jpg?1426619284";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-1001.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-3000', 'SNB-3000', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/744/original/e27572f0e61bf5fd3ab618a203438387.jpg?1416378283";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/743/original/9e09976248c7a6f13eec175d8b7b17a9.jpg?1426619279";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-3000.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-3002', 'SNB-3002', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '704Ãƒâ€”480', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/675/original/e9b03b7ee4509b8bce5dd18f369a760d.jpg?1415738658";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/674/original/7da9df9d0372da576236b7730f6050cb.jpg?1426619274";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-3002.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-5001', 'SNB-5001', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/748/original/e8d3e7edda3a4a2ab1d5556771fba6ae.jpg?1426619270";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/749/original/86a27bdc2c2f0d9a6f2dfecb0f1af6b2.jpg?1416378289";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/750/original/37f5d68189ed9f53d2ddee704c861ffa.jpg?1416378291";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-5001.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-5000', 'SNB-5000', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/747/original/5513256013e1d96fd23b8aeeb82a0f7f.jpg?1426619265";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-5000.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-5004', 'SNB-5004', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1280x1024', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/752/original/c122e1e81e2a05cfa631889bd1703fc4.jpg?1416378294";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/753/original/21c960751677bbe29925e9cc52b6d9c6.jpg?1416378295";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/751/original/72dc43e5d2cc71cd2773509f18ff9067.jpg?1426619261";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/754/original/b962d935b11139fc8651ddc5104bd95e.jpg?1416378296";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-5004.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-6003', 'SNB-6003', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/756/original/ac4cd9c4b635a3057778a7a38a08f6ad.jpg?1416378299";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/757/original/eb0a3be94c5c761adc45b0a920a3890c.jpg?1416378300";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/758/original/d3132f101335e6452e7b4a41c89db9f5.jpg?1416378302";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/755/original/d155e66a6904e9eb310a052933303d44.jpg?1426619255";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/network-box-cameras/snb-6003.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-6004', 'SNB-6004', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/688/original/569b637f4727c2254bbffa7bfb86ec4e.jpg?1426619250";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/689/original/0f770c32e58e9d64533dd00bdf5fceb7.jpg?1415738700";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/690/original/de76e205beb2fa645ef00a6c976562a8.jpg?1415738702";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/003/691/original/53209e1a9888a20807d7fa292a1d3482.jpg?1415738704";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/network-box-cameras/snb-6004.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-7001', 'SNB-7001', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/768/original/85dd10fdd417e4d937f88b2601a22b4d.jpg?1416378316";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/769/original/2668a892d3f1c3c2c430cb5edcabf5b0.jpg?1416378317";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/767/original/b7a69af138eff24a31e82e42501a957b.jpg?1426619245";}}', 'https://www.samsung-security.com/en/products/security-cameras/network-cameras/network-box-cameras/snb-7001.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-7002', 'SNB-7002', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '2048x1536', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/770/original/c5f556a29ba11c0a5f906bafc2aaff8b.jpg?1426619240";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-7002.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'snb-6010', 'SNB-6010', '51', 'stw-cgi/video.cgi?msubmenu=snapshot&action=view', 'stw-cgi/video.cgi?msubmenu=stream&action=view', 'H.264/media.smp', '1920x1080', 'Box', 'admin', '4321', '', 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 'a:4:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/764/original/29ac629b5400a01e7872cded715fff37.jpg?1416378310";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/765/original/98576572a2abe1e85209b5f28acf32a0.jpg?1416378312";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/766/original/9321c6fd85f4e56e80173a36a07be1a8.jpg?1416378313";}i:3;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/007/763/original/8960cc11cac96e4c68996258e0ebba9c.jpg?1426619235";}}', 'https://www.samsung-security.com/products/security-cameras/network-cameras/network-box-cameras/snb-6010.aspx');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd732f-e-discontinued', 'DS-2CD732F(-E) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '704x576', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/222/original/587074c62795a79ab60791179795306b.jpg?1416390280";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/223/original/589553f8a6bb7810dd44c9bcc2328f66.jpg?1416390281";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/221/original/186342e82dc88b455bb90f4e6bf4ff41.jpg?1426620258";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd762mf-ifbh-discontinued', 'DS-2CD762MF-(I)FB(H) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/336/original/2d1295eade81c6781057b2b071116897.jpg?1426620151";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd752mf-ifbh-discontinued', 'DS-2CD752MF-(I)FB(H) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/328/original/f0adb903bc725633b08ad9e0104ddbfb.jpg?1426620146";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd702712pnf-e-discontinued', 'DS-2CD702/712P(N)F-E [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/225/original/cc01013edc2a579018bdea0e17ecf900.jpg?1416390314";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/224/original/d8694ac131ea1ab663302625efca6054.jpg?1426620158";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd832f-e-discontinued', 'DS-2CD832F(-E) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '704x576', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/345/original/0491cca7298418adf6d7223afd44f7fa.jpg?1426620141";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd752mf-e-discontinued', 'DS-2CD752MF-E [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/332/original/fc62d6339b4f7adf8d3f211dbcf52fa2.jpg?1426620136";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8133f-e-discontinued', 'DS-2CD8133F-E [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/227/original/9d549ea74c46a64dc34ea95eb3719c1c.jpg?1416390360";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/226/original/3345fd93e6ecb4a2b4a9dfc8b6564b23.jpg?1426620091";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd763pnf-eiz-discontinued', 'DS-2CD763P(N)F-E(I)(Z [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/229/original/fc85f787557e88feaa7970318765590d.jpg?1416390629";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/228/original/dc6e05aba49df982f2846af7c3878247.jpg?1426620095";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7133-e-discontinued', 'DS-2CD7133-E [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/231/original/4e4ebafb268a23536c1d40b83c0f2b66.jpg?1416390674";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/230/original/0f032d36ea539ad841143667d58f6d92.jpg?1426620100";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7353f-ei-discontinued', 'DS-2CD7353F-E(I) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/233/original/2f0db1d3c5a2e5f02891176fd853d763.jpg?1416390712";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/232/original/c4947f0e247b1b19203309767d4c8c87.jpg?1426620104";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812892pn-ir1-discontinued', 'DS-2CD802/812/892P(N)-IR1 [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/235/original/32f3880062bf3cbbd78a821c35e5521c.jpg?1416390751";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/234/original/fb8a34ec952bbb638426b0cc4e12e71c.jpg?1426620263";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812892pn-ir3-discontinued', 'DS-2CD802/812/892P(N)-IR3 [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/236/original/a7fa1b9c4c5e367c26a3ad73b9ecf502.jpg?1426620108";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/237/original/701579b812b7b9ce0eac5033906d353f.jpg?1416390780";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812892pn-ir5-discontinued', 'DS-2CD802/812/892P(N)-IR5 [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/239/original/a0508dd0031d0fe20a7b992c6942567a.jpg?1416390810";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/238/original/16a4ae42d81fc90f7a9fb9666342904b.jpg?1426620113";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd802812pnf-ew-discontinued', 'DS-2CD802/812P(N)F-E(W) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Box', 'admin', '12345', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/241/original/170c289d3f46e805875b766374fa95fa.jpg?1416390847";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/240/original/fec29cfe36becb44e5be6e5909dc59ee.jpg?1426620268";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd863pnf-ew-discontinued', 'DS-2CD863P(N)F-E(W) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/350/original/a7aeda87abf79e58ebc23a6e3ea090b3.jpg?1426620132";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd876bfmf-discontinued', 'DS-2CD876BF(MF) [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/358/original/5124802dbdb467a8262cdc02f78284cc.jpg?1426620127";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8153f-e-discontinued', 'DS-2CD8153F-E [DISCONTINUED]', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/242/original/9d3860dd797beaaa1edb208e24c9c0ec.jpg?1426620118";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd893pf-e-version-no1', 'DS-2CD893PF-E version no.1', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '704x576', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/364/original/6a41e0055bb6bb2e1431eefb19b57526.jpg?1426620122";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2015-i', 'DS-2CD2015-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/283/original/369d1256d27afbe517c63be7077a54b2.jpg?1426620081";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2035-i', 'DS-2CD2035-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/287/original/9edc71bac7c5bdcd4ca59f675e14629f.jpg?1426620077";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2135-i', 'DS-2CD2135-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/244/original/ef3b84506668b60a5773947bc3f0733d.jpg?1416390895";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/243/original/3dfcdb32989199cd03dd133d1cd22e18.jpg?1426620273";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2115-i', 'DS-2CD2115-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/246/original/0bc875ce269146b8f4019e337e01cef5.jpg?1416390919";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/245/original/cb58e7115a7dbf2e8e693f2b776825d0.jpg?1426620278";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2615-isr', 'DS-2CD2615-IS(R)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/248/original/7250a607b16019f0f9188b0632d9f2a7.jpg?1416390942";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/247/original/1896a35e4d064316d350c117d3adc567.jpg?1426620086";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2715f-isr', 'DS-2CD2715F-IS(R)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/299/original/3eb79bd178a43c5e27934399ebbfc5e3.jpg?1426620072";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2515-iwsr', 'DS-2CD2515-IWS(R)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/250/original/830ce6589f6f73920584d8664bcd2ad3.jpg?1416390967";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/249/original/ea0a3f876cbb0532cec831b37ed75ad8.jpg?1426619922";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2415f-iwr', 'DS-2CD2415F-IW(R)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:3:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/252/original/2786c6ced99f1325df0c75a07b90b8b7.jpg?1416390994";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/253/original/f343b273066aca670abc5ec231e3600c.jpg?1416390995";}i:2;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/251/original/65f970a13a3713e14f454bb9f0d32536.jpg?1426619926";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd6412fwd', 'DS-2CD6412FWD', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/255/original/4e4c1deceb4233154d728290aea6a50b.jpg?1416391018";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/254/original/7e58f3ca5b275ea6408e106fd7a18816.jpg?1426619931";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8464f-eiw', 'DS-2CD8464F-EIW', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/257/original/ab0b7919a0f948668f9380b7de5d314c.jpg?1416391043";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/256/original/170e16e3928cab87fe1200ac7d99eb31.jpg?1426619935";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2412f-iw', 'DS-2CD2412F-I(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/259/original/8aa29228af02afb376b897c081836cd5.jpg?1416391073";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/258/original/080c37c0456bd4c1d78207768cf8b5f6.jpg?1426619940";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2432f-iw', 'DS-2CD2432F-I(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Box', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/261/original/0768b0e32da710429e809a3475717463.jpg?1416391102";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/260/original/79a7586a9dba59b5e809cef662a0df1f.jpg?1426619944";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8233f-eiz', 'DS-2CD8233F-EI(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Bullet', 'admin', '12345', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/263/original/ebc5c5adfac8501dea2f8aae631147b8.jpg?1416391127";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/262/original/927bb62ae27c4ffcf89ed7297de2fca5.jpg?1426619948";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8264f-eiz', 'DS-2CD8264F-EI(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/267/original/98da200990547a34aaad917c64ebdb2d.jpg?1416391234";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/266/original/ce21fffb65ba74735b5f9ffc91cb23a7.jpg?1426619957";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8255f-eiz', 'DS-2CD8255F-EI(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/269/original/22b7e92135d364ec598c7fbb8e3d70e1.jpg?1416391273";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/268/original/26381827351ae14a74082c2772233b58.jpg?1426619962";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8254fwd-eiz', 'DS-2CD8254FWD-EI(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/271/original/f9b478730a2c8c86bf4c21b6c1bf5c86.jpg?1416391306";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/270/original/c4e9329e96541c6a4dd479ac0b52540b.jpg?1426619966";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8254f-eiz', 'DS-2CD8254F-EI(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '', 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/273/original/3f2f1d0d25ce2c727f42efa6a002c077.jpg?1416391326";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/272/original/d7831366eaa436a0868a9948a00d7bde.jpg?1426619971";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd855-ei3ei5', 'DS-2CD855-EI3(EI5)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/275/original/6263e0da5dc13d57d6db44d5f3a62b3d.jpg?1416391354";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/274/original/91976a0c1feb7384402a6f51435a2da3.jpg?1426619975";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd8253f-eiz', 'DS-2CD8253F-EI(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Bullet', 'admin', '12345', '', 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/277/original/dfb3d3d4392642265d39cde76c824bcf.jpg?1416391376";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/276/original/8f4352b350a8a79b5cdc108446d4383e.jpg?1426620282";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd864-ei3', 'DS-2CD864-EI3', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/354/original/8c54ce530461bb892fa9c0a8e91721c9.jpg?1426620068";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2012-i', 'DS-2CD2012-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/281/original/cb3c005b4e0ef0af7a780db949d4b7d1.jpg?1426620063";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2032-i', 'DS-2CD2032-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/285/original/25dc788a86801a66b023eceb74496814.jpg?1426620059";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2612f-is', 'DS-2CD2612F-I(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/279/original/15a9ee453dc4f9adbc54849a1ab0904d.jpg?1416391403";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/278/original/a3198d734d67b29bdbfd88ff3c70a1a5.jpg?1426619980";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2632f-is', 'DS-2CD2632F-I(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:2:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/281/original/0d8ed7e74165d11b668c876150d978d1.jpg?1416391426";}i:1;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/280/original/f73d10a1e950083a9b745b6761c4a5f7.jpg?1426619985";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2212-i5', 'DS-2CD2212-I5', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/290/original/1a61481bc33880919a0ddd0b8a79079f.jpg?1426620054";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2232-i5', 'DS-2CD2232-I5', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/293/original/7a6420adf049ebc1a183df82e654b552.jpg?1426620050";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7164-e', 'DS-2CD7164-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/282/original/0d942fb25b4d837873db44b8f7f92293.jpg?1426619990";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7153-e', 'DS-2CD7153-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/283/original/94395709c32962817e29f8ff63327e6a.jpg?1426619994";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2512-isw', 'DS-2CD2512-I(S)(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/284/original/f8b2a4eb1740646e35fddbdf60a42410.jpg?1426619999";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2532-isw', 'DS-2CD2532-I(S)(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/285/original/c47cd5a7f38a7c0b862891097e3133cd.jpg?1426620003";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7233f-eizh', 'DS-2CD7233F-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/286/original/bf154a2fa4a92bda0ff4745a5e9382af.jpg?1426620008";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7264fwd-eizh', 'DS-2CD7264FWD-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/287/original/1f6b9e0dd63ac3859d779d01a8c66a62.jpg?1426620013";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7255f-eizh', 'DS-2CD7255F-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/288/original/a164d114d2435de0441d198d4bf47edd.jpg?1426620017";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7253f-eizh', 'DS-2CD7253F-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/289/original/2c0b0b6b2f342de61777d209a709c87f.jpg?1426620022";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7254fwd-eizh', 'DS-2CD7254FWD-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/290/original/78ddaedb8583b1f925437333c17f72a2.jpg?1426620026";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7283f-eizh', 'DS-2CD7283F-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2560x1920', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/291/original/422c94d75bd9521dec09c8289d595331.jpg?1426620031";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd7254f-eizh', 'DS-2CD7254F-E(I)Z(H)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/292/original/5b89ea28acacd9317362ac40203b8436.jpg?1426620036";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2312-i', 'DS-2CD2312-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/293/original/4a9fdec43de95f957baa6c6f80458d9c.jpg?1426620041";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2332-i', 'DS-2CD2332-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/294/original/e4e05131674a87ef460f9af844628cd3.jpg?1426620045";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2132-i', 'DS-2CD2132-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/295/original/8477ef013002ef9a5156c1d02cf3d65f.jpg?1426620287";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2112-i', 'DS-2CD2112-I', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/296/original/1962876af9e45f66c41d40ea1a27e747.jpg?1426619917";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2732f-is', 'DS-2CD2732F-I(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/301/original/c38230d68b37c648de6120ce5c1850fb.jpg?1426619913";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd2712f-is', 'DS-2CD2712F-I(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/297/original/5f3ab19383fe5d0621fa593807977e32.jpg?1426619908";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd733f-eiz', 'DS-2CD733F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/297/original/9e684696235814c80992dd2cd7bc489b.jpg?1426619760";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd793pnf-eiz', 'DS-2CD793P(N)F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/298/original/e431a5a124e99eb866adb72bda5a5001.jpg?1426620292";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd793pnfwd-eiz', 'DS-2CD793P(N)FWD-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/299/original/3f840fe658aa0dd99b9ea45f00225cbb.jpg?1426619764";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd764f-eiz', 'DS-2CD764F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/300/original/96136addcce80cef1d495450f50f798b.jpg?1426619768";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd764fwd-eiz', 'DS-2CD764FWD-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/301/original/6b69e904ae0d0b7b85c2ea0ed9d8cd15.jpg?1426619772";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd753f-eiz', 'DS-2CD753F-E(I)(Z', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/302/original/58ed67fdaa5ced4fc382c222a473b72d.jpg?1426619776";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd755f-eiz', 'DS-2CD755F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/303/original/5712019100ff94d4d2e622a6dc8c3532.jpg?1426619781";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd754fwd-eiz', 'DS-2CD754FWD-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/318/original/2491a6bc384d0dc545e3d7d253f090a0.jpg?1426619848";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd754f-eiz', 'DS-2CD754F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/304/original/cdac0e66b82098b7ae7e74ef1ef5faea.jpg?1426619785";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd783f-eiz', 'DS-2CD783F-E(I)(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2560x1920', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/305/original/47940dd8dd2d6d97ef9143afe7991fb1.jpg?1426619789";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd833f-ew', 'DS-2CD833F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '640x480', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/306/original/1649e066de475e979298c4f73afcbd1c.jpg?1426619794";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd893pfnf-ew', 'DS-2CD893PF(NF)-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/307/original/6d53612e1e407e425abda72c4098bbb3.jpg?1426619798";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd893pfnfwd-ew', 'DS-2CD893PF(NF)WD-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', 'pal:704x576;ntsc:704x480', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/362/original/5a46475734b577fd71848439dd4afc76.jpg?1426619904";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd864f-ew', 'DS-2CD864F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/308/original/8c20e39c0575653bff0953c0fad9a561.jpg?1426619803";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd864fwd-e', 'DS-2CD864FWD-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/356/original/ca0fa10801fe071085e4524237ba5e43.jpg?1426619899";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd853f-ew', 'DS-2CD853F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1600x1200', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/309/original/a945655b2328a3b17890c4620a5ca09a.jpg?1426619808";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd855f-e', 'DS-2CD855F-E', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/310/original/bd137388aca4baf0e8b5fc40bb529f6b.jpg?1426619812";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd854f-ew', 'DS-2CD854F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/311/original/5dbe53cc976f44e35057f423961b0a35.jpg?1426619816";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd883f-ew', 'DS-2CD883F-E(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2560x1920', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/312/original/67c4be4b4243b7e3bb4416bde1c4db24.jpg?1426619821";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4324f-izhs', 'DS-2CD4324F-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/313/original/6417ad23f5e0dcbf8714e89cb339c852.jpg?1426619825";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4312fwd-izhs', 'DS-2CD4312FWD-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/320/original/50d32efd5d9bc8c03c0bc118bee85a33.jpg?1426619895";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4312f-izhs', 'DS-2CD4312F-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x1024', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/314/original/873c9e28f6c6d26e1230416ea00bbba0.jpg?1426619829";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4232fwd-izhs', 'DS-2CD4232FWD-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/318/original/aea977bcdbe1593f16edb75eb05838c1.jpg?1426619891";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4224f-izhs', 'DS-2CD4224F-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/316/original/a2658a8685b4630725c9ed3413daace3.jpg?1426619887";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4212fwd-izhs', 'DS-2CD4212FWD-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/314/original/5d7c47ac646e95b5d40272978c3e5f2d.jpg?1426619882";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4212f-izhs', 'DS-2CD4212F-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x1024', 'Bullet', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/312/original/7fafc7a027728da33992a32672844c9a.jpg?1426619877";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4332fwd-izhs', 'DS-2CD4332FWD-I(Z)(H)(S)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/323/original/051f9db612f89ead6fe0ab08cd74cada.jpg?1426619873";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4132fwd-iz', 'DS-2CD4132FWD-I(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Dome', 'admin', '12345', '1', 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/315/original/546094daea948a7f8c025dabae4abd68.jpg?1426619834";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd6026fhwd-a', 'DS-2CD6026FHWD-(A)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/325/original/4685e51d1585b9aab5af7ae7082aefd1.jpg?1426619869";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4124f-iz', 'DS-2CD4124F-I(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/316/original/d5f5ef2d403e69098b1821a4c6722586.jpg?1426619839";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4112f-iz', 'DS-2CD4112F-I(Z)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x1024', 'Dome', 'admin', '12345', '1', 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/008/317/original/2e3f2e3312e2507f09be191d08329508.jpg?1426619843";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4032fwd-apw', 'DS-2CD4032FWD-(A)(P)(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '2048x1536', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/309/original/4fdcb31bdfecb976f4936be4eb09e6a9.jpg?1426619865";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4024f-apw', 'DS-2CD4024F-(A)(P)(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1920x1080', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/306/original/cd4f4d64be5ee3efca8a738587af4458.jpg?1426619860";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4012fwd-apw', 'DS-2CD4012FWD-(A)(P)(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x960', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/305/original/47d6c7bc581d9771b7ffae003255f7f7.jpg?1426619856";}}', '');
INSERT INTO "cameras" 
VALUES (NULL, 'ds-2cd4012f-apw', 'DS-2CD4012F-(A)(P)(W)', '52', 'Streaming/Channels/1/picture', '', 'h264/ch1/maiv_stream', '1280x1024', 'Box', 'admin', '12345', '1', 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 'a:1:{i:0;a:1:{s:3:"url";s:113:"http://s3.amazonaws.com/cambase/images/files/000/006/303/original/0768b602b9f62fced531c922f4ee6e6a.jpg?1426619852";}}', '');
